<%@ Import namespace="System.Reflection" %>
<%@ Import namespace="System.Collections" %>
<%@ Assembly name="WebCab.Libraries.PortfolioDemo" %>
<script runat="server" language="c#">
private String[][] typesTable = new String[][] {
	new String[] {"bool", "System.Boolean", "Boolean"},
	new String[] {"byte", "System.Byte", "Byte"},
	new String[] {"short", "System.Int16", "Short"},
	new String[] {"int", "Int32", "Integer"},
	new String[] {"long", "System.Int64", "Long"},
	new String[] {"single", "System.Single", "Single"},
	new String[] {"double", "System.Double", "Double"},
	new String[] {"string", "String", "String"},
};

/// <summary>
/// Takes a primitive wrapping structure type as a parameter and returns its primitive type name.
/// Ex. typeof (Int32) implies `int'.
/// </summary>
private String getPrimitiveTypeName (Type myType) {
	String typeName = myType.FullName;
	String arraySuffix = "";
	String name = null;
	if (typeName.IndexOf ("[]") != -1) {
		arraySuffix = typeName.Substring (typeName.IndexOf ("[]"));
		typeName = typeName.Substring (0, typeName.IndexOf ("[]"));
	}

	for (int i = 0; i < typesTable.Length; i++)
		if (typesTable[i][1].Equals (typeName)) {
			name = typesTable[i][0];
			break;
		}
	
	return name;
}

/// <summary>
/// Takes a primitive wrapping structure type as a parameter and returns its display name.
/// Ex. typeof (Int32) implies `Integer'.
/// </summary>
private String getPrimitiveTypeDisplayName (Type myType) {
	String typeName = myType.FullName;
	String arraySuffix = "";
	String displayName = "";
	
	if (typeName.IndexOf ("[]") != -1) {
		arraySuffix = typeName.Substring (typeName.IndexOf ("[]"));
		typeName = typeName.Substring (0, typeName.IndexOf ("[]"));
	}

	for (int i = 0; i < typesTable.Length; i++)
		if (typesTable[i][1].Equals (typeName)) {
			displayName = typesTable[i][2];
		}
	return displayName;
}

private class AnonymousClassComparator : IComparer {
	public virtual int Compare(Object o1, Object o2) {
		//UPGRADE_TODO: The equivalent in .NET for method 'java.lang.reflect.Method.getParameterTypes' may return a different value. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1043"'
		return ((MethodInfo) o1).GetParameters().Length - ((MethodInfo) o2).GetParameters().Length;
	}
}</script>
<HTML>
<HEAD>
<SCRIPT LANGUAGE="javascript" SRC="db_tree.js"></SCRIPT>
<SCRIPT LANGUAGE="javascript">
function initOutlineIcons(imgStore) {
	var ip = 'images/lines/';
	
	imgStore.add('iconPlusTop', ip + 'plustop.gif', 18, 21);
	imgStore.add('iconPlus', ip + 'plus.gif', 18, 21);
	imgStore.add('iconPlusBottom', ip + 'plusbottom.gif', 18, 21);
	imgStore.add('iconPlusOnly', ip + 'plusonly.gif', 18, 21);
	imgStore.add('iconMinusTop', ip + 'minustop.gif', 18, 21);
	imgStore.add('iconMinus', ip + 'minus.gif', 18, 21);
	imgStore.add('iconMinusBottom', ip + 'minusbottom.gif', 18, 21);
	imgStore.add('iconMinusOnly', ip + 'minusonly.gif', 18, 21);
	imgStore.add('iconLine', ip + 'line.gif', 18, 21);
	imgStore.add('iconBlank', ip + 'blank.gif', 18, 21);
	imgStore.add('iconJoinTop', ip + 'jointop.gif', 18, 21);
	imgStore.add('iconJoin', ip + 'join.gif', 18, 21);
	imgStore.add('iconJoinBottom', ip + 'joinbottom.gif', 18, 21);

	ip = 'images/j2se/';
	imgStore.add('Home', ip + 'homeclosed.gif', 18, 21);
	imgStore.add('HomeExpanded', ip + 'homeopen.gif', 18, 21);

	imgStore.add('Class', ip + 'folderclosed.gif', 18, 21);
	imgStore.add('ClassExpanded', ip + 'folderopen.gif', 18, 21);

	imgStore.add('Method', ip + 'method.gif', 18, 21);
	imgStore.add('MethodSelected', ip + 'method_sel.gif', 18, 21);

	imgStore.add('SuperMethod', ip + 'folderclosed.gif', 18, 21);
	imgStore.add('SuperMethodExpanded', ip + 'folderopen.gif', 18, 21);
}
function initialise() {
	// Set up parameters to control menu behaviour
	theMenu.autoScrolling = true;	
	theMenu.modalFolders = true;
	theMenu.linkOnExpand = false;
	theMenu.toggleOnLink = false;
	theMenu.showAllAsLinks = false;
	theMenu.savePage = true;
	theMenu.tipText = "status";
	theMenu.selectParents = false;
	theMenu.name = "theMenu";
	theMenu.container = "self.bean_menu";
	theMenu.reverseRef = "parent";
	theMenu.contentFrame = "text";
	theMenu.defaultTarget = "webApp";
	
	initOutlineIcons(theMenu.imgStore);
	var level1ID = -1;
	var level2ID = -1;
	var level3ID = -1;
	var level4ID = -1;
	var level5ID = -1;
	
<%
	String applicationName = "Portfolio v5.0 Demo";
	String[][] packageNames = new String[][] {
			new String[] {"WebCab.Libraries.Finance.Portfolio", "WebCab.Libraries.Finance.Portfolio", "WebCab.Libraries.Finance.Portfolio", "WebCab.Libraries.Finance.Portfolio", "WebCab.Libraries.Finance.Portfolio", "WebCab.Libraries.Finance.Portfolio", "WebCab.Libraries.Finance.Portfolio", "WebCab.Libraries.Finance.Portfolio", "WebCab.Libraries.Finance.Portfolio"}
		};
	String[] moduleNames = new String[] {
			"Portfolio"
		};
	String[][] appClassNames = new String[][] {
			new String[] {"EasyOptimal", "Markowitz", "CapitalMarket", "PerformanceEvaluation", "AssetParameters", "TwoAssetPortfolio", "Volatility", "Interpolation", "SolveFrontier"}
		};
	Type[][] appTypes = new Type[][] {
			new Type[] {typeof (WebCab.Libraries.Finance.Portfolio.EasyOptimal), typeof (WebCab.Libraries.Finance.Portfolio.Markowitz), typeof (WebCab.Libraries.Finance.Portfolio.CapitalMarket), typeof (WebCab.Libraries.Finance.Portfolio.PerformanceEvaluation), typeof (WebCab.Libraries.Finance.Portfolio.AssetParameters), typeof (WebCab.Libraries.Finance.Portfolio.TwoAssetPortfolio), typeof (WebCab.Libraries.Finance.Portfolio.Volatility), typeof (WebCab.Libraries.Finance.Portfolio.Interpolation), typeof (WebCab.Libraries.Finance.Portfolio.SolveFrontier)}
		};
%>

	level1ID = theMenu.addEntry(-1, "Home", "WebCab <%=applicationName%>", "", "<%=applicationName%>");
	theMenu.entry[level1ID].isopen = true;
	<%
	 /*
	 * Inspect methods
	 */
	for (int moduleIndex = 0; moduleIndex < moduleNames.Length; moduleIndex++){
		
		if (moduleIndex == 0) {
			%>
			level2ID = theMenu.addChild(level1ID, "Home", "WebCab <%=moduleNames[moduleIndex]%>", "", "<%=moduleNames[moduleIndex]%> Module");
			theMenu.entry[level2ID].isopen = true;
			<%
		}
		else {
			%>
			level2ID = theMenu.addEntry(level2ID, "Home", "WebCab <%=moduleNames[moduleIndex]%>", "", "<%=moduleNames[moduleIndex]%> Module");
			<%
		}
		
		for (int classIndex = 0; classIndex < appClassNames[moduleIndex].Length; classIndex++){
			MethodInfo[] allMethods = appTypes[moduleIndex][classIndex].GetMethods(BindingFlags.Instance | BindingFlags.Public | BindingFlags.DeclaredOnly);

			MethodInfo[][] methods = null;
			String[] methodNames = null;
			
			if (allMethods.Length > 0) {
				ArrayList namesVector = new ArrayList();
				ArrayList methodsVector = new ArrayList();
				ArrayList allMethodsVector = new ArrayList();
				
				for (int i = 0; i < allMethods.Length; i++)allMethodsVector.Add(allMethods[i]);
				
				while (allMethodsVector.Count > 0) {
					ArrayList sameNameMethodsVector = new ArrayList();
					String methodName = ((MethodInfo) allMethodsVector[0]).Name;
					
					for (int i = 0; i < allMethodsVector.Count; i++)
						if (((MethodInfo) allMethodsVector[i]).Name.Equals(methodName)) {
							/*
							 * Check if the method is acceptable
							 */
							MethodInfo m = (MethodInfo) allMethodsVector[i];
							if (m.ReturnType != Type.GetType("System.Void")) {
								Type[] types = new Type[m.GetParameters().Length];
								for (int typeIndex = 0; typeIndex < types.Length; typeIndex++)
									types[typeIndex] = m.GetParameters()[typeIndex].ParameterType;
								
								if (types.Length == 0)
									sameNameMethodsVector.Add(allMethodsVector[i]);
								else
								{
									int j = 0;
									for (j = 0; j < types.Length; j++)
										if (types[j] == Type.GetType("System.Char") || !types[j].IsPrimitive)
											break;
									
									if (j == types.Length)
										sameNameMethodsVector.Add(allMethodsVector[i]);
								}
							}
							
							allMethodsVector.RemoveAt(i);
							i--;
						}
					
					if (sameNameMethodsVector.Count > 0) {
						methodsVector.Add(sameNameMethodsVector);
						namesVector.Add(methodName);
					}
				}
				
				methods = new MethodInfo[methodsVector.Count][];
				for (int i = 0; i < methods.Length; i++) {
					methods[i] = (MethodInfo[]) ((ArrayList) methodsVector[i]).ToArray(typeof (MethodInfo));
					System.Array.Sort(methods[i], new AnonymousClassComparator());
				}
				methodNames = (String[]) namesVector.ToArray(typeof (String));
			}
			
			if (classIndex == 0) {
				%>
				level3ID = theMenu.addChild(level2ID, "Class", "<%=appClassNames[moduleIndex][classIndex]%>", "", "<%=appClassNames[moduleIndex][classIndex]%> Class");
				<%
			}
			else {
				%>
				level3ID = theMenu.addEntry(level3ID, "Class", "<%=appClassNames[moduleIndex][classIndex]%>", "", "<%=appClassNames[moduleIndex][classIndex]%> Class");
				<%
			}
			
			for (int i = 0; i < methodNames.Length; i++) {
				if (i == 0) {
					%>
					level4ID = theMenu.addChild(level3ID, <%
				}
				else {
					%>
					level4ID = theMenu.addEntry(level4ID, <%
				}
				
				if (methods[i].Length == 1) {
					%>"Method", "<%=methodNames[i]%>", "test.aspx?appClassName=<%=appClassNames[moduleIndex][classIndex]%>&methodName=<%=methodNames[i]%>", "Method <%=methodNames[i]%>");<%
					if (moduleIndex == 0 && classIndex == 0 && i == 0) {
						%>
						theMenu.entry[level3ID].isopen = true;
						theMenu.selectEntry (level4ID);
						<%
					}
				}
				else {				
					%>"SuperMethod", "<%=methodNames[i]%>", "", "<%=methods[i].Length%> <%=methodNames[i]%> methods");<%
					
					for (int j = 0; j < methods[i].Length; j++){
						MethodInfo m = methods[i][j];
						Type[] types = new Type[m.GetParameters().Length];
						for (int typeIndex = 0; typeIndex < types.Length; typeIndex++)
							types[typeIndex] = m.GetParameters()[typeIndex].ParameterType;

						String parametersDisplayName = "(";
						
						for (int k = 0; k < types.Length - 1; k++) {
							parametersDisplayName += (getPrimitiveTypeDisplayName (types[k]) + ", ");
						}
						if (types.Length > 0) {
							parametersDisplayName += getPrimitiveTypeDisplayName (types[types.Length - 1]);
						}
						
						parametersDisplayName += ")";
						
						if (j == 0) {
							%>
							level5ID = theMenu.addChild(level4ID, "Method", "<%=methods[i][j].Name%><%=parametersDisplayName%>", "test.aspx?appClassName=<%=appClassNames[moduleIndex][classIndex]%>&methodName=<%=methodNames[i]%>&methodNumber=<%=j%>", "Method <%=methods[i][j].Name%><%=parametersDisplayName%>");
							<%
							if (moduleIndex == 0 && classIndex == 0 && i == 0) {
								%>
								theMenu.entry[level3ID].isopen = true;
								theMenu.entry[level4ID].isopen = true;
								theMenu.selectEntry (level5ID);
								<%
							}
						}
						else {
							%>
							level5ID = theMenu.addEntry(level5ID, "Method", "<%=methods[i][j].Name%><%=parametersDisplayName%>", "test.aspx?appClassName=<%=appClassNames[moduleIndex][classIndex]%>&methodName=<%=methodNames[i]%>&methodNumber=<%=j%>", "Method <%=methods[i][j].Name%><%=parametersDisplayName%>");
							<%
						}
					}
				}
			}
		}// classIndex
	}// moduleIndex
%>
}

self.defaultStatus = "";	

function updateColumn (columnName) {
	buttonsFrame.updateColumn (columnName);
}
</script>

<TITLE>WebCab <%=applicationName%> Web Application Example</TITLE>
</HEAD>
<SCRIPT LANGUAGE="JavaScript">
if (self.name == 'bean_menu') {
	self.location.href = "bean_menu.htm";
} else {
	initialise();
}
</SCRIPT>

<FRAMESET cols="220, *" onResize="defaultResizeHandler();" FRAMEBORDER="0">
<FRAME name = "bean_menu" src = "bean_menu.htm" scrolling = "auto" marginwidth = "1" marginheight = "1" APPLICATION = "yes">
<FRAME name = "webApp" src = "test.aspx">
</FRAMESET>
</HTML>