<%@ Import namespace="System.IO" %>
<%@ Import namespace="System.Reflection" %>
<%@ Import namespace="System.Collections" %>
<%@ Import namespace="System.Net" %>
<%@ Assembly name="WebCab.Libraries.PortfolioDemo" %>
<script runat="server" language="c#">
private String[][] typesTable = new String[][] {
	new String[] {"bool", "System.Boolean", "Boolean"},
	new String[] {"byte", "System.Byte", "Byte"},
	new String[] {"short", "System.Int16", "Short"},
	new String[] {"int", "System.Int32", "Integer"},
	new String[] {"long", "System.Int64", "Long"},
	new String[] {"single", "System.Single", "Single"},
	new String[] {"double", "System.Double", "Double"},
	new String[] {"string", "String", "String"},
};

/// <summary>
/// Takes a primitive wrapping structure type as a parameter and returns its primitive type name.
/// Ex. typeof (System.Int32) implies `int'.
/// </summary>
private String getPrimitiveTypeName (Type myType) {
	String typeName = myType.FullName;
	String arraySuffix = "";
	String name = null;
	if (typeName.IndexOf ("[]") != -1) {
		arraySuffix = typeName.Substring (typeName.IndexOf ("[]"));
		typeName = typeName.Substring (0, typeName.IndexOf ("[]"));
	}

	for (int i = 0; i < typesTable.Length; i++)
		if (typesTable[i][1].Equals (typeName)) {
			name = typesTable[i][0];
			break;
		}
	
	return name;
}

/// <summary>
/// Takes a primitive wrapping structure type as a parameter and returns its display name.
/// Ex. typeof (System.Int32) implies `Integer'.
/// </summary>
private String getPrimitiveTypeDisplayName (Type myType) {
	String typeName = myType.FullName;
	String arraySuffix = "";
	String displayName = "";
	
	if (typeName.IndexOf ("[]") != -1) {
		arraySuffix = typeName.Substring (typeName.IndexOf ("[]"));
		typeName = typeName.Substring (0, typeName.IndexOf ("[]"));
	}

	for (int i = 0; i < typesTable.Length; i++)
		if (typesTable[i][1].Equals (typeName)) {
			displayName = typesTable[i][2];
		}
	return displayName;
}

private class AnonymousClassComparator : IComparer {
	public virtual int Compare(Object o1, Object o2) {
		return ((MethodInfo) o1).GetParameters().Length - ((MethodInfo) o2).GetParameters().Length;
	}
}
</script>
<html>
<head>
<SCRIPT LANGUAGE="JavaScript" SRC="index2.js"></SCRIPT>
<SCRIPT>
<!--
self.defaultStatus = "";

function markInvalid (windowName) {
	eval ("document.browserForm.schema" + windowName + ".value='';");
	eval ("document.browserForm.table" + windowName + ".value='';");
	eval ("document.browserForm.column" + windowName + ".value='';");
}

function setColumn (windowName, text) {
	i = text.indexOf ('.');
	if (i != -1) {
		eval ("document.browserForm.schema" + windowName + ".value=text.substring (0, i);");
		text = text.substring (i + 1);
		i = text.indexOf ('.');
		if (i != -1) {
			eval ("document.browserForm.table" + windowName + ".value=text.substring (0, i);");
			eval ("document.browserForm.column" + windowName + ".value=text.substring (i + 1);");
		}
		else
			markInvalid (windowName);
	}
	else
		markInvalid (windowName);
}

function getCatalogName (windowName) {
	return eval ("document.browserForm.schema" + windowName + ".value");
}

function getTableName (windowName) {
	return eval ("document.browserForm.table" + windowName + ".value");
}

function getColumnName (windowName) {
	return eval ("document.browserForm.column" + windowName + ".value");
}

function getColumn (windowName) {
	if (getCatalogName (windowName) != '' && getTableName (windowName) != '' && getColumnName (windowName) != '')
		return getCatalogName (windowName) + '.' + getTableName (windowName) + '.' + getColumnName (windowName);
	return "";
}
//-->
</SCRIPT>
<script language="javascript">
<!--
function checkTextField (textObject) {
	if (textObject.type != "text")
		return true;
	
	s = textObject.value;
	
	while (s.length > 1 && s.charAt (0) == ' ')
		s = s.substring (1);
	
	while (s.length > 1 && s.charAt (s.length - 1) == ' ')
		s = s.substring (0, s.length - 1);
	
	if (s == ' ')
		s = '';
	
     if ((s.length == 0)) {
          alert ("Please fill out all corresponding parameter fields.");
          textObject.focus();
     	return false;
     }
     
     if (isNaN(s)) {
          alert ("Please fill out a number in the selected field.");
          textObject.focus ();
          textObject.select ();
          return false;
     }

	return true;
}

//-->
</script>
</head>
<body bgcolor="#ffffff">
<font face="Verdana, Arial, Sans-serif">
<%
	Object instance = null;
	String[] packageNames = new String[] {
			"WebCab.Libraries.Finance.Portfolio", "WebCab.Libraries.Finance.Portfolio", "WebCab.Libraries.Finance.Portfolio", "WebCab.Libraries.Finance.Portfolio", "WebCab.Libraries.Finance.Portfolio", "WebCab.Libraries.Finance.Portfolio", "WebCab.Libraries.Finance.Portfolio", "WebCab.Libraries.Finance.Portfolio", "WebCab.Libraries.Finance.Portfolio"
		};
	String packageName = packageNames[0];
	String[] appClassNames = new String[] {
			"EasyOptimal", "Markowitz", "CapitalMarket", "PerformanceEvaluation", "AssetParameters", "TwoAssetPortfolio", "Volatility", "Interpolation", "SolveFrontier"
		};
	String appClassName = appClassNames[0];
	Type[] appTypes = new Type[] {
			typeof (WebCab.Libraries.Finance.Portfolio.EasyOptimal), typeof (WebCab.Libraries.Finance.Portfolio.Markowitz), typeof (WebCab.Libraries.Finance.Portfolio.CapitalMarket), typeof (WebCab.Libraries.Finance.Portfolio.PerformanceEvaluation), typeof (WebCab.Libraries.Finance.Portfolio.AssetParameters), typeof (WebCab.Libraries.Finance.Portfolio.TwoAssetPortfolio), typeof (WebCab.Libraries.Finance.Portfolio.Volatility), typeof (WebCab.Libraries.Finance.Portfolio.Interpolation), typeof (WebCab.Libraries.Finance.Portfolio.SolveFrontier)
		};

	Type classType = null;
	
	if ((Object) Request["appClassName"] != null) {
		appClassName = Request["appClassName"];
	}
	
	int index = 0;
	for (index = 0; index < appClassNames.Length; index++)
		if (appClassNames[index].Equals(appClassName))
		{
			packageName = packageNames[index];
			classType = appTypes[index];
			break;
		}
	
	try {
		instance = classType.GetConstructor (new Type[0]).Invoke (new Object[0]);
	}
	catch (Exception e) {
		instance = null;
		%>Error instantiating <%=appClassName%>. Exception:<%=e.Message%><%
	}
	
	/*
	 * Inspect methods
	 */
	MethodInfo[] allMethods = classType.GetMethods(BindingFlags.Instance | BindingFlags.Public | BindingFlags.DeclaredOnly);
	MethodInfo[][] methods = null;
	bool[] overloaded = null; // true for every overloaded method name.
	String[] methodNames = null;
	int methodIndex = 0;
	int methodNumber = 0;
	
	if (allMethods.Length > 0) {
		ArrayList namesVector = new ArrayList(10);
		ArrayList methodsVector = new ArrayList(10);
		ArrayList allMethodsVector = new ArrayList(10);
		
		for (int i = 0; i < allMethods.Length; i++)allMethodsVector.Add(allMethods[i]);
		
		while (allMethodsVector.Count > 0) {
			ArrayList sameNameMethodsVector = new ArrayList(10);
			String methodName = ((MethodInfo) allMethodsVector[0]).Name;
			
			for (int i = 0; i < allMethodsVector.Count; i++)
				if (((MethodInfo) allMethodsVector[i]).Name.Equals(methodName)) {
					 /*
					 * Check if the method is acceptable
					 */
					MethodInfo m = (MethodInfo) allMethodsVector[i];
					if (m.ReturnType != Type.GetType("System.Void")) {
						Type[] types = new Type[m.GetParameters().Length];
							for (int typeIndex = 0; typeIndex < types.Length; typeIndex++)
								types[typeIndex] = m.GetParameters()[typeIndex].ParameterType;
						
						if (types.Length == 0)
							sameNameMethodsVector.Add(allMethodsVector[i]);
						else {
							int j = 0;
							for (j = 0; j < types.Length; j++)
								if (types[j] == Type.GetType("System.Char") || !types[j].IsPrimitive)
									break;
							
							if (j == types.Length)
								sameNameMethodsVector.Add(allMethodsVector[i]);
						}
					}
					
					allMethodsVector.RemoveAt(i);
					i--;
				}
			
			if (sameNameMethodsVector.Count > 0)
			{
				methodsVector.Add(sameNameMethodsVector);
				namesVector.Add(methodName);
			}
		}
		
		methods = new MethodInfo[methodsVector.Count][];
		overloaded = new bool[methods.Length];
		for (int i = 0; i < methods.Length; i++) {
			methods[i] = (MethodInfo[]) ((ArrayList) methodsVector[i]).ToArray (typeof (MethodInfo));
			System.Array.Sort(methods[i], new AnonymousClassComparator());
			
			MethodInfo[] mInfos = classType.GetMethods(BindingFlags.Instance | BindingFlags.Public | BindingFlags.DeclaredOnly);
			int howMany = 0;
			foreach (MethodInfo mInfo in mInfos) {
				if (mInfo.Name.Equals (methods[i][0].Name))
					howMany++;
			}
			if (howMany > 1)
				overloaded[i] = true;
			else
				overloaded[i] = false;
		}

		methodNames = (String[]) namesVector.ToArray(typeof (String));
	}
	
	if ((Object) Request["methodName"] != null)
		for (int i = 0; i < methodNames.Length; i++){
			if (methodNames[i].Equals(Request["methodName"])) {
				methodIndex = i;
				break;
			}
		}
	if ((Object) Request["methodNumber"] != null)
		try {
			methodNumber = Int32.Parse(Request["methodNumber"]);
		}
		catch (FormatException e)
		{
		}
	
	if (instance != null && methodNames != null && methodNames.Length > 0) {
		MethodInfo m = methods[methodIndex][methodNumber];
		Type[] types = new Type[m.GetParameters().Length];
			for (int typeIndex = 0; typeIndex < types.Length; typeIndex++)
				types[typeIndex] = m.GetParameters()[typeIndex].ParameterType;
		String parametersDisplayName = "(";
		String methodDisplayName = getPrimitiveTypeDisplayName (m.ReturnType) + " <B>" + m.Name + "</B>";
		String[] argNames = null;
		String[] argDescriptions = null;
		String methodDoc = null;
		
		for (int j = 0; j < types.Length; j++) {
			parametersDisplayName += getPrimitiveTypeName (types[j]);
			if (j < types.Length - 1)
				parametersDisplayName += ",";
		}

		parametersDisplayName += ")";
		
		String servletPath = Request.ApplicationPath + Request.ServerVariables["SCRIPT_NAME"];
		servletPath = servletPath.Substring(0, (servletPath.LastIndexOf("/")) - (0));
		servletPath = servletPath.Substring(0, (servletPath.LastIndexOf("/") + 1) - (0));
		String beanHTML = appClassName + "." + m.Name;
		
		/*
		 * The name of the HTML file which contains the overloaded method
		 * links might change (as it has in the 1.2 version).
		 */
		if (overloaded[methodIndex])
			beanHTML += "_overloads.html";
		else
			beanHTML += ".html";
	
		Uri javaDocsFile = new Uri("http://" + Request.ServerVariables["SERVER_NAME"] + ":" + Int32.Parse(Request.ServerVariables["SERVER_PORT"]) + servletPath + "HTMLDocs/" + beanHTML);

		Stream javaDocsInputStream = null;
		try {
			javaDocsInputStream = WebRequest.Create(javaDocsFile).GetResponse().GetResponseStream();
		}
		catch (Exception) {
		}
		
		// Find out the name of the HTML for the corresponding methodNumber method from
		// the HTML file which contains links to all overloaded methods.
		if (overloaded[methodIndex] && javaDocsInputStream != null) {
			StreamReader f = new StreamReader(new StreamReader(javaDocsInputStream).BaseStream, System.Text.Encoding.UTF7);
			String line = null;
			Stream newStream = null;
			
			while ((line = f.ReadLine()) != null) {
				string hrefString = "<a href=\"" + packageName + "." + appClassName + "." + m.Name;
				int hrefIndex = line.IndexOf (hrefString);
				
				if (hrefIndex != -1) {
					line = line.Substring (hrefIndex + hrefString.Length);
					hrefString = ".html\">";
					int methodNameIndex = line.IndexOf (hrefString);
					if (methodNameIndex != -1) {
						string htmlIndex = line.Substring (0, methodNameIndex);
						line = line.Substring (methodNameIndex + hrefString.Length);
						methodNameIndex = line.IndexOf (";");
						if (methodNameIndex != -1) {
							/*
							 * line contains the method declaration: public <returntype> <methodname> (<parameters)
							 */
							line = line.Substring (0, methodNameIndex);
							if (line.IndexOf (m.Name + parametersDisplayName) != -1) {
								beanHTML = appClassName + "." + m.Name + htmlIndex + ".html";
								javaDocsFile = new Uri("http://" + Request.ServerVariables["SERVER_NAME"] + ":" + Int32.Parse(Request.ServerVariables["SERVER_PORT"]) + servletPath + "HTMLDocs/" + beanHTML);
								try {
									newStream = WebRequest.Create(javaDocsFile).GetResponse().GetResponseStream();
								}
								catch (Exception) {
								}
								
								break;
							}
						}
					}
				}
			}

			try {f.Close ();}
			catch (Exception) {}

			javaDocsInputStream = newStream;
		}
				
		if (javaDocsInputStream != null) {
			StreamReader f = new StreamReader(new StreamReader(javaDocsInputStream).BaseStream, System.Text.Encoding.UTF7);
			String line = null;
			String summary = null;
			String remarks = null;
			int paramNo = 0;

			while ((line = f.ReadLine()) != null) {
				if (summary == null) {
					String summaryId = "</h1></div></div><div id=\"nstext\"><p>";
					if (line.IndexOf (summaryId) != -1) {
						line = line.Substring (line.IndexOf (summaryId) + summaryId.Length);
						summary = "";
					}
				}

				if (summary != null) {
					if (argNames == null) {
						String argNamesId = "</p><div class=\"syntax\"";
						if (line.IndexOf (argNamesId) != -1) {
							summary += line.Substring (0, line.IndexOf (argNamesId));
							line = line.Substring (line.IndexOf (argNamesId) + argNamesId.Length);
							argNames = new String[types.Length];
						}
					}
					
					if (argNames != null) {
						if (paramNo < types.Length) {
							String paramId = "<i>";
							while (line.IndexOf (paramId) != -1 && paramNo < types.Length) {
								line = line.Substring (line.IndexOf (paramId) + paramId.Length);
								paramId = "</i>";
								if (line.IndexOf (paramId) != -1) {
									argNames[paramNo++] = line.Substring (0, line.IndexOf (paramId));
									line = line.Substring (line.IndexOf (paramId) + paramId.Length);
									paramId = "<i>";
								}
							}
						}
						
						if (paramNo == types.Length) {
							if (argDescriptions == null && types.Length > 0) {
								String parametersId = "<h4 class=\"dtH4\">Parameters</h4><dl>";
								if (line.IndexOf (parametersId) != -1) {
									line = line.Substring (line.IndexOf (parametersId) + parametersId.Length);
									argDescriptions = new String[types.Length];
									for (int i = 0; i < types.Length; i++)
										argDescriptions[i] = "";
									int noParams = 0;

									// Populates the argDescriptions array by exhausting the file's
									// parameter descriptions. This way it makes sure all parameter
									// descriptions have been read before the Remarks section.
									String parameterId = "<dt><i>";
									while (noParams < types.Length && line.IndexOf (parameterId) != -1) {
										line = line.Substring (line.IndexOf (parameterId) + parameterId.Length);
										parameterId = "</i></dt><dd>";
										if (line.IndexOf (parameterId) != -1) {
											String argName = line.Substring (0, line.IndexOf (parameterId));
											line = line.Substring (line.IndexOf (parameterId) + parameterId.Length);

											// assuming parameter descriptions are not necessarily ordered, or
											// that not all parameters are necessarilly documented.
											for (int i = 0; i < argNames.Length; i++)
												if (argNames[i].Equals (argName)) {
													parameterId = "</dd>";
													argDescriptions[i] = "";
													while (line.IndexOf (parameterId) == -1) {
														argDescriptions[i] += line + "\n";
														line = f.ReadLine ();
													}

													argDescriptions[i] += line.Substring (0, line.IndexOf (parameterId));
													line = line.Substring (line.IndexOf (parameterId) + parameterId.Length);
													parameterId = "<dt><i>";
													noParams++;
													break;
												}
										}
									}
								}
							}
							
							if (remarks == null) {
								String remarksId = "<h4 class=\"dtH4\">Remarks</h4>";
								if (line.IndexOf (remarksId) != -1) {
									line = line.Substring (line.IndexOf (remarksId) + remarksId.Length);
									remarks = "";
								}
							}
							
							if (remarks != null) {
								String exceptionsId = "<h4 class=\"dtH4\">Exceptions</h4>";
								String seeAlsoId = "<h4 class=\"dtH4\">See Also</h4>";
								int remarksEndIndex = -1;
								if ((remarksEndIndex = line.IndexOf (exceptionsId)) != -1 ||
									(remarksEndIndex = line.IndexOf (seeAlsoId)) != -1) {
									remarks += line.Substring (0, remarksEndIndex);
									line = line.Substring (remarksEndIndex);

									break;
								}
								else {
									remarks += line + "\n";
								}
							}
						}
					}
					else {
						summary += line + "\n";
					}
				}
			}
			
			if (summary != null) {
				methodDoc = summary;
				if (remarks != null)
					methodDoc += "<h4>Remarks</h4>" + remarks;
			}
			
			if (argNames != null) {
				parametersDisplayName = "(";
				for (int i = 0; i < types.Length; i++) {
					parametersDisplayName += getPrimitiveTypeDisplayName (types[i]) + "&nbsp;" + argNames[i];
					if (i < types.Length - 1)
						parametersDisplayName += ", ";
				}
				parametersDisplayName += ")";
			}
			
			f.Close();
		}

		if (argDescriptions == null)
			argDescriptions = new String[types.Length];

		for (int i = 0; i < types.Length; i++)
			if (argDescriptions[i] == null)
				argDescriptions[i] = "";

		// Spec out all <a href="">...</a> tags.
		if (methodDoc != null) {
			String methodDocUpCase = methodDoc.ToUpper();
			int j = - 1;
			
			while ((j = methodDocUpCase.IndexOf("<A HREF")) != - 1)
			{
				methodDoc = methodDoc.Substring(0, (j) - (0)) + methodDoc.Substring(j + methodDoc.Substring(j).IndexOf(">") + 1);
				methodDocUpCase = methodDocUpCase.Substring(0, (j) - (0)) + methodDocUpCase.Substring(j + methodDocUpCase.Substring(j).IndexOf(">") + 1);
			}
			
			while ((j = methodDocUpCase.IndexOf("</A>")) != - 1)
			{
				methodDoc = methodDoc.Substring(0, (j) - (0)) + methodDoc.Substring(j + "</A>".Length);
				methodDocUpCase = methodDocUpCase.Substring(0, (j) - (0)) + methodDocUpCase.Substring(j + "</A>".Length);
			}
		}
	%>
	<form name="browserForm" method="POST" onSubmit="<%
		
		/*
		 * JavaScript check for real numbers input.
		 */
		for (int i = 0; i < types.Length; i++)
			if (types[i].FullName.Equals ("System.Byte") ||
			    types[i].FullName.Equals ("System.Int16") ||
			    types[i].FullName.Equals ("System.Int32") ||
			    types[i].FullName.Equals ("System.Int64") ||
			    types[i].FullName.Equals ("System.Single") ||
			    types[i].FullName.Equals ("System.Double")) {
			
				%>if (checkTextField (<%="arg_" + methodIndex + "_" + methodNumber + "_" + i%>) == false) return false;<%
			}

		%>">
		<h3><%=appClassName%> Class</h3>
		<input type="hidden" name="appClassName" value="<%=appClassName%>">
		<input type="hidden" name="methodName" value="<%=methodNames[methodIndex]%>">
		<input type="hidden" name="methodIndex" value="<%=methodIndex%>">
		<input type="hidden" name="methodNumber" value="<%=methodNumber%>">
		<table>
		<%
		String methodName = m.Name;
		
		%><tr><td><table><tr><td valign="top"><b><%=methodName%></b></td><td><%=parametersDisplayName%></td></tr></table></td></tr><%
		
		if (methodDoc != null) {
			%><tr><td><%=methodDoc%><p></td></tr><%
		}
		
		try {
			if (Request["result"] != null && Request["methodIndex"] != null && Request["methodNumber"] != null && methodIndex == Int32.Parse(Request["methodIndex"]) && methodNumber == Int32.Parse(Request["methodNumber"])) {
				Object[] o = new Object[types.Length];
				%><!--tr><td align="left"-->
				<tr><td align="left">
				<table border="0" cellspacing="0" cellpadding="2">
				<tr><td><b>&nbsp;</b></td><td><b>Method Results</b></td></tr>
				<tr><td>&nbsp;</td></tr>
				<%
				for (int i = 0; i < types.Length; i++) {
					String inputName = "_" + methodIndex + "_" + methodNumber + "_" + i;
					String argValue = Request["arg" + inputName];
					
					if ((Object) argValue == null)
						throw new Exception();
					
					try {
						if (types[i].FullName.Equals ("System.Boolean"))
							o[i] = argValue.ToUpper().Equals("TRUE");
						else if (types[i].FullName.Equals ("System.Byte"))
							o[i] = System.Byte.Parse(argValue);
						else if (types[i].FullName.Equals ("System.Int16"))
							o[i] = System.Int16.Parse(argValue);
						else if (types[i].FullName.Equals ("System.Int32"))
							o[i] = System.Int32.Parse(argValue);
						else if (types[i].FullName.Equals ("System.Int64"))
							o[i] = System.Int64.Parse(argValue);
						else if (types[i].FullName.Equals ("System.Single")) {
							o[i] = System.Single.Parse(argValue);
						}
						else if (types[i].FullName.Equals ("System.Double")) {
							o[i] = System.Double.Parse(argValue);
						}
						else if (types[i].FullName.Equals ("String"))
							o[i] = argValue;
						else
							throw new Exception();
					}
					catch (Exception e) {
						o[i] = null;
						%></table></td></tr><tr><td>Incorrect input values. Please check the input fields.</td></tr><%
						throw new Exception();
					}
					
					%><tr><td></td><td><%
					if (argNames != null) {
						%><%=argNames[i]%> <%
					}
					else {
						%><%=getPrimitiveTypeDisplayName (types[i])%><%
					}
					
					%></td><td> <code>=</code> </td><td>
					<%=o[i].ToString()%></td></tr><%
				}
				
				try {
					Type returnType = m.ReturnType;
					Object result = methods[methodIndex][methodNumber].Invoke(instance, (Object[]) o);
					
					%><tr><td></td><td><b><%=methodName%></b> </td><td> <code>=</code> </td><td align="right"><%
					
					if (result == null) {
						%>NULL<%
					}
					else {
						if (result.GetType().IsArray) {
							for (int i = 0; i < ((System.Array) result).Length; i++) {
								if (i > 0) {
									%></td></tr><tr><td></td><td></td><td></td><td align="right"><%
								}
								
								Object arrayElement = ((System.Array) result).GetValue(i);

								/* Format numbers to 4 decimal places.
								if (arrayElement is System.Single) {
									%><%=((System.Single) arrayElement).ToString("F4")%><%
								}
								else if (arrayElement is System.Double) {
									%><%=((System.Double) arrayElement).ToString("F4")%><%
								}
								else if (arrayElement is System.Decimal) {
									%><%=((System.Decimal) arrayElement).ToString("F4")%><%
								}
								else */{
									%><%=((System.Array) result).GetValue(i).ToString()%><%
								}
							}
						}
						else {
							/* Format numbers to 4 decimal places.
							if (result is System.Single) {
								%><%=((System.Single) result).ToString("F4")%><%
							}
							else if (result is System.Double) {
								%><%=((System.Double) result).ToString("F4")%><%
							}
							else if (result is System.Decimal) {
								%><%=((System.Decimal) result).ToString("F4")%><%
							}
							else */{
								%><%=result.ToString()%><%
							}
						}
					}
					
					%></td></tr></table><%
				}
				catch (Exception ex) {
					%><tr><td colspan="4" align="center"><b>Please input correct values</b></td></tr></table></td></tr><%
					if (ex is TargetInvocationException) {
						%><tr><td><%=ex.InnerException.Message%><%
					}
					else {
						%><tr><td><%=ex.Message%><%
					}
				}
				
				
				%></td></tr><%
				
				instance = null;
			}
		}
		catch (Exception) {
		}
		%>
		<tr><td><br>Values assigned to input values</td></tr>
		<tr><td><table width="350">
		<%
		for (int j = 0; j < types.Length; j++) {
			String inputName = "_" + methodIndex + "_" + methodNumber + "_" + j;
			String argValue = Request["arg" + inputName];
			
			if (argValue == null)
				argValue = "";

			%>
			<tr align="center" bgcolor="#eeeeee"><td>	<%
			if (argNames != null) {
				%><b><%=argNames[j]%></b><%
			}
			else {
				%><b><%=getPrimitiveTypeDisplayName (types[j])%></b><%
			}
			%></td></tr><%
			
			if (argDescriptions[j].Length > 0) {
				%><tr align="left"><td><%=argDescriptions[j]%></td></tr><%
			}
			
			%><tr><td align="center"><%
			
			if (types[j].FullName.Equals ("System.Boolean")) {
				%><SELECT NAME="arg<%=inputName%>">
								<OPTION<%
				if (argValue.Equals("True")) {
					%> SELECTED<%
				}
				
				%>>True</OPTION>
								<OPTION<%
				if (argValue.Equals("False")) {
					%> SELECTED<%
				}
				
				%>>False</OPTION>
							</SELECT><%
			}
			else {
				%><INPUT TYPE="text" size="8" NAME="arg<%=inputName%>" VALUE="<%=argValue%>"><%
			}
			
			
		%></td></tr><%
		}
		
	%></table></td></tr>
			<tr><td><table width="350"><tr><td align="right">
			<input type="submit" name="result" value="Get Result" ></td></tr>
			</table></td></tr>
		</table>
	</form>
	<%
	}
%>
<br>
</font>
</body>
</html>