using System;
using WebCab.Lib.Util.Example;

using WebCab.Libraries.Finance.Portfolio;

public class ForwardLookingClient {
   public static void Main( String[] args ) {
      // used components
      AssetParameters instanceOfAssetParameters = new AssetParameters();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "                    #########################################" );
      System.Console.WriteLine( "                    # ForwardLooking Console Client Example #" );
      System.Console.WriteLine( "                    #########################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    With this example we provide a Custom Example which illustrates  the" );
      System.Console.WriteLine( "    application of the Asset  Parameters  class  to  estimating  forward" );
      System.Console.WriteLine( "    looking properties of a collection of assets." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Expected Variance of the 1st Asset +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    covariance( double[] probability," );
      System.Console.WriteLine( "                double[] returns1," );
      System.Console.WriteLine( "                double[] returns2 )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the expected variance of the 1st Asset.  Note:  The" );
      System.Console.WriteLine( "     variance of an asset  is  just  the  covariance  of  an  asset  with" );
      System.Console.WriteLine( "     itself." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probability = {0.1, 0.7, 0.2}" );
      System.Console.WriteLine( "    returns1 = {100.0, 120.0, 130.0}" );
      System.Console.WriteLine( "    returns2 = {100.0, 120.0, 130.0}" );
      // Here we evaluated the expected variance of the 1st Asset.
      double variance1 = instanceOfAssetParameters.Covariance( 
         new double[] {0.1, 0.7, 0.2}, // probability
         new double[] {100.0, 120.0, 130.0}, // returns1
         new double[] {100.0, 120.0, 130.0} // returns2
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The expected variance of the 1st Asset is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( variance1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Expected Variance of the 2nd Asset +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    covariance( double[] probability," );
      System.Console.WriteLine( "                double[] returns1," );
      System.Console.WriteLine( "                double[] returns2 )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the expected variance of the 2nd Asset.  Note:  The" );
      System.Console.WriteLine( "     variance of an asset  is  just  the  covariance  of  an  asset  with" );
      System.Console.WriteLine( "     itself." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probability = {0.1, 0.7, 0.2}" );
      System.Console.WriteLine( "    returns1 = {120.0, 130.0, 140.0}" );
      System.Console.WriteLine( "    returns2 = {120.0, 130.0, 140.0}" );
      // Here we evaluated the expected variance of the 1st Asset.
      double variance2 = instanceOfAssetParameters.Covariance( 
         new double[] {0.1, 0.7, 0.2}, // probability
         new double[] {120.0, 130.0, 140.0}, // returns1
         new double[] {120.0, 130.0, 140.0} // returns2
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The expected variance of the 2nd Asset is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( variance2 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Expected Variance of the 3rd Asset +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    covariance( double[] probability," );
      System.Console.WriteLine( "                double[] returns1," );
      System.Console.WriteLine( "                double[] returns2 )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the expected variance of the 3rd Asset.  Note:  The" );
      System.Console.WriteLine( "     variance of an asset  is  just  the  covariance  of  an  asset  with" );
      System.Console.WriteLine( "     itself." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probability = {0.1, 0.7, 0.2}" );
      System.Console.WriteLine( "    returns1 = {200.0, 150.0, 140.0}" );
      System.Console.WriteLine( "    returns2 = {200.0, 150.0, 140.0}" );
      // Here we evaluated the expected variance of the 3rd Asset.
      double variance3 = instanceOfAssetParameters.Covariance( 
         new double[] {0.1, 0.7, 0.2}, // probability
         new double[] {200.0, 150.0, 140.0}, // returns1
         new double[] {200.0, 150.0, 140.0} // returns2
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The expected variance of the 3rd Asset is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( variance3 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Expected Return of the 1st Asset +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn( double[] probability," );
      System.Console.WriteLine( "                    double[] returns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the expected return of the 1st asset.  Note:  Since" );
      System.Console.WriteLine( "     the returns of the assets  are  given  as  absolute  values  of  the" );
      System.Console.WriteLine( "     expected returns evaluate will also  be  given  in  absolute  values" );
      System.Console.WriteLine( "     rather than in relative (i.e. percentage) terms." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probability = {0.1, 0.7, 0.2}" );
      System.Console.WriteLine( "    returns = {100.0, 120.0, 130.0}" );
      // Here we evaluated the expected return of the 1st Asset.
      double expectedReturn1 = instanceOfAssetParameters.ExpectedReturn( 
         new double[] {0.1, 0.7, 0.2}, // probability
         new double[] {100.0, 120.0, 130.0} // returns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The expected return of the 1st Asset is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( expectedReturn1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Expected Return of the 2nd Asset +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn( double[] probability," );
      System.Console.WriteLine( "                    double[] returns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the expected return of the 2nd asset.  Note:  Since" );
      System.Console.WriteLine( "     the returns of the assets  are  given  as  absolute  values  of  the" );
      System.Console.WriteLine( "     expected returns evaluate will also  be  given  in  absolute  values" );
      System.Console.WriteLine( "     rather than in relative (i.e. percentage) terms." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probability = {0.1, 0.7, 0.2}" );
      System.Console.WriteLine( "    returns = {120.0, 130.0, 140.0}" );
      // Here we evaluated the expected return of the 2nd Asset.
      double expectedReturn2 = instanceOfAssetParameters.ExpectedReturn( 
         new double[] {0.1, 0.7, 0.2}, // probability
         new double[] {120.0, 130.0, 140.0} // returns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The expected return of the 2nd Asset is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( expectedReturn2 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Expected Return of the 3rd Asset +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn( double[] probability," );
      System.Console.WriteLine( "                    double[] returns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the expected return of the 1st asset.  Note:  Since" );
      System.Console.WriteLine( "     the returns of the assets  are  given  as  absolute  values  of  the" );
      System.Console.WriteLine( "     expected returns evaluate will also  be  given  in  absolute  values" );
      System.Console.WriteLine( "     rather than in relative (i.e. percentage) terms." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probability = {0.1, 0.7, 0.2}" );
      System.Console.WriteLine( "    returns = {200.0, 150.0, 140.0}" );
      // Here we evaluated the expected return of the 3rd Asset.
      double expectedReturn3 = instanceOfAssetParameters.ExpectedReturn( 
         new double[] {0.1, 0.7, 0.2}, // probability
         new double[] {200.0, 150.0, 140.0} // returns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The expected return of the 3rd Asset is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( expectedReturn3 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Covariance between the 1st and 2nd Asset +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    covariance( double[] probability," );
      System.Console.WriteLine( "                double[] returns1," );
      System.Console.WriteLine( "                double[] returns2 )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the Covariance between the 1st and 2nd Asset." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probability = {0.1, 0.7, 0.2}" );
      System.Console.WriteLine( "    returns1 = {100.0, 120.0, 130.0}" );
      System.Console.WriteLine( "    returns2 = {120.0, 130.0, 140.0}" );
      // Here we evaluate the Covariance between the 1st and 2nd Asset.
      double covariance1 = instanceOfAssetParameters.Covariance( 
         new double[] {0.1, 0.7, 0.2}, // probability
         new double[] {100.0, 120.0, 130.0}, // returns1
         new double[] {120.0, 130.0, 140.0} // returns2
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The Covariance between the 1st and 2nd Asset is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( covariance1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Expected Return of Portfolio with equal weighting  between  the  three +" );
      System.Console.WriteLine( "+ available Assets                                                       +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    portfolioExpectedReturn( double[] weights," );
      System.Console.WriteLine( "                             double[] expectedReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the expected return  of  the  portfolio  where  the" );
      System.Console.WriteLine( "     expected      returns  of  the  three  assets  are:  120.  131,  153" );
      System.Console.WriteLine( "     respectively, and each of the assets has equal weight of 1/3." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    weights = {120.0, 131.0, 153.0}" );
      System.Console.WriteLine( "    expectedReturns = {0.3333, 0.3333, 0.3333}" );
      // Here we evaluate the expected return of the portfolio.
      double portExpectedReturn1 = instanceOfAssetParameters.PortfolioExpectedReturn( 
         new double[] {120.0, 131.0, 153.0}, // weights
         new double[] {0.3333, 0.3333, 0.3333} // expectedReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The expected return of the portfolio is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( portExpectedReturn1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Risk of Portfolio with equal weighting  between  the  three  available +" );
      System.Console.WriteLine( "+ Assets                                                                 +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    portfolioRisk( double[] weight," );
      System.Console.WriteLine( "                   double[][] covarianceMatrix )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the risk of  the  portfolio  constructed  by  given" );
      System.Console.WriteLine( "     equal weighting to the three available assets." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    weight = {0.3333, 0.3333, 0.3333}" );
      System.Console.WriteLine( "    covarianceMatrix = covarianceMatrixPort1" );
      // Here we evaluate the covariance matrix of the three assets.
      double[][] covarianceMatrixPort1 = instanceOfAssetParameters.CovarianceMatrix( 
         new double[] {0.1, 0.7, 0.2}, // probability
         new double[][] {new double[] {100.0, 120.0, 130.0},
                         new double[] {120.0, 130.0, 140.0},
                         new double[] {200.0, 150.0, 140.0}} // returns
      );
      // Here we evaluate the risk of the portfolio constructed by given  equal
      // weighting to the three available assets.
      double portRisk1 = instanceOfAssetParameters.PortfolioRisk( 
         new double[] {0.3333, 0.3333, 0.3333}, // weight
         covarianceMatrixPort1 // covarianceMatrix
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The risk of the portfolio  with  equal  weighting  between  the  three" );
      System.Console.WriteLine( "    available assets is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( portRisk1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Variance of Returns of the Portfolio with equal +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    portfolioVariance( double[] weight," );
      System.Console.WriteLine( "                       double[][] covarianceMatrix )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the variance of the portfolio with equal  weighting" );
      System.Console.WriteLine( "     between the three available assets." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    weight = {0.3333, 0.3333, 0.3333}" );
      System.Console.WriteLine( "    covarianceMatrix = covarianceMatrixPort2" );
      // Here we evaluate the covariance matrix of the three assets.
      double[][] covarianceMatrixPort2 = instanceOfAssetParameters.CovarianceMatrix( 
         new double[] {0.1, 0.7, 0.2}, // probability
         new double[][] {new double[] {100.0, 120.0, 130.0},
                         new double[] {120.0, 130.0, 140.0},
                         new double[] {200.0, 150.0, 140.0}} // returns
      );
      // Here we evaluate the variance of the portfolio  with  equal  weighting
      // between the three available assets.
      double variancePort1 = instanceOfAssetParameters.PortfolioVariance( 
         new double[] {0.3333, 0.3333, 0.3333}, // weight
         covarianceMatrixPort2 // covarianceMatrix
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The variance of the portfolio with equal weighting between  the  three" );
      System.Console.WriteLine( "    available assets is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( variancePort1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }

   public static String double2String( double d ) {
      if ( System.Double.IsNaN( d ) ) return d.ToString();
      if ( System.Double.IsNegativeInfinity( d ) ) return d.ToString();
      if ( System.Double.IsPositiveInfinity( d ) ) return d.ToString();
      if ( d == Double.MinValue ) return d.ToString();
      if ( d == Double.MaxValue ) return d.ToString();
      double frac = d - ( int )d;
      double frac4 = ( int )( frac * 10000 ) / 10000.0;
      return "" + ( ( int )d + frac4 );
   }

   public static void displayArray( double[] a ) {
      System.Console.Write( "     {" );
      for ( int i = 0; i < a.Length; i ++ ) {
         System.Console.Write( double2String( a[ i ] ) );
         if ( i < -1 + a.Length ) {
            System.Console.Write( ", " );
         }
      }
      System.Console.Write( "}" );
   }

   public static void display2DArray( double[][] a ) {
      for ( int i = 0; i < a.Length; i ++ ) {
         if ( i == 0 ) {
            System.Console.Write( "     {{" );
         } else {
            System.Console.Write( "     {" );
         }
         for ( int j = 0; j < a[ i ].Length; j ++ ) {
            System.Console.Write( double2String( a[ i ][ j ] ) );
            if ( j < -1 + a[ i ].Length ) {
               System.Console.Write( ", " );
            } else {
               System.Console.Write( "}" );
            }
         }
         if ( i < -1 + a.Length ) {
            System.Console.Write( ",\n " );
         } else {
            System.Console.Write( "}" );
         }
      }
   }
}
