using System;
using WebCab.Lib.Util.Example;

using WebCab.Libraries.Finance.Portfolio;

public class SolveFrontierClient {
   public static void Main( String[] args ) {
      // used components
      SolveFrontier instanceOfSolveFrontier = new SolveFrontier();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "                     ########################################" );
      System.Console.WriteLine( "                     # SolveFrontier Console Client Example #" );
      System.Console.WriteLine( "                     ########################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Within this client we provide an example for  each  of  the  methods" );
      System.Console.WriteLine( "    within Solve Frontier." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Risk of Portfolios on  the  Efficient  Forntier  with  given  expected +" );
      System.Console.WriteLine( "+ returns                                                                +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    findRisk( double expectedReturn," );
      System.Console.WriteLine( "              double[] riskPoints," );
      System.Console.WriteLine( "              double[] returnPoints )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What of the risk of the portfolios on the Efficient  Frontier  which" );
      System.Console.WriteLine( "     is given by the following points:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - Risk = 0, Expected Return = 3 percent" );
      System.Console.WriteLine( "        - Risk = 10 percent, Expected Return = 4 percent" );
      System.Console.WriteLine( "        - Risk = 20 percent, Expected Return = 5 percent" );
      System.Console.WriteLine( "        - Risk = 40 percent, Expected Return = 10 percent" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     for the following values of the expected return 3.5, 4.5, 5.5,  6.5," );
      System.Console.WriteLine( "     7.5 percent?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn = 0.035" );
      System.Console.WriteLine( "    riskPoints = {0.0, 0.1, 0.2, 0.4}" );
      System.Console.WriteLine( "    returnPoints = {0.03, 0.04, 0.05, 0.1}" );
      double findRisk1 = instanceOfSolveFrontier.FindRisk( 
         0.035, // expectedReturn
         new double[] {0.0, 0.1, 0.2, 0.4}, // riskPoints
         new double[] {0.03, 0.04, 0.05, 0.1} // returnPoints
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" );
      System.Console.WriteLine( "    return of 3.5 percent is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( findRisk1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Risk of Portfolios on  the  Efficient  Forntier  with  given  expected +" );
      System.Console.WriteLine( "+ returns                                                                +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    findRisk( double expectedReturn," );
      System.Console.WriteLine( "              double[] riskPoints," );
      System.Console.WriteLine( "              double[] returnPoints )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn = 0.045" );
      System.Console.WriteLine( "    riskPoints = {0.0, 0.1, 0.2, 0.4}" );
      System.Console.WriteLine( "    returnPoints = {0.03, 0.04, 0.05, 0.1}" );
      double findRisk2 = instanceOfSolveFrontier.FindRisk( 
         0.045, // expectedReturn
         new double[] {0.0, 0.1, 0.2, 0.4}, // riskPoints
         new double[] {0.03, 0.04, 0.05, 0.1} // returnPoints
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" );
      System.Console.WriteLine( "    return of 4.5 percent is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( findRisk2 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Risk of Portfolios on  the  Efficient  Forntier  with  given  expected +" );
      System.Console.WriteLine( "+ returns                                                                +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    findRisk( double expectedReturn," );
      System.Console.WriteLine( "              double[] riskPoints," );
      System.Console.WriteLine( "              double[] returnPoints )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn = 0.055" );
      System.Console.WriteLine( "    riskPoints = {0.0, 0.1, 0.2, 0.4}" );
      System.Console.WriteLine( "    returnPoints = {0.03, 0.04, 0.05, 0.1}" );
      double findRisk3 = instanceOfSolveFrontier.FindRisk( 
         0.055, // expectedReturn
         new double[] {0.0, 0.1, 0.2, 0.4}, // riskPoints
         new double[] {0.03, 0.04, 0.05, 0.1} // returnPoints
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" );
      System.Console.WriteLine( "    return of 5.5 percent is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( findRisk3 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Risk of Portfolios on  the  Efficient  Forntier  with  given  expected +" );
      System.Console.WriteLine( "+ returns                                                                +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    findRisk( double expectedReturn," );
      System.Console.WriteLine( "              double[] riskPoints," );
      System.Console.WriteLine( "              double[] returnPoints )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn = 0.065" );
      System.Console.WriteLine( "    riskPoints = {0.0, 0.1, 0.2, 0.4}" );
      System.Console.WriteLine( "    returnPoints = {0.03, 0.04, 0.05, 0.1}" );
      double findRisk4 = instanceOfSolveFrontier.FindRisk( 
         0.065, // expectedReturn
         new double[] {0.0, 0.1, 0.2, 0.4}, // riskPoints
         new double[] {0.03, 0.04, 0.05, 0.1} // returnPoints
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" );
      System.Console.WriteLine( "    return of 6.5 percent is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( findRisk4 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Risk of Portfolios on  the  Efficient  Forntier  with  given  expected +" );
      System.Console.WriteLine( "+ returns                                                                +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    findRisk( double expectedReturn," );
      System.Console.WriteLine( "              double[] riskPoints," );
      System.Console.WriteLine( "              double[] returnPoints )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn = 0.075" );
      System.Console.WriteLine( "    riskPoints = {0.0, 0.1, 0.2, 0.4}" );
      System.Console.WriteLine( "    returnPoints = {0.03, 0.04, 0.05, 0.1}" );
      double findRisk5 = instanceOfSolveFrontier.FindRisk( 
         0.075, // expectedReturn
         new double[] {0.0, 0.1, 0.2, 0.4}, // riskPoints
         new double[] {0.03, 0.04, 0.05, 0.1} // returnPoints
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" );
      System.Console.WriteLine( "    return of 7.5 percent is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( findRisk5 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Risk of Optimal Portfolios +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    findRisk( double[] riskUtility," );
      System.Console.WriteLine( "              double[] returnUtility," );
      System.Console.WriteLine( "              double[] riskPoints," );
      System.Console.WriteLine( "              double[] returnPoints," );
      System.Console.WriteLine( "              double precision )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     For a collection of assets  we  know  that  the  Efficient  Frontier" );
      System.Console.WriteLine( "     passes through the follow four points:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - Risk = 0, Expected Return = 3 percent" );
      System.Console.WriteLine( "        - Risk = 10 percent, Expected Return = 4 percent" );
      System.Console.WriteLine( "        - Risk = 20 percent, Expected Return = 5 percent" );
      System.Console.WriteLine( "        - Risk = 40 percent, Expected Return = 10 percent" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     If we also know that a given investor is prepared  to  accepted  the" );
      System.Console.WriteLine( "     following levels of risk for the corresponds levels of reward:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - Expected Return = 2 percent, Maximum Risk that will accept  for" );
      System.Console.WriteLine( "        this level of return = 0" );
      System.Console.WriteLine( "        - Expected Return = 4 percent, Maximum Risk that will accept  for" );
      System.Console.WriteLine( "        this level of return = 8 percent" );
      System.Console.WriteLine( "        - Expected Return = 5 percent, Maximum Risk that will accept  for" );
      System.Console.WriteLine( "        this level of return = 30 percent" );
      System.Console.WriteLine( "        - Expected Return = 6 percent, Maximum Risk that will accept  for" );
      System.Console.WriteLine( "        this level of return = 40 percent" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     assuming that the  investors  increase  in  required  return  varies" );
      System.Console.WriteLine( "     smoothly with the risk, what is the value of the risk (to 2  decimal" );
      System.Console.WriteLine( "     places)   of  the  optimal  portfolio  constructed  from  the  given" );
      System.Console.WriteLine( "     collection of assets?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    riskUtility = {0.0, 0.08, 0.03, 0.04}" );
      System.Console.WriteLine( "    returnUtility = {0.02, 0.04, 0.05, 0.06}" );
      System.Console.WriteLine( "    riskPoints = {0.0, 0.1, 0.2, 0.4}" );
      System.Console.WriteLine( "    returnPoints = {0.03, 0.04, 0.05, 0.1}" );
      System.Console.WriteLine( "    precision = 0.001" );
      double findRisk6 = instanceOfSolveFrontier.FindRisk( 
         new double[] {0.0, 0.08, 0.03, 0.04}, // riskUtility
         new double[] {0.02, 0.04, 0.05, 0.06}, // returnUtility
         new double[] {0.0, 0.1, 0.2, 0.4}, // riskPoints
         new double[] {0.03, 0.04, 0.05, 0.1}, // returnPoints
         0.001 // precision
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The risk of the optimal portfolio is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( findRisk6 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Return of the Portfolios  on  the  Efficient  Frontier  with  a  given +" );
      System.Console.WriteLine( "+ expected return                                                        +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    findReturn( double risk," );
      System.Console.WriteLine( "                double[] riskAtPoints," );
      System.Console.WriteLine( "                double[] returnAtPoints )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What of the expected return  of  the  portfolios  on  the  Efficient" );
      System.Console.WriteLine( "     Frontier which is given by the following points:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - Risk = 0, Expected Return = 3 percent" );
      System.Console.WriteLine( "        - Risk = 10 percent, Expected Return = 4 percent" );
      System.Console.WriteLine( "        - Risk = 20 percent, Expected Return = 5 percent" );
      System.Console.WriteLine( "        - Risk = 40 percent, Expected Return = 10 percent" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     for the following values of the risk 5, 15, 25, 35, 45 percent?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    risk = 0.05" );
      System.Console.WriteLine( "    riskAtPoints = {0.0, 0.1, 0.2, 0.4}" );
      System.Console.WriteLine( "    returnAtPoints = {0.03, 0.04, 0.05, 0.1}" );
      double findReturn1 = instanceOfSolveFrontier.FindReturn( 
         0.05, // risk
         new double[] {0.0, 0.1, 0.2, 0.4}, // riskAtPoints
         new double[] {0.03, 0.04, 0.05, 0.1} // returnAtPoints
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" );
      System.Console.WriteLine( "    return of 5 percent is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( findReturn1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Return of the Portfolios  on  the  Efficient  Frontier  with  a  given +" );
      System.Console.WriteLine( "+ expected return                                                        +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    findReturn( double risk," );
      System.Console.WriteLine( "                double[] riskAtPoints," );
      System.Console.WriteLine( "                double[] returnAtPoints )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    risk = 0.15" );
      System.Console.WriteLine( "    riskAtPoints = {0.0, 0.1, 0.2, 0.4}" );
      System.Console.WriteLine( "    returnAtPoints = {0.03, 0.04, 0.05, 0.1}" );
      double findReturn2 = instanceOfSolveFrontier.FindReturn( 
         0.15, // risk
         new double[] {0.0, 0.1, 0.2, 0.4}, // riskAtPoints
         new double[] {0.03, 0.04, 0.05, 0.1} // returnAtPoints
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" );
      System.Console.WriteLine( "    return of 15 percent is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( findReturn2 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Return of the Portfolios  on  the  Efficient  Frontier  with  a  given +" );
      System.Console.WriteLine( "+ expected return                                                        +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    findReturn( double risk," );
      System.Console.WriteLine( "                double[] riskAtPoints," );
      System.Console.WriteLine( "                double[] returnAtPoints )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    risk = 0.25" );
      System.Console.WriteLine( "    riskAtPoints = {0.0, 0.1, 0.2, 0.4}" );
      System.Console.WriteLine( "    returnAtPoints = {0.03, 0.04, 0.05, 0.1}" );
      double findReturn3 = instanceOfSolveFrontier.FindReturn( 
         0.25, // risk
         new double[] {0.0, 0.1, 0.2, 0.4}, // riskAtPoints
         new double[] {0.03, 0.04, 0.05, 0.1} // returnAtPoints
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" );
      System.Console.WriteLine( "    return of 25 percent is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( findReturn3 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Return of the Portfolios  on  the  Efficient  Frontier  with  a  given +" );
      System.Console.WriteLine( "+ expected return                                                        +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    findReturn( double risk," );
      System.Console.WriteLine( "                double[] riskAtPoints," );
      System.Console.WriteLine( "                double[] returnAtPoints )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    risk = 0.35" );
      System.Console.WriteLine( "    riskAtPoints = {0.0, 0.1, 0.2, 0.4}" );
      System.Console.WriteLine( "    returnAtPoints = {0.03, 0.04, 0.05, 0.1}" );
      double findReturn4 = instanceOfSolveFrontier.FindReturn( 
         0.35, // risk
         new double[] {0.0, 0.1, 0.2, 0.4}, // riskAtPoints
         new double[] {0.03, 0.04, 0.05, 0.1} // returnAtPoints
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" );
      System.Console.WriteLine( "    return of 35 percent is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( findReturn4 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Return of the Portfolios  on  the  Efficient  Frontier  with  a  given +" );
      System.Console.WriteLine( "+ expected return                                                        +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    findReturn( double risk," );
      System.Console.WriteLine( "                double[] riskAtPoints," );
      System.Console.WriteLine( "                double[] returnAtPoints )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    risk = 0.45" );
      System.Console.WriteLine( "    riskAtPoints = {0.0, 0.1, 0.2, 0.4}" );
      System.Console.WriteLine( "    returnAtPoints = {0.03, 0.04, 0.05, 0.1}" );
      double findReturn5 = instanceOfSolveFrontier.FindReturn( 
         0.45, // risk
         new double[] {0.0, 0.1, 0.2, 0.4}, // riskAtPoints
         new double[] {0.03, 0.04, 0.05, 0.1} // returnAtPoints
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" );
      System.Console.WriteLine( "    return of 45 percent is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( findReturn5 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Value of the Expected Return of the Optimal Portfolio +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    findReturn( double[] riskUtility," );
      System.Console.WriteLine( "                double[] returnUtility," );
      System.Console.WriteLine( "                double[] riskAtPoints," );
      System.Console.WriteLine( "                double[] returnAtPoints," );
      System.Console.WriteLine( "                double precision )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     For a collection of assets  we  know  that  the  Efficient  Frontier" );
      System.Console.WriteLine( "     passes through the follow four points:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - Risk = 0, Expected Return = 3 percent" );
      System.Console.WriteLine( "        - Risk = 10 percent, Expected Return = 4 percent" );
      System.Console.WriteLine( "        - Risk = 20 percent, Expected Return = 5 percent" );
      System.Console.WriteLine( "        - Risk = 40 percent, Expected Return = 10 percent" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     If we also know that a given investor is prepared  to  accepted  the" );
      System.Console.WriteLine( "     following levels of risk for the corresponds levels of reward:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - Expected Return = 2 percent, Maximum Risk that will accept  for" );
      System.Console.WriteLine( "        this level of return = 0" );
      System.Console.WriteLine( "        - Expected Return = 4 percent, Maximum Risk that will accept  for" );
      System.Console.WriteLine( "        this level of return = 8 percent" );
      System.Console.WriteLine( "        - Expected Return = 5 percent, Maximum Risk that will accept  for" );
      System.Console.WriteLine( "        this level of return = 30 percent" );
      System.Console.WriteLine( "        - Expected Return = 6 percent, Maximum Risk that will accept  for" );
      System.Console.WriteLine( "        this level of return = 40 percent" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     also assuming that the investors increase in required return  varies" );
      System.Console.WriteLine( "     smoothly with the risk, what is the value  of  the  expected  return" );
      System.Console.WriteLine( "     (to 2 decimal places) of the optimal portfolio constructed from  the" );
      System.Console.WriteLine( "     given collection of assets?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    riskUtility = {0.01, 0.08, 0.03, 0.04}" );
      System.Console.WriteLine( "    returnUtility = {0.02, 0.04, 0.05, 0.06}" );
      System.Console.WriteLine( "    riskAtPoints = {0.0, 0.1, 0.2, 0.4}" );
      System.Console.WriteLine( "    returnAtPoints = {0.03, 0.04, 0.05, 0.1}" );
      System.Console.WriteLine( "    precision = 0.001" );
      double findReturn6 = instanceOfSolveFrontier.FindReturn( 
         new double[] {0.01, 0.08, 0.03, 0.04}, // riskUtility
         new double[] {0.02, 0.04, 0.05, 0.06}, // returnUtility
         new double[] {0.0, 0.1, 0.2, 0.4}, // riskAtPoints
         new double[] {0.03, 0.04, 0.05, 0.1}, // returnAtPoints
         0.001 // precision
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The expected return of the optimal portfolio is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( findReturn6 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }

   public static String double2String( double d ) {
      if ( System.Double.IsNaN( d ) ) return d.ToString();
      if ( System.Double.IsNegativeInfinity( d ) ) return d.ToString();
      if ( System.Double.IsPositiveInfinity( d ) ) return d.ToString();
      if ( d == Double.MinValue ) return d.ToString();
      if ( d == Double.MaxValue ) return d.ToString();
      double frac = d - ( int )d;
      double frac4 = ( int )( frac * 10000 ) / 10000.0;
      return "" + ( ( int )d + frac4 );
   }

   public static void displayArray( double[] a ) {
      System.Console.Write( "     {" );
      for ( int i = 0; i < a.Length; i ++ ) {
         System.Console.Write( double2String( a[ i ] ) );
         if ( i < -1 + a.Length ) {
            System.Console.Write( ", " );
         }
      }
      System.Console.Write( "}" );
   }

   public static void display2DArray( double[][] a ) {
      for ( int i = 0; i < a.Length; i ++ ) {
         if ( i == 0 ) {
            System.Console.Write( "     {{" );
         } else {
            System.Console.Write( "     {" );
         }
         for ( int j = 0; j < a[ i ].Length; j ++ ) {
            System.Console.Write( double2String( a[ i ][ j ] ) );
            if ( j < -1 + a[ i ].Length ) {
               System.Console.Write( ", " );
            } else {
               System.Console.Write( "}" );
            }
         }
         if ( i < -1 + a.Length ) {
            System.Console.Write( ",\n " );
         } else {
            System.Console.Write( "}" );
         }
      }
   }
}
