Imports System
Imports Microsoft.VisualBasic
Imports WebCab.Lib.Util.Example
Imports WebCab.Libraries.Finance.Portfolio

Module DOWOptimalClient
   Sub Main()
      ' used components
      Dim instanceOfAssetParameters As AssetParameters = New AssetParameters
      Dim instanceOfCapitalMarket As WebCab.Libraries.Finance.Portfolio.CapitalMarket = New WebCab.Libraries.Finance.Portfolio.CapitalMarket
      '
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "                      #####################################" )
      System.Console.WriteLine( "                      # DOWOptimal Console Client Example #" )
      System.Console.WriteLine( "                      #####################################" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " Overview" )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ We first evaluate the covariance of the asset being considered +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covarianceMatrix( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "        DD: E.I. Du Pont De Nemours" )
      System.Console.WriteLine( "        We  first  evaluate  the  covariance  matrix  of  the  historical" )
      System.Console.WriteLine( "        returns from which the portfolios can be constructed." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {{9.41, 9.81, 10.67, 11.07, 12.0, 11.81, 11.18, 12.33, 12.33, 12.39, 11.92, 10.68, 11.15, 12.38, 13.15, 13.27, 14.09, 16.01, 17.76, 16.81, 17.41, 16.64, 19.04, 18.81, 18.9899, 22.09, 24.31, 24.19, 26.37, 29.14, 30.28, 28.3, 26.27, 33.21, 36.22, 39.24, 41.44, 41.5, 44.52, 44.43, 41.17, 46.65, 40.85, 42.84, 46.04, 54.51, 55.78, 66.9599, 53.04, 47.22, 54.8, 53.71, 55.9, 55.96, 53.65, 46.25, 46.78, 44.11, 50.7299, 51.71, 55.28, 48.75, 49.22, 50.43, 50.44, 47.63, 54.56, 46.9, 48.39, 50.25, 53.91, 56.33, 58.71, 60.7, 60.07, 54.74, 53.02, 53.98, 48.26, 52.48, 48.38, 52.62, 52.96, 49.7, 47.04, 47.29, 51.29, 55.52, 51.86, 52.99, 55.2, 58.42, 55.14, 58.3, 55.02, 52.55, 53.35, 59.0, 59.26, 56.59, 55.46, 52.25, 52.76, 52.54, 53.07, 53.79, 51.93, 52.82, 54.05}," )
      System.Console.WriteLine( "                        {10.18, 10.43, 11.49, 11.44, 11.47, 10.68, 10.97, 11.75, 11.16, 11.34, 12.3, 12.32, 13.34, 13.96, 13.32, 13.89, 14.63, 14.98, 17.59, 16.54, 16.4899, 14.68, 13.71, 14.34, 15.57, 15.25, 14.31, 16.11, 14.61, 13.89, 14.6, 12.81, 15.19, 16.95, 16.09, 16.15, 18.1, 17.9, 18.2, 27.51, 24.46, 27.52, 26.63, 28.9, 27.78, 27.2, 29.52, 37.4, 31.41, 31.09, 31.88, 29.44, 26.73, 26.53, 27.67, 30.55, 23.2399, 26.35, 26.0, 30.9, 34.03, 33.13, 33.3, 38.35, 40.12, 37.19, 36.47, 35.58, 28.94, 30.25, 36.19, 33.33, 33.61, 35.38, 35.54, 32.05, 33.09, 31.36, 25.73, 23.87, 18.36, 20.9899, 24.46, 21.81, 18.93, 19.78, 18.7, 22.27, 23.91, 24.77, 26.98, 27.9, 25.55, 30.84, 32.2, 37.3, 33.55, 36.94, 34.2, 30.31, 31.01, 32.72, 31.73, 32.2299, 33.43, 32.35, 33.9799, 31.41, 30.38}," )
      System.Console.WriteLine( "                        {8.02, 8.33, 8.22, 7.66, 7.93, 8.71, 8.07, 8.4, 9.52, 10.63, 11.75, 11.85, 13.8, 14.13, 12.65, 14.63, 14.61, 16.75, 19.23, 16.98, 18.26, 18.8299, 20.54, 21.75, 20.0, 22.56, 24.3299, 24.92, 24.94, 24.69, 27.49, 18.14, 15.33, 19.37, 20.71, 20.48, 23.26, 24.37, 26.5, 31.24, 27.64, 29.72, 27.99, 27.92, 27.64, 34.21, 33.97, 35.12, 35.94, 32.75, 37.9, 37.47, 39.49, 38.26, 44.77, 49.61, 45.94, 44.72, 42.44, 43.5, 47.69, 42.01, 38.42, 41.9799, 43.9, 45.26, 43.01, 39.35, 34.8, 39.11, 41.3, 43.53, 41.01, 39.15, 42.84, 37.46, 37.51, 33.6599, 29.14, 30.67, 27.77, 34.78, 36.59, 33.12, 32.51, 31.56, 32.61, 37.15, 39.03, 40.72, 42.95, 41.56, 43.63, 45.78, 45.43, 46.88, 48.18, 48.94, 50.35, 47.22, 45.59, 45.6599, 43.69, 46.1599, 43.72, 44.37, 44.75, 48.18, 48.93}," )
      System.Console.WriteLine( "                        {25.18, 26.12, 26.6, 25.35, 25.94, 26.78, 26.36, 27.56, 30.16, 27.76, 32.01, 30.44, 31.73, 31.98, 32.8, 36.72, 40.28, 44.31, 46.42, 48.13, 44.71, 42.6599, 39.9099, 40.37, 40.17, 45.6599, 46.08, 47.87, 46.18, 44.4799, 41.01, 35.51, 37.62, 38.24, 42.07, 39.14, 37.09, 39.01, 39.34, 55.39, 47.2299, 51.63, 50.7299, 49.0, 47.42, 48.15, 40.37, 40.96, 37.18, 30.71, 34.55, 34.83, 33.78, 29.92, 30.37, 32.78, 27.64, 31.61, 35.44, 42.6599, 40.17, 37.79, 40.32, 45.93, 49.55, 45.79, 50.74, 46.05, 41.26, 41.49, 44.0, 48.4799, 47.0, 51.88, 53.14, 51.37, 49.1599, 46.04, 42.39, 41.38, 35.29, 39.09, 47.75, 43.75, 42.4, 45.31, 47.43, 51.05, 50.61, 54.02, 65.87, 70.13, 67.2099, 71.88, 74.6, 81.44, 76.98, 74.63, 77.91, 76.94, 74.58, 78.63, 73.12, 72.33, 80.04, 80.54, 91.55, 97.51, 93.58}," )
      System.Console.WriteLine( "                        {28.75, 29.03, 31.5, 30.45, 30.71, 30.46, 31.09, 32.06, 34.4, 36.21, 37.24, 37.19, 43.31, 42.81, 42.32, 42.36, 43.86, 50.78, 54.16, 50.56, 49.95, 46.15, 49.4, 48.99, 46.19, 50.26, 55.75, 59.69, 63.56, 61.5, 51.05, 47.94, 46.59, 47.83, 49.04, 44.2, 42.64, 43.02, 48.68, 59.27, 55.13, 57.54, 60.75, 53.66, 51.22, 54.55, 50.61, 56.08, 50.2299, 43.28, 45.37, 40.6599, 42.29, 37.76, 39.1, 39.03, 35.54, 39.46, 37.09, 42.35, 38.32, 38.62, 35.9799, 39.95, 41.32, 42.96, 38.14, 36.79, 33.7, 35.9099, 40.15, 38.5, 40.0, 42.75, 43.04, 40.62, 42.31, 40.84, 38.55, 37.39, 33.45, 38.26, 41.7299, 39.6599, 35.42, 34.63, 36.7, 40.1599, 40.12, 39.64, 41.83, 42.94, 38.4, 38.77, 40.13, 44.42, 42.49, 43.99, 41.19, 41.9, 42.5, 43.7, 42.18, 41.93, 42.46, 42.53, 45.32, 49.05, 47.4099}," )
      System.Console.WriteLine( "                        {29.56, 29.01, 30.14, 30.7, 31.44, 29.87, 27.8, 28.52, 27.58, 30.82, 33.36, 32.27, 34.15, 33.79, 32.33, 33.79, 33.79, 32.83, 36.44, 37.25, 39.74, 38.11, 36.46, 38.52, 36.74, 44.06, 43.3, 43.06, 46.26, 43.0, 46.54, 37.68, 35.57, 40.96, 45.63, 46.7299, 58.61, 54.21, 57.12, 58.48, 55.1, 52.7, 48.81, 53.33, 50.6599, 56.7, 59.84, 58.94, 65.3199, 62.06, 67.5699, 76.39, 57.96, 47.65, 46.7299, 57.92, 53.78, 51.4099, 41.32, 42.53, 44.83, 44.92, 43.68, 46.17, 48.36, 54.7, 54.06, 46.9, 36.75, 35.4, 43.08, 42.13, 44.33, 46.39, 52.93, 56.17, 54.82, 47.15, 41.06, 42.71, 34.71, 29.67, 35.95, 33.38, 32.9, 31.01, 30.87, 33.1, 32.89, 33.52, 34.85, 38.78, 38.62, 40.26, 40.84, 50.9799, 47.43, 46.4099, 45.57, 45.74, 44.27, 45.44, 42.08, 40.78, 41.93, 38.05, 38.59, 40.06, 39.45}," )
      System.Console.WriteLine( "                        {19.2399, 19.0, 18.7399, 18.8, 20.11, 20.45, 19.72, 20.4899, 21.32, 20.4899, 22.32, 20.85, 24.21, 24.25, 22.3, 25.78, 25.4899, 27.35, 26.39, 24.26, 24.69, 24.56, 27.14, 28.4, 28.86, 32.71, 31.87, 31.03, 30.18, 32.34, 33.76, 30.35, 34.42, 35.85, 35.95, 37.11, 37.6599, 38.0, 41.62, 43.4, 41.47, 43.88, 40.77, 46.06, 41.38, 47.18, 46.99, 42.2299, 38.9799, 32.84, 32.05, 37.63, 41.12, 46.81, 42.76, 42.53, 43.45, 42.61, 46.57, 48.93, 43.37, 45.63, 41.01, 45.2299, 45.78, 47.18, 51.09, 49.94, 52.49, 54.87, 55.36, 56.17, 54.66, 58.06, 61.92, 60.88, 58.69, 49.99, 50.32, 52.14, 51.92, 56.41, 54.93, 51.74, 51.65, 50.74, 55.98, 54.52, 52.8, 50.2299, 50.32, 48.4, 48.34, 49.13, 48.35, 50.67, 52.39, 53.11, 49.97, 53.23, 55.17, 55.16, 54.73, 57.83, 56.07, 58.11, 60.32, 63.42, 62.84}," )
      System.Console.WriteLine( "                        {20.67, 22.1, 21.75, 21.29, 21.6, 21.79, 21.45, 22.95, 24.72, 26.46, 29.16, 27.58, 28.54, 30.9, 28.97, 28.43, 29.16, 29.95, 35.04, 34.31, 36.4099, 35.62, 33.56, 33.79, 33.08, 38.28, 41.62, 42.76, 41.95, 46.6, 46.67, 32.4, 26.62, 35.06, 39.15, 43.82, 47.4799, 49.14, 50.22, 50.92, 44.6599, 53.38, 47.56, 51.65, 46.52, 53.85, 47.68, 47.95, 49.8, 49.14, 53.81, 44.51, 46.1, 42.64, 46.11, 51.7299, 42.76, 42.12, 34.14, 42.07, 50.9099, 43.2, 41.57, 44.42, 45.5, 41.17, 40.08, 36.47, 31.61, 32.7299, 34.92, 33.65, 31.52, 27.08, 33.0, 32.49, 33.28, 31.4, 23.11, 24.44, 17.5799, 19.21, 23.3, 22.22, 21.61, 21.0, 21.95, 27.56, 30.85, 32.09, 33.24, 32.45, 32.56, 34.38, 33.9, 35.17, 37.59, 39.65, 40.54, 36.64, 35.89, 37.78, 36.69, 38.9099, 39.05, 38.26, 37.32, 38.67, 38.71}," )
      System.Console.WriteLine( "                        {17.85, 19.05, 17.39, 17.86, 19.7, 21.23, 21.36, 18.32, 19.07, 19.62, 21.93, 24.76, 26.04, 29.63, 25.67, 26.58, 29.69, 30.14, 30.74, 29.76, 28.57, 27.24, 29.91, 31.39, 28.79, 30.17, 29.18, 25.9899, 26.16, 27.85, 30.99, 29.4, 33.05, 36.54, 39.9799, 38.56, 33.79, 28.2, 25.64, 25.55, 28.1, 29.59, 27.43, 27.57, 25.5, 19.66, 19.57, 17.48, 15.86, 15.34, 16.15, 17.03, 20.3299, 21.04, 20.01, 23.57, 23.75, 29.55, 30.81, 35.9799, 35.9799, 39.4, 39.2299, 41.42, 42.5, 41.37, 38.02, 39.61, 40.36, 39.11, 39.42, 38.8, 42.4, 44.56, 45.07, 46.57, 48.9799, 37.84, 39.9, 43.32, 34.07, 35.78, 33.12, 36.15, 33.78, 34.47, 27.21, 27.93, 37.5, 41.87, 36.87, 37.99, 41.03, 43.56, 48.72, 51.63, 52.74, 54.6, 52.27, 53.16, 46.05, 48.7299, 46.34, 47.6599, 46.4799, 47.88, 56.8, 61.1, 60.51}," )
      System.Console.WriteLine( "                        {5.13, 5.47, 5.72, 6.28, 6.58, 6.66, 6.53, 6.79, 7.31, 7.61, 8.69, 9.16, 11.31, 10.81, 10.16, 13.47, 13.74, 14.01, 15.67, 14.65, 14.67, 14.41, 15.68, 14.33, 16.54, 18.79, 19.84, 19.98, 18.8, 24.02, 24.37, 21.27, 24.4, 23.47, 27.05, 30.75, 38.8, 33.28, 39.74, 36.05, 35.78, 39.99, 38.05, 41.04, 40.15, 41.04, 40.37, 51.76, 43.39, 39.62, 47.11, 30.93, 27.74, 35.47, 30.95, 30.95, 26.74, 30.54, 25.44, 19.23, 27.07, 26.16, 24.25, 30.04, 30.67, 32.37, 29.35, 25.29, 22.69, 25.78, 28.47, 29.37, 28.25, 25.87, 26.74, 23.17, 22.57, 24.25, 21.27, 21.76, 19.39, 23.71, 25.57, 22.92, 21.04, 21.0799, 21.54, 22.75, 21.89, 22.81, 23.4899, 23.59, 24.73, 23.38, 23.0, 24.48, 24.7399, 23.73, 22.3, 23.38, 23.47, 25.55, 25.4899, 24.4899, 24.81, 25.1, 26.81, 26.72, 26.75}," )
      System.Console.WriteLine( "                        {8.69, 8.58, 8.76, 8.97, 9.48, 9.57, 9.61, 9.77, 10.89, 11.38, 12.59, 11.66, 13.0, 13.17, 12.09, 13.8, 15.12, 17.54, 17.65, 16.41, 17.8, 21.02, 21.69, 22.23, 24.38, 26.57, 29.93, 34.17, 31.63, 32.8, 33.14, 28.22, 32.09, 32.56, 34.15, 38.13, 39.24, 40.46, 42.55, 35.29, 33.0, 33.62, 31.35, 35.01, 33.27, 36.81, 34.05, 30.16, 33.64, 29.94, 34.08, 39.26, 41.56, 44.82, 40.5, 40.37, 42.04, 40.42, 41.56, 43.14, 42.34, 42.3, 38.5, 40.71, 40.42, 37.75, 38.85, 36.2, 37.9, 39.6, 41.04, 37.76, 39.4799, 38.93, 37.77, 34.55, 33.0, 33.38, 30.86, 31.68, 27.79, 30.43, 30.31, 29.39, 29.33, 28.81, 30.1, 29.71, 30.1, 33.14, 32.38, 29.17, 29.62, 30.81, 32.88, 34.61, 35.88, 36.06, 34.49, 35.19, 34.94, 33.89, 31.6, 32.47, 30.42, 28.78, 27.77, 26.89, 26.29}," )
      System.Console.WriteLine( "                        {14.62, 14.27, 14.75, 14.99, 15.58, 16.07, 16.17, 16.1, 17.67, 18.28, 20.0799, 19.87, 21.7, 22.54, 21.53, 23.95, 26.26, 26.9, 29.36, 25.7, 26.66, 26.43, 29.62, 31.02, 30.66, 33.2, 33.0, 32.35, 33.01, 35.84, 31.44, 30.3, 28.17, 35.38, 34.95, 36.42, 36.49, 35.94, 39.32, 37.89, 37.71, 35.59, 36.84, 40.37, 38.14, 42.94, 44.22, 44.86, 41.61, 36.18, 23.36, 24.8299, 27.64, 23.5799, 23.98, 26.01, 28.18, 30.34, 31.8, 33.31, 30.81, 30.23, 26.85, 26.07, 27.89, 27.7, 31.17, 32.55, 31.95, 32.7299, 34.37, 35.11, 36.59, 37.9799, 40.36, 40.77, 40.45, 40.97, 41.24, 41.09, 41.42, 41.37, 39.53, 40.19, 40.4099, 38.65, 42.05, 42.82, 43.76, 42.5, 42.31, 42.03, 44.69, 47.78, 46.78, 48.55, 49.59, 50.29, 51.46, 52.4, 53.41, 53.93, 51.9, 55.71, 53.86, 51.18, 53.48, 55.08, 55.34}}" )
      ' Here we evaluate the covariance matrix of the  historical  returns  of
      ' the assets from which the portfolios can be constructed.
      Dim covariance1 As Double()() = instanceOfAssetParameters.CovarianceMatrix( _
         New Double()() {New Double() {9.41, 9.81, 10.67, 11.07, 12.0, 11.81, 11.18, 12.33, 12.33, 12.39, 11.92, 10.68, 11.15, 12.38, 13.15, 13.27, 14.09, 16.01, 17.76, 16.81, 17.41, 16.64, 19.04, 18.81, 18.9899, 22.09, 24.31, 24.19, 26.37, 29.14, 30.28, 28.3, 26.27, 33.21, 36.22, 39.24, 41.44, 41.5, 44.52, 44.43, 41.17, 46.65, 40.85, 42.84, 46.04, 54.51, 55.78, 66.9599, 53.04, 47.22, 54.8, 53.71, 55.9, 55.96, 53.65, 46.25, 46.78, 44.11, 50.7299, 51.71, 55.28, 48.75, 49.22, 50.43, 50.44, 47.63, 54.56, 46.9, 48.39, 50.25, 53.91, 56.33, 58.71, 60.7, 60.07, 54.74, 53.02, 53.98, 48.26, 52.48, 48.38, 52.62, 52.96, 49.7, 47.04, 47.29, 51.29, 55.52, 51.86, 52.99, 55.2, 58.42, 55.14, 58.3, 55.02, 52.55, 53.35, 59.0, 59.26, 56.59, 55.46, 52.25, 52.76, 52.54, 53.07, 53.79, 51.93, 52.82, 54.05}, _
                         New Double() {10.18, 10.43, 11.49, 11.44, 11.47, 10.68, 10.97, 11.75, 11.16, 11.34, 12.3, 12.32, 13.34, 13.96, 13.32, 13.89, 14.63, 14.98, 17.59, 16.54, 16.4899, 14.68, 13.71, 14.34, 15.57, 15.25, 14.31, 16.11, 14.61, 13.89, 14.6, 12.81, 15.19, 16.95, 16.09, 16.15, 18.1, 17.9, 18.2, 27.51, 24.46, 27.52, 26.63, 28.9, 27.78, 27.2, 29.52, 37.4, 31.41, 31.09, 31.88, 29.44, 26.73, 26.53, 27.67, 30.55, 23.2399, 26.35, 26.0, 30.9, 34.03, 33.13, 33.3, 38.35, 40.12, 37.19, 36.47, 35.58, 28.94, 30.25, 36.19, 33.33, 33.61, 35.38, 35.54, 32.05, 33.09, 31.36, 25.73, 23.87, 18.36, 20.9899, 24.46, 21.81, 18.93, 19.78, 18.7, 22.27, 23.91, 24.77, 26.98, 27.9, 25.55, 30.84, 32.2, 37.3, 33.55, 36.94, 34.2, 30.31, 31.01, 32.72, 31.73, 32.2299, 33.43, 32.35, 33.9799, 31.41, 30.38}, _
                         New Double() {8.02, 8.33, 8.22, 7.66, 7.93, 8.71, 8.07, 8.4, 9.52, 10.63, 11.75, 11.85, 13.8, 14.13, 12.65, 14.63, 14.61, 16.75, 19.23, 16.98, 18.26, 18.8299, 20.54, 21.75, 20.0, 22.56, 24.3299, 24.92, 24.94, 24.69, 27.49, 18.14, 15.33, 19.37, 20.71, 20.48, 23.26, 24.37, 26.5, 31.24, 27.64, 29.72, 27.99, 27.92, 27.64, 34.21, 33.97, 35.12, 35.94, 32.75, 37.9, 37.47, 39.49, 38.26, 44.77, 49.61, 45.94, 44.72, 42.44, 43.5, 47.69, 42.01, 38.42, 41.9799, 43.9, 45.26, 43.01, 39.35, 34.8, 39.11, 41.3, 43.53, 41.01, 39.15, 42.84, 37.46, 37.51, 33.6599, 29.14, 30.67, 27.77, 34.78, 36.59, 33.12, 32.51, 31.56, 32.61, 37.15, 39.03, 40.72, 42.95, 41.56, 43.63, 45.78, 45.43, 46.88, 48.18, 48.94, 50.35, 47.22, 45.59, 45.6599, 43.69, 46.1599, 43.72, 44.37, 44.75, 48.18, 48.93}, _
                         New Double() {25.18, 26.12, 26.6, 25.35, 25.94, 26.78, 26.36, 27.56, 30.16, 27.76, 32.01, 30.44, 31.73, 31.98, 32.8, 36.72, 40.28, 44.31, 46.42, 48.13, 44.71, 42.6599, 39.9099, 40.37, 40.17, 45.6599, 46.08, 47.87, 46.18, 44.4799, 41.01, 35.51, 37.62, 38.24, 42.07, 39.14, 37.09, 39.01, 39.34, 55.39, 47.2299, 51.63, 50.7299, 49.0, 47.42, 48.15, 40.37, 40.96, 37.18, 30.71, 34.55, 34.83, 33.78, 29.92, 30.37, 32.78, 27.64, 31.61, 35.44, 42.6599, 40.17, 37.79, 40.32, 45.93, 49.55, 45.79, 50.74, 46.05, 41.26, 41.49, 44.0, 48.4799, 47.0, 51.88, 53.14, 51.37, 49.1599, 46.04, 42.39, 41.38, 35.29, 39.09, 47.75, 43.75, 42.4, 45.31, 47.43, 51.05, 50.61, 54.02, 65.87, 70.13, 67.2099, 71.88, 74.6, 81.44, 76.98, 74.63, 77.91, 76.94, 74.58, 78.63, 73.12, 72.33, 80.04, 80.54, 91.55, 97.51, 93.58}, _
                         New Double() {28.75, 29.03, 31.5, 30.45, 30.71, 30.46, 31.09, 32.06, 34.4, 36.21, 37.24, 37.19, 43.31, 42.81, 42.32, 42.36, 43.86, 50.78, 54.16, 50.56, 49.95, 46.15, 49.4, 48.99, 46.19, 50.26, 55.75, 59.69, 63.56, 61.5, 51.05, 47.94, 46.59, 47.83, 49.04, 44.2, 42.64, 43.02, 48.68, 59.27, 55.13, 57.54, 60.75, 53.66, 51.22, 54.55, 50.61, 56.08, 50.2299, 43.28, 45.37, 40.6599, 42.29, 37.76, 39.1, 39.03, 35.54, 39.46, 37.09, 42.35, 38.32, 38.62, 35.9799, 39.95, 41.32, 42.96, 38.14, 36.79, 33.7, 35.9099, 40.15, 38.5, 40.0, 42.75, 43.04, 40.62, 42.31, 40.84, 38.55, 37.39, 33.45, 38.26, 41.7299, 39.6599, 35.42, 34.63, 36.7, 40.1599, 40.12, 39.64, 41.83, 42.94, 38.4, 38.77, 40.13, 44.42, 42.49, 43.99, 41.19, 41.9, 42.5, 43.7, 42.18, 41.93, 42.46, 42.53, 45.32, 49.05, 47.4099}, _
                         New Double() {29.56, 29.01, 30.14, 30.7, 31.44, 29.87, 27.8, 28.52, 27.58, 30.82, 33.36, 32.27, 34.15, 33.79, 32.33, 33.79, 33.79, 32.83, 36.44, 37.25, 39.74, 38.11, 36.46, 38.52, 36.74, 44.06, 43.3, 43.06, 46.26, 43.0, 46.54, 37.68, 35.57, 40.96, 45.63, 46.7299, 58.61, 54.21, 57.12, 58.48, 55.1, 52.7, 48.81, 53.33, 50.6599, 56.7, 59.84, 58.94, 65.3199, 62.06, 67.5699, 76.39, 57.96, 47.65, 46.7299, 57.92, 53.78, 51.4099, 41.32, 42.53, 44.83, 44.92, 43.68, 46.17, 48.36, 54.7, 54.06, 46.9, 36.75, 35.4, 43.08, 42.13, 44.33, 46.39, 52.93, 56.17, 54.82, 47.15, 41.06, 42.71, 34.71, 29.67, 35.95, 33.38, 32.9, 31.01, 30.87, 33.1, 32.89, 33.52, 34.85, 38.78, 38.62, 40.26, 40.84, 50.9799, 47.43, 46.4099, 45.57, 45.74, 44.27, 45.44, 42.08, 40.78, 41.93, 38.05, 38.59, 40.06, 39.45}, _
                         New Double() {19.2399, 19.0, 18.7399, 18.8, 20.11, 20.45, 19.72, 20.4899, 21.32, 20.4899, 22.32, 20.85, 24.21, 24.25, 22.3, 25.78, 25.4899, 27.35, 26.39, 24.26, 24.69, 24.56, 27.14, 28.4, 28.86, 32.71, 31.87, 31.03, 30.18, 32.34, 33.76, 30.35, 34.42, 35.85, 35.95, 37.11, 37.6599, 38.0, 41.62, 43.4, 41.47, 43.88, 40.77, 46.06, 41.38, 47.18, 46.99, 42.2299, 38.9799, 32.84, 32.05, 37.63, 41.12, 46.81, 42.76, 42.53, 43.45, 42.61, 46.57, 48.93, 43.37, 45.63, 41.01, 45.2299, 45.78, 47.18, 51.09, 49.94, 52.49, 54.87, 55.36, 56.17, 54.66, 58.06, 61.92, 60.88, 58.69, 49.99, 50.32, 52.14, 51.92, 56.41, 54.93, 51.74, 51.65, 50.74, 55.98, 54.52, 52.8, 50.2299, 50.32, 48.4, 48.34, 49.13, 48.35, 50.67, 52.39, 53.11, 49.97, 53.23, 55.17, 55.16, 54.73, 57.83, 56.07, 58.11, 60.32, 63.42, 62.84}, _
                         New Double() {20.67, 22.1, 21.75, 21.29, 21.6, 21.79, 21.45, 22.95, 24.72, 26.46, 29.16, 27.58, 28.54, 30.9, 28.97, 28.43, 29.16, 29.95, 35.04, 34.31, 36.4099, 35.62, 33.56, 33.79, 33.08, 38.28, 41.62, 42.76, 41.95, 46.6, 46.67, 32.4, 26.62, 35.06, 39.15, 43.82, 47.4799, 49.14, 50.22, 50.92, 44.6599, 53.38, 47.56, 51.65, 46.52, 53.85, 47.68, 47.95, 49.8, 49.14, 53.81, 44.51, 46.1, 42.64, 46.11, 51.7299, 42.76, 42.12, 34.14, 42.07, 50.9099, 43.2, 41.57, 44.42, 45.5, 41.17, 40.08, 36.47, 31.61, 32.7299, 34.92, 33.65, 31.52, 27.08, 33.0, 32.49, 33.28, 31.4, 23.11, 24.44, 17.5799, 19.21, 23.3, 22.22, 21.61, 21.0, 21.95, 27.56, 30.85, 32.09, 33.24, 32.45, 32.56, 34.38, 33.9, 35.17, 37.59, 39.65, 40.54, 36.64, 35.89, 37.78, 36.69, 38.9099, 39.05, 38.26, 37.32, 38.67, 38.71}, _
                         New Double() {17.85, 19.05, 17.39, 17.86, 19.7, 21.23, 21.36, 18.32, 19.07, 19.62, 21.93, 24.76, 26.04, 29.63, 25.67, 26.58, 29.69, 30.14, 30.74, 29.76, 28.57, 27.24, 29.91, 31.39, 28.79, 30.17, 29.18, 25.9899, 26.16, 27.85, 30.99, 29.4, 33.05, 36.54, 39.9799, 38.56, 33.79, 28.2, 25.64, 25.55, 28.1, 29.59, 27.43, 27.57, 25.5, 19.66, 19.57, 17.48, 15.86, 15.34, 16.15, 17.03, 20.3299, 21.04, 20.01, 23.57, 23.75, 29.55, 30.81, 35.9799, 35.9799, 39.4, 39.2299, 41.42, 42.5, 41.37, 38.02, 39.61, 40.36, 39.11, 39.42, 38.8, 42.4, 44.56, 45.07, 46.57, 48.9799, 37.84, 39.9, 43.32, 34.07, 35.78, 33.12, 36.15, 33.78, 34.47, 27.21, 27.93, 37.5, 41.87, 36.87, 37.99, 41.03, 43.56, 48.72, 51.63, 52.74, 54.6, 52.27, 53.16, 46.05, 48.7299, 46.34, 47.6599, 46.4799, 47.88, 56.8, 61.1, 60.51}, _
                         New Double() {5.13, 5.47, 5.72, 6.28, 6.58, 6.66, 6.53, 6.79, 7.31, 7.61, 8.69, 9.16, 11.31, 10.81, 10.16, 13.47, 13.74, 14.01, 15.67, 14.65, 14.67, 14.41, 15.68, 14.33, 16.54, 18.79, 19.84, 19.98, 18.8, 24.02, 24.37, 21.27, 24.4, 23.47, 27.05, 30.75, 38.8, 33.28, 39.74, 36.05, 35.78, 39.99, 38.05, 41.04, 40.15, 41.04, 40.37, 51.76, 43.39, 39.62, 47.11, 30.93, 27.74, 35.47, 30.95, 30.95, 26.74, 30.54, 25.44, 19.23, 27.07, 26.16, 24.25, 30.04, 30.67, 32.37, 29.35, 25.29, 22.69, 25.78, 28.47, 29.37, 28.25, 25.87, 26.74, 23.17, 22.57, 24.25, 21.27, 21.76, 19.39, 23.71, 25.57, 22.92, 21.04, 21.0799, 21.54, 22.75, 21.89, 22.81, 23.4899, 23.59, 24.73, 23.38, 23.0, 24.48, 24.7399, 23.73, 22.3, 23.38, 23.47, 25.55, 25.4899, 24.4899, 24.81, 25.1, 26.81, 26.72, 26.75}, _
                         New Double() {8.69, 8.58, 8.76, 8.97, 9.48, 9.57, 9.61, 9.77, 10.89, 11.38, 12.59, 11.66, 13.0, 13.17, 12.09, 13.8, 15.12, 17.54, 17.65, 16.41, 17.8, 21.02, 21.69, 22.23, 24.38, 26.57, 29.93, 34.17, 31.63, 32.8, 33.14, 28.22, 32.09, 32.56, 34.15, 38.13, 39.24, 40.46, 42.55, 35.29, 33.0, 33.62, 31.35, 35.01, 33.27, 36.81, 34.05, 30.16, 33.64, 29.94, 34.08, 39.26, 41.56, 44.82, 40.5, 40.37, 42.04, 40.42, 41.56, 43.14, 42.34, 42.3, 38.5, 40.71, 40.42, 37.75, 38.85, 36.2, 37.9, 39.6, 41.04, 37.76, 39.4799, 38.93, 37.77, 34.55, 33.0, 33.38, 30.86, 31.68, 27.79, 30.43, 30.31, 29.39, 29.33, 28.81, 30.1, 29.71, 30.1, 33.14, 32.38, 29.17, 29.62, 30.81, 32.88, 34.61, 35.88, 36.06, 34.49, 35.19, 34.94, 33.89, 31.6, 32.47, 30.42, 28.78, 27.77, 26.89, 26.29}, _
                         New Double() {14.62, 14.27, 14.75, 14.99, 15.58, 16.07, 16.17, 16.1, 17.67, 18.28, 20.0799, 19.87, 21.7, 22.54, 21.53, 23.95, 26.26, 26.9, 29.36, 25.7, 26.66, 26.43, 29.62, 31.02, 30.66, 33.2, 33.0, 32.35, 33.01, 35.84, 31.44, 30.3, 28.17, 35.38, 34.95, 36.42, 36.49, 35.94, 39.32, 37.89, 37.71, 35.59, 36.84, 40.37, 38.14, 42.94, 44.22, 44.86, 41.61, 36.18, 23.36, 24.8299, 27.64, 23.5799, 23.98, 26.01, 28.18, 30.34, 31.8, 33.31, 30.81, 30.23, 26.85, 26.07, 27.89, 27.7, 31.17, 32.55, 31.95, 32.7299, 34.37, 35.11, 36.59, 37.9799, 40.36, 40.77, 40.45, 40.97, 41.24, 41.09, 41.42, 41.37, 39.53, 40.19, 40.4099, 38.65, 42.05, 42.82, 43.76, 42.5, 42.31, 42.03, 44.69, 47.78, 46.78, 48.55, 49.59, 50.29, 51.46, 52.4, 53.41, 53.93, 51.9, 55.71, 53.86, 51.18, 53.48, 55.08, 55.34}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The covariance matrix of the assets historical returns is:" )
      System.Console.WriteLine( " " )
      display2DArray( covariance1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ We next evaluate the expected returns of the asset being considered +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "        Here we  evaluate  the  expected  returns  of  the  assets  under" )
      System.Console.WriteLine( "        consideration." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {{9.41, 9.81, 10.67, 11.07, 12.0, 11.81, 11.18, 12.33, 12.33, 12.39, 11.92, 10.68, 11.15, 12.38, 13.15, 13.27, 14.09, 16.01, 17.76, 16.81, 17.41, 16.64, 19.04, 18.81, 18.9899, 22.09, 24.31, 24.19, 26.37, 29.14, 30.28, 28.3, 26.27, 33.21, 36.22, 39.24, 41.44, 41.5, 44.52, 44.43, 41.17, 46.65, 40.85, 42.84, 46.04, 54.51, 55.78, 66.9599, 53.04, 47.22, 54.8, 53.71, 55.9, 55.96, 53.65, 46.25, 46.78, 44.11, 50.7299, 51.71, 55.28, 48.75, 49.22, 50.43, 50.44, 47.63, 54.56, 46.9, 48.39, 50.25, 53.91, 56.33, 58.71, 60.7, 60.07, 54.74, 53.02, 53.98, 48.26, 52.48, 48.38, 52.62, 52.96, 49.7, 47.04, 47.29, 51.29, 55.52, 51.86, 52.99, 55.2, 58.42, 55.14, 58.3, 55.02, 52.55, 53.35, 59.0, 59.26, 56.59, 55.46, 52.25, 52.76, 52.54, 53.07, 53.79, 51.93, 52.82, 54.05}," )
      System.Console.WriteLine( "                        {10.18, 10.43, 11.49, 11.44, 11.47, 10.68, 10.97, 11.75, 11.16, 11.34, 12.3, 12.32, 13.34, 13.96, 13.32, 13.89, 14.63, 14.98, 17.59, 16.54, 16.4899, 14.68, 13.71, 14.34, 15.57, 15.25, 14.31, 16.11, 14.61, 13.89, 14.6, 12.81, 15.19, 16.95, 16.09, 16.15, 18.1, 17.9, 18.2, 27.51, 24.46, 27.52, 26.63, 28.9, 27.78, 27.2, 29.52, 37.4, 31.41, 31.09, 31.88, 29.44, 26.73, 26.53, 27.67, 30.55, 23.2399, 26.35, 26.0, 30.9, 34.03, 33.13, 33.3, 38.35, 40.12, 37.19, 36.47, 35.58, 28.94, 30.25, 36.19, 33.33, 33.61, 35.38, 35.54, 32.05, 33.09, 31.36, 25.73, 23.87, 18.36, 20.9899, 24.46, 21.81, 18.93, 19.78, 18.7, 22.27, 23.91, 24.77, 26.98, 27.9, 25.55, 30.84, 32.2, 37.3, 33.55, 36.94, 34.2, 30.31, 31.01, 32.72, 31.73, 32.2299, 33.43, 32.35, 33.9799, 31.41, 30.38}," )
      System.Console.WriteLine( "                        {8.02, 8.33, 8.22, 7.66, 7.93, 8.71, 8.07, 8.4, 9.52, 10.63, 11.75, 11.85, 13.8, 14.13, 12.65, 14.63, 14.61, 16.75, 19.23, 16.98, 18.26, 18.8299, 20.54, 21.75, 20.0, 22.56, 24.3299, 24.92, 24.94, 24.69, 27.49, 18.14, 15.33, 19.37, 20.71, 20.48, 23.26, 24.37, 26.5, 31.24, 27.64, 29.72, 27.99, 27.92, 27.64, 34.21, 33.97, 35.12, 35.94, 32.75, 37.9, 37.47, 39.49, 38.26, 44.77, 49.61, 45.94, 44.72, 42.44, 43.5, 47.69, 42.01, 38.42, 41.9799, 43.9, 45.26, 43.01, 39.35, 34.8, 39.11, 41.3, 43.53, 41.01, 39.15, 42.84, 37.46, 37.51, 33.6599, 29.14, 30.67, 27.77, 34.78, 36.59, 33.12, 32.51, 31.56, 32.61, 37.15, 39.03, 40.72, 42.95, 41.56, 43.63, 45.78, 45.43, 46.88, 48.18, 48.94, 50.35, 47.22, 45.59, 45.6599, 43.69, 46.1599, 43.72, 44.37, 44.75, 48.18, 48.93}," )
      System.Console.WriteLine( "                        {25.18, 26.12, 26.6, 25.35, 25.94, 26.78, 26.36, 27.56, 30.16, 27.76, 32.01, 30.44, 31.73, 31.98, 32.8, 36.72, 40.28, 44.31, 46.42, 48.13, 44.71, 42.6599, 39.9099, 40.37, 40.17, 45.6599, 46.08, 47.87, 46.18, 44.4799, 41.01, 35.51, 37.62, 38.24, 42.07, 39.14, 37.09, 39.01, 39.34, 55.39, 47.2299, 51.63, 50.7299, 49.0, 47.42, 48.15, 40.37, 40.96, 37.18, 30.71, 34.55, 34.83, 33.78, 29.92, 30.37, 32.78, 27.64, 31.61, 35.44, 42.6599, 40.17, 37.79, 40.32, 45.93, 49.55, 45.79, 50.74, 46.05, 41.26, 41.49, 44.0, 48.4799, 47.0, 51.88, 53.14, 51.37, 49.1599, 46.04, 42.39, 41.38, 35.29, 39.09, 47.75, 43.75, 42.4, 45.31, 47.43, 51.05, 50.61, 54.02, 65.87, 70.13, 67.2099, 71.88, 74.6, 81.44, 76.98, 74.63, 77.91, 76.94, 74.58, 78.63, 73.12, 72.33, 80.04, 80.54, 91.55, 97.51, 93.58}," )
      System.Console.WriteLine( "                        {28.75, 29.03, 31.5, 30.45, 30.71, 30.46, 31.09, 32.06, 34.4, 36.21, 37.24, 37.19, 43.31, 42.81, 42.32, 42.36, 43.86, 50.78, 54.16, 50.56, 49.95, 46.15, 49.4, 48.99, 46.19, 50.26, 55.75, 59.69, 63.56, 61.5, 51.05, 47.94, 46.59, 47.83, 49.04, 44.2, 42.64, 43.02, 48.68, 59.27, 55.13, 57.54, 60.75, 53.66, 51.22, 54.55, 50.61, 56.08, 50.2299, 43.28, 45.37, 40.6599, 42.29, 37.76, 39.1, 39.03, 35.54, 39.46, 37.09, 42.35, 38.32, 38.62, 35.9799, 39.95, 41.32, 42.96, 38.14, 36.79, 33.7, 35.9099, 40.15, 38.5, 40.0, 42.75, 43.04, 40.62, 42.31, 40.84, 38.55, 37.39, 33.45, 38.26, 41.7299, 39.6599, 35.42, 34.63, 36.7, 40.1599, 40.12, 39.64, 41.83, 42.94, 38.4, 38.77, 40.13, 44.42, 42.49, 43.99, 41.19, 41.9, 42.5, 43.7, 42.18, 41.93, 42.46, 42.53, 45.32, 49.05, 47.4099}," )
      System.Console.WriteLine( "                        {29.56, 29.01, 30.14, 30.7, 31.44, 29.87, 27.8, 28.52, 27.58, 30.82, 33.36, 32.27, 34.15, 33.79, 32.33, 33.79, 33.79, 32.83, 36.44, 37.25, 39.74, 38.11, 36.46, 38.52, 36.74, 44.06, 43.3, 43.06, 46.26, 43.0, 46.54, 37.68, 35.57, 40.96, 45.63, 46.7299, 58.61, 54.21, 57.12, 58.48, 55.1, 52.7, 48.81, 53.33, 50.6599, 56.7, 59.84, 58.94, 65.3199, 62.06, 67.5699, 76.39, 57.96, 47.65, 46.7299, 57.92, 53.78, 51.4099, 41.32, 42.53, 44.83, 44.92, 43.68, 46.17, 48.36, 54.7, 54.06, 46.9, 36.75, 35.4, 43.08, 42.13, 44.33, 46.39, 52.93, 56.17, 54.82, 47.15, 41.06, 42.71, 34.71, 29.67, 35.95, 33.38, 32.9, 31.01, 30.87, 33.1, 32.89, 33.52, 34.85, 38.78, 38.62, 40.26, 40.84, 50.9799, 47.43, 46.4099, 45.57, 45.74, 44.27, 45.44, 42.08, 40.78, 41.93, 38.05, 38.59, 40.06, 39.45}," )
      System.Console.WriteLine( "                        {19.2399, 19.0, 18.7399, 18.8, 20.11, 20.45, 19.72, 20.4899, 21.32, 20.4899, 22.32, 20.85, 24.21, 24.25, 22.3, 25.78, 25.4899, 27.35, 26.39, 24.26, 24.69, 24.56, 27.14, 28.4, 28.86, 32.71, 31.87, 31.03, 30.18, 32.34, 33.76, 30.35, 34.42, 35.85, 35.95, 37.11, 37.6599, 38.0, 41.62, 43.4, 41.47, 43.88, 40.77, 46.06, 41.38, 47.18, 46.99, 42.2299, 38.9799, 32.84, 32.05, 37.63, 41.12, 46.81, 42.76, 42.53, 43.45, 42.61, 46.57, 48.93, 43.37, 45.63, 41.01, 45.2299, 45.78, 47.18, 51.09, 49.94, 52.49, 54.87, 55.36, 56.17, 54.66, 58.06, 61.92, 60.88, 58.69, 49.99, 50.32, 52.14, 51.92, 56.41, 54.93, 51.74, 51.65, 50.74, 55.98, 54.52, 52.8, 50.2299, 50.32, 48.4, 48.34, 49.13, 48.35, 50.67, 52.39, 53.11, 49.97, 53.23, 55.17, 55.16, 54.73, 57.83, 56.07, 58.11, 60.32, 63.42, 62.84}," )
      System.Console.WriteLine( "                        {20.67, 22.1, 21.75, 21.29, 21.6, 21.79, 21.45, 22.95, 24.72, 26.46, 29.16, 27.58, 28.54, 30.9, 28.97, 28.43, 29.16, 29.95, 35.04, 34.31, 36.4099, 35.62, 33.56, 33.79, 33.08, 38.28, 41.62, 42.76, 41.95, 46.6, 46.67, 32.4, 26.62, 35.06, 39.15, 43.82, 47.4799, 49.14, 50.22, 50.92, 44.6599, 53.38, 47.56, 51.65, 46.52, 53.85, 47.68, 47.95, 49.8, 49.14, 53.81, 44.51, 46.1, 42.64, 46.11, 51.7299, 42.76, 42.12, 34.14, 42.07, 50.9099, 43.2, 41.57, 44.42, 45.5, 41.17, 40.08, 36.47, 31.61, 32.7299, 34.92, 33.65, 31.52, 27.08, 33.0, 32.49, 33.28, 31.4, 23.11, 24.44, 17.5799, 19.21, 23.3, 22.22, 21.61, 21.0, 21.95, 27.56, 30.85, 32.09, 33.24, 32.45, 32.56, 34.38, 33.9, 35.17, 37.59, 39.65, 40.54, 36.64, 35.89, 37.78, 36.69, 38.9099, 39.05, 38.26, 37.32, 38.67, 38.71}," )
      System.Console.WriteLine( "                        {17.85, 19.05, 17.39, 17.86, 19.7, 21.23, 21.36, 18.32, 19.07, 19.62, 21.93, 24.76, 26.04, 29.63, 25.67, 26.58, 29.69, 30.14, 30.74, 29.76, 28.57, 27.24, 29.91, 31.39, 28.79, 30.17, 29.18, 25.9899, 26.16, 27.85, 30.99, 29.4, 33.05, 36.54, 39.9799, 38.56, 33.79, 28.2, 25.64, 25.55, 28.1, 29.59, 27.43, 27.57, 25.5, 19.66, 19.57, 17.48, 15.86, 15.34, 16.15, 17.03, 20.3299, 21.04, 20.01, 23.57, 23.75, 29.55, 30.81, 35.9799, 35.9799, 39.4, 39.2299, 41.42, 42.5, 41.37, 38.02, 39.61, 40.36, 39.11, 39.42, 38.8, 42.4, 44.56, 45.07, 46.57, 48.9799, 37.84, 39.9, 43.32, 34.07, 35.78, 33.12, 36.15, 33.78, 34.47, 27.21, 27.93, 37.5, 41.87, 36.87, 37.99, 41.03, 43.56, 48.72, 51.63, 52.74, 54.6, 52.27, 53.16, 46.05, 48.7299, 46.34, 47.6599, 46.4799, 47.88, 56.8, 61.1, 60.51}," )
      System.Console.WriteLine( "                        {5.13, 5.47, 5.72, 6.28, 6.58, 6.66, 6.53, 6.79, 7.31, 7.61, 8.69, 9.16, 11.31, 10.81, 10.16, 13.47, 13.74, 14.01, 15.67, 14.65, 14.67, 14.41, 15.68, 14.33, 16.54, 18.79, 19.84, 19.98, 18.8, 24.02, 24.37, 21.27, 24.4, 23.47, 27.05, 30.75, 38.8, 33.28, 39.74, 36.05, 35.78, 39.99, 38.05, 41.04, 40.15, 41.04, 40.37, 51.76, 43.39, 39.62, 47.11, 30.93, 27.74, 35.47, 30.95, 30.95, 26.74, 30.54, 25.44, 19.23, 27.07, 26.16, 24.25, 30.04, 30.67, 32.37, 29.35, 25.29, 22.69, 25.78, 28.47, 29.37, 28.25, 25.87, 26.74, 23.17, 22.57, 24.25, 21.27, 21.76, 19.39, 23.71, 25.57, 22.92, 21.04, 21.0799, 21.54, 22.75, 21.89, 22.81, 23.4899, 23.59, 24.73, 23.38, 23.0, 24.48, 24.7399, 23.73, 22.3, 23.38, 23.47, 25.55, 25.4899, 24.4899, 24.81, 25.1, 26.81, 26.72, 26.75}," )
      System.Console.WriteLine( "                        {8.69, 8.58, 8.76, 8.97, 9.48, 9.57, 9.61, 9.77, 10.89, 11.38, 12.59, 11.66, 13.0, 13.17, 12.09, 13.8, 15.12, 17.54, 17.65, 16.41, 17.8, 21.02, 21.69, 22.23, 24.38, 26.57, 29.93, 34.17, 31.63, 32.8, 33.14, 28.22, 32.09, 32.56, 34.15, 38.13, 39.24, 40.46, 42.55, 35.29, 33.0, 33.62, 31.35, 35.01, 33.27, 36.81, 34.05, 30.16, 33.64, 29.94, 34.08, 39.26, 41.56, 44.82, 40.5, 40.37, 42.04, 40.42, 41.56, 43.14, 42.34, 42.3, 38.5, 40.71, 40.42, 37.75, 38.85, 36.2, 37.9, 39.6, 41.04, 37.76, 39.4799, 38.93, 37.77, 34.55, 33.0, 33.38, 30.86, 31.68, 27.79, 30.43, 30.31, 29.39, 29.33, 28.81, 30.1, 29.71, 30.1, 33.14, 32.38, 29.17, 29.62, 30.81, 32.88, 34.61, 35.88, 36.06, 34.49, 35.19, 34.94, 33.89, 31.6, 32.47, 30.42, 28.78, 27.77, 26.89, 26.29}," )
      System.Console.WriteLine( "                        {14.62, 14.27, 14.75, 14.99, 15.58, 16.07, 16.17, 16.1, 17.67, 18.28, 20.0799, 19.87, 21.7, 22.54, 21.53, 23.95, 26.26, 26.9, 29.36, 25.7, 26.66, 26.43, 29.62, 31.02, 30.66, 33.2, 33.0, 32.35, 33.01, 35.84, 31.44, 30.3, 28.17, 35.38, 34.95, 36.42, 36.49, 35.94, 39.32, 37.89, 37.71, 35.59, 36.84, 40.37, 38.14, 42.94, 44.22, 44.86, 41.61, 36.18, 23.36, 24.8299, 27.64, 23.5799, 23.98, 26.01, 28.18, 30.34, 31.8, 33.31, 30.81, 30.23, 26.85, 26.07, 27.89, 27.7, 31.17, 32.55, 31.95, 32.7299, 34.37, 35.11, 36.59, 37.9799, 40.36, 40.77, 40.45, 40.97, 41.24, 41.09, 41.42, 41.37, 39.53, 40.19, 40.4099, 38.65, 42.05, 42.82, 43.76, 42.5, 42.31, 42.03, 44.69, 47.78, 46.78, 48.55, 49.59, 50.29, 51.46, 52.4, 53.41, 53.93, 51.9, 55.71, 53.86, 51.18, 53.48, 55.08, 55.34}}" )
      ' Here       we  evaluate  the  expcted  returns  of  the  assets  under
      ' consideration.
      Dim expectedReturns1 As Double() = instanceOfAssetParameters.ExpectedReturns( _
         New Double()() {New Double() {9.41, 9.81, 10.67, 11.07, 12.0, 11.81, 11.18, 12.33, 12.33, 12.39, 11.92, 10.68, 11.15, 12.38, 13.15, 13.27, 14.09, 16.01, 17.76, 16.81, 17.41, 16.64, 19.04, 18.81, 18.9899, 22.09, 24.31, 24.19, 26.37, 29.14, 30.28, 28.3, 26.27, 33.21, 36.22, 39.24, 41.44, 41.5, 44.52, 44.43, 41.17, 46.65, 40.85, 42.84, 46.04, 54.51, 55.78, 66.9599, 53.04, 47.22, 54.8, 53.71, 55.9, 55.96, 53.65, 46.25, 46.78, 44.11, 50.7299, 51.71, 55.28, 48.75, 49.22, 50.43, 50.44, 47.63, 54.56, 46.9, 48.39, 50.25, 53.91, 56.33, 58.71, 60.7, 60.07, 54.74, 53.02, 53.98, 48.26, 52.48, 48.38, 52.62, 52.96, 49.7, 47.04, 47.29, 51.29, 55.52, 51.86, 52.99, 55.2, 58.42, 55.14, 58.3, 55.02, 52.55, 53.35, 59.0, 59.26, 56.59, 55.46, 52.25, 52.76, 52.54, 53.07, 53.79, 51.93, 52.82, 54.05}, _
                         New Double() {10.18, 10.43, 11.49, 11.44, 11.47, 10.68, 10.97, 11.75, 11.16, 11.34, 12.3, 12.32, 13.34, 13.96, 13.32, 13.89, 14.63, 14.98, 17.59, 16.54, 16.4899, 14.68, 13.71, 14.34, 15.57, 15.25, 14.31, 16.11, 14.61, 13.89, 14.6, 12.81, 15.19, 16.95, 16.09, 16.15, 18.1, 17.9, 18.2, 27.51, 24.46, 27.52, 26.63, 28.9, 27.78, 27.2, 29.52, 37.4, 31.41, 31.09, 31.88, 29.44, 26.73, 26.53, 27.67, 30.55, 23.2399, 26.35, 26.0, 30.9, 34.03, 33.13, 33.3, 38.35, 40.12, 37.19, 36.47, 35.58, 28.94, 30.25, 36.19, 33.33, 33.61, 35.38, 35.54, 32.05, 33.09, 31.36, 25.73, 23.87, 18.36, 20.9899, 24.46, 21.81, 18.93, 19.78, 18.7, 22.27, 23.91, 24.77, 26.98, 27.9, 25.55, 30.84, 32.2, 37.3, 33.55, 36.94, 34.2, 30.31, 31.01, 32.72, 31.73, 32.2299, 33.43, 32.35, 33.9799, 31.41, 30.38}, _
                         New Double() {8.02, 8.33, 8.22, 7.66, 7.93, 8.71, 8.07, 8.4, 9.52, 10.63, 11.75, 11.85, 13.8, 14.13, 12.65, 14.63, 14.61, 16.75, 19.23, 16.98, 18.26, 18.8299, 20.54, 21.75, 20.0, 22.56, 24.3299, 24.92, 24.94, 24.69, 27.49, 18.14, 15.33, 19.37, 20.71, 20.48, 23.26, 24.37, 26.5, 31.24, 27.64, 29.72, 27.99, 27.92, 27.64, 34.21, 33.97, 35.12, 35.94, 32.75, 37.9, 37.47, 39.49, 38.26, 44.77, 49.61, 45.94, 44.72, 42.44, 43.5, 47.69, 42.01, 38.42, 41.9799, 43.9, 45.26, 43.01, 39.35, 34.8, 39.11, 41.3, 43.53, 41.01, 39.15, 42.84, 37.46, 37.51, 33.6599, 29.14, 30.67, 27.77, 34.78, 36.59, 33.12, 32.51, 31.56, 32.61, 37.15, 39.03, 40.72, 42.95, 41.56, 43.63, 45.78, 45.43, 46.88, 48.18, 48.94, 50.35, 47.22, 45.59, 45.6599, 43.69, 46.1599, 43.72, 44.37, 44.75, 48.18, 48.93}, _
                         New Double() {25.18, 26.12, 26.6, 25.35, 25.94, 26.78, 26.36, 27.56, 30.16, 27.76, 32.01, 30.44, 31.73, 31.98, 32.8, 36.72, 40.28, 44.31, 46.42, 48.13, 44.71, 42.6599, 39.9099, 40.37, 40.17, 45.6599, 46.08, 47.87, 46.18, 44.4799, 41.01, 35.51, 37.62, 38.24, 42.07, 39.14, 37.09, 39.01, 39.34, 55.39, 47.2299, 51.63, 50.7299, 49.0, 47.42, 48.15, 40.37, 40.96, 37.18, 30.71, 34.55, 34.83, 33.78, 29.92, 30.37, 32.78, 27.64, 31.61, 35.44, 42.6599, 40.17, 37.79, 40.32, 45.93, 49.55, 45.79, 50.74, 46.05, 41.26, 41.49, 44.0, 48.4799, 47.0, 51.88, 53.14, 51.37, 49.1599, 46.04, 42.39, 41.38, 35.29, 39.09, 47.75, 43.75, 42.4, 45.31, 47.43, 51.05, 50.61, 54.02, 65.87, 70.13, 67.2099, 71.88, 74.6, 81.44, 76.98, 74.63, 77.91, 76.94, 74.58, 78.63, 73.12, 72.33, 80.04, 80.54, 91.55, 97.51, 93.58}, _
                         New Double() {28.75, 29.03, 31.5, 30.45, 30.71, 30.46, 31.09, 32.06, 34.4, 36.21, 37.24, 37.19, 43.31, 42.81, 42.32, 42.36, 43.86, 50.78, 54.16, 50.56, 49.95, 46.15, 49.4, 48.99, 46.19, 50.26, 55.75, 59.69, 63.56, 61.5, 51.05, 47.94, 46.59, 47.83, 49.04, 44.2, 42.64, 43.02, 48.68, 59.27, 55.13, 57.54, 60.75, 53.66, 51.22, 54.55, 50.61, 56.08, 50.2299, 43.28, 45.37, 40.6599, 42.29, 37.76, 39.1, 39.03, 35.54, 39.46, 37.09, 42.35, 38.32, 38.62, 35.9799, 39.95, 41.32, 42.96, 38.14, 36.79, 33.7, 35.9099, 40.15, 38.5, 40.0, 42.75, 43.04, 40.62, 42.31, 40.84, 38.55, 37.39, 33.45, 38.26, 41.7299, 39.6599, 35.42, 34.63, 36.7, 40.1599, 40.12, 39.64, 41.83, 42.94, 38.4, 38.77, 40.13, 44.42, 42.49, 43.99, 41.19, 41.9, 42.5, 43.7, 42.18, 41.93, 42.46, 42.53, 45.32, 49.05, 47.4099}, _
                         New Double() {29.56, 29.01, 30.14, 30.7, 31.44, 29.87, 27.8, 28.52, 27.58, 30.82, 33.36, 32.27, 34.15, 33.79, 32.33, 33.79, 33.79, 32.83, 36.44, 37.25, 39.74, 38.11, 36.46, 38.52, 36.74, 44.06, 43.3, 43.06, 46.26, 43.0, 46.54, 37.68, 35.57, 40.96, 45.63, 46.7299, 58.61, 54.21, 57.12, 58.48, 55.1, 52.7, 48.81, 53.33, 50.6599, 56.7, 59.84, 58.94, 65.3199, 62.06, 67.5699, 76.39, 57.96, 47.65, 46.7299, 57.92, 53.78, 51.4099, 41.32, 42.53, 44.83, 44.92, 43.68, 46.17, 48.36, 54.7, 54.06, 46.9, 36.75, 35.4, 43.08, 42.13, 44.33, 46.39, 52.93, 56.17, 54.82, 47.15, 41.06, 42.71, 34.71, 29.67, 35.95, 33.38, 32.9, 31.01, 30.87, 33.1, 32.89, 33.52, 34.85, 38.78, 38.62, 40.26, 40.84, 50.9799, 47.43, 46.4099, 45.57, 45.74, 44.27, 45.44, 42.08, 40.78, 41.93, 38.05, 38.59, 40.06, 39.45}, _
                         New Double() {19.2399, 19.0, 18.7399, 18.8, 20.11, 20.45, 19.72, 20.4899, 21.32, 20.4899, 22.32, 20.85, 24.21, 24.25, 22.3, 25.78, 25.4899, 27.35, 26.39, 24.26, 24.69, 24.56, 27.14, 28.4, 28.86, 32.71, 31.87, 31.03, 30.18, 32.34, 33.76, 30.35, 34.42, 35.85, 35.95, 37.11, 37.6599, 38.0, 41.62, 43.4, 41.47, 43.88, 40.77, 46.06, 41.38, 47.18, 46.99, 42.2299, 38.9799, 32.84, 32.05, 37.63, 41.12, 46.81, 42.76, 42.53, 43.45, 42.61, 46.57, 48.93, 43.37, 45.63, 41.01, 45.2299, 45.78, 47.18, 51.09, 49.94, 52.49, 54.87, 55.36, 56.17, 54.66, 58.06, 61.92, 60.88, 58.69, 49.99, 50.32, 52.14, 51.92, 56.41, 54.93, 51.74, 51.65, 50.74, 55.98, 54.52, 52.8, 50.2299, 50.32, 48.4, 48.34, 49.13, 48.35, 50.67, 52.39, 53.11, 49.97, 53.23, 55.17, 55.16, 54.73, 57.83, 56.07, 58.11, 60.32, 63.42, 62.84}, _
                         New Double() {20.67, 22.1, 21.75, 21.29, 21.6, 21.79, 21.45, 22.95, 24.72, 26.46, 29.16, 27.58, 28.54, 30.9, 28.97, 28.43, 29.16, 29.95, 35.04, 34.31, 36.4099, 35.62, 33.56, 33.79, 33.08, 38.28, 41.62, 42.76, 41.95, 46.6, 46.67, 32.4, 26.62, 35.06, 39.15, 43.82, 47.4799, 49.14, 50.22, 50.92, 44.6599, 53.38, 47.56, 51.65, 46.52, 53.85, 47.68, 47.95, 49.8, 49.14, 53.81, 44.51, 46.1, 42.64, 46.11, 51.7299, 42.76, 42.12, 34.14, 42.07, 50.9099, 43.2, 41.57, 44.42, 45.5, 41.17, 40.08, 36.47, 31.61, 32.7299, 34.92, 33.65, 31.52, 27.08, 33.0, 32.49, 33.28, 31.4, 23.11, 24.44, 17.5799, 19.21, 23.3, 22.22, 21.61, 21.0, 21.95, 27.56, 30.85, 32.09, 33.24, 32.45, 32.56, 34.38, 33.9, 35.17, 37.59, 39.65, 40.54, 36.64, 35.89, 37.78, 36.69, 38.9099, 39.05, 38.26, 37.32, 38.67, 38.71}, _
                         New Double() {17.85, 19.05, 17.39, 17.86, 19.7, 21.23, 21.36, 18.32, 19.07, 19.62, 21.93, 24.76, 26.04, 29.63, 25.67, 26.58, 29.69, 30.14, 30.74, 29.76, 28.57, 27.24, 29.91, 31.39, 28.79, 30.17, 29.18, 25.9899, 26.16, 27.85, 30.99, 29.4, 33.05, 36.54, 39.9799, 38.56, 33.79, 28.2, 25.64, 25.55, 28.1, 29.59, 27.43, 27.57, 25.5, 19.66, 19.57, 17.48, 15.86, 15.34, 16.15, 17.03, 20.3299, 21.04, 20.01, 23.57, 23.75, 29.55, 30.81, 35.9799, 35.9799, 39.4, 39.2299, 41.42, 42.5, 41.37, 38.02, 39.61, 40.36, 39.11, 39.42, 38.8, 42.4, 44.56, 45.07, 46.57, 48.9799, 37.84, 39.9, 43.32, 34.07, 35.78, 33.12, 36.15, 33.78, 34.47, 27.21, 27.93, 37.5, 41.87, 36.87, 37.99, 41.03, 43.56, 48.72, 51.63, 52.74, 54.6, 52.27, 53.16, 46.05, 48.7299, 46.34, 47.6599, 46.4799, 47.88, 56.8, 61.1, 60.51}, _
                         New Double() {5.13, 5.47, 5.72, 6.28, 6.58, 6.66, 6.53, 6.79, 7.31, 7.61, 8.69, 9.16, 11.31, 10.81, 10.16, 13.47, 13.74, 14.01, 15.67, 14.65, 14.67, 14.41, 15.68, 14.33, 16.54, 18.79, 19.84, 19.98, 18.8, 24.02, 24.37, 21.27, 24.4, 23.47, 27.05, 30.75, 38.8, 33.28, 39.74, 36.05, 35.78, 39.99, 38.05, 41.04, 40.15, 41.04, 40.37, 51.76, 43.39, 39.62, 47.11, 30.93, 27.74, 35.47, 30.95, 30.95, 26.74, 30.54, 25.44, 19.23, 27.07, 26.16, 24.25, 30.04, 30.67, 32.37, 29.35, 25.29, 22.69, 25.78, 28.47, 29.37, 28.25, 25.87, 26.74, 23.17, 22.57, 24.25, 21.27, 21.76, 19.39, 23.71, 25.57, 22.92, 21.04, 21.0799, 21.54, 22.75, 21.89, 22.81, 23.4899, 23.59, 24.73, 23.38, 23.0, 24.48, 24.7399, 23.73, 22.3, 23.38, 23.47, 25.55, 25.4899, 24.4899, 24.81, 25.1, 26.81, 26.72, 26.75}, _
                         New Double() {8.69, 8.58, 8.76, 8.97, 9.48, 9.57, 9.61, 9.77, 10.89, 11.38, 12.59, 11.66, 13.0, 13.17, 12.09, 13.8, 15.12, 17.54, 17.65, 16.41, 17.8, 21.02, 21.69, 22.23, 24.38, 26.57, 29.93, 34.17, 31.63, 32.8, 33.14, 28.22, 32.09, 32.56, 34.15, 38.13, 39.24, 40.46, 42.55, 35.29, 33.0, 33.62, 31.35, 35.01, 33.27, 36.81, 34.05, 30.16, 33.64, 29.94, 34.08, 39.26, 41.56, 44.82, 40.5, 40.37, 42.04, 40.42, 41.56, 43.14, 42.34, 42.3, 38.5, 40.71, 40.42, 37.75, 38.85, 36.2, 37.9, 39.6, 41.04, 37.76, 39.4799, 38.93, 37.77, 34.55, 33.0, 33.38, 30.86, 31.68, 27.79, 30.43, 30.31, 29.39, 29.33, 28.81, 30.1, 29.71, 30.1, 33.14, 32.38, 29.17, 29.62, 30.81, 32.88, 34.61, 35.88, 36.06, 34.49, 35.19, 34.94, 33.89, 31.6, 32.47, 30.42, 28.78, 27.77, 26.89, 26.29}, _
                         New Double() {14.62, 14.27, 14.75, 14.99, 15.58, 16.07, 16.17, 16.1, 17.67, 18.28, 20.0799, 19.87, 21.7, 22.54, 21.53, 23.95, 26.26, 26.9, 29.36, 25.7, 26.66, 26.43, 29.62, 31.02, 30.66, 33.2, 33.0, 32.35, 33.01, 35.84, 31.44, 30.3, 28.17, 35.38, 34.95, 36.42, 36.49, 35.94, 39.32, 37.89, 37.71, 35.59, 36.84, 40.37, 38.14, 42.94, 44.22, 44.86, 41.61, 36.18, 23.36, 24.8299, 27.64, 23.5799, 23.98, 26.01, 28.18, 30.34, 31.8, 33.31, 30.81, 30.23, 26.85, 26.07, 27.89, 27.7, 31.17, 32.55, 31.95, 32.7299, 34.37, 35.11, 36.59, 37.9799, 40.36, 40.77, 40.45, 40.97, 41.24, 41.09, 41.42, 41.37, 39.53, 40.19, 40.4099, 38.65, 42.05, 42.82, 43.76, 42.5, 42.31, 42.03, 44.69, 47.78, 46.78, 48.55, 49.59, 50.29, 51.46, 52.4, 53.41, 53.93, 51.9, 55.71, 53.86, 51.18, 53.48, 55.08, 55.34}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected return of the assets is:" )
      System.Console.WriteLine( " " )
      displayArray( expectedReturns1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Minimum  value  of  the  expected  return  over  which  the  Efficient +" )
      System.Console.WriteLine( "+ Frontier exits                                                         +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    minFrontierReturn( double[] expectedReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "        Here we evaluate the minimum expected return of  the  range  over" )
      System.Console.WriteLine( "        which the Efficient Frontier exits. As a  general  remark  it  is" )
      System.Console.WriteLine( "        usually best to evaluate the range of the expected return of  the" )
      System.Console.WriteLine( "        Efficient Frontier in order to provide a  range  over  which  the" )
      System.Console.WriteLine( "        Efficient Frontier can be evaluated and the range over which  the" )
      System.Console.WriteLine( "        optimal portfolio can be sort." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" )
      Dim min1 As Double = instanceOfCapitalMarket.MinFrontierReturn( _
         expectedReturns1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The minimum  bound  of  the  range  of  the  expected  return  of  the" )
      System.Console.WriteLine( "    Efficient Frontier is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( min1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Maximum  value  of  the  expected  return  over  which  the  Efficient +" )
      System.Console.WriteLine( "+ Frontier exits                                                         +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    maxFrontierReturn( double[] expectedReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "        Here we evaluate the maximum expected return of  the  range  over" )
      System.Console.WriteLine( "        which the Efficient Frontier exits. As a  general  remark  it  is" )
      System.Console.WriteLine( "        usually best to evaluate the range of the expected return of  the" )
      System.Console.WriteLine( "        Efficient Frontier in order to provide a  range  over  which  the" )
      System.Console.WriteLine( "        Efficient Frontier can be evaluated and the range over which  the" )
      System.Console.WriteLine( "        optimal portfolio can be sort." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" )
      Dim max1 As Double = instanceOfCapitalMarket.MaxFrontierReturn( _
         expectedReturns1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The maximum  bound  of  the  range  of  the  expected  return  of  the" )
      System.Console.WriteLine( "    Efficient Frontier is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( max1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Here we construct the Efficient Frontier +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    calculateEfficientFrontier( double minimumExpectedReturn," )
      System.Console.WriteLine( "                                double maximumExpectedReturn," )
      System.Console.WriteLine( "                                double[][] covarianceMatrix," )
      System.Console.WriteLine( "                                double[] expectedReturns," )
      System.Console.WriteLine( "                                int numberInterpolationPoints," )
      System.Console.WriteLine( "                                double precision )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "        Construct the Efficient Frontier and set the results  to  private" )
      System.Console.WriteLine( "        fields.    Note  that  we  use  100  interpolation  points  equal" )
      System.Console.WriteLine( "        distributed over  the  entire  range  over  which  the  Efficient" )
      System.Console.WriteLine( "        Frontier exits." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    minimumExpectedReturn = min1" )
      System.Console.WriteLine( "    maximumExpectedReturn = max1" )
      System.Console.WriteLine( "    covarianceMatrix = covariance1" )
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" )
      System.Console.WriteLine( "    numberInterpolationPoints = 50" )
      System.Console.WriteLine( "    precision = 0.001" )
      ' Here we construct the efficient frontier.
      instanceOfCapitalMarket.CalculateEfficientFrontier( _
         min1, _
         max1, _
         covariance1, _
         expectedReturns1, _
         50, _
         0.001 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The Efficient Frontier has now been evaluate of persisted  by  setting" )
      System.Console.WriteLine( "    various private fields which record to the points about  which  it  is" )
      System.Console.WriteLine( "    interpolated." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Identify the Market Portfolio +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    marketPortfolio( double minimumExpectedReturn," )
      System.Console.WriteLine( "                     double maximumExpectedReturn," )
      System.Console.WriteLine( "                     double[][] covarianceMatrix," )
      System.Console.WriteLine( "                     double marketRate )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "        We will now identify the  market  portfolio  which  lies  of  the" )
      System.Console.WriteLine( "        Efficient Frontier and is distinguished  by  having  the  highest" )
      System.Console.WriteLine( "        return per unit of risk." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    minimumExpectedReturn = min1" )
      System.Console.WriteLine( "    maximumExpectedReturn = max1" )
      System.Console.WriteLine( "    covarianceMatrix = covariance1" )
      System.Console.WriteLine( "    marketRate = 0.1" )
      ' Here we evaluate the  weights  of  the  assets  contained  within  the
      ' Market Portfolio
      Dim marketPortfolio1 As Double() = instanceOfCapitalMarket.MarketPortfolio( _
         min1, _
         max1, _
         covariance1, _
         0.1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The weights of the assets within the market portfolio are:" )
      System.Console.WriteLine( " " )
      displayArray( marketPortfolio1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Here we evaluate the Risk of the Market Portfolio +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    marketPortfolioRisk( double[] weights," )
      System.Console.WriteLine( "                         double[][] covariance )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "        Here we evaluate the risk of the market portfolio found.  We  use" )
      System.Console.WriteLine( "        here a method from the Capital Markets class but  we  could  have" )
      System.Console.WriteLine( "        applied the MarketPortfolioRisk method from the Asset  Parameters" )
      System.Console.WriteLine( "        class." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weights = marketPortfolio1" )
      System.Console.WriteLine( "    covariance = covariance1" )
      ' Here we evaluate the risk of the market portfolio.
      Dim marketPortfolioRisk1 As Double = instanceOfCapitalMarket.MarketPortfolioRisk( _
         marketPortfolio1, _
         covariance1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the market portfolio is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( marketPortfolioRisk1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( " " )
   End Sub

   Function Double2String(ByVal d As Double) As String
      If (System.Double.IsNaN(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsNegativeInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsPositiveInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MinValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MaxValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      Dim frac As Double = d - Int(d)
      Dim frac4 As Double = Int(frac * 10000) / 10000.0
      Double2String = (Int(d) + frac4).ToString()
      Exit Function
   End Function

   Sub displayArray(ByVal a As Double())
      System.Console.Write("     {")
      For I As Integer = 0 To -1 + a.Length
         System.Console.Write(Double2String(a(I)))
         If (I < -1 + a.Length) Then System.Console.Write(", ")
      Next I
      System.Console.Write("}")
   End Sub

   Sub display2DArray(ByVal a As Double()())
      For I As Integer = 0 To -1 + a.Length
         If (I = 0) Then
            System.Console.Write("     {{")
         Else
            System.Console.Write("      {")
         End If
         For J As Integer = 0 To -1 + a(I).Length
            System.Console.Write(Double2String(a(I)(J)))
            If (J < -1 + a(I).Length) Then
               System.Console.Write(", ")
            Else
               System.Console.Write("}")
               End If
         Next J
         If (I < -1 + a.Length) Then
            System.Console.Write(",")
            System.Console.WriteLine()
            Else
               System.Console.Write("}")
            End If
      Next I
   End Sub
End Module

