Imports System
Imports Microsoft.VisualBasic
Imports WebCab.Lib.Util.Example
Imports WebCab.Libraries.Finance.Portfolio

Module Optimal4Risk4ReturnClient
   Sub Main()
      ' used components
      Dim instanceOfAssetParameters As AssetParameters = New AssetParameters
      Dim instanceOfMarkowitz As WebCab.Libraries.Finance.Portfolio.Markowitz = New WebCab.Libraries.Finance.Portfolio.Markowitz
      Dim instanceOfSolveFrontier As SolveFrontier = New SolveFrontier
      '
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "                  ##############################################" )
      System.Console.WriteLine( "                  # Optimal4Risk4Return Console Client Example #" )
      System.Console.WriteLine( "                  ##############################################" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " Overview" )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    Within this client we apply the Markowitz Theory  to  construct  the" )
      System.Console.WriteLine( "    portfolio which has:" )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "       - The lowest risk for a  given  expected  return  (i.e.  expected" )
      System.Console.WriteLine( "       performance level)" )
      System.Console.WriteLine( "       - The highest expected return  (i.e.  performance)  for  a  given" )
      System.Console.WriteLine( "       level of risk" )
      System.Console.WriteLine( "       " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    for six investment funds where each of the funds historical  monthly" )
      System.Console.WriteLine( "    returns is known over the past 3 years (approx.)." )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    Remark: In order to address the first problem it will be  sufficient" )
      System.Console.WriteLine( "    to apply methods from the Markowitz class, in  order  to  solve  for" )
      System.Console.WriteLine( "    risk we  will  need  to  use  in  addition  functionality  from  the" )
      System.Console.WriteLine( "    SolveFrontier class." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation of the Expected Returns of the  Covariance  Matrix  of  the +" )
      System.Console.WriteLine( "+ six funds                                                              +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     We first evaluate the auxiliary results of  the  evaluation  of  the" )
      System.Console.WriteLine( "     expected return and covariance matrix for the six funds." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {{4.4928, -0.5, -3.7217, 5.5363, 2.59, 3.84, -5.3557, -1.8956, -7.3863, 7.2251, 2.1183, 2.5436, 0.659, -2.3006, 0.9028, -1.4759, -0.1685, -4.1827, -4.7008, 2.44, -4.15, 2.7, 0.52, -2.02, -1.42, -6.13, 3.32, 4.5, 1.01, 1.09, 3.34, 3.96, -0.4833, 3.5881, -2.6122, 3.14, -0.1715, 3.5878, 1.5237}," )
      System.Console.WriteLine( "                        {4.2836, -1.5969, -3.5088, 5.4545, 2.6437, 4.0314, -0.7542, -2.146, -6.216, 7.1641, 8.3669, 3.4885, 4.2806, 1.446, 1.5322, -0.7604, 3.4422, -3.1453, -3.5711, 3.1147, -3.0087, 2.0966, 1.1289, -0.7481, -1.7552, -4.8194, 3.7551, 4.1362, 1.6227, 1.847, 5.2058, 3.1978, 0.3172, 3.0158, -2.8332, 4.5681, -0.8861, 1.9512, 2.3923}," )
      System.Console.WriteLine( "                        {4.1594, 0.5321, -3.8462, 6.3852, 2.1974, 4.0819, -4.4832, -0.6364, -6.8294, 7.5531, 3.4173, 2.794, 1.2265, -0.7133, 0.2657, -1.1308, 1.1437, -3.5899, -4.2387, 0.3706, -3.8758, 2.8994, 0.5832, -0.6015, -1.1212, -5.0083, 4.2191, 4.0147, 0.2446, 0.5965, 2.9805, 2.2474, -0.3817, 3.4459, -1.789, 3.97, -0.63, 3.0, 2.13}," )
      System.Console.WriteLine( "                        {9.4602, -1.1535, 0.2537, 1.9343, 0.1876, -1.2994, -2.8434, 0.6879, -2.4594, 5.7116, 3.2044, 1.0155, 2.2244, 2.7582, 3.3827, 0.2979, -0.1432, -3.9894, -3.9283, 0.0805, -8.2333, 2.8198, 5.8587, -3.2972, -3.3968, -3.4432, -1.6696, 5.4713, 4.1208, 1.0435, 7.2781, 5.3522, -1.377, 1.4556, 0.1991, 2.2443, 1.1718, 0.5, 4.97}," )
      System.Console.WriteLine( "                        {1.569, -3.4544, -0.2814, 2.9511, -0.7206, -3.5062, -1.4296, -8.4004, -2.6908, 0.3386, 3.9464, 3.1022, -2.7639, -2.8965, 1.2043, -5.1625, -6.0129, -4.7596, -5.2756, -1.4464, -9.1503, 6.7633, 4.2673, -5.9258, -7.5245, -5.7249, 0.4358, 4.8425, 1.2815, -0.9156, 6.6362, 3.1242, -4.9597, 1.8252, -0.0757, 1.2001, 0.6117, 0.1365, 0.1981}," )
      System.Console.WriteLine( "                        {4.819, -4.6227, 1.1918, 4.6195, -1.2665, -4.0698, -1.8161, -7.0, -7.0789, 1.6715, 5.588, 3.5332, -3.7416, -2.9669, 3.4756, -3.5684, -4.4025, -6.6948, -7.7679, -1.7673, -8.7342, 7.0426, 6.7659, -5.6708, -5.9616, -4.0967, -0.5444, 5.8311, 2.6441, -0.586, 6.362, 2.4468, -3.3001, 1.9114, -0.5833, 1.7702, 1.0884, 0.7227, 0.4979}}" )
      ' Here  we  evaluate  the  expected  returns  of  six  funds  using  the
      ' historical approach.
      Dim expectedReturnsOfFunds As Double() = instanceOfAssetParameters.ExpectedReturns( _
         New Double()() {New Double() {4.4928, -0.5, -3.7217, 5.5363, 2.59, 3.84, -5.3557, -1.8956, -7.3863, 7.2251, 2.1183, 2.5436, 0.659, -2.3006, 0.9028, -1.4759, -0.1685, -4.1827, -4.7008, 2.44, -4.15, 2.7, 0.52, -2.02, -1.42, -6.13, 3.32, 4.5, 1.01, 1.09, 3.34, 3.96, -0.4833, 3.5881, -2.6122, 3.14, -0.1715, 3.5878, 1.5237}, _
                         New Double() {4.2836, -1.5969, -3.5088, 5.4545, 2.6437, 4.0314, -0.7542, -2.146, -6.216, 7.1641, 8.3669, 3.4885, 4.2806, 1.446, 1.5322, -0.7604, 3.4422, -3.1453, -3.5711, 3.1147, -3.0087, 2.0966, 1.1289, -0.7481, -1.7552, -4.8194, 3.7551, 4.1362, 1.6227, 1.847, 5.2058, 3.1978, 0.3172, 3.0158, -2.8332, 4.5681, -0.8861, 1.9512, 2.3923}, _
                         New Double() {4.1594, 0.5321, -3.8462, 6.3852, 2.1974, 4.0819, -4.4832, -0.6364, -6.8294, 7.5531, 3.4173, 2.794, 1.2265, -0.7133, 0.2657, -1.1308, 1.1437, -3.5899, -4.2387, 0.3706, -3.8758, 2.8994, 0.5832, -0.6015, -1.1212, -5.0083, 4.2191, 4.0147, 0.2446, 0.5965, 2.9805, 2.2474, -0.3817, 3.4459, -1.789, 3.97, -0.63, 3.0, 2.13}, _
                         New Double() {9.4602, -1.1535, 0.2537, 1.9343, 0.1876, -1.2994, -2.8434, 0.6879, -2.4594, 5.7116, 3.2044, 1.0155, 2.2244, 2.7582, 3.3827, 0.2979, -0.1432, -3.9894, -3.9283, 0.0805, -8.2333, 2.8198, 5.8587, -3.2972, -3.3968, -3.4432, -1.6696, 5.4713, 4.1208, 1.0435, 7.2781, 5.3522, -1.377, 1.4556, 0.1991, 2.2443, 1.1718, 0.5, 4.97}, _
                         New Double() {1.569, -3.4544, -0.2814, 2.9511, -0.7206, -3.5062, -1.4296, -8.4004, -2.6908, 0.3386, 3.9464, 3.1022, -2.7639, -2.8965, 1.2043, -5.1625, -6.0129, -4.7596, -5.2756, -1.4464, -9.1503, 6.7633, 4.2673, -5.9258, -7.5245, -5.7249, 0.4358, 4.8425, 1.2815, -0.9156, 6.6362, 3.1242, -4.9597, 1.8252, -0.0757, 1.2001, 0.6117, 0.1365, 0.1981}, _
                         New Double() {4.819, -4.6227, 1.1918, 4.6195, -1.2665, -4.0698, -1.8161, -7.0, -7.0789, 1.6715, 5.588, 3.5332, -3.7416, -2.9669, 3.4756, -3.5684, -4.4025, -6.6948, -7.7679, -1.7673, -8.7342, 7.0426, 6.7659, -5.6708, -5.9616, -4.0967, -0.5444, 5.8311, 2.6441, -0.586, 6.362, 2.4468, -3.3001, 1.9114, -0.5833, 1.7702, 1.0884, 0.7227, 0.4979}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    This expected returns of the six funds is:" )
      System.Console.WriteLine( " " )
      displayArray( expectedReturnsOfFunds )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation of the Expected Returns of the  Covariance  Matrix  of  the +" )
      System.Console.WriteLine( "+ six funds                                                              +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covarianceMatrix( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {{4.4928, -0.5, -3.7217, 5.5363, 2.59, 3.84, -5.3557, -1.8956, -7.3863, 7.2251, 2.1183, 2.5436, 0.659, -2.3006, 0.9028, -1.4759, -0.1685, -4.1827, -4.7008, 2.44, -4.15, 2.7, 0.52, -2.02, -1.42, -6.13, 3.32, 4.5, 1.01, 1.09, 3.34, 3.96, -0.4833, 3.5881, -2.6122, 3.14, -0.1715, 3.5878, 1.5237}," )
      System.Console.WriteLine( "                        {4.2836, -1.5969, -3.5088, 5.4545, 2.6437, 4.0314, -0.7542, -2.146, -6.216, 7.1641, 8.3669, 3.4885, 4.2806, 1.446, 1.5322, -0.7604, 3.4422, -3.1453, -3.5711, 3.1147, -3.0087, 2.0966, 1.1289, -0.7481, -1.7552, -4.8194, 3.7551, 4.1362, 1.6227, 1.847, 5.2058, 3.1978, 0.3172, 3.0158, -2.8332, 4.5681, -0.8861, 1.9512, 2.3923}," )
      System.Console.WriteLine( "                        {4.1594, 0.5321, -3.8462, 6.3852, 2.1974, 4.0819, -4.4832, -0.6364, -6.8294, 7.5531, 3.4173, 2.794, 1.2265, -0.7133, 0.2657, -1.1308, 1.1437, -3.5899, -4.2387, 0.3706, -3.8758, 2.8994, 0.5832, -0.6015, -1.1212, -5.0083, 4.2191, 4.0147, 0.2446, 0.5965, 2.9805, 2.2474, -0.3817, 3.4459, -1.789, 3.97, -0.63, 3.0, 2.13}," )
      System.Console.WriteLine( "                        {9.4602, -1.1535, 0.2537, 1.9343, 0.1876, -1.2994, -2.8434, 0.6879, -2.4594, 5.7116, 3.2044, 1.0155, 2.2244, 2.7582, 3.3827, 0.2979, -0.1432, -3.9894, -3.9283, 0.0805, -8.2333, 2.8198, 5.8587, -3.2972, -3.3968, -3.4432, -1.6696, 5.4713, 4.1208, 1.0435, 7.2781, 5.3522, -1.377, 1.4556, 0.1991, 2.2443, 1.1718, 0.5, 4.97}," )
      System.Console.WriteLine( "                        {1.569, -3.4544, -0.2814, 2.9511, -0.7206, -3.5062, -1.4296, -8.4004, -2.6908, 0.3386, 3.9464, 3.1022, -2.7639, -2.8965, 1.2043, -5.1625, -6.0129, -4.7596, -5.2756, -1.4464, -9.9503, 6.7633, 4.2673, -5.9258, -7.5245, -5.7249, 0.4358, 4.8425, 1.2815, -0.9156, 6.6362, 3.1242, -4.9597, 1.8252, -0.0757, 1.2001, 0.6117, 0.1365, 0.1981}," )
      System.Console.WriteLine( "                        {4.819, -4.6227, 1.1918, 4.6195, -1.2665, -4.0698, -1.8161, -7.0, -7.0789, 1.6715, 5.588, 3.5332, -3.7416, -2.9669, 3.4756, -3.5684, -4.4025, -6.6948, -7.7679, -1.7673, -8.7342, 7.0426, 6.7659, -5.6708, -5.9616, -4.0967, -0.5444, 5.8311, 2.6441, -0.586, 6.362, 2.4468, -3.3001, 1.9114, -0.5833, 1.7702, 1.0884, 0.7227, 0.4979}}" )
      ' Here we evaluate the covariance matrix of the 6 funds considered.
      Dim covarianceOfFunds As Double()() = instanceOfAssetParameters.CovarianceMatrix( _
         New Double()() {New Double() {4.4928, -0.5, -3.7217, 5.5363, 2.59, 3.84, -5.3557, -1.8956, -7.3863, 7.2251, 2.1183, 2.5436, 0.659, -2.3006, 0.9028, -1.4759, -0.1685, -4.1827, -4.7008, 2.44, -4.15, 2.7, 0.52, -2.02, -1.42, -6.13, 3.32, 4.5, 1.01, 1.09, 3.34, 3.96, -0.4833, 3.5881, -2.6122, 3.14, -0.1715, 3.5878, 1.5237}, _
                         New Double() {4.2836, -1.5969, -3.5088, 5.4545, 2.6437, 4.0314, -0.7542, -2.146, -6.216, 7.1641, 8.3669, 3.4885, 4.2806, 1.446, 1.5322, -0.7604, 3.4422, -3.1453, -3.5711, 3.1147, -3.0087, 2.0966, 1.1289, -0.7481, -1.7552, -4.8194, 3.7551, 4.1362, 1.6227, 1.847, 5.2058, 3.1978, 0.3172, 3.0158, -2.8332, 4.5681, -0.8861, 1.9512, 2.3923}, _
                         New Double() {4.1594, 0.5321, -3.8462, 6.3852, 2.1974, 4.0819, -4.4832, -0.6364, -6.8294, 7.5531, 3.4173, 2.794, 1.2265, -0.7133, 0.2657, -1.1308, 1.1437, -3.5899, -4.2387, 0.3706, -3.8758, 2.8994, 0.5832, -0.6015, -1.1212, -5.0083, 4.2191, 4.0147, 0.2446, 0.5965, 2.9805, 2.2474, -0.3817, 3.4459, -1.789, 3.97, -0.63, 3.0, 2.13}, _
                         New Double() {9.4602, -1.1535, 0.2537, 1.9343, 0.1876, -1.2994, -2.8434, 0.6879, -2.4594, 5.7116, 3.2044, 1.0155, 2.2244, 2.7582, 3.3827, 0.2979, -0.1432, -3.9894, -3.9283, 0.0805, -8.2333, 2.8198, 5.8587, -3.2972, -3.3968, -3.4432, -1.6696, 5.4713, 4.1208, 1.0435, 7.2781, 5.3522, -1.377, 1.4556, 0.1991, 2.2443, 1.1718, 0.5, 4.97}, _
                         New Double() {1.569, -3.4544, -0.2814, 2.9511, -0.7206, -3.5062, -1.4296, -8.4004, -2.6908, 0.3386, 3.9464, 3.1022, -2.7639, -2.8965, 1.2043, -5.1625, -6.0129, -4.7596, -5.2756, -1.4464, -9.9503, 6.7633, 4.2673, -5.9258, -7.5245, -5.7249, 0.4358, 4.8425, 1.2815, -0.9156, 6.6362, 3.1242, -4.9597, 1.8252, -0.0757, 1.2001, 0.6117, 0.1365, 0.1981}, _
                         New Double() {4.819, -4.6227, 1.1918, 4.6195, -1.2665, -4.0698, -1.8161, -7.0, -7.0789, 1.6715, 5.588, 3.5332, -3.7416, -2.9669, 3.4756, -3.5684, -4.4025, -6.6948, -7.7679, -1.7673, -8.7342, 7.0426, 6.7659, -5.6708, -5.9616, -4.0967, -0.5444, 5.8311, 2.6441, -0.586, 6.362, 2.4468, -3.3001, 1.9114, -0.5833, 1.7702, 1.0884, 0.7227, 0.4979}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The covariance matrix between the six funds is:" )
      System.Console.WriteLine( " " )
      display2DArray( covarianceOfFunds )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ The Risk of the six funds +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolioRisk( double[] weight," )
      System.Console.WriteLine( "                   double[][] covarianceMatrix )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     Here we evaluate the (expected)  risks  of  the  funds  individually" )
      System.Console.WriteLine( "     from which using the corresponding values of  the  expected  returns" )
      System.Console.WriteLine( "     will allow you to see the  effects  of  diversification  when  these" )
      System.Console.WriteLine( "     results are compared within the optimal portfolio constructed below" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weight = {1.0, 0.0, 0.0, 0.0, 0.0, 0.0}" )
      System.Console.WriteLine( "    covarianceMatrix = covarianceOfFunds" )
      ' Here we evaluate the risk of the 1st fund
      Dim riskOf1 As Double = instanceOfAssetParameters.PortfolioRisk( _
         New Double() {1.0, 0.0, 0.0, 0.0, 0.0, 0.0}, _
         covarianceOfFunds _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the 1st fund is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( riskOf1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ The Risk of the six funds +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolioRisk( double[] weight," )
      System.Console.WriteLine( "                   double[][] covarianceMatrix )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weight = {0.0, 1.0, 0.0, 0.0, 0.0, 0.0}" )
      System.Console.WriteLine( "    covarianceMatrix = covarianceOfFunds" )
      ' Here we evaluate the risk of the 2nd fund
      Dim riskOf2 As Double = instanceOfAssetParameters.PortfolioRisk( _
         New Double() {0.0, 1.0, 0.0, 0.0, 0.0, 0.0}, _
         covarianceOfFunds _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the 2nd fund is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( riskOf2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ The Risk of the six funds +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolioRisk( double[] weight," )
      System.Console.WriteLine( "                   double[][] covarianceMatrix )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weight = {0.0, 0.0, 1.0, 0.0, 0.0, 0.0}" )
      System.Console.WriteLine( "    covarianceMatrix = covarianceOfFunds" )
      ' Here we evaluate the risk of the 3rd fund
      Dim riskOf3 As Double = instanceOfAssetParameters.PortfolioRisk( _
         New Double() {0.0, 0.0, 1.0, 0.0, 0.0, 0.0}, _
         covarianceOfFunds _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the 3rd fund is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( riskOf3 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ The Risk of the six funds +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolioRisk( double[] weight," )
      System.Console.WriteLine( "                   double[][] covarianceMatrix )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weight = {0.0, 0.0, 0.0, 1.0, 0.0, 0.0}" )
      System.Console.WriteLine( "    covarianceMatrix = covarianceOfFunds" )
      ' Here we evaluate the risk of the 4th fund
      Dim riskOf4 As Double = instanceOfAssetParameters.PortfolioRisk( _
         New Double() {0.0, 0.0, 0.0, 1.0, 0.0, 0.0}, _
         covarianceOfFunds _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the 4th fund is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( riskOf4 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ The Risk of the six funds +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolioRisk( double[] weight," )
      System.Console.WriteLine( "                   double[][] covarianceMatrix )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weight = {0.0, 0.0, 0.0, 0.0, 1.0, 0.0}" )
      System.Console.WriteLine( "    covarianceMatrix = covarianceOfFunds" )
      ' Here we evaluate the risk of the 5th fund
      Dim riskOf5 As Double = instanceOfAssetParameters.PortfolioRisk( _
         New Double() {0.0, 0.0, 0.0, 0.0, 1.0, 0.0}, _
         covarianceOfFunds _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the 5th fund is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( riskOf5 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ The Risk of the six funds +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolioRisk( double[] weight," )
      System.Console.WriteLine( "                   double[][] covarianceMatrix )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weight = {0.0, 0.0, 0.0, 0.0, 0.0, 1.0}" )
      System.Console.WriteLine( "    covarianceMatrix = covarianceOfFunds" )
      ' Here we evaluate the risk of the 6th fund
      Dim riskOf6 As Double = instanceOfAssetParameters.PortfolioRisk( _
         New Double() {0.0, 0.0, 0.0, 0.0, 0.0, 1.0}, _
         covarianceOfFunds _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the 6th fund is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( riskOf6 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the Efficient Frontier and read  off  Optimal  Portfolio  for +" )
      System.Console.WriteLine( "+ given values of the expected return                                    +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    efficientFrontier( double expectedReturn," )
      System.Console.WriteLine( "                       int numberOfAssets )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     Within this  section  we  evaluate  the  Efficient  Frontier  at  20" )
      System.Console.WriteLine( "     equally distributed points over its range and read off  the  weights" )
      System.Console.WriteLine( "     of the optimal portfolio when the expected return is 0.2, 0.4, 0.6." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn = 0.2" )
      System.Console.WriteLine( "    numberOfAssets = 6" )
      ' Here we evaluate the 20 points on the  Efficient  Frontier  and  store
      ' them with a private field.
      instanceOfMarkowitz.CalculateEfficientFrontier( _
         covarianceOfFunds, _
         expectedReturnsOfFunds, _
         20, _
         0.0001 _
      )
      ' Here we read off the value  of  the  weights  of  the  assets  of  the
      ' optimal portfolio on the Efficient Frntier when  the  expected  return
      ' is 0.2.
      Dim optimalPortfolio4Return1 As Double() = instanceOfMarkowitz.EfficientFrontier( _
         0.2, _
         6 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    When the expected return of 0.2 the weights of the assets are:" )
      System.Console.WriteLine( " " )
      displayArray( optimalPortfolio4Return1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the Efficient Frontier and read  off  Optimal  Portfolio  for +" )
      System.Console.WriteLine( "+ given values of the expected return                                    +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    efficientFrontier( double expectedReturn," )
      System.Console.WriteLine( "                       int numberOfAssets )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn = 0.4" )
      System.Console.WriteLine( "    numberOfAssets = 6" )
      ' Here we read off the value  of  the  weights  of  the  assets  of  the
      ' optimal portfolio on the Efficient Frntier when  the  expected  return
      ' is 0.4.
      Dim optimalPortfolio4Return2 As Double() = instanceOfMarkowitz.EfficientFrontier( _
         0.4, _
         6 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    When the expected return of 0.4 the weights of the assets are:" )
      System.Console.WriteLine( " " )
      displayArray( optimalPortfolio4Return2 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the Efficient Frontier and read  off  Optimal  Portfolio  for +" )
      System.Console.WriteLine( "+ given values of the expected return                                    +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    efficientFrontier( double expectedReturn," )
      System.Console.WriteLine( "                       int numberOfAssets )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn = 0.6" )
      System.Console.WriteLine( "    numberOfAssets = 6" )
      ' Here we read off the value  of  the  weights  of  the  assets  of  the
      ' optimal portfolio on the Efficient Frntier when  the  expected  return
      ' is 0.6.
      Dim optimalPortfolio4Return3 As Double() = instanceOfMarkowitz.EfficientFrontier( _
         0.6, _
         6 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    When the expected return of 0.6 the weights of the assets are:" )
      System.Console.WriteLine( " " )
      displayArray( optimalPortfolio4Return3 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Use SolveFrontier to find Optimal Portfolios for given maximum  levels +" )
      System.Console.WriteLine( "+ of risk                                                                +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findReturn( double risk," )
      System.Console.WriteLine( "                double[] riskAtPoints," )
      System.Console.WriteLine( "                double[] returnAtPoints )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    risk = 3" )
      System.Console.WriteLine( "    riskAtPoints = riskAtPoints1" )
      System.Console.WriteLine( "    returnAtPoints = returnAtPoints1" )
      ' Read off the values of the expected  return  at  which  the  Efficient
      ' Frontier was evaluated above.
      Dim returnAtPoints1 As Double() = instanceOfMarkowitz.GetEfficientFrontierExpectedReturns( _
      )
      ' Read off the values of the expected  return  at  which  the  Efficient
      ' Frontier was evaluated abive.
      Dim riskAtPoints1 As Double() = instanceOfMarkowitz.GetEfficientFrontierPortfolioRisks( _
         covarianceOfFunds _
      )
      ' Here we find the expected return of the optimal portfolio for a  given
      ' value of the risk.
      Dim optimalPortfolio4Risk1 As Double = instanceOfSolveFrontier.FindReturn( _
         3.0, _
         riskAtPoints1, _
         returnAtPoints1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The portfolio with  the  maximum  expected  return  when  the  maximum" )
      System.Console.WriteLine( "    allowable risk is 3 is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( optimalPortfolio4Risk1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Use SolveFrontier to find Optimal Portfolios for given maximum  levels +" )
      System.Console.WriteLine( "+ of risk                                                                +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findReturn( double risk," )
      System.Console.WriteLine( "                double[] riskAtPoints," )
      System.Console.WriteLine( "                double[] returnAtPoints )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    risk = 3.5" )
      System.Console.WriteLine( "    riskAtPoints = riskAtPoints1" )
      System.Console.WriteLine( "    returnAtPoints = returnAtPoints1" )
      ' Here we find the expected return of the optimal portfolio for a  given
      ' value of the risk.
      Dim optimalPortfolio4Risk2 As Double = instanceOfSolveFrontier.FindReturn( _
         3.5, _
         riskAtPoints1, _
         returnAtPoints1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The portfolio with  the  maximum  expected  return  when  the  maximum" )
      System.Console.WriteLine( "    allowable risk is 3.5 is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( optimalPortfolio4Risk2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Use SolveFrontier to find Optimal Portfolios for given maximum  levels +" )
      System.Console.WriteLine( "+ of risk                                                                +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findReturn( double risk," )
      System.Console.WriteLine( "                double[] riskAtPoints," )
      System.Console.WriteLine( "                double[] returnAtPoints )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    risk = 4" )
      System.Console.WriteLine( "    riskAtPoints = riskAtPoints1" )
      System.Console.WriteLine( "    returnAtPoints = returnAtPoints1" )
      ' Here we find the expected return of the optimal portfolio for a  given
      ' value of the risk.
      Dim optimalPortfolio4Risk3 As Double = instanceOfSolveFrontier.FindReturn( _
         4.0, _
         riskAtPoints1, _
         returnAtPoints1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The portfolio with  the  maximum  expected  return  when  the  maximum" )
      System.Console.WriteLine( "    allowable risk is 4 is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( optimalPortfolio4Risk3 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( " " )
   End Sub

   Function Double2String(ByVal d As Double) As String
      If (System.Double.IsNaN(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsNegativeInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsPositiveInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MinValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MaxValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      Dim frac As Double = d - Int(d)
      Dim frac4 As Double = Int(frac * 10000) / 10000.0
      Double2String = (Int(d) + frac4).ToString()
      Exit Function
   End Function

   Sub displayArray(ByVal a As Double())
      System.Console.Write("     {")
      For I As Integer = 0 To -1 + a.Length
         System.Console.Write(Double2String(a(I)))
         If (I < -1 + a.Length) Then System.Console.Write(", ")
      Next I
      System.Console.Write("}")
   End Sub

   Sub display2DArray(ByVal a As Double()())
      For I As Integer = 0 To -1 + a.Length
         If (I = 0) Then
            System.Console.Write("     {{")
         Else
            System.Console.Write("      {")
         End If
         For J As Integer = 0 To -1 + a(I).Length
            System.Console.Write(Double2String(a(I)(J)))
            If (J < -1 + a(I).Length) Then
               System.Console.Write(", ")
            Else
               System.Console.Write("}")
               End If
         Next J
         If (I < -1 + a.Length) Then
            System.Console.Write(",")
            System.Console.WriteLine()
            Else
               System.Console.Write("}")
            End If
      Next I
   End Sub
End Module

