Imports System
Imports Microsoft.VisualBasic
Imports WebCab.Lib.Util.Example
Imports WebCab.Libraries.Finance.Portfolio

Module SolveFrontierClient
   Sub Main()
      ' used components
      Dim instanceOfSolveFrontier As WebCab.Libraries.Finance.Portfolio.SolveFrontier = New WebCab.Libraries.Finance.Portfolio.SolveFrontier
      '
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "                     ########################################" )
      System.Console.WriteLine( "                     # SolveFrontier Console Client Example #" )
      System.Console.WriteLine( "                     ########################################" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " Overview" )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    Within this client we provide an example for  each  of  the  methods" )
      System.Console.WriteLine( "    within Solve Frontier." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Risk of Portfolios on  the  Efficient  Forntier  with  given  expected +" )
      System.Console.WriteLine( "+ returns                                                                +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findRisk( double expectedReturn," )
      System.Console.WriteLine( "              double[] riskPoints," )
      System.Console.WriteLine( "              double[] returnPoints )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What of the risk of the portfolios on the Efficient  Frontier  which" )
      System.Console.WriteLine( "     is given by the following points:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Risk = 0, Expected Return = 3 percent" )
      System.Console.WriteLine( "        - Risk = 10 percent, Expected Return = 4 percent" )
      System.Console.WriteLine( "        - Risk = 20 percent, Expected Return = 5 percent" )
      System.Console.WriteLine( "        - Risk = 40 percent, Expected Return = 10 percent" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     for the following values of the expected return 3.5, 4.5, 5.5,  6.5," )
      System.Console.WriteLine( "     7.5 percent?" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn = 0.035" )
      System.Console.WriteLine( "    riskPoints = {0.0, 0.1, 0.2, 0.4}" )
      System.Console.WriteLine( "    returnPoints = {0.03, 0.04, 0.05, 0.1}" )
      Dim findRisk1 As Double = instanceOfSolveFrontier.FindRisk( _
         0.035, _
         New Double() {0.0, 0.1, 0.2, 0.4}, _
         New Double() {0.03, 0.04, 0.05, 0.1} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" )
      System.Console.WriteLine( "    return of 3.5 percent is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( findRisk1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Risk of Portfolios on  the  Efficient  Forntier  with  given  expected +" )
      System.Console.WriteLine( "+ returns                                                                +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findRisk( double expectedReturn," )
      System.Console.WriteLine( "              double[] riskPoints," )
      System.Console.WriteLine( "              double[] returnPoints )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn = 0.045" )
      System.Console.WriteLine( "    riskPoints = {0.0, 0.1, 0.2, 0.4}" )
      System.Console.WriteLine( "    returnPoints = {0.03, 0.04, 0.05, 0.1}" )
      Dim findRisk2 As Double = instanceOfSolveFrontier.FindRisk( _
         0.045, _
         New Double() {0.0, 0.1, 0.2, 0.4}, _
         New Double() {0.03, 0.04, 0.05, 0.1} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" )
      System.Console.WriteLine( "    return of 4.5 percent is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( findRisk2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Risk of Portfolios on  the  Efficient  Forntier  with  given  expected +" )
      System.Console.WriteLine( "+ returns                                                                +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findRisk( double expectedReturn," )
      System.Console.WriteLine( "              double[] riskPoints," )
      System.Console.WriteLine( "              double[] returnPoints )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn = 0.055" )
      System.Console.WriteLine( "    riskPoints = {0.0, 0.1, 0.2, 0.4}" )
      System.Console.WriteLine( "    returnPoints = {0.03, 0.04, 0.05, 0.1}" )
      Dim findRisk3 As Double = instanceOfSolveFrontier.FindRisk( _
         0.055, _
         New Double() {0.0, 0.1, 0.2, 0.4}, _
         New Double() {0.03, 0.04, 0.05, 0.1} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" )
      System.Console.WriteLine( "    return of 5.5 percent is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( findRisk3 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Risk of Portfolios on  the  Efficient  Forntier  with  given  expected +" )
      System.Console.WriteLine( "+ returns                                                                +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findRisk( double expectedReturn," )
      System.Console.WriteLine( "              double[] riskPoints," )
      System.Console.WriteLine( "              double[] returnPoints )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn = 0.065" )
      System.Console.WriteLine( "    riskPoints = {0.0, 0.1, 0.2, 0.4}" )
      System.Console.WriteLine( "    returnPoints = {0.03, 0.04, 0.05, 0.1}" )
      Dim findRisk4 As Double = instanceOfSolveFrontier.FindRisk( _
         0.065, _
         New Double() {0.0, 0.1, 0.2, 0.4}, _
         New Double() {0.03, 0.04, 0.05, 0.1} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" )
      System.Console.WriteLine( "    return of 6.5 percent is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( findRisk4 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Risk of Portfolios on  the  Efficient  Forntier  with  given  expected +" )
      System.Console.WriteLine( "+ returns                                                                +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findRisk( double expectedReturn," )
      System.Console.WriteLine( "              double[] riskPoints," )
      System.Console.WriteLine( "              double[] returnPoints )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn = 0.075" )
      System.Console.WriteLine( "    riskPoints = {0.0, 0.1, 0.2, 0.4}" )
      System.Console.WriteLine( "    returnPoints = {0.03, 0.04, 0.05, 0.1}" )
      Dim findRisk5 As Double = instanceOfSolveFrontier.FindRisk( _
         0.075, _
         New Double() {0.0, 0.1, 0.2, 0.4}, _
         New Double() {0.03, 0.04, 0.05, 0.1} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" )
      System.Console.WriteLine( "    return of 7.5 percent is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( findRisk5 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Risk of Optimal Portfolios +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findRisk( double[] riskUtility," )
      System.Console.WriteLine( "              double[] returnUtility," )
      System.Console.WriteLine( "              double[] riskPoints," )
      System.Console.WriteLine( "              double[] returnPoints," )
      System.Console.WriteLine( "              double precision )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     For a collection of assets  we  know  that  the  Efficient  Frontier" )
      System.Console.WriteLine( "     passes through the follow four points:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Risk = 0, Expected Return = 3 percent" )
      System.Console.WriteLine( "        - Risk = 10 percent, Expected Return = 4 percent" )
      System.Console.WriteLine( "        - Risk = 20 percent, Expected Return = 5 percent" )
      System.Console.WriteLine( "        - Risk = 40 percent, Expected Return = 10 percent" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     If we also know that a given investor is prepared  to  accepted  the" )
      System.Console.WriteLine( "     following levels of risk for the corresponds levels of reward:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Expected Return = 2 percent, Maximum Risk that will accept  for" )
      System.Console.WriteLine( "        this level of return = 0" )
      System.Console.WriteLine( "        - Expected Return = 4 percent, Maximum Risk that will accept  for" )
      System.Console.WriteLine( "        this level of return = 8 percent" )
      System.Console.WriteLine( "        - Expected Return = 5 percent, Maximum Risk that will accept  for" )
      System.Console.WriteLine( "        this level of return = 30 percent" )
      System.Console.WriteLine( "        - Expected Return = 6 percent, Maximum Risk that will accept  for" )
      System.Console.WriteLine( "        this level of return = 40 percent" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     assuming that the  investors  increase  in  required  return  varies" )
      System.Console.WriteLine( "     smoothly with the risk, what is the value of the risk (to 2  decimal" )
      System.Console.WriteLine( "     places)   of  the  optimal  portfolio  constructed  from  the  given" )
      System.Console.WriteLine( "     collection of assets?" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    riskUtility = {0.0, 0.08, 0.03, 0.04}" )
      System.Console.WriteLine( "    returnUtility = {0.02, 0.04, 0.05, 0.06}" )
      System.Console.WriteLine( "    riskPoints = {0.0, 0.1, 0.2, 0.4}" )
      System.Console.WriteLine( "    returnPoints = {0.03, 0.04, 0.05, 0.1}" )
      System.Console.WriteLine( "    precision = 0.001" )
      Dim findRisk6 As Double = instanceOfSolveFrontier.FindRisk( _
         New Double() {0.0, 0.08, 0.03, 0.04}, _
         New Double() {0.02, 0.04, 0.05, 0.06}, _
         New Double() {0.0, 0.1, 0.2, 0.4}, _
         New Double() {0.03, 0.04, 0.05, 0.1}, _
         0.001 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the optimal portfolio is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( findRisk6 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Return of the Portfolios  on  the  Efficient  Frontier  with  a  given +" )
      System.Console.WriteLine( "+ expected return                                                        +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findReturn( double risk," )
      System.Console.WriteLine( "                double[] riskAtPoints," )
      System.Console.WriteLine( "                double[] returnAtPoints )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What of the expected return  of  the  portfolios  on  the  Efficient" )
      System.Console.WriteLine( "     Frontier which is given by the following points:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Risk = 0, Expected Return = 3 percent" )
      System.Console.WriteLine( "        - Risk = 10 percent, Expected Return = 4 percent" )
      System.Console.WriteLine( "        - Risk = 20 percent, Expected Return = 5 percent" )
      System.Console.WriteLine( "        - Risk = 40 percent, Expected Return = 10 percent" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     for the following values of the risk 5, 15, 25, 35, 45 percent?" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    risk = 0.05" )
      System.Console.WriteLine( "    riskAtPoints = {0.0, 0.1, 0.2, 0.4}" )
      System.Console.WriteLine( "    returnAtPoints = {0.03, 0.04, 0.05, 0.1}" )
      Dim findReturn1 As Double = instanceOfSolveFrontier.FindReturn( _
         0.05, _
         New Double() {0.0, 0.1, 0.2, 0.4}, _
         New Double() {0.03, 0.04, 0.05, 0.1} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" )
      System.Console.WriteLine( "    return of 5 percent is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( findReturn1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Return of the Portfolios  on  the  Efficient  Frontier  with  a  given +" )
      System.Console.WriteLine( "+ expected return                                                        +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findReturn( double risk," )
      System.Console.WriteLine( "                double[] riskAtPoints," )
      System.Console.WriteLine( "                double[] returnAtPoints )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    risk = 0.15" )
      System.Console.WriteLine( "    riskAtPoints = {0.0, 0.1, 0.2, 0.4}" )
      System.Console.WriteLine( "    returnAtPoints = {0.03, 0.04, 0.05, 0.1}" )
      Dim findReturn2 As Double = instanceOfSolveFrontier.FindReturn( _
         0.15, _
         New Double() {0.0, 0.1, 0.2, 0.4}, _
         New Double() {0.03, 0.04, 0.05, 0.1} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" )
      System.Console.WriteLine( "    return of 15 percent is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( findReturn2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Return of the Portfolios  on  the  Efficient  Frontier  with  a  given +" )
      System.Console.WriteLine( "+ expected return                                                        +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findReturn( double risk," )
      System.Console.WriteLine( "                double[] riskAtPoints," )
      System.Console.WriteLine( "                double[] returnAtPoints )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    risk = 0.25" )
      System.Console.WriteLine( "    riskAtPoints = {0.0, 0.1, 0.2, 0.4}" )
      System.Console.WriteLine( "    returnAtPoints = {0.03, 0.04, 0.05, 0.1}" )
      Dim findReturn3 As Double = instanceOfSolveFrontier.FindReturn( _
         0.25, _
         New Double() {0.0, 0.1, 0.2, 0.4}, _
         New Double() {0.03, 0.04, 0.05, 0.1} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" )
      System.Console.WriteLine( "    return of 25 percent is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( findReturn3 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Return of the Portfolios  on  the  Efficient  Frontier  with  a  given +" )
      System.Console.WriteLine( "+ expected return                                                        +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findReturn( double risk," )
      System.Console.WriteLine( "                double[] riskAtPoints," )
      System.Console.WriteLine( "                double[] returnAtPoints )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    risk = 0.35" )
      System.Console.WriteLine( "    riskAtPoints = {0.0, 0.1, 0.2, 0.4}" )
      System.Console.WriteLine( "    returnAtPoints = {0.03, 0.04, 0.05, 0.1}" )
      Dim findReturn4 As Double = instanceOfSolveFrontier.FindReturn( _
         0.35, _
         New Double() {0.0, 0.1, 0.2, 0.4}, _
         New Double() {0.03, 0.04, 0.05, 0.1} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" )
      System.Console.WriteLine( "    return of 35 percent is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( findReturn4 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Return of the Portfolios  on  the  Efficient  Frontier  with  a  given +" )
      System.Console.WriteLine( "+ expected return                                                        +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findReturn( double risk," )
      System.Console.WriteLine( "                double[] riskAtPoints," )
      System.Console.WriteLine( "                double[] returnAtPoints )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    risk = 0.45" )
      System.Console.WriteLine( "    riskAtPoints = {0.0, 0.1, 0.2, 0.4}" )
      System.Console.WriteLine( "    returnAtPoints = {0.03, 0.04, 0.05, 0.1}" )
      Dim findReturn5 As Double = instanceOfSolveFrontier.FindReturn( _
         0.45, _
         New Double() {0.0, 0.1, 0.2, 0.4}, _
         New Double() {0.03, 0.04, 0.05, 0.1} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the portfolio on the Efficient Frontier with  an  expected" )
      System.Console.WriteLine( "    return of 45 percent is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( findReturn5 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Value of the Expected Return of the Optimal Portfolio +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findReturn( double[] riskUtility," )
      System.Console.WriteLine( "                double[] returnUtility," )
      System.Console.WriteLine( "                double[] riskAtPoints," )
      System.Console.WriteLine( "                double[] returnAtPoints," )
      System.Console.WriteLine( "                double precision )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     For a collection of assets  we  know  that  the  Efficient  Frontier" )
      System.Console.WriteLine( "     passes through the follow four points:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Risk = 0, Expected Return = 3 percent" )
      System.Console.WriteLine( "        - Risk = 10 percent, Expected Return = 4 percent" )
      System.Console.WriteLine( "        - Risk = 20 percent, Expected Return = 5 percent" )
      System.Console.WriteLine( "        - Risk = 40 percent, Expected Return = 10 percent" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     If we also know that a given investor is prepared  to  accepted  the" )
      System.Console.WriteLine( "     following levels of risk for the corresponds levels of reward:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Expected Return = 2 percent, Maximum Risk that will accept  for" )
      System.Console.WriteLine( "        this level of return = 0" )
      System.Console.WriteLine( "        - Expected Return = 4 percent, Maximum Risk that will accept  for" )
      System.Console.WriteLine( "        this level of return = 8 percent" )
      System.Console.WriteLine( "        - Expected Return = 5 percent, Maximum Risk that will accept  for" )
      System.Console.WriteLine( "        this level of return = 30 percent" )
      System.Console.WriteLine( "        - Expected Return = 6 percent, Maximum Risk that will accept  for" )
      System.Console.WriteLine( "        this level of return = 40 percent" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     also assuming that the investors increase in required return  varies" )
      System.Console.WriteLine( "     smoothly with the risk, what is the value  of  the  expected  return" )
      System.Console.WriteLine( "     (to 2 decimal places) of the optimal portfolio constructed from  the" )
      System.Console.WriteLine( "     given collection of assets?" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    riskUtility = {0.01, 0.08, 0.03, 0.04}" )
      System.Console.WriteLine( "    returnUtility = {0.02, 0.04, 0.05, 0.06}" )
      System.Console.WriteLine( "    riskAtPoints = {0.0, 0.1, 0.2, 0.4}" )
      System.Console.WriteLine( "    returnAtPoints = {0.03, 0.04, 0.05, 0.1}" )
      System.Console.WriteLine( "    precision = 0.001" )
      Dim findReturn6 As Double = instanceOfSolveFrontier.FindReturn( _
         New Double() {0.01, 0.08, 0.03, 0.04}, _
         New Double() {0.02, 0.04, 0.05, 0.06}, _
         New Double() {0.0, 0.1, 0.2, 0.4}, _
         New Double() {0.03, 0.04, 0.05, 0.1}, _
         0.001 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected return of the optimal portfolio is:" )
      System.Console.WriteLine( " " )
      System.Console.Write( "       "  )
      System.Console.WriteLine( double2String( findReturn6 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( " " )
   End Sub

   Function Double2String(ByVal d As Double) As String
      If (System.Double.IsNaN(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsNegativeInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsPositiveInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MinValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MaxValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      Dim frac As Double = d - Int(d)
      Dim frac4 As Double = Int(frac * 10000) / 10000.0
      Double2String = (Int(d) + frac4).ToString()
      Exit Function
   End Function

   Sub displayArray(ByVal a As Double())
      System.Console.Write("     {")
      For I As Integer = 0 To -1 + a.Length
         System.Console.Write(Double2String(a(I)))
         If (I < -1 + a.Length) Then System.Console.Write(", ")
      Next I
      System.Console.Write("}")
   End Sub

   Sub display2DArray(ByVal a As Double()())
      For I As Integer = 0 To -1 + a.Length
         If (I = 0) Then
            System.Console.Write("     {{")
         Else
            System.Console.Write("      {")
         End If
         For J As Integer = 0 To -1 + a(I).Length
            System.Console.Write(Double2String(a(I)(J)))
            If (J < -1 + a(I).Length) Then
               System.Console.Write(", ")
            Else
               System.Console.Write("}")
               End If
         Next J
         If (I < -1 + a.Length) Then
            System.Console.Write(",")
            System.Console.WriteLine()
            Else
               System.Console.Write("}")
            End If
      Next I
   End Sub
End Module

