VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Form_Load()
  ' Here we demostrate how the optimal portfolios can be constructed when
  ' the historical returns are known and the portfolio is determined by given the
  ' expected return and risk, in cases where the portfolio may or may not hold cash.
  ' We also select the optimal portfolio in accordance with the investors utility
  ' function.
  
    ' Declare an instnce of class EasyOptimal
    Dim instance As WebCab_COM_PortfolioDemo.EasyOptimal
    ' Initialize the instance
    Set instance = New WebCab_COM_PortfolioDemo.EasyOptimal
    
    ' The value of the expected return for which the optimal portfolio is sort.
    Dim expectedReturns As Double
    expectedReturn = 101
    
    ' The lower bounds on the asset weights are.
    Dim lowerBounds(0 To 3) As Double
    lowerBounds(0) = 0.1
    lowerBounds(1) = 0.1
    lowerBounds(2) = 0.1
    lowerBounds(3) = 0.1
        
    ' The upper bounds on the asset weights are.
    Dim upperBounds(0 To 3) As Double
    upperBounds(0) = 0.5
    upperBounds(1) = 0.5
    upperBounds(2) = 0.5
    upperBounds(3) = 0.5
    
    ' Historical Values Used
    ' We are able to construct portfolios from four assets with the following
    ' historical returns over the last 4 months:
    '
    ' 1st Asset: 102, 101, 99, 101
    ' 2nd Asset: 100, 103, 99, 101
    ' 3rd Asset: 100, 99, 103, 101
    ' 4th Asset: 101, 101, 102, 101
    
    Dim historicalReturns(0 To 3, 0 To 3) As Double
  
    historicalReturns(0, 0) = 102
    historicalReturns(0, 1) = 101
    historicalReturns(0, 2) = 99
    historicalReturns(0, 3) = 101
    historicalReturns(1, 0) = 100
    historicalReturns(1, 1) = 103
    historicalReturns(1, 2) = 99
    historicalReturns(1, 3) = 101
    historicalReturns(2, 0) = 100
    historicalReturns(2, 1) = 99
    historicalReturns(2, 2) = 103
    historicalReturns(2, 3) = 101
    historicalReturns(3, 0) = 101
    historicalReturns(3, 1) = 101
    historicalReturns(3, 2) = 102
    historicalReturns(3, 3) = 101

    ' The precision used but the algorithm.
    Dim precision As Double
    precision = 0.000000000001
    
    
   ' Here we construct the optimal portfolio which can be constructed from Equity
   ' Assets only where the weight of each asset lies within the range [0.1, 0.5],
   ' which has an expected return of 101.
    weights = instance.MarkowitzReturn(expectedReturn, lowerBounds, upperBounds, historicalReturns, precision)
    
    
    ' These four lines just print our the result.
    MsgBox "The weights of the first asset in the optimal portfolio is: " & weights(0)
    MsgBox "The weights of the second asset in the optimal portfolio is:" & weights(1)
    MsgBox "The weights of the third asset in the optimal portfolio is:" & weights(2)
    MsgBox "The weights of the fourth asset in the optimal portfolio is:" & weights(3)


End Sub
