using System;
using WebCab.Lib.Util.Example;

public class ManyZeroWeightsClient {
   public static void Main( String[] args ) {
      // used components
      CapitalMarket instanceOfCapitalMarket = new CapitalMarket();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "                    ##########################################" );
      System.Console.WriteLine( "                    # ManyZeroWeights Console Client Example #" );
      System.Console.WriteLine( "                    ##########################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    This example demonstrates how we are able to  evaluate  a  Portfolio" );
      System.Console.WriteLine( "    on the Efficient  Frontier  with  a  given  value  of  the  expected" );
      System.Console.WriteLine( "    return. The particular feature of this example is that a  number  of" );
      System.Console.WriteLine( "    the asset weights of the optimal portfolio are  zero.  This  feature" );
      System.Console.WriteLine( "    puts particular stress on the internal optimization  algorithm  from" );
      System.Console.WriteLine( "    which the Efficient Frontier is  constructed  since  the  since  the" );
      System.Console.WriteLine( "    internal iterative search will be performed  by  ;moving  along  the" );
      System.Console.WriteLine( "    boundary;. The rationale that such instances cause problems is  that" );
      System.Console.WriteLine( "    any rounding error or step in the direction  of  the  boundary  will" );
      System.Console.WriteLine( "    cause the search to pass over  the  boundary  and  continue  on  the" );
      System.Console.WriteLine( "    other side and ultimately fail." );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    In instances when we only require to evaluate a  few  portfolios  on" );
      System.Console.WriteLine( "    the Efficient Frontier then this direct approach is  not  only  more" );
      System.Console.WriteLine( "    efficient but also more accurate." );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    Level of the Precision" );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    Another aspect of this example is that you will need to use  a  high" );
      System.Console.WriteLine( "    level of precision,  in  order  to  acheive  good  accuracy  of  the" );
      System.Console.WriteLine( "    results. With this example we  have  used  a  precision  of,  1E-12," );
      System.Console.WriteLine( "    which is sufficient. However, if say a precision of 1E-4,  which  is" );
      System.Console.WriteLine( "    sifficient for most examples had been used then the algorithm  would" );
      System.Console.WriteLine( "    have failed." );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    Historical Values Used" );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    Within this example we know that the expected returns  of  the  nine" );
      System.Console.WriteLine( "    assets considered is:" );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "       - 1st Assets Expected Return: 0.0626" );
      System.Console.WriteLine( "       - 2nd Assets Expected Return: 0.0791" );
      System.Console.WriteLine( "       - 3rd Assets Expected Return: 0.0869" );
      System.Console.WriteLine( "       - 4th Assets Expected Return: 0.094" );
      System.Console.WriteLine( "       - 5th Assets Expected Return: 0.1129" );
      System.Console.WriteLine( "       - 6th Assets Expected Return: 0.1028" );
      System.Console.WriteLine( "       - 7th Assets Expected Return: 0.1127" );
      System.Console.WriteLine( "       - 8th Assets Expected Return: 0.1081" );
      System.Console.WriteLine( "       - 9th Assets Expected Return: 0.1911" );
      System.Console.WriteLine( "       " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    Where the portfolios on the Efficient Frontier  can  be  constructed" );
      System.Console.WriteLine( "    with respect to the following asset weight constraints:" );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "       - 1st Asset Weight Constraints: Lower  bound  of  =  0.15,  Upper" );
      System.Console.WriteLine( "       bound = 1" );
      System.Console.WriteLine( "       - 2nd Asset Weight Constraints: Lower bound = 0.15,  Upper  bound" );
      System.Console.WriteLine( "       = 1" );
      System.Console.WriteLine( "       - 3rd Asset Weight Constraints: Lower bound = 0.15,  Upper  bound" );
      System.Console.WriteLine( "       = 1" );
      System.Console.WriteLine( "       - 4th Asset Weight Constraints: Lower bound = 0.00,  Upper  bound" );
      System.Console.WriteLine( "       = 1" );
      System.Console.WriteLine( "       - 5th Asset Weight Constraints: Lower bound = 0.00,  Upper  bound" );
      System.Console.WriteLine( "       = 1" );
      System.Console.WriteLine( "       - 6th Asset Weight Constraints: Lower bound = 0.00,  Upper  bound" );
      System.Console.WriteLine( "       = 1" );
      System.Console.WriteLine( "       - 7th Asset Weight Constraints: Lower bound = 0.00,  Upper  bound" );
      System.Console.WriteLine( "       = 1" );
      System.Console.WriteLine( "       - 8th Asset Weight Constraints: Lower bound = 0.00,  Upper  bound" );
      System.Console.WriteLine( "       = 1" );
      System.Console.WriteLine( "       - 9th Asset Weight Constraints: Lower bound = 0.00,  Upper  bound" );
      System.Console.WriteLine( "       = 1" );
      System.Console.WriteLine( "       " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    Remark: For the assets considered the  covariance  matrix  is  known" );
      System.Console.WriteLine( "    and will be used below where appropriate." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Setting the asset weight Constraints +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    setConstraints( double[] lowerBounds," );
      System.Console.WriteLine( "                    double[] upperBounds )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     Here we set the asset weights constraints." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    lowerBounds = {0.15, 0.15, 0.15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}" );
      System.Console.WriteLine( "    upperBounds = {1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0}" );
      // Here we set the asset weight constraints
      instanceOfCapitalMarket.SetConstraints( 
         new double[] {0.15, 0.15, 0.15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}, // lowerBounds
         new double[] {1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0} // upperBounds
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The asset weight constraints have how be set and  written  to  private" );
      System.Console.WriteLine( "    fields." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Lower Bound of the Efficient Frontier with Constraints  on  the  Asset +" );
      System.Console.WriteLine( "+ Weights                                                                +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    minFrontierReturn( double[] expectedReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     Here we evaluate the lower bound of the expected return  over  which" );
      System.Console.WriteLine( "     the (constrained) Efficient Frontier exits." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturns = {0.0626, 0.0791, 0.0869, 0.094, 0.1129, 0.1028, 0.1127, 0.1081, 0.1911}" );
      // Here  we  evaluate  the  lower  bound  over  which  the  (constrained)
      // Efficient Frontier exits.
      double lowerBound1 = instanceOfCapitalMarket.MinFrontierReturn( 
         new double[] {0.0626, 0.0791, 0.0869, 0.094, 0.1129, 0.1028, 0.1127, 0.1081, 0.1911} // expectedReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The lower bound is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( lowerBound1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Upper Bound of the Efficient Frontier with Constraints  on  the  Asset +" );
      System.Console.WriteLine( "+ Weights                                                                +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    maxFrontierReturn( double[] expectedReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     Here we evaluate the upper bound of the expected return  over  which" );
      System.Console.WriteLine( "     the (constrained) Efficient Frontier exits." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturns = {0.0626, 0.0791, 0.0869, 0.094, 0.1129, 0.1028, 0.1127, 0.1081, 0.1911}" );
      // Here  we  evaluate  the  upper  bound  over  which  the  (constrained)
      // Efficient Frontier exits.
      double upperBound1 = instanceOfCapitalMarket.MaxFrontierReturn( 
         new double[] {0.0626, 0.0791, 0.0869, 0.094, 0.1129, 0.1028, 0.1127, 0.1081, 0.1911} // expectedReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The upper bound is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( upperBound1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate the Efficient Frontier with an Expected Return of 0.08 +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    calculateEfficientFrontier( double[][] covarianceMatrix," );
      System.Console.WriteLine( "                                double[] expectedReturns," );
      System.Console.WriteLine( "                                int numberInterpolationPoints," );
      System.Console.WriteLine( "                                double precision )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     Here we evaluate the Efficient Frontier and  set  the  interpolation" );
      System.Console.WriteLine( "     points to internal fields." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    covarianceMatrix = {{8.0E-4, 7.0E-4, 4.0E-4, 0.0, 0.0, 1.0E-4, -1.0E-4, -6.0E-4, -0.0024}," );
      System.Console.WriteLine( "                        {7.0E-4, 0.0016, 0.0023, 0.0031, 0.0012, 0.0012, 0.0, -0.0010, -0.0030}," );
      System.Console.WriteLine( "                        {4.0E-4, 0.0023, 0.0044, 0.0067, 0.0026, 0.0019, -2.0E-4, -6.0E-4, -0.0033}," );
      System.Console.WriteLine( "                        {0.0, 0.0031, 0.0067, 0.012, 0.0073, 0.0058, 0.0023, 0.0022, -0.0016}," );
      System.Console.WriteLine( "                        {0.0, 0.0012, 0.0026, 0.0073, 0.0305, 0.0284, 0.0225, 0.0237, 0.0224}," );
      System.Console.WriteLine( "                        {1.0E-4, 0.0012, 0.0019, 0.0058, 0.0284, 0.0386, 0.0187, 0.0237, 0.0229}," );
      System.Console.WriteLine( "                        {-1.0E-4, 0.0, -2.0E-4, 0.0023, 0.0225, 0.0187, 0.0306, 0.0165, 0.0232}," );
      System.Console.WriteLine( "                        {-6.0E-4, -0.0010, -6.0E-4, 0.0022, 0.0237, 0.0237, 0.0165, 0.0517, 0.0376}," );
      System.Console.WriteLine( "                        {-0.0024, -0.0030, -0.0033, -0.0016, 0.0224, 0.0229, 0.0232, 0.0376, 0.0835}}" );
      System.Console.WriteLine( "    expectedReturns = {0.0626, 0.0791, 0.0869, 0.094, 0.1129, 0.1028, 0.1127, 0.1081, 0.1911}" );
      System.Console.WriteLine( "    numberInterpolationPoints = 20" );
      System.Console.WriteLine( "    precision = 0.000000000001" );
      // Here we evaluate the  portfolio  on  the  portfolio  with  an  exacted
      // return of 0.08 (i.e. 8 percent), using a precision of 0.000000001.
      instanceOfCapitalMarket.CalculateEfficientFrontier( 
         new double[][] {new double[] {8.0E-4, 7.0E-4, 4.0E-4, 0.0, 0.0, 1.0E-4, -1.0E-4, -6.0E-4, -0.0024},
                         new double[] {7.0E-4, 0.0016, 0.0023, 0.0031, 0.0012, 0.0012, 0.0, -0.0010, -0.0030},
                         new double[] {4.0E-4, 0.0023, 0.0044, 0.0067, 0.0026, 0.0019, -2.0E-4, -6.0E-4, -0.0033},
                         new double[] {0.0, 0.0031, 0.0067, 0.012, 0.0073, 0.0058, 0.0023, 0.0022, -0.0016},
                         new double[] {0.0, 0.0012, 0.0026, 0.0073, 0.0305, 0.0284, 0.0225, 0.0237, 0.0224},
                         new double[] {1.0E-4, 0.0012, 0.0019, 0.0058, 0.0284, 0.0386, 0.0187, 0.0237, 0.0229},
                         new double[] {-1.0E-4, 0.0, -2.0E-4, 0.0023, 0.0225, 0.0187, 0.0306, 0.0165, 0.0232},
                         new double[] {-6.0E-4, -0.0010, -6.0E-4, 0.0022, 0.0237, 0.0237, 0.0165, 0.0517, 0.0376},
                         new double[] {-0.0024, -0.0030, -0.0033, -0.0016, 0.0224, 0.0229, 0.0232, 0.0376, 0.0835}}, // covarianceMatrix
         new double[] {0.0626, 0.0791, 0.0869, 0.094, 0.1129, 0.1028, 0.1127, 0.1081, 0.1911}, // expectedReturns
         20, // numberInterpolationPoints
         0.000000000001 // precision
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The Efficient Frontier has been evaluated and set the private fields." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }

   public static String double2String( double d ) {
      if ( System.Double.IsNaN( d ) ) return d.ToString();
      if ( System.Double.IsNegativeInfinity( d ) ) return d.ToString();
      if ( System.Double.IsPositiveInfinity( d ) ) return d.ToString();
      if ( d == Double.MinValue ) return d.ToString();
      if ( d == Double.MaxValue ) return d.ToString();
      double frac = d - ( int )d;
      double frac4 = ( int )( frac * 10000 ) / 10000.0;
      return "" + ( ( int )d + frac4 );
   }

   public static void displayArray( double[] a ) {
      System.Console.Write( "     {" );
      for ( int i = 0; i < a.Length; i ++ ) {
         System.Console.Write( double2String( a[ i ] ) );
         if ( i < -1 + a.Length ) {
            System.Console.Write( ", " );
         }
      }
      System.Console.Write( "}" );
   }

   public static void display2DArray( double[][] a ) {
      for ( int i = 0; i < a.Length; i ++ ) {
         if ( i == 0 ) {
            System.Console.Write( "     {{" );
         } else {
            System.Console.Write( "     {" );
         }
         for ( int j = 0; j < a[ i ].Length; j ++ ) {
            System.Console.Write( double2String( a[ i ][ j ] ) );
            if ( j < -1 + a[ i ].Length ) {
               System.Console.Write( ", " );
            } else {
               System.Console.Write( "}" );
            }
         }
         if ( i < -1 + a.Length ) {
            System.Console.Write( ",\n " );
         } else {
            System.Console.Write( "}" );
         }
      }
   }
}
