using System;
using WebCab.Lib.Util.Example;

public class AbsoluteRelativeClient {
   public static void Main( String[] args ) {
      // used components
      AssetParameters instanceOfAssetParameters = new AssetParameters();
      Markowitz instanceOfMarkowitz = new Markowitz();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "                   ###########################################" );
      System.Console.WriteLine( "                   # AbsoluteRelative Console Client Example #" );
      System.Console.WriteLine( "                   ###########################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    This example demonstrates that  whether  the  absolute  or  relative" );
      System.Console.WriteLine( "    values are used for the source data of the  historical  returns  the" );
      System.Console.WriteLine( "    Portfolio Component will  yield  the  ;same;  results  in  terms  of" );
      System.Console.WriteLine( "    selecting the optimal portfolio. In particular,  we  will  show  the" );
      System.Console.WriteLine( "    independence of the Weights of the Portfolio found on the  Efficient" );
      System.Console.WriteLine( "    Frontier for a given expected return. Moreover, we  will  show  that" );
      System.Console.WriteLine( "    whether we use  absolute  or  relative  values  for  the  historical" );
      System.Console.WriteLine( "    returns the weights of the optimal portfolio  found  are  identical." );
      System.Console.WriteLine( "    One reason for this independence is that  the  units  in  which  the" );
      System.Console.WriteLine( "    historical returns are given does not  effect  the  weights  of  the" );
      System.Console.WriteLine( "    portfolio of the Efficient Frontier,  include  the  weights  of  the" );
      System.Console.WriteLine( "    optimal portfolio is that asset weights themselves  are  `unit-less'" );
      System.Console.WriteLine( "    (in the sense of Measurement  Theory).  Hence  intuitively  speaking" );
      System.Console.WriteLine( "    during the computation of the asset  weights  the  units  are  being" );
      System.Console.WriteLine( "    canceled out with the end result (i.e. the weights) being  recording" );
      System.Console.WriteLine( "    without  an  attached  unit.  Historical  Values  used  Within  this" );
      System.Console.WriteLine( "    example we will consider five assets  historical  returns  over  the" );
      System.Console.WriteLine( "    last five periods:" );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "       - 1st Asset: 0.03, 0.04, 0.02, 0.05, 0.03" );
      System.Console.WriteLine( "       - 2nd Asset: 0.03, 0.040, 0.1, 0.03, 0.035" );
      System.Console.WriteLine( "       - 3rd Asset: 0.03, 0.032, 0.033, 0.035, 0.036" );
      System.Console.WriteLine( "       - 4th Asset: 0.02, 0.021, 0.021, 0.021, 0.0205" );
      System.Console.WriteLine( "       - 5th Asset: 0.02, 0.01, 0.02, 0.015, 0.028" );
      System.Console.WriteLine( "       " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluation of the Covariance Matrix using Relative Values +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    covarianceMatrix( double[][] historicalReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here   we  evaluate  the  covariance  matrix  for  the  five  assets" );
      System.Console.WriteLine( "     considered." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    historicalReturns = {{0.03, 0.04, 0.02, 0.05, 0.03}," );
      System.Console.WriteLine( "                         {0.03, 0.04, 0.1, 0.03, 0.035}," );
      System.Console.WriteLine( "                         {0.03, 0.032, 0.033, 0.035, 0.036}," );
      System.Console.WriteLine( "                         {0.02, 0.021, 0.021, 0.021, 0.0205}," );
      System.Console.WriteLine( "                         {0.02, 0.01, 0.02, 0.015, 0.028}}" );
      // Here we evaluate the covariance matrix of the five assets considered
      double[][] covariance1 = instanceOfMarkowitz.CovarianceMatrix( 
         new double[][] {new double[] {0.03, 0.04, 0.02, 0.05, 0.03},
                         new double[] {0.03, 0.04, 0.1, 0.03, 0.035},
                         new double[] {0.03, 0.032, 0.033, 0.035, 0.036},
                         new double[] {0.02, 0.021, 0.021, 0.021, 0.0205},
                         new double[] {0.02, 0.01, 0.02, 0.015, 0.028}} // historicalReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The covariance matrix is:" );
      System.Console.WriteLine( " " );
      display2DArray( covariance1 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluation of the Expected Returns using Relative Values +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturns( double[][] historicalReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here     we  evaluate  the  expected  returns  of  the  five  assets" );
      System.Console.WriteLine( "     considered." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    historicalReturns = {{0.03, 0.04, 0.02, 0.05, 0.03}," );
      System.Console.WriteLine( "                         {0.03, 0.04, 0.1, 0.03, 0.035}," );
      System.Console.WriteLine( "                         {0.03, 0.032, 0.033, 0.035, 0.036}," );
      System.Console.WriteLine( "                         {0.02, 0.021, 0.021, 0.021, 0.0205}," );
      System.Console.WriteLine( "                         {0.02, 0.01, 0.02, 0.015, 0.028}}" );
      // Here we evaluate the expected returns of the assets.
      double[] expectedReturns1 = instanceOfMarkowitz.ExpectedReturns( 
         new double[][] {new double[] {0.03, 0.04, 0.02, 0.05, 0.03},
                         new double[] {0.03, 0.04, 0.1, 0.03, 0.035},
                         new double[] {0.03, 0.032, 0.033, 0.035, 0.036},
                         new double[] {0.02, 0.021, 0.021, 0.021, 0.0205},
                         new double[] {0.02, 0.01, 0.02, 0.015, 0.028}} // historicalReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The  expected  returns  of  the  assets  using  the  relative  set  of" );
      System.Console.WriteLine( "    historical values, which means that the  results  (i.e.  the  expected" );
      System.Console.WriteLine( "    returns) will be displayed with  respect  to  relative  values  rather" );
      System.Console.WriteLine( "    than absolute values. The values found are:" );
      System.Console.WriteLine( " " );
      displayArray( expectedReturns1 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Lower Bound of the Efficient Frontier +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    minFrontierReturn( double[] expectedReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the lower bound of the expected return  over  which" );
      System.Console.WriteLine( "     the Efficient Frontier exits." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" );
      // Here we evaluate the lower bound in  relative  terms  over  which  the
      // Efficient Frontier exits.
      double lowerBound1 = instanceOfMarkowitz.MinFrontierReturn( 
         expectedReturns1 // expectedReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The lower bound of the expected returns in relative terms  over  which" );
      System.Console.WriteLine( "    the Efficient Frontier exists is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( lowerBound1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Upper Bound of the Efficient Frontier +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    maxFrontierReturn( double[] expectedReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the upper bound of the expected return  over  which" );
      System.Console.WriteLine( "     the Efficient Frontier exits." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" );
      // Here we evaluate the upper bound in  relative  terms  over  which  the
      // Efficient Frontier exits.
      double upperBound1 = instanceOfMarkowitz.MaxFrontierReturn( 
         expectedReturns1 // expectedReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The upper bound of the expected return in relative  terms  over  which" );
      System.Console.WriteLine( "    the Efficient Frontier exists is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( upperBound1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate of a Portfolio on the Efficient  Frontier  at  the  mid-point +" );
      System.Console.WriteLine( "+ using the Relative set of Values                                       +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    efficientFrontier( double expectedReturn," );
      System.Console.WriteLine( "                       double[][] covarianceMatrix," );
      System.Console.WriteLine( "                       double[] expectedReturns," );
      System.Console.WriteLine( "                       double precision )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate a  portfolio  on  the  Efficient  Frontier  at  the" );
      System.Console.WriteLine( "     mid-point of the expected returns using  a  precision  of  1E-8  (or" );
      System.Console.WriteLine( "     equivalently 0.00000001)." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn = 0.5*(upperBound1+lowerBound1)" );
      System.Console.WriteLine( "    covarianceMatrix = covariance1" );
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" );
      System.Console.WriteLine( "    precision = 0.00000001" );
      // Here we evaluate the portfolio  at  the  mid-point  of  the  Efficient
      // Frontier using a precisin of 0.00000001.
      double[] portfolioMidPoint1 = instanceOfMarkowitz.EfficientFrontier( 
         0.5*(upperBound1+lowerBound1), // expectedReturn
         covariance1, // covarianceMatrix
         expectedReturns1, // expectedReturns
         0.00000001 // precision
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The asset weights of the mid-point portfolio found using  a  precision" );
      System.Console.WriteLine( "    of 0.00000001 are:" );
      System.Console.WriteLine( " " );
      displayArray( portfolioMidPoint1 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Here we transform the Relative Values into the Absolute Values +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    relativeToAbsolute( double[][] relativeValues )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we transform the relative historical values into an  equivalent" );
      System.Console.WriteLine( "     set of absolute values." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    relativeValues = {{0.03, 0.04, 0.02, 0.05, 0.03}," );
      System.Console.WriteLine( "                      {0.03, 0.04, 0.1, 0.03, 0.035}," );
      System.Console.WriteLine( "                      {0.03, 0.032, 0.033, 0.035, 0.036}," );
      System.Console.WriteLine( "                      {0.02, 0.021, 0.021, 0.021, 0.0205}," );
      System.Console.WriteLine( "                      {0.02, 0.01, 0.02, 0.015, 0.028}}" );
      // Here we transform the relative values into absolute values
      double[][] real2absolute = instanceOfAssetParameters.RelativeToAbsolute( 
         new double[][] {new double[] {0.03, 0.04, 0.02, 0.05, 0.03},
                         new double[] {0.03, 0.04, 0.1, 0.03, 0.035},
                         new double[] {0.03, 0.032, 0.033, 0.035, 0.036},
                         new double[] {0.02, 0.021, 0.021, 0.021, 0.0205},
                         new double[] {0.02, 0.01, 0.02, 0.015, 0.028}} // relativeValues
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    An equivalent set of absolute values is:" );
      System.Console.WriteLine( " " );
      display2DArray( real2absolute );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluation of the Covariance matrix using Absolute Values +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    covarianceMatrix( double[][] historicalReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the covariance matrix  using  an  absolute  set  of" );
      System.Console.WriteLine( "     values." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    historicalReturns = real2absolute" );
      // Here we evaluate the covariance matrix using the absolute values.
      double[][] covariance2 = instanceOfMarkowitz.CovarianceMatrix( 
         real2absolute // historicalReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The covariance matrix evaluated using an absolute set of values is:" );
      System.Console.WriteLine( " " );
      display2DArray( covariance2 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluation the Expected Returns using the Absolute Values +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturns( double[][] historicalReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluated the expected returns using  the  absolute  set  of" );
      System.Console.WriteLine( "     historical values." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    historicalReturns = real2absolute" );
      // Here we evaluate the expected returns using the absolute values.
      double[] expectedreturn2 = instanceOfMarkowitz.ExpectedReturns( 
         real2absolute // historicalReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The  expected  returns  of  the  assets  using  the  absolute  set  of" );
      System.Console.WriteLine( "    historical values, which means that the  results  (i.e.  the  expected" );
      System.Console.WriteLine( "    returns) will be displayed with  respect  to  absolute  values  rather" );
      System.Console.WriteLine( "    than relative values. The values found are:" );
      System.Console.WriteLine( " " );
      displayArray( expectedreturn2 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Lower Bound of the Efficient Frontier +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    minFrontierReturn( double[] expectedReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the lower bound of the expected return in  absolute" );
      System.Console.WriteLine( "     terms over which the Efficient Frontier exits." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturns = expectedreturn2" );
      // Here we evaluate the lower bound over  which  the  Efficient  Frontier
      // exits.
      double lowerBound2 = instanceOfMarkowitz.MinFrontierReturn( 
         expectedreturn2 // expectedReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The lower bound of the expected return in  absolute  terms  for  which" );
      System.Console.WriteLine( "    the Efficient Frontier exists is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( lowerBound2 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Upper Bound of the Efficient Frontier +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    maxFrontierReturn( double[] expectedReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the upper bound of the expected return in  absolute" );
      System.Console.WriteLine( "     terms over which the Efficient Frontier exits." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturns = expectedreturn2" );
      // Here we evaluate the upper bound over  which  the  Efficient  Frontier
      // exits.
      double upperBound2 = instanceOfMarkowitz.MaxFrontierReturn( 
         expectedreturn2 // expectedReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The upper bound of the expected return in  absolute  terms  for  which" );
      System.Console.WriteLine( "    the Efficient Frontier exists is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( upperBound2 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate the Portfolio on the  Efficient  Frontier  at  the  mid-point +" );
      System.Console.WriteLine( "+ using the Absolute set of Values                                       +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    efficientFrontier( double expectedReturn," );
      System.Console.WriteLine( "                       double[][] covarianceMatrix," );
      System.Console.WriteLine( "                       double[] expectedReturns," );
      System.Console.WriteLine( "                       double precision )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate a  portfolio  on  the  Efficient  Frontier  at  the" );
      System.Console.WriteLine( "     mid-point  of  the  expected  returns  using  the  absolute  set  of" );
      System.Console.WriteLine( "     historical values." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn = midpoint1" );
      System.Console.WriteLine( "    covarianceMatrix = covariance2" );
      System.Console.WriteLine( "    expectedReturns = expectedreturn2" );
      System.Console.WriteLine( "    precision = 0.00000001" );
      // Here we evaluate the mid-point of the expected returns.
      double midpoint1 = instanceOfAssetParameters.IntermediateValue( 
         upperBound2, // upperBound
         lowerBound2, // lowerBound
         50.0 // ratio
      );
      // Here we evaluate the portfolio at the mid-point of the  range  of  the
      // expected returns  of  the  Efficient  Frontier  using  a  precisin  of
      // 0.00000001.
      double[] portfolioMidPoint2 = instanceOfMarkowitz.EfficientFrontier( 
         midpoint1, // expectedReturn
         covariance2, // covarianceMatrix
         expectedreturn2, // expectedReturns
         0.00000001 // precision
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The asset weights of the mid-point portfolio found using the  absolute" );
      System.Console.WriteLine( "    set of historical values is:" );
      System.Console.WriteLine( " " );
      displayArray( portfolioMidPoint2 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }

   public static String double2String( double d ) {
      if ( System.Double.IsNaN( d ) ) return d.ToString();
      if ( System.Double.IsNegativeInfinity( d ) ) return d.ToString();
      if ( System.Double.IsPositiveInfinity( d ) ) return d.ToString();
      if ( d == Double.MinValue ) return d.ToString();
      if ( d == Double.MaxValue ) return d.ToString();
      double frac = d - ( int )d;
      double frac4 = ( int )( frac * 10000 ) / 10000.0;
      return "" + ( ( int )d + frac4 );
   }

   public static void displayArray( double[] a ) {
      System.Console.Write( "     {" );
      for ( int i = 0; i < a.Length; i ++ ) {
         System.Console.Write( double2String( a[ i ] ) );
         if ( i < -1 + a.Length ) {
            System.Console.Write( ", " );
         }
      }
      System.Console.Write( "}" );
   }

   public static void display2DArray( double[][] a ) {
      for ( int i = 0; i < a.Length; i ++ ) {
         if ( i == 0 ) {
            System.Console.Write( "     {{" );
         } else {
            System.Console.Write( "     {" );
         }
         for ( int j = 0; j < a[ i ].Length; j ++ ) {
            System.Console.Write( double2String( a[ i ][ j ] ) );
            if ( j < -1 + a[ i ].Length ) {
               System.Console.Write( ", " );
            } else {
               System.Console.Write( "}" );
            }
         }
         if ( i < -1 + a.Length ) {
            System.Console.Write( ",\n " );
         } else {
            System.Console.Write( "}" );
         }
      }
   }
}
