using System;
using WebCab.Lib.Util.Example;

public class EfficientClient {
   public static void Main( String[] args ) {
      // used components
      AssetParameters instanceOfAssetParameters = new AssetParameters();
      Markowitz instanceOfMarkowitz = new Markowitz();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "                       ####################################" );
      System.Console.WriteLine( "                       # Efficient Console Client Example #" );
      System.Console.WriteLine( "                       ####################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    This example demonstrates how we  are  able  to  evaluate  a  single" );
      System.Console.WriteLine( "    Portfolio on the Efficient Frontier. That is, we demonstrate how  we" );
      System.Console.WriteLine( "    are able to find any portfolio of the Efficient Frontier  with  only" );
      System.Console.WriteLine( "    one call  to  the  underlying  Rosen's  optimization  algorithm.  In" );
      System.Console.WriteLine( "    instances when we only require to evaluate a few portfolios  on  the" );
      System.Console.WriteLine( "    Efficient Frontier then  this  direct  approach  is  not  only  more" );
      System.Console.WriteLine( "    efficient but also more accurate. Level  of  the  Precision  Another" );
      System.Console.WriteLine( "    aspect of this example is that  we  show  how  the  portfolio  found" );
      System.Console.WriteLine( "    depends on the  precision  used.  In  particular,  we  find  that  a" );
      System.Console.WriteLine( "    precision of 1E-12 (or higher) should be used  in  order  to  assure" );
      System.Console.WriteLine( "    that the weights of the portfolio are corrects to 2 decimal  places." );
      System.Console.WriteLine( "    Historical Values Used Within this  example  we  use  the  following" );
      System.Console.WriteLine( "    relative historical values of five assets  historical  returns  over" );
      System.Console.WriteLine( "    the last five periods:" );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "       - 1st Asset: 0.03, 0.04, 0.02, 0.05, 0.03" );
      System.Console.WriteLine( "       - 2nd Asset: 0.03, 0.040, 0.1, 0.03, 0.035" );
      System.Console.WriteLine( "       - 3rd Asset: 0.03, 0.032, 0.033, 0.035, 0.036" );
      System.Console.WriteLine( "       - 4th Asset: 0.02, 0.021, 0.021, 0.021, 0.0205" );
      System.Console.WriteLine( "       - 5th Asset: 0.02, 0.01, 0.02, 0.015, 0.028" );
      System.Console.WriteLine( "       " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    Where the portfolios on the Efficient Frontier  can  be  constructed" );
      System.Console.WriteLine( "    with respect to the following asset weight constraints:" );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "       - 1st Asset Weight Constraints: Lower  bound  of  =  0.05,  Upper" );
      System.Console.WriteLine( "       bound = 0.2" );
      System.Console.WriteLine( "       - 2nd Asset Weight Constraints: Lower bound = 0.05,  Upper  bound" );
      System.Console.WriteLine( "       = 1" );
      System.Console.WriteLine( "       - 3rd Asset Weight Constraints: Lower bound = 0.05,  Upper  bound" );
      System.Console.WriteLine( "       = 1" );
      System.Console.WriteLine( "       - 4th Asset Weight Constraints: Lower bound = 0.05,  Upper  bound" );
      System.Console.WriteLine( "       = 0.5" );
      System.Console.WriteLine( "       - 5th Asset Weight Constraints: Lower bound = 0.05,  Upper  bound" );
      System.Console.WriteLine( "       = 1" );
      System.Console.WriteLine( "       " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluation of the Covariance Matrix +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    covarianceMatrix( double[][] historicalReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here   we  evaluate  the  covariance  matrix  for  the  five  assets" );
      System.Console.WriteLine( "     considered." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    historicalReturns = {{0.03, 0.04, 0.02, 0.05, 0.03}," );
      System.Console.WriteLine( "                         {0.03, 0.04, 0.1, 0.03, 0.035}," );
      System.Console.WriteLine( "                         {0.03, 0.032, 0.033, 0.035, 0.036}," );
      System.Console.WriteLine( "                         {0.02, 0.021, 0.021, 0.021, 0.0205}," );
      System.Console.WriteLine( "                         {0.02, 0.01, 0.02, 0.015, 0.028}}" );
      // Here we evaluate the covariance matrix of the five assets considered
      double[][] covariance1 = instanceOfMarkowitz.CovarianceMatrix( 
         new double[][] {new double[] {0.03, 0.04, 0.02, 0.05, 0.03},
                         new double[] {0.03, 0.04, 0.1, 0.03, 0.035},
                         new double[] {0.03, 0.032, 0.033, 0.035, 0.036},
                         new double[] {0.02, 0.021, 0.021, 0.021, 0.0205},
                         new double[] {0.02, 0.01, 0.02, 0.015, 0.028}} // historicalReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The covariance matrix is:" );
      System.Console.WriteLine( " " );
      display2DArray( covariance1 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluation of the Expected Returns of the Five Assets +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturns( double[][] historicalReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here     we  evaluate  the  expected  returns  of  the  five  assets" );
      System.Console.WriteLine( "     considered." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    historicalReturns = {{0.03, 0.04, 0.02, 0.05, 0.03}," );
      System.Console.WriteLine( "                         {0.03, 0.04, 0.1, 0.03, 0.035}," );
      System.Console.WriteLine( "                         {0.03, 0.032, 0.033, 0.035, 0.036}," );
      System.Console.WriteLine( "                         {0.02, 0.021, 0.021, 0.021, 0.0205}," );
      System.Console.WriteLine( "                         {0.02, 0.01, 0.02, 0.015, 0.028}}" );
      // Here we evaluate the expected returns of the assets.
      double[] expectedReturns1 = instanceOfMarkowitz.ExpectedReturns( 
         new double[][] {new double[] {0.03, 0.04, 0.02, 0.05, 0.03},
                         new double[] {0.03, 0.04, 0.1, 0.03, 0.035},
                         new double[] {0.03, 0.032, 0.033, 0.035, 0.036},
                         new double[] {0.02, 0.021, 0.021, 0.021, 0.0205},
                         new double[] {0.02, 0.01, 0.02, 0.015, 0.028}} // historicalReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The expected returns of the five assets is:" );
      System.Console.WriteLine( " " );
      displayArray( expectedReturns1 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Setting the asset weight Constraints +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    setConstraints( double[] lowerBounds," );
      System.Console.WriteLine( "                    double[] upperBounds )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we set the asset weights constraints." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    lowerBounds = {0.05, 0.05, 0.05, 0.05, 0.05}" );
      System.Console.WriteLine( "    upperBounds = {0.2, 1.0, 1.0, 0.5, 1.0}" );
      // Here we set the asset weight constraints
      instanceOfMarkowitz.SetConstraints( 
         new double[] {0.05, 0.05, 0.05, 0.05, 0.05}, // lowerBounds
         new double[] {0.2, 1.0, 1.0, 0.5, 1.0} // upperBounds
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The asset weight constraints have how be set and  written  to  private" );
      System.Console.WriteLine( "    fields." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Lower Bound of the Efficient Frontier with Constraints +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    minFrontierReturn( double[] expectedReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the lower bound of the expected return  over  which" );
      System.Console.WriteLine( "     the (constrained) Efficient Frontier exits." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" );
      // Here  we  evaluate  the  lower  bound  over  which  the  (constrained)
      // Efficient Frontier exits.
      double lowerBound1 = instanceOfMarkowitz.MinFrontierReturn( 
         expectedReturns1 // expectedReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The lower bound is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( lowerBound1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Upper Bound of the Efficient Frontier with Constraints +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    maxFrontierReturn( double[] expectedReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the upper bound of the expected return  over  which" );
      System.Console.WriteLine( "     the (constrained) Efficient Frontier exits." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" );
      // Here  we  evaluate  the  upper  bound  over  which  the  (constrained)
      // Efficient Frontier exits.
      double upperBound1 = instanceOfMarkowitz.MaxFrontierReturn( 
         expectedReturns1 // expectedReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The upper bound is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( upperBound1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate of a Portfolio on the Efficient  Frontier  at  the  mid-point +" );
      System.Console.WriteLine( "+ using a precision of 1E-2                                              +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    efficientFrontier( double expectedReturn," );
      System.Console.WriteLine( "                       double[][] covarianceMatrix," );
      System.Console.WriteLine( "                       double[] expectedReturns," );
      System.Console.WriteLine( "                       double precision )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate a  portfolio  on  the  Efficient  Frontier  at  the" );
      System.Console.WriteLine( "     mid-point of the expected returns using  a  precision  of  1E-2  (or" );
      System.Console.WriteLine( "     equivalently 0.01)." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn = midpoint1" );
      System.Console.WriteLine( "    covarianceMatrix = covariance1" );
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" );
      System.Console.WriteLine( "    precision = 0.01" );
      // Here we evaluate the mid-point of the range of the expected returns.
      double midpoint1 = instanceOfAssetParameters.IntermediateValue( 
         upperBound1, // upperBound
         lowerBound1, // lowerBound
         50.0 // ratio
      );
      // Here we evaluate the portfolio  at  the  mid-point  of  the  Efficient
      // Frontier using a precision of 0.01.
      double[] portfolioMidPoint1 = instanceOfMarkowitz.EfficientFrontier( 
         midpoint1, // expectedReturn
         covariance1, // covarianceMatrix
         expectedReturns1, // expectedReturns
         0.01 // precision
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The asset weights of the mid-point portfolio found using  a  precision" );
      System.Console.WriteLine( "    of 0.01 are:" );
      System.Console.WriteLine( " " );
      displayArray( portfolioMidPoint1 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate of a Portfolio on the Efficient  Frontier  at  the  mid-point +" );
      System.Console.WriteLine( "+ using a precision of 1E-3                                              +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    efficientFrontier( double expectedReturn," );
      System.Console.WriteLine( "                       double[][] covarianceMatrix," );
      System.Console.WriteLine( "                       double[] expectedReturns," );
      System.Console.WriteLine( "                       double precision )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate a  portfolio  on  the  Efficient  Frontier  at  the" );
      System.Console.WriteLine( "     mid-point of the expected returns using  a  precision  of  1E-3  (or" );
      System.Console.WriteLine( "     equivalently 0.001)." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn = midpoint2" );
      System.Console.WriteLine( "    covarianceMatrix = covariance1" );
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" );
      System.Console.WriteLine( "    precision = 0.001" );
      // Here we evaluate the mid-point of the range of the expected returns.
      double midpoint2 = instanceOfAssetParameters.IntermediateValue( 
         upperBound1, // upperBound
         lowerBound1, // lowerBound
         50.0 // ratio
      );
      // Here we evaluate the portfolio  at  the  mid-point  of  the  Efficient
      // Frontier using a precision of 0.001.
      double[] portfolioMidPoint2 = instanceOfMarkowitz.EfficientFrontier( 
         midpoint2, // expectedReturn
         covariance1, // covarianceMatrix
         expectedReturns1, // expectedReturns
         0.001 // precision
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The asset weights of the mid-point portfolio found using  a  precision" );
      System.Console.WriteLine( "    of 0.001 are:" );
      System.Console.WriteLine( " " );
      displayArray( portfolioMidPoint2 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate of a Portfolio on the Efficient  Frontier  at  the  mid-point +" );
      System.Console.WriteLine( "+ using a precision of 1E-4                                              +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    efficientFrontier( double expectedReturn," );
      System.Console.WriteLine( "                       double[][] covarianceMatrix," );
      System.Console.WriteLine( "                       double[] expectedReturns," );
      System.Console.WriteLine( "                       double precision )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate a  portfolio  on  the  Efficient  Frontier  at  the" );
      System.Console.WriteLine( "     mid-point of the expected returns using  a  precision  of  1E-4  (or" );
      System.Console.WriteLine( "     equivalently 0.0001)." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn = midpoint3" );
      System.Console.WriteLine( "    covarianceMatrix = covariance1" );
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" );
      System.Console.WriteLine( "    precision = 0.0001" );
      // Here we evaluate the mid-point of the range of the expected returns.
      double midpoint3 = instanceOfAssetParameters.IntermediateValue( 
         upperBound1, // upperBound
         lowerBound1, // lowerBound
         50.0 // ratio
      );
      // Here we evaluate the portfolio  at  the  mid-point  of  the  Efficient
      // Frontier using a precision of 1E-4 (or equivalently 0.0001).
      double[] portfolioMidPoint3 = instanceOfMarkowitz.EfficientFrontier( 
         midpoint3, // expectedReturn
         covariance1, // covarianceMatrix
         expectedReturns1, // expectedReturns
         0.0001 // precision
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The asset weights of the mid-point portfolio found using  a  precision" );
      System.Console.WriteLine( "    of 1E-4 are:" );
      System.Console.WriteLine( " " );
      displayArray( portfolioMidPoint3 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate of a Portfolio on the Efficient  Frontier  at  the  mid-point +" );
      System.Console.WriteLine( "+ using a precision of 1E-5                                              +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    efficientFrontier( double expectedReturn," );
      System.Console.WriteLine( "                       double[][] covarianceMatrix," );
      System.Console.WriteLine( "                       double[] expectedReturns," );
      System.Console.WriteLine( "                       double precision )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate a  portfolio  on  the  Efficient  Frontier  at  the" );
      System.Console.WriteLine( "     mid-point of the expected returns using  a  precision  of  1E-5  (or" );
      System.Console.WriteLine( "     equivalently 0.00001)." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn = midpoint4" );
      System.Console.WriteLine( "    covarianceMatrix = covariance1" );
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" );
      System.Console.WriteLine( "    precision = 0.00001" );
      // Here we evaluate the mid-point of the range of the expected returns.
      double midpoint4 = instanceOfAssetParameters.IntermediateValue( 
         upperBound1, // upperBound
         lowerBound1, // lowerBound
         50.0 // ratio
      );
      // Here we evaluate the portfolio  at  the  mid-point  of  the  Efficient
      // Frontier using a precision of 1E-5 (or equivalently 0.00001).
      double[] portfolioMidPoint4 = instanceOfMarkowitz.EfficientFrontier( 
         midpoint4, // expectedReturn
         covariance1, // covarianceMatrix
         expectedReturns1, // expectedReturns
         0.00001 // precision
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The asset weights of the mid-point portfolio found using  a  precision" );
      System.Console.WriteLine( "    of 1E-5 are:" );
      System.Console.WriteLine( " " );
      displayArray( portfolioMidPoint4 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate of a Portfolio on the Efficient  Frontier  at  the  mid-point +" );
      System.Console.WriteLine( "+ using a precision of 1E-6                                              +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    efficientFrontier( double expectedReturn," );
      System.Console.WriteLine( "                       double[][] covarianceMatrix," );
      System.Console.WriteLine( "                       double[] expectedReturns," );
      System.Console.WriteLine( "                       double precision )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate a  portfolio  on  the  Efficient  Frontier  at  the" );
      System.Console.WriteLine( "     mid-point of the expected returns using  a  precision  of  1E-6  (or" );
      System.Console.WriteLine( "     equivalently 0.000001)." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn = midpoint5" );
      System.Console.WriteLine( "    covarianceMatrix = covariance1" );
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" );
      System.Console.WriteLine( "    precision = 0.000001" );
      // Here we evaluate the mid-point of the range of the expected returns.
      double midpoint5 = instanceOfAssetParameters.IntermediateValue( 
         upperBound1, // upperBound
         lowerBound1, // lowerBound
         50.0 // ratio
      );
      // Here we evaluate the portfolio  at  the  mid-point  of  the  Efficient
      // Frontier using a precision of 1E-6 (or equivalently 0.000001).
      double[] portfolioMidPoint5 = instanceOfMarkowitz.EfficientFrontier( 
         midpoint5, // expectedReturn
         covariance1, // covarianceMatrix
         expectedReturns1, // expectedReturns
         0.000001 // precision
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The asset weights of the mid-point portfolio found using  a  precision" );
      System.Console.WriteLine( "    of 1E-6 are:" );
      System.Console.WriteLine( " " );
      displayArray( portfolioMidPoint5 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate of a Portfolio on the Efficient  Frontier  at  the  mid-point +" );
      System.Console.WriteLine( "+ using a precision of 1E-7                                              +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    efficientFrontier( double expectedReturn," );
      System.Console.WriteLine( "                       double[][] covarianceMatrix," );
      System.Console.WriteLine( "                       double[] expectedReturns," );
      System.Console.WriteLine( "                       double precision )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate a  portfolio  on  the  Efficient  Frontier  at  the" );
      System.Console.WriteLine( "     mid-point of the expected returns using  a  precision  of  1E-7  (or" );
      System.Console.WriteLine( "     equivalently 0.0000001)." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn = midpoint6" );
      System.Console.WriteLine( "    covarianceMatrix = covariance1" );
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" );
      System.Console.WriteLine( "    precision = 0.0000001" );
      // Here we evaluate the mid-point of the range of the expected returns.
      double midpoint6 = instanceOfAssetParameters.IntermediateValue( 
         upperBound1, // upperBound
         lowerBound1, // lowerBound
         50.0 // ratio
      );
      // Here we evaluate the portfolio  at  the  mid-point  of  the  Efficient
      // Frontier using a precision of 1E-7 (or equivalently 0.0000001).
      double[] portfolioMidPoint6 = instanceOfMarkowitz.EfficientFrontier( 
         midpoint6, // expectedReturn
         covariance1, // covarianceMatrix
         expectedReturns1, // expectedReturns
         0.0000001 // precision
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The asset weights of the mid-point portfolio found using  a  precision" );
      System.Console.WriteLine( "    of 1E-7 are:" );
      System.Console.WriteLine( " " );
      displayArray( portfolioMidPoint6 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }

   public static String double2String( double d ) {
      if ( System.Double.IsNaN( d ) ) return d.ToString();
      if ( System.Double.IsNegativeInfinity( d ) ) return d.ToString();
      if ( System.Double.IsPositiveInfinity( d ) ) return d.ToString();
      if ( d == Double.MinValue ) return d.ToString();
      if ( d == Double.MaxValue ) return d.ToString();
      double frac = d - ( int )d;
      double frac4 = ( int )( frac * 10000 ) / 10000.0;
      return "" + ( ( int )d + frac4 );
   }

   public static void displayArray( double[] a ) {
      System.Console.Write( "     {" );
      for ( int i = 0; i < a.Length; i ++ ) {
         System.Console.Write( double2String( a[ i ] ) );
         if ( i < -1 + a.Length ) {
            System.Console.Write( ", " );
         }
      }
      System.Console.Write( "}" );
   }

   public static void display2DArray( double[][] a ) {
      for ( int i = 0; i < a.Length; i ++ ) {
         if ( i == 0 ) {
            System.Console.Write( "     {{" );
         } else {
            System.Console.Write( "     {" );
         }
         for ( int j = 0; j < a[ i ].Length; j ++ ) {
            System.Console.Write( double2String( a[ i ][ j ] ) );
            if ( j < -1 + a[ i ].Length ) {
               System.Console.Write( ", " );
            } else {
               System.Console.Write( "}" );
            }
         }
         if ( i < -1 + a.Length ) {
            System.Console.Write( ",\n " );
         } else {
            System.Console.Write( "}" );
         }
      }
   }
}
