using System;
using WebCab.Lib.Util.Example;

public class PerformanceEvaluationClient {
   public static void Main( String[] args ) {
      // used components
      PerformanceEvaluation instanceOfPerformanceEvaluation = new PerformanceEvaluation();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "                 ################################################" );
      System.Console.WriteLine( "                 # PerformanceEvaluation Console Client Example #" );
      System.Console.WriteLine( "                 ################################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Within this client we provide an example of the application of  each" );
      System.Console.WriteLine( "    of the methods within Performance Evaluation." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluation of the Expected Return of a Portfolio +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    portfolioReturn( double[] weight," );
      System.Console.WriteLine( "                     double[] returns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the expected return of a portfolio  which  consists  of  the" );
      System.Console.WriteLine( "     following three assets:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - High Return Asset: Weight in Portfolio = 0.1,  Expected  return" );
      System.Console.WriteLine( "        = 10 percent" );
      System.Console.WriteLine( "        - Medium Risk Asset  1:  Weight  in  Portfolio  =  0.3,  Expected" );
      System.Console.WriteLine( "        return = 7 percent" );
      System.Console.WriteLine( "        - Medium Risk Asset  2:  Weight  in  Portfolio  =  0.4,  Expected" );
      System.Console.WriteLine( "        return = 4 percent" );
      System.Console.WriteLine( "        - Low Risk Asset: Weight in Portfolio = 0.2, Expected Return =  5" );
      System.Console.WriteLine( "        percent" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    weight = {0.1, 0.3, 0.4, 0.2}" );
      System.Console.WriteLine( "    returns = {0.1, 0.07, 0.04, 0.05}" );
      // Here we evaluate the expected return of the portfolio
      double portfolioReturn1 = instanceOfPerformanceEvaluation.PortfolioReturn( 
         new double[] {0.1, 0.3, 0.4, 0.2}, // weight
         new double[] {0.1, 0.07, 0.04, 0.05} // returns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The Expected Return of the Portfolio is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( portfolioReturn1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ The Total Return of a Portfolio +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    totalReturn( double disbursement," );
      System.Console.WriteLine( "                 double dividends," );
      System.Console.WriteLine( "                 double marketPriceStart," );
      System.Console.WriteLine( "                 double marketPriceEnd )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the total return over one year from a mining  stock  if  the" );
      System.Console.WriteLine( "     market price of the stock at the start  of  the  year  was  90,  the" );
      System.Console.WriteLine( "     market price at the end of the year was  80,  during  the  year  the" );
      System.Console.WriteLine( "     company paid a special dividend of 12.3 USD after  selling  of  some" );
      System.Console.WriteLine( "     mining asset and the company pay two dividends during the year of  5" );
      System.Console.WriteLine( "     USD and 3 USD?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    disbursement = 12.3" );
      System.Console.WriteLine( "    dividends = 8" );
      System.Console.WriteLine( "    marketPriceStart = 90" );
      System.Console.WriteLine( "    marketPriceEnd = 80" );
      // Here we evaluate the annual return from the portfolio
      double totalReturn1 = instanceOfPerformanceEvaluation.TotalReturn( 
         12.3, // disbursement
         8.0, // dividends
         90.0, // marketPriceStart
         80.0 // marketPriceEnd
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The total return from the mining stock over the year is" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( totalReturn1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Geometric Mean Return of a Portfolio +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    geometricMeanReturn( double[] returnOverEachPeriod )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     We know that the return of an investment over  the  1st,  2nd,  3rd," );
      System.Console.WriteLine( "     4th and 5th year will be 10%, 12%, 15%, 13%  and  16%  respectively." );
      System.Console.WriteLine( "     What is the fixed rate of return over the 5 year period which  would" );
      System.Console.WriteLine( "     offer the equivalent return?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    returnOverEachPeriod = {0.1, 0.12, 0.15, 0.13, 0.16}" );
      // Here we evaluate the geometric mean return of the investment
      double geometricMeanReturn1 = instanceOfPerformanceEvaluation.GeometricMeanReturn( 
         new double[] {0.1, 0.12, 0.15, 0.13, 0.16} // returnOverEachPeriod
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The equivalent rate of equal to the geometric mean return, which is" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( geometricMeanReturn1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Sharpe's Ratio of two Portfolios Performance +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    sharpesRatio( double averageReturn," );
      System.Console.WriteLine( "                  double standardDeviation," );
      System.Console.WriteLine( "                  double riskFree )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Which of the following two portfolios offers  the  best  return  per" );
      System.Console.WriteLine( "     unit of risk over the annual period considered:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - 1st Portfolio: Annual  Return  =  7  percent,  Annual  Standard" );
      System.Console.WriteLine( "        Deviation = 2 percent, (Annual)  Risk  free  interest  rate  =  3" );
      System.Console.WriteLine( "        percent" );
      System.Console.WriteLine( "        - 2nd Portfolio: Annual  Return  =  8  percent,  Annual  Standard" );
      System.Console.WriteLine( "        Deviation = 4 percent, (Annual)  Risk  free  interest  rate  =  3" );
      System.Console.WriteLine( "        percent" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     That is, which portfolio offer the best return  in  accordance  with" );
      System.Console.WriteLine( "     Sharpe's ratio?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    averageReturn = 0.07" );
      System.Console.WriteLine( "    standardDeviation = 0.02" );
      System.Console.WriteLine( "    riskFree = 0.03" );
      // Here we evaluate Sharpe's Ratio of the 1st portfolio with a 7  percent
      // return
      double sharpesRatio1 = instanceOfPerformanceEvaluation.SharpesRatio( 
         0.07, // averageReturn
         0.02, // standardDeviation
         0.03 // riskFree
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Sharpe's Ratio of the 1st Portfolio is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( sharpesRatio1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Sharpe's Ratio of two Portfolios Performance +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    sharpesRatio( double averageReturn," );
      System.Console.WriteLine( "                  double standardDeviation," );
      System.Console.WriteLine( "                  double riskFree )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    averageReturn = 0.08" );
      System.Console.WriteLine( "    standardDeviation = 0.04" );
      System.Console.WriteLine( "    riskFree = 0.03" );
      // Here we evaluate Sharpe's Ratio of the 2nd portfolio with a 8  percent
      // return
      double sharpesRatio2 = instanceOfPerformanceEvaluation.SharpesRatio( 
         0.08, // averageReturn
         0.04, // standardDeviation
         0.03 // riskFree
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Sharpe's Ratio of the 2nd Portfolio is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( sharpesRatio2 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Treynor's Ratio of Two Portfolios Performance +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    treynorsMeasure( double averageReturn," );
      System.Console.WriteLine( "                     double beta," );
      System.Console.WriteLine( "                     double riskFree )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Which of the following two US Treasury Bond  portfolios  offers  the" );
      System.Console.WriteLine( "     best risk adjusted return as measured by the Treynor measure over  a" );
      System.Console.WriteLine( "     1 year period:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - 1st Portfolio: Annual Return = 8 percent, Beta (w.r.t. US  Bond" );
      System.Console.WriteLine( "        index) = 3, (Annual) Risk free interest rate = 3 percent" );
      System.Console.WriteLine( "        - 2nd Portfolio: Annual Return = 4 percent, Beta (w.r.t. US  Bond" );
      System.Console.WriteLine( "        index) = 0.9, (Annual) Risk free interest rate = 3 percent" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     That is, which bond portfolio has the highest Treynor measure?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    averageReturn = 0.08" );
      System.Console.WriteLine( "    beta = 1.2" );
      System.Console.WriteLine( "    riskFree = 0.03" );
      // Here we evaluate Treynors Ratio of the 1st portfolio
      double treynorsMeasure1 = instanceOfPerformanceEvaluation.TreynorsMeasure( 
         0.08, // averageReturn
         1.2, // beta
         0.03 // riskFree
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The Treynors measure of the 1st portfolio over the 1 year period is" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( treynorsMeasure1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Treynor's Ratio of Two Portfolios Performance +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    treynorsMeasure( double averageReturn," );
      System.Console.WriteLine( "                     double beta," );
      System.Console.WriteLine( "                     double riskFree )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    averageReturn = 0.04" );
      System.Console.WriteLine( "    beta = 0.9" );
      System.Console.WriteLine( "    riskFree = 0.03" );
      // Here we evaluate Treynors Ratio of the 2nd portfolio
      double treynorsMeasure2 = instanceOfPerformanceEvaluation.TreynorsMeasure( 
         0.04, // averageReturn
         0.9, // beta
         0.03 // riskFree
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The Treynors measure of the 2nd portfolio over the 1 year period is" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( treynorsMeasure2 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }

   public static String double2String( double d ) {
      if ( System.Double.IsNaN( d ) ) return d.ToString();
      if ( System.Double.IsNegativeInfinity( d ) ) return d.ToString();
      if ( System.Double.IsPositiveInfinity( d ) ) return d.ToString();
      if ( d == Double.MinValue ) return d.ToString();
      if ( d == Double.MaxValue ) return d.ToString();
      double frac = d - ( int )d;
      double frac4 = ( int )( frac * 10000 ) / 10000.0;
      return "" + ( ( int )d + frac4 );
   }

   public static void displayArray( double[] a ) {
      System.Console.Write( "     {" );
      for ( int i = 0; i < a.Length; i ++ ) {
         System.Console.Write( double2String( a[ i ] ) );
         if ( i < -1 + a.Length ) {
            System.Console.Write( ", " );
         }
      }
      System.Console.Write( "}" );
   }

   public static void display2DArray( double[][] a ) {
      for ( int i = 0; i < a.Length; i ++ ) {
         if ( i == 0 ) {
            System.Console.Write( "     {{" );
         } else {
            System.Console.Write( "     {" );
         }
         for ( int j = 0; j < a[ i ].Length; j ++ ) {
            System.Console.Write( double2String( a[ i ][ j ] ) );
            if ( j < -1 + a[ i ].Length ) {
               System.Console.Write( ", " );
            } else {
               System.Console.Write( "}" );
            }
         }
         if ( i < -1 + a.Length ) {
            System.Console.Write( ",\n " );
         } else {
            System.Console.Write( "}" );
         }
      }
   }
}
