using System;
using WebCab.Lib.Util.Example;

public class OptimalDiversificationClient {
   public static void Main( String[] args ) {
      // used components
      AssetParameters instanceOfAssetParameters = new AssetParameters();
      TwoAssetPortfolio instanceOfTwoAssetPortfolio = new TwoAssetPortfolio();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "                #################################################" );
      System.Console.WriteLine( "                # OptimalDiversification Console Client Example #" );
      System.Console.WriteLine( "                #################################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    With this example we consider the following problem: Say  the  first" );
      System.Console.WriteLine( "    asset represents a portfolio which is  held  and  the  second  asset" );
      System.Console.WriteLine( "    represents an asset which the portfolio manager  wishes  to  add  to" );
      System.Console.WriteLine( "    the portfolio such the optimal effects (i.e. minimize the  risk)  of" );
      System.Console.WriteLine( "    diversification from the purchase is felt. The question  to  address" );
      System.Console.WriteLine( "    here now many of shares of Asset 2 should the portfolio manager  buy" );
      System.Console.WriteLine( "    in order to achieve this? We will consider  two  assets,  for  which" );
      System.Console.WriteLine( "    you know three possible returns may take place and  you  can  assign" );
      System.Console.WriteLine( "    corresponding probabilities for each of these returns  taking  place" );
      System.Console.WriteLine( "    in accordance with the following table: State | Asset1  |  Asset2  |" );
      System.Console.WriteLine( "    Probability -------------------------------------- 1st state  |  300" );
      System.Console.WriteLine( "    | 500 | 0.5 2nd state | 310 | 400 | 0.2 3rd state | 330 | 550 | 0.3" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ First we evaluate the Standard deviation of the  Portfolio  (i.e.  1st +" );
      System.Console.WriteLine( "+ Asset)                                                                 +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    standardDeviation( double[] historicalReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here      we  evaluate  the  standard  deviation  of  the  portfolio" );
      System.Console.WriteLine( "     corresponding to th 1st asset." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    historicalReturns = {300.0, 310.0, 330.0}" );
      // Here        we  evaluate  the  standard  deviation  of  the  portfolio
      // corresponding to th 1st asset.
      double standard1 = instanceOfTwoAssetPortfolio.StandardDeviation( 
         new double[] {300.0, 310.0, 330.0} // historicalReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The standard deviation of the portfolio is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( standard1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Then we evaluate the Standard Deviation of the 2nd Asset +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    standardDeviation( double[] historicalReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the standard deviation of the 2nd Asset." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    historicalReturns = {500.0, 400.0, 550.0}" );
      // Here we evaluate the standard deviation of the 2nd Asset.
      double standard2 = instanceOfTwoAssetPortfolio.StandardDeviation( 
         new double[] {500.0, 400.0, 550.0} // historicalReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The standard deviation of the 2nd Asset is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( standard2 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Covariance between the two Asset is Evaluted +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    covariance( double[] probability," );
      System.Console.WriteLine( "                double[] rateOfReturn1," );
      System.Console.WriteLine( "                double[] rateOfReturn2 )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the covariance between the Portfolio  and  the  2nd" );
      System.Console.WriteLine( "     Asset." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probability = {0.5, 0.2, 0.3}" );
      System.Console.WriteLine( "    rateOfReturn1 = {300.0, 310.0, 330.0}" );
      System.Console.WriteLine( "    rateOfReturn2 = {500.0, 400.0, 550.0}" );
      // Here we evaluate the covariance between  the  Portfolio  and  the  2nd
      // Asset.
      double covariance1 = instanceOfTwoAssetPortfolio.Covariance( 
         new double[] {0.5, 0.2, 0.3}, // probability
         new double[] {300.0, 310.0, 330.0}, // rateOfReturn1
         new double[] {500.0, 400.0, 550.0} // rateOfReturn2
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The covariance between the two assets is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( covariance1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Now we can evaluate the optimal weight +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    weight2MinimizeRisk( double standardDeviation1," );
      System.Console.WriteLine( "                         double standardDeviation2," );
      System.Console.WriteLine( "                         double covariance )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the weight of the original  portfolio  (i.e.  Asset" );
      System.Console.WriteLine( "     1) within the constructed  portfolio  consisting  of  Portfolio  and" );
      System.Console.WriteLine( "     Asset 2, in which the risk is minimized." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    standardDeviation1 = standard1" );
      System.Console.WriteLine( "    standardDeviation2 = standard2" );
      System.Console.WriteLine( "    covariance = covariance1" );
      // Here   is  evaluate  the  weight  of  the  Portfolio  in  the  optimal
      // portfolio.
      double optimalWeight1 = instanceOfTwoAssetPortfolio.Weight2MinimizeRisk( 
         standard1, // standardDeviation1
         standard2, // standardDeviation2
         covariance1 // covariance
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The optimal weight in terms of minimizing the risk  of  the  portfolio" );
      System.Console.WriteLine( "    is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( optimalWeight1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Risk of the Optimal Portfolio +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    portfolio2Risk( double alpha," );
      System.Console.WriteLine( "                    double standardDeviation1," );
      System.Console.WriteLine( "                    double standardDeviation2," );
      System.Console.WriteLine( "                    double covariance )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the Risk of the Optimal  Portfolio.  That  is,  the" );
      System.Console.WriteLine( "     risk of the portfolio found which  take  maximum  advantage  of  the" );
      System.Console.WriteLine( "     effects of diversification." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    alpha = optimalWeight1" );
      System.Console.WriteLine( "    standardDeviation1 = standard1" );
      System.Console.WriteLine( "    standardDeviation2 = standard2" );
      System.Console.WriteLine( "    covariance = covariance1" );
      // Here we evaluate the risk pf the optimal portfolio.
      double riskOptimalPort1 = instanceOfTwoAssetPortfolio.Portfolio2Risk( 
         optimalWeight1, // alpha
         standard1, // standardDeviation1
         standard2, // standardDeviation2
         covariance1 // covariance
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( riskOptimalPort1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Expected Return of the Optimal Portfolio +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    portfolio2Return( double alpha," );
      System.Console.WriteLine( "                      double expectedReturn1," );
      System.Console.WriteLine( "                      double expectedReturn2 )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate  the  expected  return  of  the  optimal  portfolio" );
      System.Console.WriteLine( "     found." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    alpha = optimalWeight1" );
      System.Console.WriteLine( "    expectedReturn1 = expected1" );
      System.Console.WriteLine( "    expectedReturn2 = expected2" );
      // Here we evaluate the expected return of Asset 1.
      double expected1 = instanceOfAssetParameters.ExpectedReturn( 
         new double[] {0.5, 0.2, 0.3}, // probability
         new double[] {300.0, 310.0, 330.0} // returns
      );
      // Here we evaluate the expected return of Asset 2.
      double expected2 = instanceOfAssetParameters.ExpectedReturn( 
         new double[] {0.5, 0.2, 0.3}, // probability
         new double[] {500.0, 400.0, 550.0} // returns
      );
      // Here we evaluate the expected return of the optimal portfolio found.
      double expectedPort1 = instanceOfTwoAssetPortfolio.Portfolio2Return( 
         optimalWeight1, // alpha
         expected1, // expectedReturn1
         expected2 // expectedReturn2
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The expected return of the optimal portfolio is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( expectedPort1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Risk of the Original Portfolio +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    standardDeviation( double[] historicalReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Note that the risk is just another terms for the standard  deviation" );
      System.Console.WriteLine( "     which we evaluate for the original portfolio (i.e. Asset 1) here." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    historicalReturns = {300.0, 310.0, 330.0}" );
      // Here we evaluate the risk (i.e. standard deviation)  of  the  original
      // portfolio (i.e. Asset 1).
      double risk1 = instanceOfTwoAssetPortfolio.StandardDeviation( 
         new double[] {300.0, 310.0, 330.0} // historicalReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The risk (or standard deviation) of the original portfolio is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( risk1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Expected Return of the Original Portfolio +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedReturn( double[] probability," );
      System.Console.WriteLine( "                    double[] returns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the  expected  return  of  the  original  portfolio" );
      System.Console.WriteLine( "     (i.e. Asset 1)" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probability = {0.5, 0.2, 0.3}" );
      System.Console.WriteLine( "    returns = {300.0, 310.0, 330.0}" );
      // Here we evaluate the expeted return of the original portfolio.
      double originalPortExpectedReturn1 = instanceOfAssetParameters.ExpectedReturn( 
         new double[] {0.5, 0.2, 0.3}, // probability
         new double[] {300.0, 310.0, 330.0} // returns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The expected return of the original portfolio is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( originalPortExpectedReturn1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }

   public static String double2String( double d ) {
      if ( System.Double.IsNaN( d ) ) return d.ToString();
      if ( System.Double.IsNegativeInfinity( d ) ) return d.ToString();
      if ( System.Double.IsPositiveInfinity( d ) ) return d.ToString();
      if ( d == Double.MinValue ) return d.ToString();
      if ( d == Double.MaxValue ) return d.ToString();
      double frac = d - ( int )d;
      double frac4 = ( int )( frac * 10000 ) / 10000.0;
      return "" + ( ( int )d + frac4 );
   }

   public static void displayArray( double[] a ) {
      System.Console.Write( "     {" );
      for ( int i = 0; i < a.Length; i ++ ) {
         System.Console.Write( double2String( a[ i ] ) );
         if ( i < -1 + a.Length ) {
            System.Console.Write( ", " );
         }
      }
      System.Console.Write( "}" );
   }

   public static void display2DArray( double[][] a ) {
      for ( int i = 0; i < a.Length; i ++ ) {
         if ( i == 0 ) {
            System.Console.Write( "     {{" );
         } else {
            System.Console.Write( "     {" );
         }
         for ( int j = 0; j < a[ i ].Length; j ++ ) {
            System.Console.Write( double2String( a[ i ][ j ] ) );
            if ( j < -1 + a[ i ].Length ) {
               System.Console.Write( ", " );
            } else {
               System.Console.Write( "}" );
            }
         }
         if ( i < -1 + a.Length ) {
            System.Console.Write( ",\n " );
         } else {
            System.Console.Write( "}" );
         }
      }
   }
}
