using System;
using WebCab.Lib.Util.Example;

public class TwoAssetPortfolioClient {
   public static void Main( String[] args ) {
      // used components
      TwoAssetPortfolio instanceOfTwoAssetPortfolio = new TwoAssetPortfolio();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "                   ############################################" );
      System.Console.WriteLine( "                   # TwoAssetPortfolio Console Client Example #" );
      System.Console.WriteLine( "                   ############################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Within this client we provide an example for  each  of  the  methods" );
      System.Console.WriteLine( "    within Two Asset Portfolio." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ The Correlation Coefficient between two assets +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    correlationCoef( double covariance," );
      System.Console.WriteLine( "                     double standardDeviation1," );
      System.Console.WriteLine( "                     double standardDeviation2 )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the correlation coefficient  when  the  between  two  assets" );
      System.Console.WriteLine( "     when the standard deviation of the  first  asset  is  0.4,  and  the" );
      System.Console.WriteLine( "     second asset is 0.6, and the covariance between the assets is 0.2?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    covariance = 0.2" );
      System.Console.WriteLine( "    standardDeviation1 = 0.4" );
      System.Console.WriteLine( "    standardDeviation2 = 0.6" );
      double CorrelationCoef1 = instanceOfTwoAssetPortfolio.CorrelationCoef( 
         0.2, // covariance
         0.4, // standardDeviation1
         0.6 // standardDeviation2
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The correlation coefficient is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( CorrelationCoef1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Estimate of the Future Covariance using the Scenario Approach +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    covariance( double[] probability," );
      System.Console.WriteLine( "                double[] rateOfReturn1," );
      System.Console.WriteLine( "                double[] rateOfReturn2 )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the expected value of the covariance of the returns  on  two" );
      System.Console.WriteLine( "     funds when we have  the  following  expectations  of  the  following" );
      System.Console.WriteLine( "     scenarios:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - The probability of the 1st state occurring is  20  percent,  in" );
      System.Console.WriteLine( "        this instance:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "           - 1st Fund expected return = -3 percent" );
      System.Console.WriteLine( "           - 2nd Fund expected return = 6 percent" );
      System.Console.WriteLine( "           " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - The probability of the 2nd state occurring is  30  percent,  in" );
      System.Console.WriteLine( "        this instance:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "           - 1st Fund expected return = 3 percent" );
      System.Console.WriteLine( "           - 2nd Fund expected return = -2 percent" );
      System.Console.WriteLine( "           " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - The probability of the 3rd state occurring is  30  percent,  in" );
      System.Console.WriteLine( "        this instance:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "           - 1st Fund expected return = -3 percent" );
      System.Console.WriteLine( "           - 2nd Fund expected return = 6 percent" );
      System.Console.WriteLine( "           " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - The probability of the 4th state occurring is  20  percent,  in" );
      System.Console.WriteLine( "        this instance:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "           - 1st Fund expected return = 3 percent" );
      System.Console.WriteLine( "           - 2nd Fund expected return = -2 percent" );
      System.Console.WriteLine( "           " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probability = {0.2, 0.3, 0.3, 0.2}" );
      System.Console.WriteLine( "    rateOfReturn1 = {-0.03, 0.03, 0.05, 0.02}" );
      System.Console.WriteLine( "    rateOfReturn2 = {0.06, -0.02, 0.08, -0.09}" );
      // Here we evaluate the covariance. Note  that  the  probability  of  the
      // occurence sum to 1
      double covariance1 = instanceOfTwoAssetPortfolio.Covariance( 
         new double[] {0.2, 0.3, 0.3, 0.2}, // probability
         new double[] {-0.03, 0.03, 0.05, 0.02}, // rateOfReturn1
         new double[] {0.06, -0.02, 0.08, -0.09} // rateOfReturn2
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The (expected) covariance is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( covariance1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluation of the covariance using historical values +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    covariance( double[] historicalReturns1," );
      System.Console.WriteLine( "                double[] historicalReturns2 )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the (historical) covariance between two  assets  which  over" );
      System.Console.WriteLine( "     the past 6 months have the following monthly returns:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - The 1st Assets percentage monthly returns where: 5, 6,  2,  -1," );
      System.Console.WriteLine( "        2, -2" );
      System.Console.WriteLine( "        - The 2nd Assets percentage monthly returns where: 4, 2,  4,  -2," );
      System.Console.WriteLine( "        4, 1" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    historicalReturns1 = {0.05, 0.06, 0.02, -0.01, 0.02, -0.02}" );
      System.Console.WriteLine( "    historicalReturns2 = {0.04, 0.02, 0.04, -0.02, 0.04, 0.01}" );
      double covariance2 = instanceOfTwoAssetPortfolio.Covariance( 
         new double[] {0.05, 0.06, 0.02, -0.01, 0.02, -0.02}, // historicalReturns1
         new double[] {0.04, 0.02, 0.04, -0.02, 0.04, 0.01} // historicalReturns2
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The (historical) covariance between the two assets is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( covariance2 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluation of the Standard Deviation using Probability Distribution +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    standardDeviation( double[] probability," );
      System.Console.WriteLine( "                       double[] rateOfReturn )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What of the expected standard deviation of a fund for which we  know" );
      System.Console.WriteLine( "     will take  one  of  four  states  with  the  following  returns  and" );
      System.Console.WriteLine( "     probabilities:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - Probability of 1st State = 20 percent, Return = -3 percent" );
      System.Console.WriteLine( "        - Probability of 1st State = 30 percent, Return = 2 percent" );
      System.Console.WriteLine( "        - Probability of 1st State = 30 percent, Return = 1 percent" );
      System.Console.WriteLine( "        - Probability of 1st State = 20 percent, Return = 0 percent" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probability = {0.2, 0.3, 0.3, 0.2}" );
      System.Console.WriteLine( "    rateOfReturn = {-0.03, 0.02, 0.01, 0.0}" );
      // Here we evaluate the standard deviation.
      double standardDeviation1 = instanceOfTwoAssetPortfolio.StandardDeviation( 
         new double[] {0.2, 0.3, 0.3, 0.2}, // probability
         new double[] {-0.03, 0.02, 0.01, 0.0} // rateOfReturn
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The (expected) standard deviation is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( standardDeviation1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluation of the Standard Deviation using Probability Distribution +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    standardDeviation( double[] historicalReturns )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the standard deviation  of  the  monthly  returns  when  the" );
      System.Console.WriteLine( "     historical returns over the past 6 months is: 5, 6,  2,  -1,  2,  -2" );
      System.Console.WriteLine( "     percent respectively." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    historicalReturns = {0.05, 0.06, 0.02, -0.01, 0.02, -0.02}" );
      // Here we evaluate the standard deviation from the historical values.
      double standardDeviation2 = instanceOfTwoAssetPortfolio.StandardDeviation( 
         new double[] {0.05, 0.06, 0.02, -0.01, 0.02, -0.02} // historicalReturns
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The standard deviation is the returns is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( standardDeviation2 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Risk of a Portfolio with Two Assets +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    portfolio2Variance( double alpha," );
      System.Console.WriteLine( "                        double standardDeviation1," );
      System.Console.WriteLine( "                        double standardDeviation2," );
      System.Console.WriteLine( "                        double correlation )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the risk of a portfolio with two assets where the alpha  (or" );
      System.Console.WriteLine( "     weight) of the first asset is 0.6 (hence the weight  of  the  second" );
      System.Console.WriteLine( "     asset is 0.4), the standard deviation of the returns  of  the  first" );
      System.Console.WriteLine( "     asset is 0.25, and the standard deviation  of  the  returns  of  the" );
      System.Console.WriteLine( "     second asset is 0.15, and the covariance between the assets is 0.5?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    alpha = 0.6" );
      System.Console.WriteLine( "    standardDeviation1 = 0.25" );
      System.Console.WriteLine( "    standardDeviation2 = 0.15" );
      System.Console.WriteLine( "    correlation = 0.5" );
      double portfolio2Variance1 = instanceOfTwoAssetPortfolio.Portfolio2Variance( 
         0.6, // alpha
         0.25, // standardDeviation1
         0.15, // standardDeviation2
         0.5 // correlation
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The risk of the portfolio with two assets is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( portfolio2Variance1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Expected Return of a Portfolio with Two Assets +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    portfolio2Return( double alpha," );
      System.Console.WriteLine( "                      double expectedReturn1," );
      System.Console.WriteLine( "                      double expectedReturn2 )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the expected return of the following two portfolios:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - 1st  Portfolio:  Alpha  (or  weight  of  first  asset)  =  0.5," );
      System.Console.WriteLine( "        Expected return of the 1st asset = 25  percent,  Expected  return" );
      System.Console.WriteLine( "        of the 2nd asset = 35 percent" );
      System.Console.WriteLine( "        - 2nd Portfolio:  Alpha  (or  weight  of  second  asset)  =  0.3," );
      System.Console.WriteLine( "        Expected return of the 1st asset = 25  percent,  Expected  return" );
      System.Console.WriteLine( "        of the 2nd asset = 35 percent" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    alpha = 0.5" );
      System.Console.WriteLine( "    expectedReturn1 = 0.25" );
      System.Console.WriteLine( "    expectedReturn2 = 0.35" );
      double portfolio2Return1 = instanceOfTwoAssetPortfolio.Portfolio2Return( 
         0.5, // alpha
         0.25, // expectedReturn1
         0.35 // expectedReturn2
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The expected return of the 1st Portfolio is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( portfolio2Return1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Expected Return of a Portfolio with Two Assets +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    portfolio2Return( double alpha," );
      System.Console.WriteLine( "                      double expectedReturn1," );
      System.Console.WriteLine( "                      double expectedReturn2 )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    alpha = 0.3" );
      System.Console.WriteLine( "    expectedReturn1 = 0.25" );
      System.Console.WriteLine( "    expectedReturn2 = 0.35" );
      double portfolio2Return2 = instanceOfTwoAssetPortfolio.Portfolio2Return( 
         0.3, // alpha
         0.25, // expectedReturn1
         0.35 // expectedReturn2
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The expected return of the 2nd Portfolio is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( portfolio2Return2 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Optimal Diversification of a Portfolio with Two Assets +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    weight2MinimizeRisk( double standardDeviation1," );
      System.Console.WriteLine( "                         double standardDeviation2," );
      System.Console.WriteLine( "                         double covariance )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the weight of the first asset which minimizes the risk of  a" );
      System.Console.WriteLine( "     portfolio with two assets where the standard deviation of the  first" );
      System.Console.WriteLine( "     asset is 0.25, the standard deviation of the second asset  is  0.35," );
      System.Console.WriteLine( "     and the covariance is one of the following:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - Covariance = 1, the assets are perfectly correlated" );
      System.Console.WriteLine( "        - Covariance = 0.50, the assets are positively correlated" );
      System.Console.WriteLine( "        - Covariance = 0, the assets are not correlated" );
      System.Console.WriteLine( "        - Covariance = -0.5, the assets are negatively correlated" );
      System.Console.WriteLine( "        -     Covariance  =  -1,  the  assets  are  perfectly  negatively" );
      System.Console.WriteLine( "        correlated" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    standardDeviation1 = 0.25" );
      System.Console.WriteLine( "    standardDeviation2 = 0.35" );
      System.Console.WriteLine( "    covariance = 1" );
      double weight2MinimizeRisk1 = instanceOfTwoAssetPortfolio.Weight2MinimizeRisk( 
         0.25, // standardDeviation1
         0.35, // standardDeviation2
         1.0 // covariance
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The weight of  the  first  asset  which  minimizes  the  risk  of  the" );
      System.Console.WriteLine( "    portfolio where the covariance is 1, is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( weight2MinimizeRisk1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Optimal Diversification of a Portfolio with Two Assets +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    weight2MinimizeRisk( double standardDeviation1," );
      System.Console.WriteLine( "                         double standardDeviation2," );
      System.Console.WriteLine( "                         double covariance )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    standardDeviation1 = 0.25" );
      System.Console.WriteLine( "    standardDeviation2 = 0.35" );
      System.Console.WriteLine( "    covariance = 0.5" );
      double weight2MinimizeRisk2 = instanceOfTwoAssetPortfolio.Weight2MinimizeRisk( 
         0.25, // standardDeviation1
         0.35, // standardDeviation2
         0.5 // covariance
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The weight of  the  first  asset  which  minimizes  the  risk  of  the" );
      System.Console.WriteLine( "    portfolio where the covariance is 0.5, is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( weight2MinimizeRisk2 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Optimal Diversification of a Portfolio with Two Assets +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    weight2MinimizeRisk( double standardDeviation1," );
      System.Console.WriteLine( "                         double standardDeviation2," );
      System.Console.WriteLine( "                         double covariance )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    standardDeviation1 = 0.25" );
      System.Console.WriteLine( "    standardDeviation2 = 0.35" );
      System.Console.WriteLine( "    covariance = 0" );
      double weight2MinimizeRisk3 = instanceOfTwoAssetPortfolio.Weight2MinimizeRisk( 
         0.25, // standardDeviation1
         0.35, // standardDeviation2
         0.0 // covariance
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The weight of  the  first  asset  which  minimizes  the  risk  of  the" );
      System.Console.WriteLine( "    portfolio where the covariance is 0, is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( weight2MinimizeRisk3 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Optimal Diversification of a Portfolio with Two Assets +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    weight2MinimizeRisk( double standardDeviation1," );
      System.Console.WriteLine( "                         double standardDeviation2," );
      System.Console.WriteLine( "                         double covariance )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    standardDeviation1 = 0.25" );
      System.Console.WriteLine( "    standardDeviation2 = 0.35" );
      System.Console.WriteLine( "    covariance = -0.5" );
      double weight2MinimizeRisk4 = instanceOfTwoAssetPortfolio.Weight2MinimizeRisk( 
         0.25, // standardDeviation1
         0.35, // standardDeviation2
         -0.5 // covariance
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The weight of  the  first  asset  which  minimizes  the  risk  of  the" );
      System.Console.WriteLine( "    portfolio where the covariance is -0.5, is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( weight2MinimizeRisk4 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Optimal Diversification of a Portfolio with Two Assets +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    weight2MinimizeRisk( double standardDeviation1," );
      System.Console.WriteLine( "                         double standardDeviation2," );
      System.Console.WriteLine( "                         double covariance )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    standardDeviation1 = 0.25" );
      System.Console.WriteLine( "    standardDeviation2 = 0.35" );
      System.Console.WriteLine( "    covariance = -1" );
      double weight2MinimizeRisk5 = instanceOfTwoAssetPortfolio.Weight2MinimizeRisk( 
         0.25, // standardDeviation1
         0.35, // standardDeviation2
         -1.0 // covariance
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The weight of  the  first  asset  which  minimizes  the  risk  of  the" );
      System.Console.WriteLine( "    portfolio where the covariance is -1, is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( weight2MinimizeRisk5 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }

   public static String double2String( double d ) {
      if ( System.Double.IsNaN( d ) ) return d.ToString();
      if ( System.Double.IsNegativeInfinity( d ) ) return d.ToString();
      if ( System.Double.IsPositiveInfinity( d ) ) return d.ToString();
      if ( d == Double.MinValue ) return d.ToString();
      if ( d == Double.MaxValue ) return d.ToString();
      double frac = d - ( int )d;
      double frac4 = ( int )( frac * 10000 ) / 10000.0;
      return "" + ( ( int )d + frac4 );
   }

   public static void displayArray( double[] a ) {
      System.Console.Write( "     {" );
      for ( int i = 0; i < a.Length; i ++ ) {
         System.Console.Write( double2String( a[ i ] ) );
         if ( i < -1 + a.Length ) {
            System.Console.Write( ", " );
         }
      }
      System.Console.Write( "}" );
   }

   public static void display2DArray( double[][] a ) {
      for ( int i = 0; i < a.Length; i ++ ) {
         if ( i == 0 ) {
            System.Console.Write( "     {{" );
         } else {
            System.Console.Write( "     {" );
         }
         for ( int j = 0; j < a[ i ].Length; j ++ ) {
            System.Console.Write( double2String( a[ i ][ j ] ) );
            if ( j < -1 + a[ i ].Length ) {
               System.Console.Write( ", " );
            } else {
               System.Console.Write( "}" );
            }
         }
         if ( i < -1 + a.Length ) {
            System.Console.Write( ",\n " );
         } else {
            System.Console.Write( "}" );
         }
      }
   }
}
