using System;
using WebCab.Lib.Util.Example;

public class FurtherExamplesClient {
   public static void Main( String[] args ) {
      // used components
      Volatility instanceOfVolatility = new Volatility();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "                    ##########################################" );
      System.Console.WriteLine( "                    # FurtherExamples Console Client Example #" );
      System.Console.WriteLine( "                    ##########################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Here we provide more  examples  which  illustrate  the  use  of  the" );
      System.Console.WriteLine( "    Volatility class." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Changing the Scale of the Volatility +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    yearDaysRescaling( double volPerAnnum," );
      System.Console.WriteLine( "                       double daysRescaledTo," );
      System.Console.WriteLine( "                       int convention )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     If the volatility measured  over  a  year  (i.e.  365  days)  is  12" );
      System.Console.WriteLine( "     percent, what is same assets volatility wrt 5 day period?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    volPerAnnum = 0.12" );
      System.Console.WriteLine( "    daysRescaledTo = 5" );
      System.Console.WriteLine( "    convention = 2" );
      // Here we change the scale to which the volatility is expressed.
      double scale1 = instanceOfVolatility.YearDaysRescaling( 
         0.12, // volPerAnnum
         5.0, // daysRescaledTo
         2 // convention
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The volatility with respect to the 5 days given is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( scale1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Historical Volatility Estimate +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    historicalEstimate( double[] assetPrices )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the historical estimate of the volatility of an asset  which" );
      System.Console.WriteLine( "     over the past 12 months, which took the following values:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     [ 23.4, 24.1, 24.5, 23.9, 24.5, 24.9, 25.0, 24.8, 25.1, 25.7,  26.0," );
      System.Console.WriteLine( "     25.8]" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     and during this period paid a dividend of  2  in  the  1st  and  7th" );
      System.Console.WriteLine( "     month?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    assetPrices = {23.4, 24.1, 24.5, 23.9, 24.5, 24.9, 25.0, 24.8, 25.1, 25.7, 26.0, 25.8}" );
      // He we estimate the volatility from the historical prices.
      double historical1 = instanceOfVolatility.HistoricalEstimate( 
         new double[] {23.4, 24.1, 24.5, 23.9, 24.5, 24.9, 25.0, 24.8, 25.1, 25.7, 26.0, 25.8} // assetPrices
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The historical estimate of the volatility is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( historical1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Here we evaluate the standard Error of the Above Estimate +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    historicalEstimateStandardError( double numberOfDays," );
      System.Console.WriteLine( "                                     double volatilityEstimate )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     Here we evaluate the standard Error  of  the  historical  volatility" );
      System.Console.WriteLine( "     estimate above." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    numberOfDays = 12" );
      System.Console.WriteLine( "    volatilityEstimate = historical1" );
      // Here we evaluate the error of the above estimate.
      double errorEstaimate1 = instanceOfVolatility.HistoricalEstimateStandardError( 
         12.0, // numberOfDays
         historical1 // volatilityEstimate
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The standard error is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( errorEstaimate1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Historical Estimate of the Volatility with Dividends +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    historicalEstimateWithDividends( double[] assetPrices," );
      System.Console.WriteLine( "                                     double[] dividendsPaid )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     What is the historical estimate of the volatility of an asset  which" );
      System.Console.WriteLine( "     over the past 12 months, which took the following values:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     [ 23.4, 24.1, 24.5, 23.9, 24.5, 24.9, 25.0, 24.8, 25.1, 25.7,  26.0," );
      System.Console.WriteLine( "     25.8 ]" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     and during this period paid a dividend of  2  in  the  1st  and  7th" );
      System.Console.WriteLine( "     month?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    assetPrices = {23.4, 24.1, 24.5, 23.9, 24.5, 24.9, 25.0, 24.8, 25.1, 25.7, 26.0, 25.8}" );
      System.Console.WriteLine( "    dividendsPaid = {2.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.0, 0.0, 0.0, 0.0, 0.0, 0.0}" );
      // Here we estimate the volatility  based  in  historical  values  for  a
      // dividend paying stock.
      double historicalDividends1 = instanceOfVolatility.HistoricalEstimateWithDividends( 
         new double[] {23.4, 24.1, 24.5, 23.9, 24.5, 24.9, 25.0, 24.8, 25.1, 25.7, 26.0, 25.8}, // assetPrices
         new double[] {2.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.0, 0.0, 0.0, 0.0, 0.0, 0.0} // dividendsPaid
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The historical estimate of the volatility is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( historicalDividends1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Apply the ARCH Volatility Model +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    archVolatilityEstimate( double longTermVolatility," );
      System.Console.WriteLine( "                            double weightOfVolatility," );
      System.Console.WriteLine( "                            double[] observations," );
      System.Console.WriteLine( "                            double[] weights )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     If the long term volatility of the SP500 index is 1.32  percent  per" );
      System.Console.WriteLine( "     day and the value  of  the  index  over  the  last  week  has  been:" );
      System.Console.WriteLine( "     1147.39, 1144.58, 1138.49, 1131.87, 1148.7. According  to  the  ARCH" );
      System.Console.WriteLine( "     Volatility model what will the volatility be?" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     In order to apply the ARCH model we are required to  select  weights" );
      System.Console.WriteLine( "     for the historical values of the index and the long term average  of" );
      System.Console.WriteLine( "     the volatility. The weights selected will depend upon  the  personal" );
      System.Console.WriteLine( "     judgment of the user. If we selected the weights: 0.39, 0.20,  0.15," );
      System.Console.WriteLine( "     0.10, 0.05 for the last week, and a weight  of  0.11  for  the  long" );
      System.Console.WriteLine( "     term volatility." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    longTermVolatility = 0.0132" );
      System.Console.WriteLine( "    weightOfVolatility = 0.11" );
      System.Console.WriteLine( "    observations = {1147.39, 1144.58, 1138.49, 1131.8699, 1148.7}" );
      System.Console.WriteLine( "    weights = {0.39, 0.2, 0.15, 0.1, 0.05}" );
      // Apply the ARCH volatility model.
      double arch1 = instanceOfVolatility.ArchVolatilityEstimate( 
         0.0132, // longTermVolatility
         0.11, // weightOfVolatility
         new double[] {1147.39, 1144.58, 1138.49, 1131.8699, 1148.7}, // observations
         new double[] {0.39, 0.2, 0.15, 0.1, 0.05} // weights
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The estimate of the volatility according to the ARCH model is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( arch1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Estimate the Volatility using hte EWMA Model +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    ewmaVolatilityEstimate( double weightRatio," );
      System.Console.WriteLine( "                            double i_1thDayEstimateOfVolatility," );
      System.Console.WriteLine( "                            double endi_1thDay," );
      System.Console.WriteLine( "                            double starti_1thDay )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     What is the estimate of the volatility of the price today  according" );
      System.Console.WriteLine( "     to the Exponentially Weighted Moving Average model  when  the  price" );
      System.Console.WriteLine( "     volatility yesterday was recorded to  be  1  percent  per  day,  the" );
      System.Console.WriteLine( "     asset price at the start of trading yesterday was 20, and closed  at" );
      System.Console.WriteLine( "     20.404? We take the weight ratio to be 0.90." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    weightRatio = 0.90" );
      System.Console.WriteLine( "    i_1thDayEstimateOfVolatility = 0.01" );
      System.Console.WriteLine( "    endi_1thDay = 20.404" );
      System.Console.WriteLine( "    starti_1thDay = 20" );
      // Here we estimate the volatility using the EWMA model.
      double ewma1 = instanceOfVolatility.EwmaVolatilityEstimate( 
         0.90, // weightRatio
         0.01, // i_1thDayEstimateOfVolatility
         20.404, // endi_1thDay
         20.0 // starti_1thDay
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The estimate of the volatility is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( ewma1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ EWMA model using Induction +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    ewmaVolatilityEstimateInduction( double weightRatio," );
      System.Console.WriteLine( "                                     double firstDaysVolatilityEstimate," );
      System.Console.WriteLine( "                                     double[] endOfDay," );
      System.Console.WriteLine( "                                     double[] startOfDay )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     What is the estimate of the price volatility today according to  the" );
      System.Console.WriteLine( "     Exponentially Weighted Moving Average model when  the  weight  ratio" );
      System.Console.WriteLine( "     (for the past 5 days) is taken to be 0.90,  the  volatility  5  days" );
      System.Console.WriteLine( "     ago was 1 percent per day, and the asset price at the start and  end" );
      System.Console.WriteLine( "     of the last 5 trading sessions was:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - start of day = [21, 21.3, 21.2, 21.4, 21.5]" );
      System.Console.WriteLine( "        - end of day = [21.2, 21.2, 21.35, 21.4, 21.6]" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    weightRatio = 0.9" );
      System.Console.WriteLine( "    firstDaysVolatilityEstimate = 0.01" );
      System.Console.WriteLine( "    endOfDay = {21.2, 21.2, 21.35, 21.4, 21.6}" );
      System.Console.WriteLine( "    startOfDay = {21.0, 21.3, 21.2, 21.4, 21.5}" );
      // Here is use induction in order to estimate the  volatility  using  hte
      // EWMA model.
      double ewmaInduction1 = instanceOfVolatility.EwmaVolatilityEstimateInduction( 
         0.9, // weightRatio
         0.01, // firstDaysVolatilityEstimate
         new double[] {21.2, 21.2, 21.35, 21.4, 21.6}, // endOfDay
         new double[] {21.0, 21.3, 21.2, 21.4, 21.5} // startOfDay
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The estimate of the price volatility is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + double2String( ewmaInduction1 ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }

   public static String double2String( double d ) {
      if ( System.Double.IsNaN( d ) ) return d.ToString();
      if ( System.Double.IsNegativeInfinity( d ) ) return d.ToString();
      if ( System.Double.IsPositiveInfinity( d ) ) return d.ToString();
      if ( d == Double.MinValue ) return d.ToString();
      if ( d == Double.MaxValue ) return d.ToString();
      double frac = d - ( int )d;
      double frac4 = ( int )( frac * 10000 ) / 10000.0;
      return "" + ( ( int )d + frac4 );
   }

   public static void displayArray( double[] a ) {
      System.Console.Write( "     {" );
      for ( int i = 0; i < a.Length; i ++ ) {
         System.Console.Write( double2String( a[ i ] ) );
         if ( i < -1 + a.Length ) {
            System.Console.Write( ", " );
         }
      }
      System.Console.Write( "}" );
   }

   public static void display2DArray( double[][] a ) {
      for ( int i = 0; i < a.Length; i ++ ) {
         if ( i == 0 ) {
            System.Console.Write( "     {{" );
         } else {
            System.Console.Write( "     {" );
         }
         for ( int j = 0; j < a[ i ].Length; j ++ ) {
            System.Console.Write( double2String( a[ i ][ j ] ) );
            if ( j < -1 + a[ i ].Length ) {
               System.Console.Write( ", " );
            } else {
               System.Console.Write( "}" );
            }
         }
         if ( i < -1 + a.Length ) {
            System.Console.Write( ",\n " );
         } else {
            System.Console.Write( "}" );
         }
      }
   }
}
