Imports System
Imports Microsoft.VisualBasic
Imports WebCab.Lib.Util.Example
Imports WebCab.Libraries.Finance.Portfolio

Module AssetParametersClient
   Sub Main()
      ' used components
      Dim instanceOfAssetParameters As WebCab.Libraries.Finance.Portfolio.AssetParameters = New WebCab.Libraries.Finance.Portfolio.AssetParameters
      '
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "                    ##########################################" )
      System.Console.WriteLine( "                    # AssetParameters Console Client Example #" )
      System.Console.WriteLine( "                    ##########################################" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " Overview" )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    With this client we provide an  example  for  each  of  the  methods" )
      System.Console.WriteLine( "    within Asset Parameters" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Convert historical values from Relative to Absolute values +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    relativeToAbsolute( double[][] relativeValues )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What is the absolute equivalent value when the  relative  values  of" )
      System.Console.WriteLine( "     three assets are:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - 1st Asset: 0.01, -0.02, -0.02" )
      System.Console.WriteLine( "        - 2nd Asset: 0.03, 0.01, 0.02" )
      System.Console.WriteLine( "        - 3rd Asset: -0.01, 0.02, -0.01" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    relativeValues = {{0.01, -0.02, -0.02}," )
      System.Console.WriteLine( "                     {0.03, 0.01, 0.02}," )
      System.Console.WriteLine( "                     {-0.01, 0.02, -0.01}}" )
      ' Converts the relative values into  absolute  values  where  the  first
      ' term is scaled to 100.
      Dim relative2Absolute1 As Double()() = instanceOfAssetParameters.RelativeToAbsolute( _
         New Double()() {New Double() {0.01, -0.02, -0.02}, _
                         New Double() {0.03, 0.01, 0.02}, _
                         New Double() {-0.01, 0.02, -0.01}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    An equivalent set of absolute values are:" )
      System.Console.WriteLine( " " )
      display2DArray( relative2Absolute1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Convert from Absolute values Relative values +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    relativeToAbsolute( double[][] relativeValues )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What is the absolute equivalent value when the  relative  values  of" )
      System.Console.WriteLine( "     three assets are:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - 1st Asset: 100, 100, 98, 96" )
      System.Console.WriteLine( "        - 2nd Asset: 100, 103, 101, 103" )
      System.Console.WriteLine( "        - 3rd Asset: 100, 99, 101, 100" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    relativeValues = {{100.0, 100.0, 98.0, 96.0}," )
      System.Console.WriteLine( "                     {100.0, 103.0, 101.0, 103.0}," )
      System.Console.WriteLine( "                     {100.0, 99.0, 101.0, 100.0}}" )
      ' Converts the absolute values  into  an  equaivalent  set  of  relative
      ' values.
      Dim absolute2Relative1 As Double()() = instanceOfAssetParameters.RelativeToAbsolute( _
         New Double()() {New Double() {100.0, 100.0, 98.0, 96.0}, _
                         New Double() {100.0, 103.0, 101.0, 103.0}, _
                         New Double() {100.0, 99.0, 101.0, 100.0}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    An equivalent set of relative values are:" )
      System.Console.WriteLine( " " )
      display2DArray( absolute2Relative1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Transpose of Historical data +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    transpose( double[][] twoDimArray )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     We know that the historical returns on three funds our:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Jan Returns: 1st Fund = 0.01, 2nd Fund  =  -0.02,  3rd  Fund  =" )
      System.Console.WriteLine( "        -0.02" )
      System.Console.WriteLine( "        - Feb Returns: 1st Fund = 0.03, 2nd Fund = 0.01, 3rd Fund = 0.02" )
      System.Console.WriteLine( "        - Mar Returns: 1st Fund = -0.01, 2nd Fund  =  0.02,  3rd  Fund  =" )
      System.Console.WriteLine( "        -0.01" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     we wish to transform this data set into the following form:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - 1st Fund: Jan = 0.01, Feb = 0.03, Mar = -0.01" )
      System.Console.WriteLine( "        - 2nd Fund: Jan = -0.02, Feb = 0.01, Mar = 0.02" )
      System.Console.WriteLine( "        - 3rd Fund: Jan = -0.02, Feb = 0.02, Mar = -0.01" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    twoDimArray = {{0.01, -0.02, -0.02}," )
      System.Console.WriteLine( "                  {0.03, 0.01, 0.02}," )
      System.Console.WriteLine( "                  {-0.01, 0.02, -0.01}}" )
      ' Here we transpose the historical data.
      Dim transpose1 As Double()() = instanceOfAssetParameters.Transpose( _
         New Double()() {New Double() {0.01, -0.02, -0.02}, _
                         New Double() {0.03, 0.01, 0.02}, _
                         New Double() {-0.01, 0.02, -0.01}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The required two dimensional array is:" )
      System.Console.WriteLine( " " )
      display2DArray( transpose1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Future Covariance estimates between stock price returns +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covariance( double[] probability," )
      System.Console.WriteLine( "                double[] returns1," )
      System.Console.WriteLine( "                double[] returns2 )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Estimate the covariance between a integrated oil company and a  bank" )
      System.Console.WriteLine( "     stock when for the following possible states of the  future  economy" )
      System.Console.WriteLine( "     over the next  year  will  the  corresponding  expectations  are  as" )
      System.Console.WriteLine( "     follows:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Rapid Expansion: Prob. = 0.1, Exp. Oil Company return  =  0.14," )
      System.Console.WriteLine( "        Exp. Bank return = 0.2" )
      System.Console.WriteLine( "        - Recession: Prob. = 0.2, Exp. Oil Company return =  -0.05,  Exp." )
      System.Console.WriteLine( "        Bank return = -0.02" )
      System.Console.WriteLine( "        - Average Growth: Prob. = 0.4, Exp. Oil  Company  return  =  0.1," )
      System.Console.WriteLine( "        Exp. Bank return = 0.09" )
      System.Console.WriteLine( "        - Recovery: Prob. = 0.1, Exp. Oil Company  return  =  0.09,  Exp." )
      System.Console.WriteLine( "        Bank return = 0.14" )
      System.Console.WriteLine( "        - Slow Growth: Prob. = 0.2, Exp. Oil Company return = 0.12,  Exp." )
      System.Console.WriteLine( "        Bank return = 0.18" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = {0.1, 0.2, 0.4, 0.1, 0.2}" )
      System.Console.WriteLine( "    returns1 = {0.14, -0.05, 0.1, 0.09, 0.12}" )
      System.Console.WriteLine( "    returns2 = {0.2, -0.02, 0.09, 0.14, 0.18}" )
      Dim covariance1 As Double = instanceOfAssetParameters.Covariance( _
         New Double() {0.1, 0.2, 0.4, 0.1, 0.2}, _
         New Double() {0.14, -0.05, 0.1, 0.09, 0.12}, _
         New Double() {0.2, -0.02, 0.09, 0.14, 0.18} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The (expected) annual covariance between the oil company's  stock  and" )
      System.Console.WriteLine( "    the bank stock is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( covariance1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Past Covariance evaluation of stock price returns +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covariance( double[] returns1," )
      System.Console.WriteLine( "                double[] returns2 )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What is the  historical  estimate  of  the  covariance  between  the" )
      System.Console.WriteLine( "     stocks of an oil company and a  bank  when  the  historical  returns" )
      System.Console.WriteLine( "     between these two assets have been:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Last Years Return: Oil Company return =  0.14,  Bank  return  =" )
      System.Console.WriteLine( "        0.2" )
      System.Console.WriteLine( "        - 1 Year Ago Annual Return: Oil  Company  return  =  -0.05,  Bank" )
      System.Console.WriteLine( "        return = -0.02" )
      System.Console.WriteLine( "        - 2 Year Ago Annual  Return:  Oil  Company  return  =  0.1,  Bank" )
      System.Console.WriteLine( "        return = 0.09" )
      System.Console.WriteLine( "        - 3 Year Ago Annual Return:  Oil  Company  return  =  0.09,  Bank" )
      System.Console.WriteLine( "        return = 0.14" )
      System.Console.WriteLine( "        - 4 Year Ago Annual Return:  Oil  Company  return  =  0.12,  Bank" )
      System.Console.WriteLine( "        return = 0.18" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    returns1 = {0.14, -0.05, 0.1, 0.09, 0.12}" )
      System.Console.WriteLine( "    returns2 = {0.2, -0.02, 0.09, 0.14, 0.18}" )
      Dim covariance2 As Double = instanceOfAssetParameters.Covariance( _
         New Double() {0.14, -0.05, 0.1, 0.09, 0.12}, _
         New Double() {0.2, -0.02, 0.09, 0.14, 0.18} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The (expected) annual covariance between the oil company's  stock  and" )
      System.Console.WriteLine( "    the bank stock is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( covariance2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Future estimate of Covariance Matrix +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covarianceMatrix( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What is the (expected) covariance matrix between two company  shares" )
      System.Console.WriteLine( "     during a takeover when one of the  following  two  market  scenarios" )
      System.Console.WriteLine( "     will occur:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Takeover Completed: 40 percent  probability  of  taking  place," )
      System.Console.WriteLine( "        Expected return on targets share  price  =  1  percent,  Expected" )
      System.Console.WriteLine( "        return acquiring companies share price = -2 percent." )
      System.Console.WriteLine( "        -  Takeover  Fails:  60  percent  probability  of  taking  place," )
      System.Console.WriteLine( "        Expected return on targets share price  =  -2  percent,  Expected" )
      System.Console.WriteLine( "        return on acquiring company's share price = 1 percent." )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {{0.4, 0.6}," )
      System.Console.WriteLine( "                        {0.01, -0.02}," )
      System.Console.WriteLine( "                        {-0.02, 0.01}}" )
      Dim covarianceMatrix1 As Double()() = instanceOfAssetParameters.CovarianceMatrix( _
         New Double()() {New Double() {0.4, 0.6}, _
                         New Double() {0.01, -0.02}, _
                         New Double() {-0.02, 0.01}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The (expected) covariance matrix of the two assets is:" )
      System.Console.WriteLine( " " )
      display2DArray( covarianceMatrix1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation of the past covariance matrix +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covarianceMatrix( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we illustrate the use of the  covariance  matrix  method  which" )
      System.Console.WriteLine( "     evaluates the covariance matrix  for  a  collection  of  assets.  In" )
      System.Console.WriteLine( "     particular, we consider the following three instances:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Return of 1st, 2nd and 3rd asset is 1  percent  over  the  past" )
      System.Console.WriteLine( "        four periods." )
      System.Console.WriteLine( "        - 1st Asset Returns = 2, 1, -2, and 2 percent; 2nd Asset  Returns" )
      System.Console.WriteLine( "        = 0, 3, -1, 1 percent." )
      System.Console.WriteLine( "        - 1st Assets Return = 1 percent, 2nd assets return = -1 percent." )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     The first instance should result in a  covariance  matrix  with  1's" )
      System.Console.WriteLine( "     everywhere since all assets are  perfectly  correlated.  The  second" )
      System.Console.WriteLine( "     instance will result in 1's on the diagonal (as is always the  case)" )
      System.Console.WriteLine( "     and two different numbers  taking  up  the  other  two  non-diagonal" )
      System.Console.WriteLine( "     entries. The third instance will return just -1." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {{0.01, 0.01, 0.01, 0.01}," )
      System.Console.WriteLine( "                        {0.01, 0.01, 0.01, 0.01}," )
      System.Console.WriteLine( "                        {0.01, 0.01, 0.01, 0.01}}" )
      Dim covarianceMatrix2 As Double()() = instanceOfAssetParameters.CovarianceMatrix( _
         New Double()() {New Double() {0.01, 0.01, 0.01, 0.01}, _
                         New Double() {0.01, 0.01, 0.01, 0.01}, _
                         New Double() {0.01, 0.01, 0.01, 0.01}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The covariance matrix in the 1st instance is:" )
      System.Console.WriteLine( " " )
      display2DArray( covarianceMatrix2 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation of the past covariance matrix +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covarianceMatrix( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {{0.02, 0.01, -0.02, 0.02}," )
      System.Console.WriteLine( "                        {0.0, 0.03, -0.01, 0.01}}" )
      Dim covarianceMatrix3 As Double()() = instanceOfAssetParameters.CovarianceMatrix( _
         New Double()() {New Double() {0.02, 0.01, -0.02, 0.02}, _
                         New Double() {0.0, 0.03, -0.01, 0.01}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The covariance matrix in the 2nd instance is:" )
      System.Console.WriteLine( " " )
      display2DArray( covarianceMatrix3 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation of the past covariance matrix +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covarianceMatrix( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {{0.01}," )
      System.Console.WriteLine( "                        {-0.01}}" )
      Dim covarianceMatrix4 As Double()() = instanceOfAssetParameters.CovarianceMatrix( _
         New Double()() {New Double() {0.01}, _
                         New Double() {-0.01}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The covariance matrix in the 3rd instance is:" )
      System.Console.WriteLine( " " )
      display2DArray( covarianceMatrix4 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Future scenario based approach to volatility estimation +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    volatility( double[] probability," )
      System.Console.WriteLine( "                double[] returns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Estimate the volatility of a stock price when the takeover has  been" )
      System.Console.WriteLine( "     announced in which the following  two  scenarios  could  take  place" )
      System.Console.WriteLine( "     over the next 2 months:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Takeover Completed: Probability = 90 percent,  Expected  Return" )
      System.Console.WriteLine( "        = 5 percent" )
      System.Console.WriteLine( "        - Takeover fails: Probability = 10  percent,  Expected  Return  =" )
      System.Console.WriteLine( "        -35 percent" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     In this instance the (forward  looking)  expected  volatility  would" )
      System.Console.WriteLine( "     be?" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = {0.1, 0.9}" )
      System.Console.WriteLine( "    returns = {0.05, -0.35}" )
      ' Here we evaluate the volatility.
      Dim volatility1 As Double = instanceOfAssetParameters.Volatility( _
         New Double() {0.1, 0.9}, _
         New Double() {0.05, -0.35} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    A (forward looking) estimate of  the  volatility  over  the  next  two" )
      System.Console.WriteLine( "    months (in fact, in `per 2 month' units) in percentage terms is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( volatility1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Historical evaluation of the volatility +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    volatility( double[] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What is the historical estimate  of  the  monthly  volatility  of  a" )
      System.Console.WriteLine( "     given asset when the percentage  returns  on  the  underlying  asset" )
      System.Console.WriteLine( "     where:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     0.5, 1, -3, 1, 3, 2 percentage" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     per month over the last 6 months." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {0.0050, 0.01, -0.03, 0.01, 0.03, 0.02}" )
      ' Here we evaluate the volatility.
      Dim volatility2 As Double = instanceOfAssetParameters.Volatility( _
         New Double() {0.0050, 0.01, -0.03, 0.01, 0.03, 0.02} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The historical estimate of the monthly volatility in percentage  terms" )
      System.Console.WriteLine( "    is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( volatility2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Variance of a Portfolio +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolioVariance( double[] weight," )
      System.Console.WriteLine( "                       double[][] covarianceMatrix )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     What is the variance of a portfolio with two asset where:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Asset 1: Weight = 0.7, Monthly  returns  over  the  past  three" )
      System.Console.WriteLine( "        months = 120, 110, 115" )
      System.Console.WriteLine( "        - Asset 2: Weight = 0.3, Monthly  returns  over  the  past  three" )
      System.Console.WriteLine( "        months = 100, 110, 120" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weight = {0.7, 0.3}" )
      System.Console.WriteLine( "    covarianceMatrix = covarianceMatrix4Variance1" )
      ' Here we evaluate the covariance matrix of the two assets.
      Dim covarianceMatrix4Variance1 As Double()() = instanceOfAssetParameters.CovarianceMatrix( _
         New Double()() {New Double() {120.0, 110.0, 115.0}, _
                         New Double() {100.0, 110.0, 120.0}} _
      )
      ' Here we evaluate the variance of the portfolio
      Dim varianceOfPortfolio1 As Double = instanceOfAssetParameters.PortfolioVariance( _
         New Double() {0.7, 0.3}, _
         covarianceMatrix4Variance1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The variance of the portfolio is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( varianceOfPortfolio1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Risk of a Portfolio +" )
      System.Console.WriteLine( "+++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolioRisk( double[] weight," )
      System.Console.WriteLine( "                   double[][] covarianceMatrix )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What is the risk of a portfolio with two asset where:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Asset 1: Weight = 0.7, Monthly  returns  over  the  past  three" )
      System.Console.WriteLine( "        months = 120, 110, 115" )
      System.Console.WriteLine( "        - Asset 2: Weight = 0.3, Monthly  returns  over  the  past  three" )
      System.Console.WriteLine( "        months = 100, 110, 120" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weight = {0.7, 0.3}" )
      System.Console.WriteLine( "    covarianceMatrix = covarianceMatrix4Risk1" )
      ' Here we evaluate the covariance matrix of the two assets.
      Dim covarianceMatrix4Risk1 As Double()() = instanceOfAssetParameters.CovarianceMatrix( _
         New Double()() {New Double() {120.0, 110.0, 115.0}, _
                         New Double() {100.0, 110.0, 120.0}} _
      )
      ' Here we evaluate the risk of the portfolio
      Dim varianceOfPortfolio2 As Double = instanceOfAssetParameters.PortfolioRisk( _
         New Double() {0.7, 0.3}, _
         covarianceMatrix4Risk1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the portfolio is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( varianceOfPortfolio2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Future scenario based estimate of the expected return +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn( double[] probability," )
      System.Console.WriteLine( "                    double[] returns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Estimate the expected return of a stock price when the takeover  has" )
      System.Console.WriteLine( "     been announced in which  the  following  two  scenarios  could  take" )
      System.Console.WriteLine( "     place:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Takeover Completed: Probability = 90 percent,  Expected  Return" )
      System.Console.WriteLine( "        = 5 percent" )
      System.Console.WriteLine( "        - Takeover fails: Probability = 10  percent,  Expected  Return  =" )
      System.Console.WriteLine( "        -35 percent" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     In this instance the (forward looking) expected return would be?" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = {0.1, 0.9}" )
      System.Console.WriteLine( "    returns = {0.05, -0.35}" )
      ' Here we evaluate the expected return.
      Dim expectedReturn1 As Double = instanceOfAssetParameters.ExpectedReturn( _
         New Double() {0.1, 0.9}, _
         New Double() {0.05, -0.35} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    An estimate of the (forward looking) expected return is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( expectedReturn1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Estimate of the expected return from historical values +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn( double[] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What is the historical estimate of the monthly  return  of  a  given" )
      System.Console.WriteLine( "     asset when the percentage returns on the underlying asset where:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     0.5, 1, -3, 1, 3, 2 percent" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     per month over the last 6 months." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {0.0050, 0.01, -0.03, 0.01, 0.03, 0.02}" )
      ' Here we evaluate the expected return.
      Dim expectedReturn2 As Double = instanceOfAssetParameters.ExpectedReturn( _
         New Double() {0.0050, 0.01, -0.03, 0.01, 0.03, 0.02} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The    historical  estimate  of  the  expected  return  per  month  in" )
      System.Console.WriteLine( "    percentage terms is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( expectedReturn2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Expected Return of a Portfolio +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolioExpectedReturn( double[] weights," )
      System.Console.WriteLine( "                             double[] expectedReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     A portfolio consists of three assets with a weights of 0.2, 0.5  and" )
      System.Console.WriteLine( "     0.3; with expected returns of 110, 120 and 110,  respectively.  What" )
      System.Console.WriteLine( "     is the expected return of the portfolio?" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weights = {0.2, 0.5, 0.3}" )
      System.Console.WriteLine( "    expectedReturns = {110.0, 120.0, 110.0}" )
      ' Here we evaluate the Expected return of the portfolio.
      Dim portfolioExpectedReturn1 As Double = instanceOfAssetParameters.PortfolioExpectedReturn( _
         New Double() {0.2, 0.5, 0.3}, _
         New Double() {110.0, 120.0, 110.0} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected return of the portfolio (in absolute terms) is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( portfolioExpectedReturn1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Intermediate Values of the Range of the Efficient Frontier +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    intermediateValue( double upperBound," )
      System.Console.WriteLine( "                       double lowerBound," )
      System.Console.WriteLine( "                       double ratio )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     What is the mid-point of the  range  of  the  expected  return  over" )
      System.Console.WriteLine( "     which the Efficient Frontier exists when the lower bound  and  upper" )
      System.Console.WriteLine( "     bound over which they exist is 60, 90 respectively." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    upperBound = 90" )
      System.Console.WriteLine( "    lowerBound = 60" )
      System.Console.WriteLine( "    ratio = 50" )
      ' Here we evaluate the mid-point of the range of expected  returns  over
      ' which the Efficient Frontier exists.
      Dim midpoint1 As Double = instanceOfAssetParameters.IntermediateValue( _
         90.0, _
         60.0, _
         50.0 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The mid point is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( midpoint1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( " " )
   End Sub

   Function Double2String(ByVal d As Double) As String
      If (System.Double.IsNaN(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsNegativeInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsPositiveInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MinValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MaxValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      Dim frac As Double = d - Int(d)
      Dim frac4 As Double = Int(frac * 10000) / 10000.0
      Double2String = (Int(d) + frac4).ToString()
      Exit Function
   End Function

   Sub displayArray(ByVal a As Double())
      System.Console.Write("     {")
      For I As Integer = 0 To -1 + a.Length
         System.Console.Write(Double2String(a(I)))
         If (I < -1 + a.Length) Then System.Console.Write(", ")
      Next I
      System.Console.Write("}")
   End Sub

   Sub display2DArray(ByVal a As Double()())
      For I As Integer = 0 To -1 + a.Length
         If (I = 0) Then
            System.Console.Write("     {{")
         Else
            System.Console.Write("      {")
         End If
         For J As Integer = 0 To -1 + a(I).Length
            System.Console.Write(Double2String(a(I)(J)))
            If (J < -1 + a(I).Length) Then
               System.Console.Write(", ")
            Else
               System.Console.Write("}")
               End If
         Next J
         If (I < -1 + a.Length) Then
            System.Console.Write(",")
            System.Console.WriteLine()
            Else
               System.Console.Write("}")
            End If
      Next I
   End Sub
End Module

