Imports System
Imports Microsoft.VisualBasic
Imports WebCab.Lib.Util.Example
Imports WebCab.Libraries.Finance.Portfolio

Module ForwardLookingClient
   Sub Main()
      ' used components
      Dim instanceOfAssetParameters As WebCab.Libraries.Finance.Portfolio.AssetParameters = New WebCab.Libraries.Finance.Portfolio.AssetParameters
      '
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "                    #########################################" )
      System.Console.WriteLine( "                    # ForwardLooking Console Client Example #" )
      System.Console.WriteLine( "                    #########################################" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " Overview" )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    With this example we provide a Custom Example which illustrates  the" )
      System.Console.WriteLine( "    application of the Asset  Parameters  class  to  estimating  forward" )
      System.Console.WriteLine( "    looking properties of a collection of assets." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Expected Variance of the 1st Asset +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covariance( double[] probability," )
      System.Console.WriteLine( "                double[] returns1," )
      System.Console.WriteLine( "                double[] returns2 )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the expected variance of the 1st Asset.  Note:  The" )
      System.Console.WriteLine( "     variance of an asset  is  just  the  covariance  of  an  asset  with" )
      System.Console.WriteLine( "     itself." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = {0.1, 0.7, 0.2}" )
      System.Console.WriteLine( "    returns1 = {100.0, 120.0, 130.0}" )
      System.Console.WriteLine( "    returns2 = {100.0, 120.0, 130.0}" )
      ' Here we evaluated the expected variance of the 1st Asset.
      Dim variance1 As Double = instanceOfAssetParameters.Covariance( _
         New Double() {0.1, 0.7, 0.2}, _
         New Double() {100.0, 120.0, 130.0}, _
         New Double() {100.0, 120.0, 130.0} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected variance of the 1st Asset is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( variance1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Expected Variance of the 2nd Asset +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covariance( double[] probability," )
      System.Console.WriteLine( "                double[] returns1," )
      System.Console.WriteLine( "                double[] returns2 )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the expected variance of the 2nd Asset.  Note:  The" )
      System.Console.WriteLine( "     variance of an asset  is  just  the  covariance  of  an  asset  with" )
      System.Console.WriteLine( "     itself." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = {0.1, 0.7, 0.2}" )
      System.Console.WriteLine( "    returns1 = {120.0, 130.0, 140.0}" )
      System.Console.WriteLine( "    returns2 = {120.0, 130.0, 140.0}" )
      ' Here we evaluated the expected variance of the 1st Asset.
      Dim variance2 As Double = instanceOfAssetParameters.Covariance( _
         New Double() {0.1, 0.7, 0.2}, _
         New Double() {120.0, 130.0, 140.0}, _
         New Double() {120.0, 130.0, 140.0} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected variance of the 2nd Asset is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( variance2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Expected Variance of the 3rd Asset +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covariance( double[] probability," )
      System.Console.WriteLine( "                double[] returns1," )
      System.Console.WriteLine( "                double[] returns2 )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the expected variance of the 3rd Asset.  Note:  The" )
      System.Console.WriteLine( "     variance of an asset  is  just  the  covariance  of  an  asset  with" )
      System.Console.WriteLine( "     itself." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = {0.1, 0.7, 0.2}" )
      System.Console.WriteLine( "    returns1 = {200.0, 150.0, 140.0}" )
      System.Console.WriteLine( "    returns2 = {200.0, 150.0, 140.0}" )
      ' Here we evaluated the expected variance of the 3rd Asset.
      Dim variance3 As Double = instanceOfAssetParameters.Covariance( _
         New Double() {0.1, 0.7, 0.2}, _
         New Double() {200.0, 150.0, 140.0}, _
         New Double() {200.0, 150.0, 140.0} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected variance of the 3rd Asset is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( variance3 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Expected Return of the 1st Asset +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn( double[] probability," )
      System.Console.WriteLine( "                    double[] returns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the expected return of the 1st asset.  Note:  Since" )
      System.Console.WriteLine( "     the returns of the assets  are  given  as  absolute  values  of  the" )
      System.Console.WriteLine( "     expected returns evaluate will also  be  given  in  absolute  values" )
      System.Console.WriteLine( "     rather than in relative (i.e. percentage) terms." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = {0.1, 0.7, 0.2}" )
      System.Console.WriteLine( "    returns = {100.0, 120.0, 130.0}" )
      ' Here we evaluated the expected return of the 1st Asset.
      Dim expectedReturn1 As Double = instanceOfAssetParameters.ExpectedReturn( _
         New Double() {0.1, 0.7, 0.2}, _
         New Double() {100.0, 120.0, 130.0} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected return of the 1st Asset is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( expectedReturn1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Expected Return of the 2nd Asset +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn( double[] probability," )
      System.Console.WriteLine( "                    double[] returns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the expected return of the 2nd asset.  Note:  Since" )
      System.Console.WriteLine( "     the returns of the assets  are  given  as  absolute  values  of  the" )
      System.Console.WriteLine( "     expected returns evaluate will also  be  given  in  absolute  values" )
      System.Console.WriteLine( "     rather than in relative (i.e. percentage) terms." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = {0.1, 0.7, 0.2}" )
      System.Console.WriteLine( "    returns = {120.0, 130.0, 140.0}" )
      ' Here we evaluated the expected return of the 2nd Asset.
      Dim expectedReturn2 As Double = instanceOfAssetParameters.ExpectedReturn( _
         New Double() {0.1, 0.7, 0.2}, _
         New Double() {120.0, 130.0, 140.0} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected return of the 2nd Asset is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( expectedReturn2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Expected Return of the 3rd Asset +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn( double[] probability," )
      System.Console.WriteLine( "                    double[] returns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the expected return of the 1st asset.  Note:  Since" )
      System.Console.WriteLine( "     the returns of the assets  are  given  as  absolute  values  of  the" )
      System.Console.WriteLine( "     expected returns evaluate will also  be  given  in  absolute  values" )
      System.Console.WriteLine( "     rather than in relative (i.e. percentage) terms." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = {0.1, 0.7, 0.2}" )
      System.Console.WriteLine( "    returns = {200.0, 150.0, 140.0}" )
      ' Here we evaluated the expected return of the 3rd Asset.
      Dim expectedReturn3 As Double = instanceOfAssetParameters.ExpectedReturn( _
         New Double() {0.1, 0.7, 0.2}, _
         New Double() {200.0, 150.0, 140.0} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected return of the 3rd Asset is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( expectedReturn3 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Covariance between the 1st and 2nd Asset +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covariance( double[] probability," )
      System.Console.WriteLine( "                double[] returns1," )
      System.Console.WriteLine( "                double[] returns2 )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the Covariance between the 1st and 2nd Asset." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = {0.1, 0.7, 0.2}" )
      System.Console.WriteLine( "    returns1 = {100.0, 120.0, 130.0}" )
      System.Console.WriteLine( "    returns2 = {120.0, 130.0, 140.0}" )
      ' Here we evaluate the Covariance between the 1st and 2nd Asset.
      Dim covariance1 As Double = instanceOfAssetParameters.Covariance( _
         New Double() {0.1, 0.7, 0.2}, _
         New Double() {100.0, 120.0, 130.0}, _
         New Double() {120.0, 130.0, 140.0} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The Covariance between the 1st and 2nd Asset is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( covariance1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Expected Return of Portfolio with equal weighting  between  the  three +" )
      System.Console.WriteLine( "+ available Assets                                                       +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolioExpectedReturn( double[] weights," )
      System.Console.WriteLine( "                             double[] expectedReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the expected return  of  the  portfolio  where  the" )
      System.Console.WriteLine( "     expected      returns  of  the  three  assets  are:  120.  131,  153" )
      System.Console.WriteLine( "     respectively, and each of the assets has equal weight of 1/3." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weights = {120.0, 131.0, 153.0}" )
      System.Console.WriteLine( "    expectedReturns = {0.3333, 0.3333, 0.3333}" )
      ' Here we evaluate the expected return of the portfolio.
      Dim portExpectedReturn1 As Double = instanceOfAssetParameters.PortfolioExpectedReturn( _
         New Double() {120.0, 131.0, 153.0}, _
         New Double() {0.3333, 0.3333, 0.3333} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected return of the portfolio is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( portExpectedReturn1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Risk of Portfolio with equal weighting  between  the  three  available +" )
      System.Console.WriteLine( "+ Assets                                                                 +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolioRisk( double[] weight," )
      System.Console.WriteLine( "                   double[][] covarianceMatrix )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the risk of  the  portfolio  constructed  by  given" )
      System.Console.WriteLine( "     equal weighting to the three available assets." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weight = {0.3333, 0.3333, 0.3333}" )
      System.Console.WriteLine( "    covarianceMatrix = covarianceMatrixPort1" )
      ' Here we evaluate the covariance matrix of the three assets.
      Dim covarianceMatrixPort1 As Double()() = instanceOfAssetParameters.CovarianceMatrix( _
         New Double() {0.1, 0.7, 0.2}, _
         New Double()() {New Double() {100.0, 120.0, 130.0}, _
                         New Double() {120.0, 130.0, 140.0}, _
                         New Double() {200.0, 150.0, 140.0}} _
      )
      ' Here we evaluate the risk of the portfolio constructed by given  equal
      ' weighting to the three available assets.
      Dim portRisk1 As Double = instanceOfAssetParameters.PortfolioRisk( _
         New Double() {0.3333, 0.3333, 0.3333}, _
         covarianceMatrixPort1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the portfolio  with  equal  weighting  between  the  three" )
      System.Console.WriteLine( "    available assets is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( portRisk1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Variance of Returns of the Portfolio with equal +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolioVariance( double[] weight," )
      System.Console.WriteLine( "                       double[][] covarianceMatrix )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the variance of the portfolio with equal  weighting" )
      System.Console.WriteLine( "     between the three available assets." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weight = {0.3333, 0.3333, 0.3333}" )
      System.Console.WriteLine( "    covarianceMatrix = covarianceMatrixPort2" )
      ' Here we evaluate the covariance matrix of the three assets.
      Dim covarianceMatrixPort2 As Double()() = instanceOfAssetParameters.CovarianceMatrix( _
         New Double() {0.1, 0.7, 0.2}, _
         New Double()() {New Double() {100.0, 120.0, 130.0}, _
                         New Double() {120.0, 130.0, 140.0}, _
                         New Double() {200.0, 150.0, 140.0}} _
      )
      ' Here we evaluate the variance of the portfolio  with  equal  weighting
      ' between the three available assets.
      Dim variancePort1 As Double = instanceOfAssetParameters.PortfolioVariance( _
         New Double() {0.3333, 0.3333, 0.3333}, _
         covarianceMatrixPort2 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The variance of the portfolio with equal weighting between  the  three" )
      System.Console.WriteLine( "    available assets is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( variancePort1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( " " )
   End Sub

   Function Double2String(ByVal d As Double) As String
      If (System.Double.IsNaN(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsNegativeInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsPositiveInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MinValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MaxValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      Dim frac As Double = d - Int(d)
      Dim frac4 As Double = Int(frac * 10000) / 10000.0
      Double2String = (Int(d) + frac4).ToString()
      Exit Function
   End Function

   Sub displayArray(ByVal a As Double())
      System.Console.Write("     {")
      For I As Integer = 0 To -1 + a.Length
         System.Console.Write(Double2String(a(I)))
         If (I < -1 + a.Length) Then System.Console.Write(", ")
      Next I
      System.Console.Write("}")
   End Sub

   Sub display2DArray(ByVal a As Double()())
      For I As Integer = 0 To -1 + a.Length
         If (I = 0) Then
            System.Console.Write("     {{")
         Else
            System.Console.Write("      {")
         End If
         For J As Integer = 0 To -1 + a(I).Length
            System.Console.Write(Double2String(a(I)(J)))
            If (J < -1 + a(I).Length) Then
               System.Console.Write(", ")
            Else
               System.Console.Write("}")
               End If
         Next J
         If (I < -1 + a.Length) Then
            System.Console.Write(",")
            System.Console.WriteLine()
            Else
               System.Console.Write("}")
            End If
      Next I
   End Sub
End Module

