Imports System
Imports Microsoft.VisualBasic
Imports WebCab.Lib.Util.Example
Imports WebCab.Libraries.Finance.Portfolio

Module AbsoluteRelativeClient
   Sub Main()
      ' used components
      Dim instanceOfAssetParameters As AssetParameters = New AssetParameters
      Dim instanceOfMarkowitz As WebCab.Libraries.Finance.Portfolio.Markowitz = New WebCab.Libraries.Finance.Portfolio.Markowitz
      '
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "                   ###########################################" )
      System.Console.WriteLine( "                   # AbsoluteRelative Console Client Example #" )
      System.Console.WriteLine( "                   ###########################################" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " Overview" )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    This example demonstrates that  whether  the  absolute  or  relative" )
      System.Console.WriteLine( "    values are used for the source data of the  historical  returns  the" )
      System.Console.WriteLine( "    Portfolio Component will  yield  the  ;same;  results  in  terms  of" )
      System.Console.WriteLine( "    selecting the optimal portfolio. In particular,  we  will  show  the" )
      System.Console.WriteLine( "    independence of the Weights of the Portfolio found on the  Efficient" )
      System.Console.WriteLine( "    Frontier for a given expected return. Moreover, we  will  show  that" )
      System.Console.WriteLine( "    whether we use  absolute  or  relative  values  for  the  historical" )
      System.Console.WriteLine( "    returns the weights of the optimal portfolio  found  are  identical." )
      System.Console.WriteLine( "    One reason for this independence is that  the  units  in  which  the" )
      System.Console.WriteLine( "    historical returns are given does not  effect  the  weights  of  the" )
      System.Console.WriteLine( "    portfolio of the Efficient Frontier,  include  the  weights  of  the" )
      System.Console.WriteLine( "    optimal portfolio is that asset weights themselves  are  `unit-less'" )
      System.Console.WriteLine( "    (in the sense of Measurement  Theory).  Hence  intuitively  speaking" )
      System.Console.WriteLine( "    during the computation of the asset  weights  the  units  are  being" )
      System.Console.WriteLine( "    canceled out with the end result (i.e. the weights) being  recording" )
      System.Console.WriteLine( "    without  an  attached  unit.  Historical  Values  used  Within  this" )
      System.Console.WriteLine( "    example we will consider five assets  historical  returns  over  the" )
      System.Console.WriteLine( "    last five periods:" )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "       - 1st Asset: 0.03, 0.04, 0.02, 0.05, 0.03" )
      System.Console.WriteLine( "       - 2nd Asset: 0.03, 0.040, 0.1, 0.03, 0.035" )
      System.Console.WriteLine( "       - 3rd Asset: 0.03, 0.032, 0.033, 0.035, 0.036" )
      System.Console.WriteLine( "       - 4th Asset: 0.02, 0.021, 0.021, 0.021, 0.0205" )
      System.Console.WriteLine( "       - 5th Asset: 0.02, 0.01, 0.02, 0.015, 0.028" )
      System.Console.WriteLine( "       " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation of the Covariance Matrix using Relative Values +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covarianceMatrix( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here   we  evaluate  the  covariance  matrix  for  the  five  assets" )
      System.Console.WriteLine( "     considered." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {{0.03, 0.04, 0.02, 0.05, 0.03}," )
      System.Console.WriteLine( "                        {0.03, 0.04, 0.1, 0.03, 0.035}," )
      System.Console.WriteLine( "                        {0.03, 0.032, 0.033, 0.035, 0.036}," )
      System.Console.WriteLine( "                        {0.02, 0.021, 0.021, 0.021, 0.0205}," )
      System.Console.WriteLine( "                        {0.02, 0.01, 0.02, 0.015, 0.028}}" )
      ' Here we evaluate the covariance matrix of the five assets considered
      Dim covariance1 As Double()() = instanceOfMarkowitz.CovarianceMatrix( _
         New Double()() {New Double() {0.03, 0.04, 0.02, 0.05, 0.03}, _
                         New Double() {0.03, 0.04, 0.1, 0.03, 0.035}, _
                         New Double() {0.03, 0.032, 0.033, 0.035, 0.036}, _
                         New Double() {0.02, 0.021, 0.021, 0.021, 0.0205}, _
                         New Double() {0.02, 0.01, 0.02, 0.015, 0.028}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The covariance matrix is:" )
      System.Console.WriteLine( " " )
      display2DArray( covariance1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation of the Expected Returns using Relative Values +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here     we  evaluate  the  expected  returns  of  the  five  assets" )
      System.Console.WriteLine( "     considered." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {{0.03, 0.04, 0.02, 0.05, 0.03}," )
      System.Console.WriteLine( "                        {0.03, 0.04, 0.1, 0.03, 0.035}," )
      System.Console.WriteLine( "                        {0.03, 0.032, 0.033, 0.035, 0.036}," )
      System.Console.WriteLine( "                        {0.02, 0.021, 0.021, 0.021, 0.0205}," )
      System.Console.WriteLine( "                        {0.02, 0.01, 0.02, 0.015, 0.028}}" )
      ' Here we evaluate the expected returns of the assets.
      Dim expectedReturns1 As Double() = instanceOfMarkowitz.ExpectedReturns( _
         New Double()() {New Double() {0.03, 0.04, 0.02, 0.05, 0.03}, _
                         New Double() {0.03, 0.04, 0.1, 0.03, 0.035}, _
                         New Double() {0.03, 0.032, 0.033, 0.035, 0.036}, _
                         New Double() {0.02, 0.021, 0.021, 0.021, 0.0205}, _
                         New Double() {0.02, 0.01, 0.02, 0.015, 0.028}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The  expected  returns  of  the  assets  using  the  relative  set  of" )
      System.Console.WriteLine( "    historical values, which means that the  results  (i.e.  the  expected" )
      System.Console.WriteLine( "    returns) will be displayed with  respect  to  relative  values  rather" )
      System.Console.WriteLine( "    than absolute values. The values found are:" )
      System.Console.WriteLine( " " )
      displayArray( expectedReturns1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Lower Bound of the Efficient Frontier +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    minFrontierReturn( double[] expectedReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the lower bound of the expected return  over  which" )
      System.Console.WriteLine( "     the Efficient Frontier exits." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" )
      ' Here we evaluate the lower bound in  relative  terms  over  which  the
      ' Efficient Frontier exits.
      Dim lowerBound1 As Double = instanceOfMarkowitz.MinFrontierReturn( _
         expectedReturns1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The lower bound of the expected returns in relative terms  over  which" )
      System.Console.WriteLine( "    the Efficient Frontier exists is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( lowerBound1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Upper Bound of the Efficient Frontier +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    maxFrontierReturn( double[] expectedReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the upper bound of the expected return  over  which" )
      System.Console.WriteLine( "     the Efficient Frontier exits." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" )
      ' Here we evaluate the upper bound in  relative  terms  over  which  the
      ' Efficient Frontier exits.
      Dim upperBound1 As Double = instanceOfMarkowitz.MaxFrontierReturn( _
         expectedReturns1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The upper bound of the expected return in relative  terms  over  which" )
      System.Console.WriteLine( "    the Efficient Frontier exists is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( upperBound1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate of a Portfolio on the Efficient  Frontier  at  the  mid-point +" )
      System.Console.WriteLine( "+ using the Relative set of Values                                       +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    efficientFrontier( double expectedReturn," )
      System.Console.WriteLine( "                       double[][] covarianceMatrix," )
      System.Console.WriteLine( "                       double[] expectedReturns," )
      System.Console.WriteLine( "                       double precision )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate a  portfolio  on  the  Efficient  Frontier  at  the" )
      System.Console.WriteLine( "     mid-point of the expected returns using  a  precision  of  1E-8  (or" )
      System.Console.WriteLine( "     equivalently 0.00000001)." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn = 0.5*(upperBound1+lowerBound1)" )
      System.Console.WriteLine( "    covarianceMatrix = covariance1" )
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" )
      System.Console.WriteLine( "    precision = 0.00000001" )
      ' Here we evaluate the portfolio  at  the  mid-point  of  the  Efficient
      ' Frontier using a precisin of 0.00000001.
      Dim portfolioMidPoint1 As Double() = instanceOfMarkowitz.EfficientFrontier( _
         0.5*(upperBound1+lowerBound1), _
         covariance1, _
         expectedReturns1, _
         0.00000001 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The asset weights of the mid-point portfolio found using  a  precision" )
      System.Console.WriteLine( "    of 0.00000001 are:" )
      System.Console.WriteLine( " " )
      displayArray( portfolioMidPoint1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Here we transform the Relative Values into the Absolute Values +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    relativeToAbsolute( double[][] relativeValues )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we transform the relative historical values into an  equivalent" )
      System.Console.WriteLine( "     set of absolute values." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    relativeValues = {{0.03, 0.04, 0.02, 0.05, 0.03}," )
      System.Console.WriteLine( "                     {0.03, 0.04, 0.1, 0.03, 0.035}," )
      System.Console.WriteLine( "                     {0.03, 0.032, 0.033, 0.035, 0.036}," )
      System.Console.WriteLine( "                     {0.02, 0.021, 0.021, 0.021, 0.0205}," )
      System.Console.WriteLine( "                     {0.02, 0.01, 0.02, 0.015, 0.028}}" )
      ' Here we transform the relative values into absolute values
      Dim real2absolute As Double()() = instanceOfAssetParameters.RelativeToAbsolute( _
         New Double()() {New Double() {0.03, 0.04, 0.02, 0.05, 0.03}, _
                         New Double() {0.03, 0.04, 0.1, 0.03, 0.035}, _
                         New Double() {0.03, 0.032, 0.033, 0.035, 0.036}, _
                         New Double() {0.02, 0.021, 0.021, 0.021, 0.0205}, _
                         New Double() {0.02, 0.01, 0.02, 0.015, 0.028}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    An equivalent set of absolute values is:" )
      System.Console.WriteLine( " " )
      display2DArray( real2absolute )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation of the Covariance matrix using Absolute Values +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covarianceMatrix( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the covariance matrix  using  an  absolute  set  of" )
      System.Console.WriteLine( "     values." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = real2absolute" )
      ' Here we evaluate the covariance matrix using the absolute values.
      Dim covariance2 As Double()() = instanceOfMarkowitz.CovarianceMatrix( _
         real2absolute _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The covariance matrix evaluated using an absolute set of values is:" )
      System.Console.WriteLine( " " )
      display2DArray( covariance2 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation the Expected Returns using the Absolute Values +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluated the expected returns using  the  absolute  set  of" )
      System.Console.WriteLine( "     historical values." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = real2absolute" )
      ' Here we evaluate the expected returns using the absolute values.
      Dim expectedreturn2 As Double() = instanceOfMarkowitz.ExpectedReturns( _
         real2absolute _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The  expected  returns  of  the  assets  using  the  absolute  set  of" )
      System.Console.WriteLine( "    historical values, which means that the  results  (i.e.  the  expected" )
      System.Console.WriteLine( "    returns) will be displayed with  respect  to  absolute  values  rather" )
      System.Console.WriteLine( "    than relative values. The values found are:" )
      System.Console.WriteLine( " " )
      displayArray( expectedreturn2 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Lower Bound of the Efficient Frontier +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    minFrontierReturn( double[] expectedReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the lower bound of the expected return in  absolute" )
      System.Console.WriteLine( "     terms over which the Efficient Frontier exits." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns = expectedreturn2" )
      ' Here we evaluate the lower bound over  which  the  Efficient  Frontier
      ' exits.
      Dim lowerBound2 As Double = instanceOfMarkowitz.MinFrontierReturn( _
         expectedreturn2 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The lower bound of the expected return in  absolute  terms  for  which" )
      System.Console.WriteLine( "    the Efficient Frontier exists is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( lowerBound2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Upper Bound of the Efficient Frontier +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    maxFrontierReturn( double[] expectedReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the upper bound of the expected return in  absolute" )
      System.Console.WriteLine( "     terms over which the Efficient Frontier exits." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns = expectedreturn2" )
      ' Here we evaluate the upper bound over  which  the  Efficient  Frontier
      ' exits.
      Dim upperBound2 As Double = instanceOfMarkowitz.MaxFrontierReturn( _
         expectedreturn2 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The upper bound of the expected return in  absolute  terms  for  which" )
      System.Console.WriteLine( "    the Efficient Frontier exists is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( upperBound2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the Portfolio on the  Efficient  Frontier  at  the  mid-point +" )
      System.Console.WriteLine( "+ using the Absolute set of Values                                       +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    efficientFrontier( double expectedReturn," )
      System.Console.WriteLine( "                       double[][] covarianceMatrix," )
      System.Console.WriteLine( "                       double[] expectedReturns," )
      System.Console.WriteLine( "                       double precision )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate a  portfolio  on  the  Efficient  Frontier  at  the" )
      System.Console.WriteLine( "     mid-point  of  the  expected  returns  using  the  absolute  set  of" )
      System.Console.WriteLine( "     historical values." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn = midpoint1" )
      System.Console.WriteLine( "    covarianceMatrix = covariance2" )
      System.Console.WriteLine( "    expectedReturns = expectedreturn2" )
      System.Console.WriteLine( "    precision = 0.00000001" )
      ' Here we evaluate the mid-point of the expected returns.
      Dim midpoint1 As Double = instanceOfAssetParameters.IntermediateValue( _
         upperBound2, _
         lowerBound2, _
         50.0 _
      )
      ' Here we evaluate the portfolio at the mid-point of the  range  of  the
      ' expected returns  of  the  Efficient  Frontier  using  a  precisin  of
      ' 0.00000001.
      Dim portfolioMidPoint2 As Double() = instanceOfMarkowitz.EfficientFrontier( _
         midpoint1, _
         covariance2, _
         expectedreturn2, _
         0.00000001 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The asset weights of the mid-point portfolio found using the  absolute" )
      System.Console.WriteLine( "    set of historical values is:" )
      System.Console.WriteLine( " " )
      displayArray( portfolioMidPoint2 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( " " )
   End Sub

   Function Double2String(ByVal d As Double) As String
      If (System.Double.IsNaN(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsNegativeInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsPositiveInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MinValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MaxValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      Dim frac As Double = d - Int(d)
      Dim frac4 As Double = Int(frac * 10000) / 10000.0
      Double2String = (Int(d) + frac4).ToString()
      Exit Function
   End Function

   Sub displayArray(ByVal a As Double())
      System.Console.Write("     {")
      For I As Integer = 0 To -1 + a.Length
         System.Console.Write(Double2String(a(I)))
         If (I < -1 + a.Length) Then System.Console.Write(", ")
      Next I
      System.Console.Write("}")
   End Sub

   Sub display2DArray(ByVal a As Double()())
      For I As Integer = 0 To -1 + a.Length
         If (I = 0) Then
            System.Console.Write("     {{")
         Else
            System.Console.Write("      {")
         End If
         For J As Integer = 0 To -1 + a(I).Length
            System.Console.Write(Double2String(a(I)(J)))
            If (J < -1 + a(I).Length) Then
               System.Console.Write(", ")
            Else
               System.Console.Write("}")
               End If
         Next J
         If (I < -1 + a.Length) Then
            System.Console.Write(",")
            System.Console.WriteLine()
            Else
               System.Console.Write("}")
            End If
      Next I
   End Sub
End Module

