Imports System
Imports Microsoft.VisualBasic
Imports WebCab.Lib.Util.Example
Imports WebCab.Libraries.Finance.Portfolio

Module OptimalClient
   Sub Main()
      ' used components
      Dim instanceOfAssetParameters As AssetParameters = New AssetParameters
      Dim instanceOfMarkowitz As WebCab.Libraries.Finance.Portfolio.Markowitz = New WebCab.Libraries.Finance.Portfolio.Markowitz
      '
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "                        ##################################" )
      System.Console.WriteLine( "                        # Optimal Console Client Example #" )
      System.Console.WriteLine( "                        ##################################" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " Overview" )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    Within this example we select the Optimal  Portfolio  in  accordance" )
      System.Console.WriteLine( "    with Markowitz  Theory  using  an  Investors  (risk/reward)  Utility" )
      System.Console.WriteLine( "    Function. Here the returns are given in absolute terms." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ We first evaluate the Covariance matrix for the assets returns +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covarianceMatrix( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the covariance matrix  of  the  (absolute)  returns" )
      System.Console.WriteLine( "     for the five assets under consideration." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {{100.0, 105.0, 107.0, 110.0, 95.0, 75.0, 80.0, 80.0, 90.0, 97.0, 105.0, 115.0}," )
      System.Console.WriteLine( "                        {75.0, 76.0, 76.5, 77.0, 72.0, 71.0, 73.0, 75.0, 77.0, 75.0, 72.0, 73.0}," )
      System.Console.WriteLine( "                        {120.0, 120.0, 120.0, 120.0, 115.0, 105.0, 105.0, 110.0, 120.0, 118.0, 120.0, 125.0}," )
      System.Console.WriteLine( "                        {50.0, 50.0, 50.0, 51.0, 45.0, 46.0, 46.0, 47.0, 48.0, 49.0, 50.0, 51.0}," )
      System.Console.WriteLine( "                        {130.0, 140.0, 145.0, 130.0, 120.0, 110.0, 110.0, 170.0, 200.0, 200.0, 205.0, 210.0}}" )
      ' Here we evaluate the covariance of the returns  of  the  assets  under
      ' consideration
      Dim covariance1 As Double()() = instanceOfAssetParameters.CovarianceMatrix( _
         New Double()() {New Double() {100.0, 105.0, 107.0, 110.0, 95.0, 75.0, 80.0, 80.0, 90.0, 97.0, 105.0, 115.0}, _
                         New Double() {75.0, 76.0, 76.5, 77.0, 72.0, 71.0, 73.0, 75.0, 77.0, 75.0, 72.0, 73.0}, _
                         New Double() {120.0, 120.0, 120.0, 120.0, 115.0, 105.0, 105.0, 110.0, 120.0, 118.0, 120.0, 125.0}, _
                         New Double() {50.0, 50.0, 50.0, 51.0, 45.0, 46.0, 46.0, 47.0, 48.0, 49.0, 50.0, 51.0}, _
                         New Double() {130.0, 140.0, 145.0, 130.0, 120.0, 110.0, 110.0, 170.0, 200.0, 200.0, 205.0, 210.0}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The covariance matrix of the returns of the five asset is:" )
      System.Console.WriteLine( " " )
      display2DArray( covariance1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ next we evaluate the expected return of each fund +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the expected return of each fund" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {{100.0, 105.0, 107.0, 110.0, 95.0, 75.0, 80.0, 80.0, 90.0, 97.0, 105.0, 115.0}," )
      System.Console.WriteLine( "                        {75.0, 76.0, 76.5, 77.0, 72.0, 71.0, 73.0, 75.0, 77.0, 75.0, 72.0, 73.0}," )
      System.Console.WriteLine( "                        {120.0, 120.0, 120.0, 120.0, 115.0, 105.0, 105.0, 110.0, 120.0, 118.0, 120.0, 125.0}," )
      System.Console.WriteLine( "                        {50.0, 50.0, 50.0, 51.0, 45.0, 46.0, 46.0, 47.0, 48.0, 49.0, 50.0, 51.0}," )
      System.Console.WriteLine( "                        {130.0, 140.0, 145.0, 130.0, 120.0, 110.0, 110.0, 170.0, 200.0, 200.0, 205.0, 210.0}}" )
      ' Here we evaluate the expected reurn of each of the funds.
      Dim expectedReturns1 As Double() = instanceOfAssetParameters.ExpectedReturns( _
         New Double()() {New Double() {100.0, 105.0, 107.0, 110.0, 95.0, 75.0, 80.0, 80.0, 90.0, 97.0, 105.0, 115.0}, _
                         New Double() {75.0, 76.0, 76.5, 77.0, 72.0, 71.0, 73.0, 75.0, 77.0, 75.0, 72.0, 73.0}, _
                         New Double() {120.0, 120.0, 120.0, 120.0, 115.0, 105.0, 105.0, 110.0, 120.0, 118.0, 120.0, 125.0}, _
                         New Double() {50.0, 50.0, 50.0, 51.0, 45.0, 46.0, 46.0, 47.0, 48.0, 49.0, 50.0, 51.0}, _
                         New Double() {130.0, 140.0, 145.0, 130.0, 120.0, 110.0, 110.0, 170.0, 200.0, 200.0, 205.0, 210.0}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected return of each fund is given by:" )
      System.Console.WriteLine( " " )
      displayArray( expectedReturns1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Construction of the Efficient Frontier +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    calculateEfficientFrontier( double[][] covarianceMatrix," )
      System.Console.WriteLine( "                                double[] expectedReturns," )
      System.Console.WriteLine( "                                int numberInterpolationPoints," )
      System.Console.WriteLine( "                                double precision )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we construct 20 equally distributed  points  on  the  Efficient" )
      System.Console.WriteLine( "     frontier over its entire range using a tolerance of 0.000001." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covarianceMatrix = covariance1" )
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" )
      System.Console.WriteLine( "    numberInterpolationPoints = 20" )
      System.Console.WriteLine( "    precision = 0.000001" )
      ' Here we  construct  the  efficient  frontier  at  20  points  using  a
      ' tolerance of 0.000001.
      instanceOfMarkowitz.CalculateEfficientFrontier( _
         covariance1, _
         expectedReturns1, _
         20, _
         0.000001 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    Once the point of the efficient frontier have  been  constructed  they" )
      System.Console.WriteLine( "    are set persisted within private fields." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Values of the expected return +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    getEfficientFrontierExpectedReturns(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we read off the values of the expected  return  for  portfolios" )
      System.Console.WriteLine( "     at the points at which the Efficient Frontier was evaluated." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Here we read off the values of the  expected  returns  for  which  the
      ' Efficient Frontier was evaluated.
      Dim returns1 As Double() = instanceOfMarkowitz.GetEfficientFrontierExpectedReturns( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The weights of the optimal portfolio(s) for the investor  with  a  low" )
      System.Console.WriteLine( "    risk tolerance described by the given utility function are:" )
      System.Console.WriteLine( " " )
      displayArray( returns1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++" )
      System.Console.WriteLine( "+ Values of Risk +" )
      System.Console.WriteLine( "++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    getEfficientFrontierPortfolioRisks( double[][] covarianceMatrix )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we read off the values of the risk of  the  portfolios  at  the" )
      System.Console.WriteLine( "     points at which the Efficient Frontier was evaluated." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covarianceMatrix = covariance1" )
      ' Here we read off the values of  the  risks  for  which  the  Efficient
      ' Frontier was evaluated.
      Dim risk1 As Double() = instanceOfMarkowitz.GetEfficientFrontierPortfolioRisks( _
         covariance1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the portfolios at the points where the Efficient  Frontier" )
      System.Console.WriteLine( "    was evaluated is:" )
      System.Console.WriteLine( " " )
      displayArray( risk1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Minimum  value  of  the  expected  return  over  which  the  Efficient +" )
      System.Console.WriteLine( "+ Frontier exits                                                         +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    minFrontierReturn( double[] expectedReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the minimum  expected  return  of  the  range  over" )
      System.Console.WriteLine( "     which the Efficient Frontier  exits.  As  a  general  remark  it  is" )
      System.Console.WriteLine( "     usually best to evaluate the range of the  expected  return  of  the" )
      System.Console.WriteLine( "     Efficient Frontier in order  to  provide  a  range  over  which  the" )
      System.Console.WriteLine( "     Efficient Frontier can be evaluated and the  range  over  which  the" )
      System.Console.WriteLine( "     optimal portfolio can be sort." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" )
      Dim min1 As Double = instanceOfMarkowitz.MinFrontierReturn( _
         expectedReturns1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The minimum  bound  of  the  range  of  the  expected  return  of  the" )
      System.Console.WriteLine( "    Efficient Frontier is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( min1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Maximum  value  of  the  expected  return  over  which  the  Efficient +" )
      System.Console.WriteLine( "+ Frontier exits                                                         +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    maxFrontierReturn( double[] expectedReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the maximum  expected  return  of  the  range  over" )
      System.Console.WriteLine( "     which the Efficient Frontier  exits.  As  a  general  remark  it  is" )
      System.Console.WriteLine( "     usually best to evaluate the range of the  expected  return  of  the" )
      System.Console.WriteLine( "     Efficient Frontier in order  to  provide  a  range  over  which  the" )
      System.Console.WriteLine( "     Efficient Frontier can be evaluated and the  range  over  which  the" )
      System.Console.WriteLine( "     optimal portfolio can be sort." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" )
      Dim max1 As Double = instanceOfMarkowitz.MaxFrontierReturn( _
         expectedReturns1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The maximum  bound  of  the  range  of  the  expected  return  of  the" )
      System.Console.WriteLine( "    Efficient Frontier is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( max1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Find the Optimal Portfolio for an investor  with  a  utility  function +" )
      System.Console.WriteLine( "+ given via interpolation                                                +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    optimalPortfolio( double minimumExpectedReturn," )
      System.Console.WriteLine( "                      double maximumExpectedReturn," )
      System.Console.WriteLine( "                      double[][] covarianceMatrix )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the weights  of  the  optimal  portfolios  for  the" )
      System.Console.WriteLine( "     investor in accordance with the investors utility function  provided" )
      System.Console.WriteLine( "     via its interpolation points over the entire range of the  Efficient" )
      System.Console.WriteLine( "     Frontier." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    minimumExpectedReturn = min1" )
      System.Console.WriteLine( "    maximumExpectedReturn = max1" )
      System.Console.WriteLine( "    covarianceMatrix = covariance1" )
      ' Here we set the utility function of the investor  which  is  given  by
      ' the method of interpolation.
      instanceOfMarkowitz.SetUtilityFunctionInterp( _
         New Double() {0.0, 40.0, 60.0, 80.0, 100.0, 120.0, 140.0}, _
         New Double() {0.0, 6.0, 6.4, 7.0, 14.5, 22.0, 29.2} _
      )
      ' Here we find the optimal portfolio(s) in accordance with the  provided
      ' utility functions given via its interpolation points over  the  entire
      ' range of the Efficient Frontier.
      Dim optimalInter1 As Double()() = instanceOfMarkowitz.OptimalPortfolio( _
         min1, _
         max1, _
         covariance1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The weights of the optimal portfolio(s)  for  the  investor  with  the" )
      System.Console.WriteLine( "    utility function given via its interpolation points is:" )
      System.Console.WriteLine( " " )
      display2DArray( optimalInter1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Find the Optimal Portfolio for an investor  with  a  utility  function +" )
      System.Console.WriteLine( "+ given via polynomial method                                            +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    optimalPortfolio( double minimumExpectedReturn," )
      System.Console.WriteLine( "                      double maximumExpectedReturn," )
      System.Console.WriteLine( "                      double[][] covarianceMatrix )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the weights  of  the  optimal  portfolios  for  the" )
      System.Console.WriteLine( "     investor in accordance with the investors utility function  provided" )
      System.Console.WriteLine( "     via its interpolation points over the entire range of the  Efficient" )
      System.Console.WriteLine( "     Frontier." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    minimumExpectedReturn = min1" )
      System.Console.WriteLine( "    maximumExpectedReturn = max1" )
      System.Console.WriteLine( "    covarianceMatrix = covariance1" )
      ' Here we set the utility function of the investor which is given  by  a
      ' polynomial.
      instanceOfMarkowitz.SetUtilityFunctionPoly( _
         New Double() {0.0, -0.011, 0.0015} _
      )
      ' Here we find the optimal portfolio(s) in accordance with the  provided
      ' utility functions given via its interpolation points over  the  entire
      ' range of the Efficient Frontier.
      Dim optimalInter2 As Double()() = instanceOfMarkowitz.OptimalPortfolio( _
         min1, _
         max1, _
         covariance1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The weights of the optimal portfolio(s)  for  the  investor  with  the" )
      System.Console.WriteLine( "    utility function given via its interpolation points is:" )
      System.Console.WriteLine( " " )
      display2DArray( optimalInter2 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( " " )
   End Sub

   Function Double2String(ByVal d As Double) As String
      If (System.Double.IsNaN(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsNegativeInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsPositiveInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MinValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MaxValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      Dim frac As Double = d - Int(d)
      Dim frac4 As Double = Int(frac * 10000) / 10000.0
      Double2String = (Int(d) + frac4).ToString()
      Exit Function
   End Function

   Sub displayArray(ByVal a As Double())
      System.Console.Write("     {")
      For I As Integer = 0 To -1 + a.Length
         System.Console.Write(Double2String(a(I)))
         If (I < -1 + a.Length) Then System.Console.Write(", ")
      Next I
      System.Console.Write("}")
   End Sub

   Sub display2DArray(ByVal a As Double()())
      For I As Integer = 0 To -1 + a.Length
         If (I = 0) Then
            System.Console.Write("     {{")
         Else
            System.Console.Write("      {")
         End If
         For J As Integer = 0 To -1 + a(I).Length
            System.Console.Write(Double2String(a(I)(J)))
            If (J < -1 + a(I).Length) Then
               System.Console.Write(", ")
            Else
               System.Console.Write("}")
               End If
         Next J
         If (I < -1 + a.Length) Then
            System.Console.Write(",")
            System.Console.WriteLine()
            Else
               System.Console.Write("}")
            End If
      Next I
   End Sub
End Module

