Imports System
Imports Microsoft.VisualBasic
Imports WebCab.Lib.Util.Example
Imports WebCab.Libraries.Finance.Portfolio

Module Optimal4Risk4Return200FundsClient
   Sub Main()
      ' used components
      Dim instanceOfAssetParameters As AssetParameters = New AssetParameters
      Dim instanceOfMarkowitz As WebCab.Libraries.Finance.Portfolio.Markowitz = New WebCab.Libraries.Finance.Portfolio.Markowitz
      Dim instanceOfSolveFrontier As SolveFrontier = New SolveFrontier
      '
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "              ######################################################" )
      System.Console.WriteLine( "              # Optimal4Risk4Return200Funds Console Client Example #" )
      System.Console.WriteLine( "              ######################################################" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " Overview" )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    Within this client we apply the Markowitz Theory  to  construct  the" )
      System.Console.WriteLine( "    portfolio which has:" )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "       - The lowest risk for a  given  expected  return  (i.e.  expected" )
      System.Console.WriteLine( "       performance level)" )
      System.Console.WriteLine( "       - The highest expected return  (i.e.  performance)  for  a  given" )
      System.Console.WriteLine( "       level of risk" )
      System.Console.WriteLine( "       " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    for 200 investment funds where each of the funds historical  monthly" )
      System.Console.WriteLine( "    returns is known over the past 3 years (approx.)." )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    The historical values of the  funds  is  given  within  a  array  of" )
      System.Console.WriteLine( "    dimension 2 where the first elements consists of 200  members  which" )
      System.Console.WriteLine( "    state the returns in Jan 2001, the second element the return in  Feb" )
      System.Console.WriteLine( "    2001, and so on." )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    Remark: In order to address the first problem it will be  sufficient" )
      System.Console.WriteLine( "    to apply methods from the Markowitz class, in  order  to  solve  for" )
      System.Console.WriteLine( "    risk we  will  need  to  use  in  addition  functionality  from  the" )
      System.Console.WriteLine( "    SolveFrontier class." )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    WARNING: This examples will take more than an hour to complete on  a" )
      System.Console.WriteLine( "    desktop machine." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation of the Expected Returns of the  Covariance  Matrix  of  the +" )
      System.Console.WriteLine( "+ six funds                                                              +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     We first evaluate the auxiliary results of  the  evaluation  of  the" )
      System.Console.WriteLine( "     expected return and covariance matrix for the six funds." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = returnsOfFunds" )
      ' Here we transform the format which the source data,  by  `transposing'
      ' the array of dimension 2.
      Dim returnsOfFunds As Double()() = instanceOfAssetParameters.Transpose( _
         New Double()() {New Double() {4.2584, 4.0595, -1.3818, 3.7248, 1.1662, 1.6102, 0.5642, 1.5076, 3.9479, 2.8466, 4.819, 0.4447, -0.8333, 4.01, 4.1951, 12.0877, 1.569, 4.3654, 1.5046, -1.7855, 5.7723, 7.4756, 0.5837, 4.4581, 9.4602, 2.4881, 1.35, -2.2599, 1.3682, 4.1594, 2.2886, 1.5899, 1.2548, 3.1662, 0.9318, 2.9615, 2.4018, -1.5833, 1.2008, 0.5178, 0.5248, 0.5563, 0.5148, 1.5268, 1.0041, -0.0961, 1.568, 5.998, 2.348, -0.502, 0.3441, 2.9123, 0.9953, 3.6187, 14.5898, -1.6845, 2.25, 4.2518, 6.4955, 0.598, -0.2314, 3.4588, 4.2444, 4.1942, 2.8361, 2.07, 6.56, 2.47, 1.83, -0.7, 2.99, 2.42, 12.46, 4.4309, 2.3645, 5.3213, 1.5585, 2.1271, -1.6408, 1.5783, 3.7404, 2.9065, 4.1234, -7.3357, -0.3502, 14.6533, 3.8959, 4.4306, 0.6367, -2.3252, 1.3038, 4.2017, 3.1404, 1.5788, 0.556, 0.911, -1.6542, 4.3153, -2.1726, 1.9519, 3.7939, 4.4412, 3.1604, 10.9977, 3.1185, 5.7402, 3.7415, 0.5898, 0.7769, -0.6883, 0.9056, 11.9951, 3.9005, 10.2768, 0.7475, 2.9083, 4.1757, 3.7217, -1.8526, 2.33, -3.24, 5.94, 2.21, 4.3519, 2.3159, 4.0486, -2.9228, 3.9572, 3.6369, 8.7798, 4.8465, 3.5212, -4.726, -1.7495, 3.7065, 2.5063, 1.5626, 0.4372, 3.6648, 3.4701, 2.0359, 1.5016, 1.97, 3.04, 1.56, 1.11, 2.9382, 2.3344, 4.1819, 2.6726, 5.0039, -1.7885, 3.498, 3.6458, 4.3928, 7.351, 5.7991, 26.7235, 7.1039, 3.6011, 2.4504, 3.8374, -1.4928, 1.2831, 3.7125, 6.7113, 5.049, 3.72, -0.88, 2.57, 0.25, 2.57, 0.38, 1.46, 1.5178, 4.2232, 14.9168, 3.9067, -0.4813, -2.669, -1.9356, 2.6635, -0.2099}, _
                         New Double() {0.2075, -1.3283, 0.1756, 0.0685, 0.4482, 0.1387, 0.5575, 0.1522, -6.3592, 0.3673, -4.6227, -2.9884, 0.5578, 0.03, 0.1669, -2.7902, -3.4544, -0.2373, 0.5306, 1.0339, -0.8961, -4.704, 0.4898, -0.3679, -1.1535, 1.2787, 0.58, 1.0, 0.6749, 0.5321, 0.3754, 0.5583, 0.6497, -1.7007, 0.9324, -4.093, -8.2146, 0.9961, 0.4002, 0.4593, 0.4556, 0.4742, 0.4451, 0.5203, 0.9444, 0.9467, 0.699, -1.071, 0.392, -1.033, 2.2719, -4.2815, 0.3252, -7.553, 21.8465, 1.028, 0.07, -1.3406, -9.8513, 0.5656, 1.2345, -3.725, -0.2078, 0.3009, -0.6306, 1.28, -3.08, -2.07, -0.53, -3.97, -3.14, -5.33, -18.46, 0.53, -3.8249, -2.0936, 0.6719, -0.4945, 1.5559, 0.4892, -0.6491, -1.8165, -1.553, 1.2217, 7.6917, -21.9335, -2.7155, 0.1377, 0.5658, 0.9063, 0.6501, -0.7775, -1.2595, -0.421, 0.469, 1.041, 1.3613, -1.5362, 0.8, 0.1603, -0.1963, -0.1959, -0.8435, -4.8008, -3.8306, 1.619, 3.1147, 0.388, 0.96, -2.3763, -2.3077, -1.9673, 0.2027, -1.2342, 1.606, -1.5992, -0.778, -3.8973, 0.843, -0.61, -3.95, -3.62, -0.7, -1.2407, 2.4343, -8.8405, -2.8674, -0.8831, -0.6872, -2.7173, 0.0115, -0.9403, 4.4288, 1.1811, -3.8008, -1.0829, -0.3178, 0.4056, -0.8951, -0.9597, -1.5146, 0.6395, -1.3, -0.17, -3.24, 0.06, -1.6925, -0.9566, -3.3079, -1.4666, -3.2211, 1.1937, 0.4004, 0.5024, 0.0, 1.5011, 1.93, -12.6503, -5.2846, 1.5038, 0.1925, 0.1253, 1.6707, 0.8261, -1.1255, 1.0989, -0.3963, -0.37, -2.87, 0.18, -0.09, -0.11, 0.47, -0.75, 0.666, -0.1889, -3.6918, -0.4379, -3.9748, 1.4591, 1.3343, -4.4005, 0.9466}, _
                         New Double() {-5.2432, -7.4548, -0.6309, -3.6981, 0.585, -0.3711, 0.5433, -0.7497, -3.3339, -2.2185, 1.1918, -1.4261, -0.0396, -3.59, -2.4365, -0.7917, -0.2814, -4.7439, 0.6445, -1.6698, -3.5614, -3.6338, 0.4279, -3.3235, 0.2537, -7.978, 0.66, -1.29, 0.5785, -3.8462, -1.0173, -0.1935, 0.5064, 1.5577, 0.5488, 0.392, -5.0408, -1.3573, -1.3066, 0.4593, 0.4852, 0.5014, 0.455, 0.6347, 0.6992, -1.1286, 0.5605, -5.678, -4.8868, 1.1651, 2.5652, -1.034, 0.668, -4.2003, -18.8462, -1.2889, -2.33, -4.1014, -1.2591, 0.5904, 0.3095, 0.9336, -4.8349, -4.6138, -1.6124, 1.72, -6.07, -2.57, -1.1299, -0.49, -3.79, -1.46, -5.28, -3.7509, -10.0949, -4.9009, 0.651, -1.6248, -0.8529, 0.2749, -4.8624, -2.6541, -6.6365, -4.624, -0.6562, -2.064, -4.2044, -5.0291, 0.5554, -1.256, 0.5184, -5.0849, -1.677, -0.7076, 0.477, 0.8612, -1.2936, -4.0422, -0.9603, 0.0445, -4.2281, -8.1452, -1.7013, -3.3262, 0.6289, 1.9681, 2.3847, 0.4831, 1.0087, -0.4057, 3.5433, -3.7904, -5.6053, -6.3221, -4.235, -2.3136, -4.4338, -0.1496, -0.7346, -1.52, -1.73, -0.56, -1.79, -5.8827, 2.0429, -2.3391, -1.273, -3.7797, -1.6514, -0.5071, -4.917, -2.856, 0.9181, -1.5893, -0.9802, -1.9438, -0.4337, 0.4134, -4.5284, -4.8061, 7.6041, 0.6165, -2.24, -3.55, -1.1399, -0.4, 0.485, -2.149, -0.998, -2.5742, 1.0938, -1.2704, -3.8417, -2.6667, -3.7954, -3.7509, 2.4573, 1.1557, 5.3078, -2.963, -1.3725, -2.582, -1.6867, -0.0221, -2.3643, -6.6083, -5.0301, -4.86, 0.15, 1.61, -2.18, -7.84, -1.27, -2.15, 0.5973, -4.8975, -3.5695, -3.4332, -7.3496, -0.5704, -0.7518, -1.2179, 1.3651}, _
                         New Double() {5.4143, 3.3248, 0.5252, 6.7558, -0.0649, 0.9535, 0.5117, 1.8606, 6.2906, 2.7313, 4.6195, 4.3981, 0.5629, 3.79, 5.0503, 2.2531, 2.9511, 5.7188, -1.0467, 0.674, 4.3864, 4.4505, 0.4636, 3.4377, 1.9343, 4.0858, -0.58, 1.0, -0.8636, 6.3852, 2.5276, 0.8926, -0.4904, 1.5794, -0.8551, 2.5928, 6.6601, 0.5904, 2.2458, 0.4298, 0.4158, 0.4455, 0.4161, -0.4681, -0.89, 2.1275, -0.8051, 5.1499, 2.5648, -1.1347, 0.9644, 3.1267, -0.777, 0.7886, 10.1558, 0.3799, 1.65, 5.0803, 5.0043, 0.5409, 0.5857, 2.4925, 5.8121, 5.6384, 2.9097, 0.43, 3.68, 1.8, 0.53, 1.96, 2.86, 3.17, 8.76, 6.3962, 4.1816, 4.5744, -0.9334, 2.1665, 0.584, -0.319, 5.6253, 3.5749, 9.6532, 0.4788, 8.9812, 13.362, 5.7649, 6.0212, 0.5944, 0.5258, -1.0052, 6.3529, 3.5561, 1.8055, 0.476, -0.8299, 0.3123, 5.4525, 0.2375, 2.0172, 5.6468, 3.2051, 4.0385, -0.333, 2.5, 2.6654, 0.9317, 0.3763, -0.7271, 1.4256, 4.5627, -1.0429, 4.3567, -2.0235, 2.7, 2.8283, 4.5107, 2.7651, 0.427, 1.86, 1.6, 3.37, 2.18, 6.3705, -1.0419, 3.4615, 3.3452, 6.1308, 3.4803, 4.3115, 4.861, 2.9144, 0.267, 0.2828, 1.9148, 2.6939, 0.7342, 0.3958, 6.165, 6.3599, 5.738, -0.9614, 3.8, 5.07, 4.04, 1.16, 3.3986, 3.1637, 3.781, 3.8691, 4.1527, 0.4447, 5.5477, 4.3663, 4.2882, 1.0968, -0.9446, 11.9755, 2.0945, 6.1069, 1.2052, 1.9715, 0.5262, -0.2379, 3.0493, 7.3025, 5.5797, 6.35, 0.83, 0.88, 4.38, 5.0599, 2.44, 3.1, -0.9298, 5.8849, 0.1027, 5.4061, 5.9288, 1.451, 0.5736, 3.3648, -0.7504}, _
                         New Double() {2.0733, 2.0821, 1.6233, 0.6395, -0.2189, 0.5012, 0.465, 0.8626, -0.8569, 0.9813, -1.2665, -1.0532, 1.0724, 2.75, 2.4103, 7.7893, -0.7206, 1.8663, -0.5242, 1.6168, 1.8281, 0.6056, 0.4939, 2.8804, 0.1876, 2.3798, -0.33, 1.45, -0.3598, 2.1974, 0.8911, 0.4381, 0.0604, 0.1157, 0.4771, -0.6232, -0.864, 1.4133, 1.4818, 0.4102, 0.3958, 0.4238, 0.1585, 0.1568, 0.1283, 1.3358, -0.3103, 2.3367, 6.4095, -1.9937, -0.6071, -1.5235, -0.3212, 1.3661, -4.0105, 1.3939, 0.03, 2.2022, -1.5269, 0.4953, 0.3536, -0.4109, 1.6951, 2.5367, 1.0469, 1.07, 0.71, 0.1, 0.19, -4.32, 0.25, -0.61, -4.4, 2.8798, 3.8744, 3.2484, -0.2974, 1.0461, 1.3831, -1.1345, 1.8216, 0.4893, 3.9387, 6.1612, 3.7339, -4.7012, 1.0289, 2.153, 0.6146, 1.3919, -0.415, 0.7483, 0.0191, 0.2084, 0.391, 0.3058, 1.6081, 3.4107, 1.2915, 0.3397, 1.6521, 0.0, 2.7726, 1.559, -0.6098, 3.1334, 1.7692, 0.3902, 0.3418, -3.2128, 0.0, -1.5223, 2.0923, -0.4384, 1.3451, 0.6377, 2.6871, -0.8677, 1.1163, 1.02, -3.63, -0.35, 1.21, 2.4775, -0.1239, -0.9801, -0.5967, 2.0555, 1.2963, 1.7302, 2.7907, 1.6265, 5.2859, 1.6195, 0.2617, 0.6278, 0.1356, 0.3647, 2.3083, 1.8634, 2.4805, -0.3807, 0.56, 2.35, -0.63, 0.5699, -0.8825, 0.4499, -1.5633, 0.4669, -1.6087, 1.3388, 1.6325, 2.9532, 3.3717, -2.1807, 3.5987, -1.2093, 0.3081, 2.1242, 0.6685, 0.7826, 1.1007, -0.0596, 1.1314, 3.2732, 3.0701, 2.18, 0.0, 1.1299, 2.84, 3.29, 1.85, 0.94, -0.414, 1.6814, 1.2397, 3.6447, -0.9751, 0.2368, 1.2774, -2.8224, -0.2693}, _
                         New Double() {4.5148, 1.2904, 2.8109, 4.6969, -0.0897, 0.8886, 0.4633, 1.8278, -2.6966, 2.6744, 4.0698, -3.2773, 3.6433, 4.46, 2.6867, -0.9427, -3.5062, 3.9051, 0.0575, 4.6094, 5.2571, -3.2182, 0.5592, 3.9821, -1.2994, 1.3729, 0.17, 3.61, 0.0855, 4.0819, 1.4058, 0.7046, 0.1809, -2.2463, 0.6118, -3.5087, -2.5799, 4.4993, 1.2004, 0.3806, 0.3952, 0.4515, 0.3289, 0.4548, 0.1872, 3.4602, 0.0118, 3.6632, 8.878, -4.8258, 0.7012, -2.4082, 0.4531, -4.6708, -7.5876, 4.7236, 8.25, 5.6613, -3.7644, 0.3912, 0.8241, -3.0486, 3.6944, 4.7531, 1.4456, 1.3799, 3.22, 0.45, 0.6899, -4.26, 0.44, -3.46, -4.21, 6.1249, 2.424, 7.222, -0.0017, 1.1246, 4.4715, 0.0, 4.9291, 1.0593, 8.9763, -2.5491, -3.5122, -5.934, 0.9343, 5.2076, 0.3856, 4.6663, 0.1153, 2.5761, 0.3115, 0.3726, 0.4089, 0.5776, 4.7897, 4.8416, 4.563, 0.1898, 3.5373, -1.3458, 3.0576, -2.4123, -3.3742, 0.7813, -1.8141, 0.3887, 0.36, -3.7002, -8.8836, -2.6766, 4.0031, -3.4071, 4.3954, 0.8795, 3.5137, -3.0158, 4.7069, 1.83, -3.5, -0.73, 2.27, 2.6698, 1.2937, -6.2288, -3.1836, 3.522, 0.7735, -4.9197, 4.7682, 1.3978, 0.1482, 5.1565, -3.8854, 0.9253, 0.2896, 0.3565, 4.139, 3.6851, 3.1391, 0.0742, 1.03, 4.72, -4.4, 1.02, -2.3484, 0.7542, -3.4143, 0.521, -3.9842, 4.4531, 4.0561, 3.1088, 4.1883, -3.6143, 0.024, 2.1741, -1.1284, 3.2888, 0.5713, 0.9708, 4.3952, 0.1015, 0.7315, 1.7048, 2.736, 3.99, -4.13, -2.93, 3.6, 2.19, 2.63, 1.05, 0.0189, 3.7264, -2.4581, 4.6655, -4.2492, -3.5476, 4.6444, -2.7108, 1.1318}, _
                         New Double() {-4.4194, -3.0185, 1.8265, -4.015, 0.3434, -0.372, 0.465, -0.8706, -1.0673, -1.5607, -1.8161, -2.9274, 0.8426, -4.49, -3.1718, -4.2824, -1.4296, -4.7662, 0.3403, 1.0993, -4.2768, -2.3736, 0.6221, -3.51, -2.8434, -2.8293, 0.19, 0.54, 0.462, -4.4832, -1.218, -0.0118, 0.767, -0.7531, 1.428, -1.1288, -2.0337, 0.7806, -2.2174, 0.421, 0.4158, 0.4928, 0.4673, -0.2526, 1.8307, 1.4354, 0.4133, -5.1799, -8.3033, -2.1586, -2.0442, -2.3255, 0.8124, -3.1979, -11.1035, 0.0471, 0.93, -4.3771, -1.9361, 0.5272, 0.6917, -1.4826, -4.8179, -3.8447, -1.721, 0.33, -5.25, -1.57, -0.39, 0.0, -2.52, -1.71, -4.8, -1.8785, 30.7411, -2.4744, 0.4782, -1.3387, 1.0479, 0.7691, -3.8188, -1.1774, -7.2112, -3.967, -3.2357, -8.7622, -2.1713, -3.6887, 0.5447, 0.9524, 0.4074, -4.6895, -2.063, -0.5926, 0.412, 1.4433, 1.4524, -5.4485, 0.8422, 0.5308, -4.6198, -2.725, -3.0187, -3.4043, -1.2512, -3.1275, -0.9555, 0.39, 1.0459, -1.2987, -10.137, 3.8271, -3.7307, -6.3129, -3.0144, -2.0653, -4.7394, -1.3364, 0.8575, -2.07, 0.1, -1.41, -2.24, 1.1442, 1.8646, -4.0491, -2.236, -4.0458, -1.2017, 0.8748, -4.8195, -2.4335, -0.7876, 1.3554, -2.2376, -1.3354, -0.1033, 0.366, -4.6967, -3.678, -0.6909, 0.4142, -2.83, -4.7699, -3.0099, -0.87, 1.8703, -1.848, -1.5774, -2.3081, -1.194, 0.7542, -4.3487, -3.5885, -4.7508, 0.6455, -0.4869, -4.9412, -7.1179, -3.0226, 0.0102, -0.9488, 1.3072, 0.8861, -1.3851, -4.2345, -4.1007, -4.45, -1.49, -0.8, -3.21, -2.0099, -1.56, -1.99, 0.4458, -4.7189, -6.1637, -3.8272, -3.8559, -3.1877, 0.8569, -2.4281, 1.2479}, _
                         New Double() {-0.6765, 0.8308, 4.4965, -0.6308, 1.9365, 0.4007, 0.4517, 0.9004, -8.5827, 0.6302, -7.0, -9.4088, 2.0395, -0.55, 0.4836, -6.5388, -8.4004, -1.1039, 2.8827, 3.5256, -0.2397, -1.221, 0.4119, -0.1485, 0.6879, 2.964, 2.45, 3.73, 2.8028, -0.6364, 0.0942, 0.9279, 1.96, -5.7037, 1.0058, -8.2052, -5.9469, 3.4643, -0.6707, 0.4287, 0.4338, 0.5103, 1.1778, 3.7983, 1.0517, 4.118, 2.5314, -0.9081, 2.8692, -8.2212, -5.2999, -8.1689, 1.7849, -10.9031, -17.9073, 3.5976, 2.8, -0.3849, -8.9682, 0.4392, 1.0208, -7.5961, -1.0901, -0.8625, -1.6085, 1.37, -0.72, -1.57, 0.58, -5.76, -2.33, -8.48, -15.55, -1.5179, 5.8843, -1.0578, 2.7262, -0.9635, 3.7094, 1.9036, -0.6746, -2.1823, 0.2162, -6.5986, -3.1841, -13.8165, -3.9173, -0.5871, 0.5145, 3.4493, 2.6107, -2.0748, -1.9592, 0.0877, 0.45, 1.0357, 3.3632, -2.045, 3.4021, 0.5368, -1.0711, -1.0905, -1.5497, -2.6838, -7.8242, -3.5651, -4.9402, 0.779, 0.9556, -5.8114, -9.7561, -6.6753, -1.3949, -6.1325, 2.4995, -1.7445, -0.4859, -7.8663, 3.7458, -1.15, -5.59, -8.46, -1.09, 1.206, 0.547, -10.2349, -5.0548, -0.7931, -0.6727, -5.7813, -1.4409, -1.8342, -4.9445, 3.2324, -6.4468, -0.7734, 0.8613, 0.3844, -2.0818, -2.1956, 0.5809, 2.6663, -2.2, -1.66, -7.29, 0.31, 7.2114, -1.5438, -8.2899, -2.7118, -8.6578, 3.4958, -1.465, -1.6543, -0.3271, 1.1738, 0.7961, -6.6584, 1.8488, -3.7958, 0.2187, -0.0266, 3.6914, 1.7829, -2.1898, -4.3305, -2.2636, -1.97, -8.59, -6.2699, 0.27, 1.32, 1.19, -2.2, 2.661, -1.1148, -4.7037, -0.2818, -7.373, -5.3825, 3.4345, -8.9648, 1.1889}, _
                         New Double() {-8.1724, -9.8035, -0.3957, -6.782, 0.9819, -0.7177, 0.4483, -1.0102, -4.9096, -2.6303, -7.0789, -6.9907, 0.3106, -7.16, -4.3579, -8.8112, -2.6908, -6.1316, 1.0743, -0.4142, -5.0776, -5.9892, 0.4202, -5.8736, -2.4594, -12.4488, 1.4, -0.52, 1.0828, -6.8294, -2.8466, -1.0678, 0.4285, -1.4201, 0.8953, -2.7232, 9.4454, -0.2814, -2.6578, 0.4189, 0.4025, 0.361, 0.5086, -1.0469, 0.8751, -2.0871, 1.1496, -8.441, -10.8917, -2.8687, -1.3633, -3.0593, 0.5111, -3.6442, -14.8824, 0.091, -3.75, -6.797, -5.1349, 0.4477, 0.822, -2.358, -6.3453, -6.0752, -3.4568, -0.8, -7.34, -3.54, -1.65, -4.78, -5.13, -3.18, -5.97, -4.6399, -6.4359, -4.2938, 0.9435, -2.1543, -0.6666, 0.3113, -6.3442, -3.3914, -10.0757, -0.7196, -2.255, -11.4885, -5.7932, -6.3083, 0.4838, -0.1427, 1.1862, -7.65, -4.5571, -1.9098, 0.4079, 1.1189, 0.2789, -8.9117, -0.4969, -0.2188, -6.1024, -8.269, -5.5556, -10.7914, -2.7907, -6.8392, -6.2029, 0.7729, 0.2545, -3.0268, -6.5878, -10.8666, -7.0622, -11.616, -7.3637, -3.4569, -6.4357, -2.5071, -0.6183, -3.39, -2.75, -2.77, -3.76, -7.2978, 1.674, 7.6367, -5.5466, -7.248, -4.1006, -7.0039, -5.9898, -4.2522, 3.0989, 0.1458, -7.3828, -4.1257, -1.0649, 0.4021, -6.9547, -7.2092, -10.3505, 1.1429, 5.59, 7.5, -4.89, -1.22, 0.6362, -4.4721, -4.613, -6.2341, -4.8157, -0.4102, -6.6867, -5.3827, -5.7424, -4.4375, -3.3073, -10.9962, -4.751, -7.2273, -0.6357, -2.1273, 0.5479, 0.8328, -2.7052, -2.4929, -5.5263, -9.3699, -4.0, -2.67, -7.02, -9.22, -3.4, -4.76, 1.0463, -6.3644, -9.9343, -5.6029, -7.6899, -2.9421, -0.015, -1.9605, 0.5174}, _
                         New Double() {7.5282, 7.4072, 3.1582, 6.803, 1.096, 2.2219, 0.4425, 2.1695, 4.6823, 3.6752, 1.6715, 1.36, 1.8179, 6.7, 5.1093, 6.0475, 0.3386, 6.729, 1.6631, 3.5939, 6.0843, 4.0961, 0.5856, 6.793, 5.7116, 7.0223, 1.6299, 3.09, 1.529, 7.5531, 3.7754, 2.3956, 1.3644, 0.3267, 1.9747, -0.444, 2.3056, 3.6231, 2.6962, 0.3615, 0.366, 0.2264, 0.3556, 1.2081, 1.981, 4.9828, 1.6, 7.08, 12.1, 0.16, -1.0807, 0.7231, 1.8702, 0.5946, 13.0784, 3.317, 6.94, 6.7778, 3.9433, 0.4551, 0.712, -0.3355, 6.7541, 7.3139, 3.6009, 1.33, 7.39, 3.1, 2.3, 0.0, 3.92, -0.49, 3.7, 7.2456, 15.986, 6.4572, 1.7109, 2.8409, 3.9163, 1.543, 6.3208, 4.2514, 9.8991, 0.0753, 4.3391, 14.259, 5.812, 6.1227, 0.5336, 3.8609, 1.589, 7.0188, 3.7702, 2.1707, 0.384, 2.2054, 3.645, 8.8001, 3.6736, 0.6667, 6.499, 9.2548, 8.3333, 0.672, 0.0, 2.5794, -1.8767, 0.5971, 2.0812, 0.2402, 1.4466, 4.321, 7.6578, 4.5632, 5.0161, 3.2345, 6.6071, -0.7511, 3.5473, 3.57, 0.98, 0.91, 4.0, 8.0663, 1.5641, 1.497, 1.7145, 8.3962, 4.2469, 0.4147, 5.7861, 3.5382, 0.2049, 3.8033, 0.5654, 3.6488, 1.8755, 0.3458, 6.9647, 6.5197, 7.1488, 1.6335, 4.4, 6.67, 1.76, 1.87, -0.6169, 3.7936, 1.2496, 4.2483, 1.3536, 3.5926, 6.4703, 6.5778, 6.7885, 0.6884, 3.5736, 13.3181, 1.4587, 9.166, 2.2786, 4.1093, 3.2853, 1.8143, 3.2597, 7.8941, 7.2816, 8.63, -2.09, -1.8, 7.08, 8.41, 4.39, 3.68, 1.667, 6.7701, 4.5595, 6.0473, 3.2991, -0.6553, 3.4406, -1.0173, 1.1411}, _
                         New Double() {2.173, 1.9044, 1.1468, 3.5353, -0.6313, 0.4432, 0.4192, 0.5876, 1.9436, 0.7759, 5.588, 3.4605, 0.2105, 2.6, 4.0904, 5.1315, 3.9464, 3.1079, -1.0451, -0.2688, 2.2584, 4.3231, 0.3806, 3.5503, 3.2044, 1.9837, -1.28, -0.44, -0.7438, 3.4173, 2.1782, 1.0236, -0.3014, 3.2327, -0.5919, 2.6508, 6.0016, -0.1467, 0.7947, 0.3506, 0.3449, 0.4026, 0.4429, -0.806, -0.6879, 2.8624, -1.07, 4.11, 1.024, 1.3759, 0.7144, 2.7134, -0.6252, 5.4178, 14.1061, -0.6707, 4.2, 0.705, 4.5367, 0.4245, 0.4817, 1.9942, 3.2562, 3.3404, 2.1302, 2.46, 2.46, 1.23, 0.3, -0.29, 1.89, 1.73, 8.16, 2.8687, 7.4425, 1.5015, -1.0009, 1.5982, -0.4819, -0.1346, 1.7293, 0.949, 4.1707, 0.4891, 0.4789, 7.8919, 1.9676, 2.1413, 0.4744, 0.0365, -1.1267, 2.6443, 2.2153, 0.9906, 0.351, -0.9313, -0.266, 1.3834, -0.6002, 0.3921, 3.248, 5.8305, 5.9729, 7.6101, 2.3923, 0.4836, 3.1876, 0.0961, -0.4376, -0.3593, 3.0303, 12.5741, 2.7618, 11.7172, 1.579, 1.3099, 2.449, 2.4129, -0.0893, 1.6, 0.74, 3.51, 1.76, 4.0319, -2.1479, 4.7198, 1.9806, 2.6902, 2.0694, 6.2987, 2.6723, 2.4309, 2.4932, 0.099, 2.1227, 1.4315, 0.3785, 0.3249, 3.2651, 3.5117, 1.1462, -1.0714, 2.07, 2.41, 1.9, 0.42, 1.3411, 2.4439, 3.6135, 3.4152, 5.0375, -0.4368, 3.5093, 4.0033, 3.423, 4.6118, 2.2098, 2.3751, 1.9016, 5.1201, 0.4568, 1.1567, -0.1777, -0.7249, 2.1356, 6.2356, 3.4389, 3.62, 2.69, 1.29, 3.7, 3.62, 1.53, 2.41, -1.0609, 3.3325, 8.0241, 2.446, 2.6311, 0.7354, -0.6404, 3.6374, -0.6662}, _
                         New Double() {2.432, 2.0568, 1.5549, 2.6459, -0.5867, 0.3932, 0.4175, 0.9922, 3.1862, 0.9754, 3.5332, 3.0716, 1.2604, 2.14, 1.7129, 3.7772, 3.1022, 2.5535, -1.1119, 1.9312, 2.2197, 1.8022, 0.5089, 2.1815, 1.0155, 2.4539, -1.06, 2.71, -1.0362, 2.794, 1.3218, 0.3575, -0.5038, 2.539, -0.6766, 2.226, 1.0822, 2.0106, 1.7719, 0.3494, 0.3536, 0.3815, 0.1372, -0.3703, -0.5296, 1.9096, -0.912, 2.107, 3.383, 3.335, 2.9206, 3.0141, 2.4765, 2.2115, 2.896, 2.1698, 1.11, 1.6707, 3.067, 0.4856, 0.9149, 2.3977, 2.609, 2.0158, 1.3081, 1.95, 2.18, 0.91, -0.01, 5.24, 1.58, 2.39, 1.89, 1.2629, 2.8779, 0.8657, -0.8164, 1.6042, 2.2218, -0.2884, 2.6778, 1.9997, 6.4507, 0.1872, 7.6176, 5.6188, 3.2575, 2.5793, 0.4741, 1.9212, -0.9082, 3.5288, 2.2808, 0.8583, 0.35, -0.833, 2.0118, 2.3187, 2.1246, 0.5989, 2.5739, 1.8711, 1.7079, 9.1811, 2.1027, 2.3099, 2.8243, 0.2885, -0.6593, 3.7259, -5.8823, 10.5124, 2.1864, 11.1839, 0.1652, 1.3859, 2.286, 2.73, 1.9199, 1.32, 4.09, 2.21, 1.48, 1.0915, -0.1656, 0.8017, 2.4793, 2.0132, 1.0092, 1.7308, 2.1172, 1.5128, 2.8791, 2.0308, 1.9414, 1.0764, 0.2681, 0.3278, 2.1831, 2.2125, 2.6282, -0.8807, 1.89, 2.69, 3.25, 0.65, 4.2801, 1.6768, 3.5031, 2.2097, 4.4667, 1.9464, 2.5909, 2.8238, 3.0509, 3.3807, 4.6295, 2.9107, -0.7168, 2.5297, 0.4263, 0.8361, 2.3181, -0.6513, 1.9091, 4.0697, 2.9692, 2.35, 3.79, 3.83, 1.65, 2.99, 1.33, 1.76, -0.8841, 2.633, 9.3676, 3.3785, 5.9513, 2.5511, 2.1551, 3.3092, -0.3461}, _
                         New Double() {0.428, 2.2902, -0.7354, 1.1425, -0.1428, 0.0306, 0.415, 0.3781, -2.0881, 0.4743, -3.7416, -2.9801, 1.0805, 2.0299, 3.2732, -0.1661, -2.7639, 1.2795, 0.0188, -0.8088, 1.4162, 0.7159, 0.4551, 2.5641, 2.2244, 2.3493, -0.09, -1.67, 0.0474, 1.2265, 0.1819, 0.2051, 0.327, -1.2381, 0.3384, -2.1133, -1.8279, -1.4327, -0.1421, 0.3523, 0.376, 0.4718, 0.2569, 0.7264, 0.5898, -0.4146, -0.078, 1.78, 3.859, -2.737, -0.51, -2.7056, 2.3377, -5.1349, -1.5541, -1.6006, 3.97, 0.1088, -5.6208, 0.4392, -0.0441, -2.1227, 1.2446, 1.8715, -0.1436, 2.24, 0.71, -0.47, 0.07, -3.35, -0.79, -2.38, -4.63, 3.1829, 7.7215, 2.1317, 0.2857, 0.0395, -1.3722, 0.3735, 0.0425, -0.5372, 1.5981, -6.1846, 3.8815, 0.1078, -0.3308, 0.8561, 0.4644, -1.3059, -0.0165, -1.0398, -1.4829, -0.5132, 0.355, 0.5086, -1.1389, -0.1527, -0.5709, 0.6903, 1.334, 4.203, 4.0951, 6.5909, -2.2883, -0.0941, 0.4292, 0.0854, 0.5028, -3.1286, -6.25, 3.0916, 2.064, 4.2594, -2.0466, 0.1208, 1.3292, -2.0311, -0.7796, 0.51, -4.43, -0.24, 0.53, 3.8916, -0.0622, -3.4394, -0.5242, 0.8192, -0.3109, -3.7402, 1.315, -0.0857, -1.8565, -1.1737, -2.2293, 0.0, 0.0954, 0.3159, 1.3777, 1.198, 3.7692, 0.0504, -1.08, 0.03, -4.0199, 0.02, -2.5017, -0.6105, -3.895, -0.99, -4.6486, 1.3676, 1.1373, 2.8481, 3.4348, -1.7184, 4.1174, -1.5889, 0.8481, 1.9761, 0.222, 0.4759, -1.1833, 0.2252, 0.1697, 0.9897, 1.3001, 1.03, -2.69, -1.64, 2.45, 2.93, 0.97, -0.2, 0.0938, 1.2565, 4.0403, 1.1181, -2.4651, -2.3158, -1.2641, 4.8425, 0.8323}, _
                         New Double() {-2.5753, 2.2097, 0.2623, -2.0644, 0.3526, 0.0599, 0.4108, -0.3432, -1.887, -0.4638, -2.9669, -1.3652, 0.4726, -0.56, 0.9395, -3.4793, -2.8965, -1.1467, 0.5741, 0.6035, -1.266, 2.0689, 0.4066, 0.4861, 2.7582, 1.2818, 0.58, 0.44, 0.5775, -0.7133, -0.1211, 0.145, 0.4991, -1.7019, 0.4473, -2.7071, -0.8246, 0.5881, -1.0244, 0.312, 0.3352, 0.2935, 0.3549, 0.9271, 0.6584, 1.1995, 0.609, 1.157, 1.49, -1.3939, -0.41, -2.6812, -1.0075, -4.1439, -14.4868, 0.209, -1.54, -2.041, -3.8153, 0.4435, 0.2069, -2.8893, -1.1324, -0.3656, -0.5289, 1.97, -2.34, -0.85, 0.06, -1.45, -1.32, -2.19, -9.22, -0.476, 2.7935, -1.3651, 0.587, -2.5694, 1.1861, 0.705, -2.065, -1.1281, -4.1339, -4.6505, 3.1257, -7.4806, -1.4759, -1.372, 0.4543, 0.4852, 0.6235, -2.6851, -1.6041, -0.2204, 0.331, 0.5827, 0.9573, -0.9557, 0.1266, 0.4027, -1.1132, 0.4931, 2.1399, -3.0917, -2.5761, -0.6591, -0.6838, 0.3895, 0.4802, -1.1962, 7.647, -1.3841, -1.2504, -1.9273, -0.5346, -1.4786, -1.2361, -2.1164, 0.5171, -0.5699, -2.45, -3.82, -0.56, 3.2299, -0.2283, -1.3133, -0.3851, -2.9455, -1.3302, -1.7752, -1.3432, -1.0469, -1.4869, 0.9135, -1.2304, -0.3658, 0.2165, 0.2854, -1.1234, -1.6615, 0.0398, 0.5738, -0.63, -1.84, -0.36, 0.03, -0.8628, -0.1787, 1.4016, -0.2861, -2.2187, 0.7957, -0.8337, 0.6923, 1.5094, 1.5847, 2.0215, 3.7278, 1.5795, 0.1152, -0.1643, -0.7241, 0.9579, 0.6677, -1.6423, -2.1083, -1.3295, -0.89, -3.21, -1.46, 0.51, 1.9, 0.52, -0.97, 0.5399, -1.1534, 0.4723, -2.2294, -3.427, -1.524, 1.1785, 1.9382, 0.154}, _
                         New Double() {0.1675, 2.9455, 1.0995, 1.195, -0.623, 0.0701, 0.41, 0.0078, 4.3077, 0.0566, 3.4756, 2.2145, 0.6246, -0.03, 0.6981, 4.9155, 1.2043, 0.8648, -1.1136, 1.3177, 0.2846, 5.7821, 0.4143, 0.8293, 3.3827, 2.6256, -1.0, 0.66, -0.8755, 0.2657, 0.3864, 0.0085, -0.5068, 0.6956, -0.7634, 1.1374, 4.2108, 1.1053, 0.213, 0.3402, 0.3832, 0.4975, 0.1277, -0.4593, -1.0629, 2.1196, -0.805, 0.208, -2.575, 0.81, 1.02, 0.0, -0.4836, 1.173, 2.9939, 2.3942, 2.77, 0.7596, 1.5775, 0.4308, 1.3387, 1.2322, 0.6364, 0.9403, 0.9531, 1.33, 1.18, 1.12, 0.34, 3.43, 1.88, 2.39, 3.21, 0.932, 3.124, 0.9898, -0.6609, 3.0125, 1.0981, -0.3501, 0.8405, 1.8439, 0.3048, -1.2637, 4.1876, 6.0931, 2.8275, 0.6395, 0.1381, 1.2027, -0.8117, 0.8246, 1.2278, 0.7775, 0.34, -1.0976, 1.517, 0.7873, 1.4063, 0.7766, 0.8443, 0.8832, 1.7728, 0.6601, 1.2019, 2.8436, 1.7212, -0.097, -0.9061, 1.2107, 5.4646, 4.9124, 1.3604, 3.7303, 1.6924, 0.5524, 0.2584, 1.0502, 1.0207, 0.13, 1.59, 1.22, 0.15, 2.9842, -2.2675, 2.5491, 3.4995, 1.5044, 0.9204, 2.674, 0.9479, 1.2228, -0.6304, 1.0781, 1.9086, 0.5596, 0.0966, 0.3583, 0.3187, 0.6535, 0.3045, -0.8629, 1.06, 1.05, 0.17, 0.28, 0.6152, 0.8636, 2.0196, 1.5286, 2.7101, 1.1813, 0.2474, 0.6112, 0.4461, 4.8929, 7.8826, 1.9721, 5.9518, 1.2925, 0.1259, 0.2239, 1.2804, -0.8668, 0.9276, 3.4383, 1.2443, 0.82, 2.4, 1.69, -0.08, 3.48, -0.27, 0.91, -0.9013, 0.6294, 1.9978, 0.8443, 3.0699, 0.2636, 1.4562, 1.3985, -0.8132}, _
                         New Double() {-2.1836, -2.1723, 1.4368, -2.4582, 1.1671, 0.3285, 0.4108, 0.0509, 3.069, 0.5154, 3.5684, 3.1144, 1.2137, 2.2, 0.211, 0.6, 5.1625, 1.9241, 1.4479, 1.6617, 1.676, 0.4107, 0.4691, 0.1371, 0.2979, 4.7027, 1.68, 1.3, 1.5195, 1.1308, 0.1364, 0.5382, 1.2257, 2.2336, 1.4221, 4.2055, 4.6326, 1.5822, 0.7107, 0.3621, 0.3758, 0.4121, 0.5328, 1.0926, 1.6217, 1.7867, 1.48, 0.62, 2.15, 1.6, 0.35, 4.4304, 1.3631, 4.952, 12.815, 1.2962, 0.5699, 0.8711, 6.3658, 0.4412, 2.8356, 3.3096, 1.8198, 1.3499, 0.9496, 1.79, 2.38, 1.58, 0.18, 1.7, 2.64, 5.11, 12.44, 1.4607, 0.4946, 1.5698, 1.486, 0.453, 1.8982, 1.2638, 2.6049, 1.1411, 4.2901, 4.8762, 1.0767, 7.9624, 2.3963, 2.2027, 0.6734, 1.4998, 1.4505, 2.3588, 1.4488, 0.2233, 0.369, 1.5647, 1.6237, 2.4125, 1.3905, 0.4658, 1.5814, 3.0156, 2.2961, 0.4372, 3.4442, 1.5668, 0.5921, 0.5891, 1.1701, 0.0, 3.4541, 0.3343, 3.1902, 1.5088, 4.3955, 1.9175, 2.011, 4.2183, 1.5218, 1.35, 1.91, 2.66, 1.48, 3.7894, 1.5539, 5.0814, 0.3342, 4.3173, 2.082, 4.2119, 1.6617, 1.1995, 3.9031, 1.7424, 4.0372, 1.1719, 0.1041, 0.2963, 1.1757, 2.8329, 8.2867, 1.4413, 2.02, 2.57, 3.73, 0.32, 1.1409, 1.5499, 5.1315, 2.2926, 4.9382, 1.5275, 1.652, 1.139, 0.0, 1.2293, 3.5729, 6.2975, 1.1773, 2.3784, 0.2366, -0.1232, 1.6516, 1.4652, 1.6544, 2.6789, 2.3102, 3.12, 4.5, 3.0099, 1.82, 1.86, 0.18, 1.94, 1.4673, 1.7975, -0.1953, 1.6704, 4.9961, 2.299, 1.7476, 6.9709, 1.0457}, _
                         New Double() {0.2565, -1.454, 2.9613, 1.5431, -0.328, -0.1255, 0.405, -0.0936, -4.3388, 0.0509, -4.4025, -5.7303, 0.8944, 1.47, 1.7147, -5.842, -6.0129, 0.7914, -0.2892, 2.7138, 0.6707, -0.2896, 0.4654, 1.4374, -0.1432, 1.323, -0.41, 2.43, -0.29, 1.1437, 0.0455, 0.068, 0.1715, -4.5144, 0.519, -5.0213, -0.7826, 2.9511, -0.982, 0.3608, 0.3744, 0.4006, 0.1963, 0.622, 0.6404, 3.1786, -0.22, 1.69, 1.64, -4.87, -3.11, -5.8239, 0.5157, -5.8025, -7.7798, 2.4791, 4.2733, 0.7934, -6.2585, 0.4436, 0.9178, -4.6891, 0.8274, 0.8499, -0.4811, 0.32, 0.0, -0.99, 0.12, -4.91, -1.36, -5.64, -8.88, 1.6063, 1.2535, 1.8142, -0.2639, -1.9288, 2.4823, -0.1853, -0.1503, -1.036, -0.8662, -6.4161, 5.6106, -8.0551, -1.1923, 0.3086, 0.4146, 3.028, -0.2435, -0.6279, -1.2376, 0.0354, 0.371, 0.4781, 2.8298, -0.1019, 2.546, 0.3372, 1.0397, 0.0, 2.0259, -7.5082, -4.797, -3.9927, -3.196, 0.0975, 0.8377, -5.024, 2.3372, -6.4445, 3.2526, -7.1524, 0.0102, -0.3593, 1.2787, -5.4436, 2.712, -0.2, -4.8, -5.09, 0.05, 3.539, -0.2934, -1.6686, -1.0059, -0.6196, -0.6304, -2.8971, 0.2315, -1.0926, -7.8731, 3.001, -2.1503, 0.1448, 0.0953, 0.3447, 0.4276, 0.4211, -0.828, -0.2702, -0.39, -0.2, -2.56, -0.02, -5.1214, -0.4484, -4.312, -0.7478, 4.8116, 2.8199, 0.5748, 1.0753, 1.7765, -0.3111, -0.6666, -2.2174, 3.2926, 1.4235, 0.322, 0.6425, 2.84, -0.0286, -0.0935, 2.9939, 0.7625, -1.3, -4.53, -4.07, 0.86, 2.2, 0.53, -1.3799, -0.2796, 0.8646, -6.2783, 0.1641, -2.3556, -4.463, 2.8765, -2.183, 1.0459}, _
                         New Double() {-4.1311, -5.0195, 0.2054, -4.9707, 0.8506, -0.3496, 0.425, -0.4174, -5.2098, -1.2818, -6.6948, -8.0689, 3.384, -4.19, -1.8596, -2.7875, -4.7596, -4.148, 1.1173, -0.2184, -3.2824, -6.3249, 0.4423, -1.7812, -3.9894, -5.0991, 1.49, 0.14, 1.3228, -3.5899, -1.7747, -0.3312, 0.957, -4.621, 1.6034, -5.1958, -7.6839, 0.1062, -2.5515, 0.3887, 0.4018, 0.4574, 0.5554, 1.3031, 1.2524, -0.0788, 1.16, -3.61, -2.42, -3.27, -4.34, -4.0848, 0.9456, -6.3819, -11.4793, 0.182, -4.6472, -3.799, -4.6442, 0.464, -0.653, -4.0304, -4.1872, -3.9997, -2.66, 0.63, -5.0599, -2.44, -0.53, -3.32, -3.62, -5.04, -11.0399, -3.806, 7.0968, -3.945, 1.2726, -0.1361, 0.0548, 0.8987, -4.1282, -2.9158, -6.1417, -3.4339, -6.9979, -7.781, -4.8624, -3.5143, 0.5329, -0.2897, 1.2465, -5.0455, -3.517, -1.3964, 0.39, 1.5786, -0.2475, -3.6362, -0.0646, 0.0504, -4.116, -4.8144, -3.0183, -6.9412, -4.6512, -2.741, -3.649, 0.5842, 1.1076, -1.893, -6.8711, -4.7684, -5.4947, -4.7665, 0.3686, -2.7256, -3.8286, -4.6866, 0.0718, -2.38, -2.0299, -5.72, -2.64, -5.5073, 3.868, -6.9291, -4.3036, -4.2827, -3.1921, -8.1297, -4.2503, -3.122, -8.155, 0.4279, -5.5171, -2.6499, -0.5843, 0.3182, -4.1965, -5.539, -3.8919, 1.2684, -3.87, -5.55, -4.48, -0.89, -3.5376, -3.6544, -7.2667, -4.8918, -8.6046, -0.0407, 3.7975, 2.7081, -0.9916, -3.5448, -1.1728, 9.6206, 3.6524, -4.1161, -0.7392, -1.4874, 0.1455, 1.0857, -3.3676, -6.9612, -4.9891, -5.05, 5.83, 5.0199, 4.03, 5.05, -1.5, -3.21, 1.2181, -4.2625, -6.5281, -4.2269, -8.8192, -4.5077, -0.3621, -4.6514, 1.6234}, _
                         New Double() {4.993, 4.5326, 1.2458, 4.7326, 0.7594, 0.6835, 0.4333, 0.6026, 6.1987, -1.6584, 7.7679, 6.6015, -0.6257, 4.45, 2.3135, 7.6469, 5.2756, 4.159, 0.8768, 1.8224, 3.652, 5.1121, 0.4385, 3.1825, 3.9283, 5.8319, 1.1399, 2.47, 0.9367, 4.2387, 2.5559, -0.9211, 0.5322, 5.3042, 1.5572, 5.5469, 8.797, 1.7333, -3.2303, 0.411, 0.4151, 0.2999, 0.4173, 0.4561, 1.2529, -2.1056, 0.9201, 3.104, 5.5857, 6.1485, 7.01, 7.2776, 0.7792, 6.3822, 5.7524, 2.0318, 6.0519, 4.4701, 5.7564, 0.4724, -0.0412, 4.932, 4.0284, 3.8863, 3.1393, 0.48, 4.91, 3.43, -0.88, 7.57, 4.9, 6.88, 8.03, 1.5126, 1.7413, 4.1992, 0.7645, 2.3352, 2.2253, 0.9825, 4.2594, 3.4223, 7.8059, 2.4977, 9.6967, 11.5938, 5.2943, 4.1975, 0.4942, 1.9196, 1.0122, 4.7849, 3.8449, -1.6479, 0.419, 1.7638, 1.8195, 4.5167, 1.5914, -0.8985, 3.9694, 3.6829, 2.6331, -1.9422, 5.4111, 7.1046, 7.7744, 0.67, 0.6901, 7.2633, 6.0176, -1.1321, 5.9256, -0.4032, 5.6323, 3.3009, 3.9347, 6.009, 1.9482, 2.92, 12.43, 4.84, 3.32, 3.0691, 2.8322, 8.7638, 8.0079, -3.9573, -3.1352, -6.487, -4.0213, -3.8047, 0.6148, -2.1481, -8.0394, -3.1379, -0.989, 0.3653, -4.9559, -5.3575, -5.5988, 1.0323, -4.3099, -4.71, 5.2, -0.71, -4.6563, -3.3285, -5.0545, -4.2384, -4.9699, -1.5992, 4.1165, -3.336, -2.3401, 6.8793, 5.496, -3.9789, -0.9388, -3.2838, -0.6173, -1.1647, -1.9808, 1.0744, -3.1617, -5.9031, -4.625, -5.28, -5.04, -6.84, -4.26, -4.34, -2.2599, -3.67, 1.0315, -4.0484, -4.6905, -4.7062, -4.0286, -6.1962, -1.9234, 7.4152, 0.7129}, _
                         New Double() {2.4279, 3.4448, 1.1973, 1.2188, 0.6433, 0.7053, 0.4333, 0.4999, -0.3328, 1.4331, -1.7673, -2.5305, -0.6366, 2.04, 2.9134, -2.944, -1.4464, 1.4779, 0.8877, 1.2267, 2.2248, -0.4191, 0.4234, 2.7757, 0.0805, 3.5587, 1.01, 1.42, 1.0273, 0.3706, 0.5506, 0.7967, 1.028, -0.2752, 1.7188, -1.0777, 0.2775, 1.3331, 0.1997, 0.3887, 0.4036, 0.3513, 0.3859, -0.1548, 1.405, 1.3757, 1.0314, 3.1683, 2.5676, -0.9661, -1.32, -1.47, 1.2062, -1.5828, -2.0224, 1.5802, 5.38, 2.1797, -0.7126, 0.4579, 0.4836, -1.5037, 1.5644, 1.7502, 0.5446, 0.28, 0.82, 0.56, 0.92, -1.71, 0.3, -1.85, 0.0, 2.3104, 9.5273, 2.8919, 1.0606, 0.9801, 1.1153, 0.8157, 1.9355, 1.0954, 0.258, -3.054, 2.4764, -3.6585, 1.1033, 1.977, 0.5233, 1.1166, 1.0402, 0.2524, 0.0308, 0.4643, 0.402, 1.737, 1.3504, 1.8006, 1.2128, 0.2118, 1.6343, 5.4885, 4.2373, -0.9079, -1.0072, -1.5707, -0.2959, 0.4873, 1.6634, -1.3986, -3.2014, -3.4351, 1.9196, -4.6538, 0.3467, 0.4161, 2.0895, -2.1173, 1.1891, 0.92, 1.11, 3.2, 1.17, 6.4187, 1.3456, -2.3504, -1.3554, -0.0476, 0.5606, -1.2569, 1.3796, 0.5649, -3.067, 1.4903, -0.0687, 0.3771, 0.5797, 0.3639, 0.8673, 0.7846, 3.2886, 1.0416, 0.19, 0.23, -0.54, 0.54, 0.1729, 0.9306, -0.75, 0.6973, -1.6509, 1.2924, 1.5492, 2.1364, 3.5144, 0.2522, 0.2592, 0.44, 0.1321, 0.1562, 1.0944, 1.5441, 1.3806, 1.0633, 1.2461, 3.008, 1.8946, 1.08, 0.44, -1.26, 0.48, 4.07, 0.75, 0.88, 1.0329, 1.5518, 0.0428, 0.2141, -0.8477, -0.7207, 1.2367, 0.228, 1.7528}, _
                         New Double() {5.0076, 3.7603, 0.8048, 5.2462, 1.0613, 1.0309, 0.4333, 1.3557, 10.1841, 2.1516, 8.7342, 9.4896, 0.9084, 5.4, 2.8426, 8.0323, 9.9503, 4.2382, 1.4568, 2.06, 3.9753, 8.8497, 0.4365, 4.6198, 8.2333, 2.9559, 1.84, 0.93, 1.61, 3.8758, 3.1056, -1.0086, 1.2749, 11.3043, 1.6898, 9.8997, 11.138, 1.5805, 3.5698, 0.4066, 0.3725, 0.3403, 0.3844, 2.501, 1.5276, 1.5876, 1.7737, 3.1768, 5.1769, 9.7855, 10.2, 8.48, 1.0186, 6.8197, 15.1123, 1.7766, 4.8347, 5.3621, 9.4535, 0.4579, 1.1221, 10.1207, 4.1855, 3.9675, 4.6749, 0.24, 5.36, 3.45, -0.41, 11.26, 5.13, 8.63, 12.7, -3.6483, 2.3929, 3.1278, 1.6553, 3.125, 1.3874, 1.1735, 5.0012, 4.4265, 13.4129, -2.4863, -2.9309, 12.9884, 6.756, 5.4493, 0.4628, 1.0477, 1.6043, 5.0303, -3.7277, 1.1555, 0.4, 1.9549, 2.1025, 5.2133, 1.6076, 4.253, 4.2211, 3.3299, 5.0407, 9.2932, 9.3023, 6.2766, 10.3858, 0.485, 1.6067, 10.4964, 4.6693, 10.672, 5.6384, 11.2545, 3.1093, 4.2974, 4.7378, 9.5175, 1.7161, 4.3099, 12.24, 6.49, -4.64, -2.2163, 1.888, 10.4509, 6.3343, 4.9325, 4.2074, 11.841, 4.725, 4.4282, 4.6066, 1.4947, 9.9037, -3.5972, -1.0429, 0.3374, -4.9268, -5.0516, -2.938, 1.6958, -5.5599, -5.5, 9.5399, -1.06, -6.4544, -3.4093, 7.6313, 4.7931, 6.5725, 1.7159, 4.1454, 4.3442, 3.3179, 15.1549, -4.0568, 14.6039, 2.7018, -3.8553, -0.4194, -1.0448, 1.6865, 1.512, -4.1026, -5.0833, -4.4136, 4.96, 8.47, 10.88, -3.25, -3.05, -1.03, -4.8099, 1.6944, -4.2335, 10.0632, -4.4469, 7.35, 8.1142, 2.2136, -10.4649, 0.9386}, _
                         New Double() {2.3549, -0.5442, 2.3837, 1.6322, 0.1693, 1.417, 0.4333, 0.6264, 5.7689, 0.8758, 7.0426, 2.8684, 1.1092, 2.05, 1.1934, 0.1302, 6.7633, 2.5558, 0.369, 1.7079, 2.0608, 1.7601, 0.4403, 1.5648, 2.8198, -3.5626, 0.08, 2.5299, 0.1037, 2.8994, 2.5442, 1.3396, 0.0532, 6.2532, -0.1247, 5.1686, 7.5516, 2.2353, 1.2639, 0.3998, 0.3555, 0.0489, 0.3967, 0.2027, -0.0966, 1.6924, 0.196, 1.9, 3.7467, 4.7779, 1.6299, 6.37, 0.3461, 2.6468, 12.7224, 2.1301, -2.57, 2.1841, 6.5277, 0.4624, 0.8716, 5.6125, 2.6504, 2.4572, 3.4533, 0.7428, 3.44, 2.72, 1.35, 9.02, 3.83, 4.47, 12.73, 2.3105, -1.5398, 2.2465, -0.2434, 2.4001, 1.9345, 0.244, 1.4121, 2.2498, 0.6481, -0.2269, -0.7653, 9.6984, 2.7131, 1.2905, 0.453, 2.0224, 0.2027, 2.4453, 3.016, 1.7919, 0.417, -0.2093, 1.6698, 1.2054, 2.2965, 0.0353, 2.9381, -1.6146, -0.5993, 1.8759, 4.8077, -0.681, 1.3245, 0.4713, -0.331, 5.7051, -11.2245, 3.8348, 3.6028, 3.303, 0.389, 2.7709, 2.6869, 5.6271, 2.2682, 2.45, 7.86, 5.25, 2.56, -0.9402, -1.7308, 7.0772, 3.5803, 2.4312, 2.4596, 5.6259, 1.9242, 2.4711, 3.6472, 2.3651, 6.9924, 2.8758, 1.4502, 0.375, 3.0254, 2.5503, -3.4483, 0.1879, 3.69, 2.74, 6.11, 1.12, 4.4276, 2.27, 3.4632, 2.8354, 4.4374, 2.122, 2.5041, 2.2708, 1.8356, 11.0652, 0.1232, 7.1683, -3.5963, 2.2329, 1.2105, 1.5476, 1.9604, 0.2389, 2.7808, 4.0793, 2.7422, 2.71, 4.21, 3.74, 0.48, -2.85, 0.76, 2.7599, 0.2021, 2.6979, 4.1241, 2.1892, -1.111, 1.0673, 2.0623, 4.8436, -0.2626}, _
                         New Double() {1.4987, -2.6256, 1.7544, 1.57, 0.3962, 0.8517, 0.4333, 0.6225, 3.2136, 0.8772, 6.7659, 3.4615, 1.1, 1.72, -0.425, 6.6529, 4.2673, 1.0555, 0.2758, 2.02, -0.3138, 6.7363, 0.4046, 0.4402, 5.8587, -1.5848, 0.16, 2.25, 0.2259, 0.5832, 1.5631, 1.0485, 0.6065, 5.2606, 0.1782, 4.2537, 5.6098, 1.8392, 1.724, 0.3885, 0.4034, 0.7625, 0.3753, 0.4551, 0.3765, 0.9519, 0.0313, -0.4302, -1.3447, 3.776, 4.03, 4.15, 0.2029, 2.399, 11.98, 2.0338, -1.81, 1.0558, 2.9307, 0.4399, 0.9829, 4.1266, 1.078, 0.4637, 1.9581, 1.18, 1.3899, 1.09, 0.81, 2.88, 1.23, 0.33, 8.8699, 1.7667, 0.6553, 0.4359, 0.4881, 1.8278, 2.458, 0.4478, 2.1174, 2.0437, 2.1157, -0.5084, 4.8818, 11.4357, 1.9888, 1.4864, 0.4427, 1.7884, 0.0943, 1.6389, 2.718, 1.5522, 0.392, 0.0671, 1.9011, 2.2056, 2.2012, 0.512, 1.3252, -1.2035, 2.9285, 6.2323, 3.8226, 4.6857, 5.3377, 0.3884, 0.127, 2.9985, 5.9771, 4.6875, 1.3328, 4.84, -2.0988, 1.2759, 0.1372, 3.6096, 1.9004, 1.83, 3.0299, 2.27, 1.94, -1.5952, -1.0361, 4.6711, 1.6083, 1.7455, 2.1112, 6.1001, 0.8239, 2.4601, 5.5297, 2.2512, 2.8111, 1.9188, 1.081, 0.354, 1.5362, 2.5489, -3.2369, 0.1185, 2.42, 3.0, 2.37, 0.94, 1.7755, 2.7601, 4.8976, 3.3675, 6.6755, 2.0021, 1.7925, 1.8092, 0.5486, 6.2742, 1.8923, 17.1011, 1.8469, 5.6076, 0.8838, 0.8081, 2.015, 0.2269, 1.873, 2.54, 1.5148, 1.36, 2.88, 5.82, -1.19, -3.54, 0.0, 2.0099, 0.0756, 1.1458, 5.9614, 1.8202, 5.9177, 3.2024, 1.6796, 2.6962, 0.1755}, _
                         New Double() {-1.2477, 2.4554, 0.5356, -1.4524, 1.4418, 0.4539, 0.4333, -0.0023, -5.4349, -0.0577, -5.6708, -4.368, 1.0959, -1.21, 0.3246, -2.3163, -5.9258, -1.6066, 2.1934, 1.5518, -2.0719, -5.1872, 0.4368, -0.8273, -3.2972, 0.8505, 1.97, 1.1, 2.1978, -0.6015, -0.3502, 0.6136, 1.7768, -4.5804, 1.9479, -5.2345, -6.3914, 1.5006, -0.6271, 0.4063, 0.441, 0.5627, 0.3837, 1.5605, 1.8969, 1.9453, 2.2452, 0.1807, -3.7508, -4.0198, -4.32, -5.6, 1.9233, -6.8316, -12.1775, 1.2807, 3.45, -1.903, -6.5645, 0.4524, 0.0502, -4.2565, -1.5988, -1.151, -1.3107, 1.15, -2.54, -1.46, 0.17, -4.68, -2.47, -4.43, -11.11, -1.0299, 2.7602, -1.5765, 2.3, -0.7528, 1.7005, 1.7258, -0.8341, -1.1746, -4.2955, -2.7972, 5.8612, -10.9521, -1.9408, -1.483, 0.4914, 1.8281, 2.1058, -2.9256, -2.1396, -0.54, 0.411, 2.1046, 1.3007, -2.5334, 1.4119, 0.6851, -1.8109, 2.5471, 2.1757, -4.5333, -5.0073, -2.9476, -4.0331, 0.4836, 2.0682, -1.8923, -4.9892, -7.734, -1.8295, -7.5965, 1.7975, -1.3311, -1.3506, -5.3433, 1.6695, -1.3, -4.07, -5.21, -1.3, 2.6227, 4.7385, -6.7395, -3.6145, -1.453, -1.2822, -6.3766, -1.935, -1.7367, -5.0773, 1.3863, -3.7613, -1.2862, 0.2119, 0.381, -2.6267, -2.4042, 0.3333, 2.2374, -2.17, -2.34, -3.68, -0.15, -3.246, -1.8385, 5.3361, -2.9217, -6.4231, 1.4823, -1.5491, -0.4077, 0.0994, -4.5154, -0.687, -10.6859, -4.3893, -0.5582, 0.6546, 0.4785, 1.4379, 1.9897, -1.43, -0.9396, -1.8181, -1.16, -4.71, -4.58, -0.3, 0.95, 0.47, -2.05, 2.1991, -1.6569, -3.8808, -1.5267, -3.7197, -2.5853, 1.5586, 6.0325, 1.8942}, _
                         New Double() {-2.1702, 0.1408, 0.9606, -1.7078, 0.358, -0.3973, 0.4367, -0.1075, -6.7359, -0.3088, -5.9616, -6.9971, 0.297, -1.54, -1.1524, -7.2699, -7.5245, -1.5329, 0.247, 0.2721, -0.9684, -3.2022, 0.4192, -0.9745, -3.3968, -1.3393, 0.4, -0.08, 0.4411, -1.1212, -1.6059, -0.4711, 0.4844, -7.6766, 0.8057, -6.9459, -3.3132, 0.3189, -2.3222, 0.3903, 0.4446, 0.5866, 0.3864, -0.0598, 0.5995, 0.8533, 0.3254, -0.5246, -2.0124, -8.1865, -8.26, -7.62, 0.7077, -7.4969, -2.6245, 0.3403, 0.89, -0.6541, -8.6154, 0.4491, 0.644, -5.8345, -1.6524, -1.4876, -1.6231, 1.0, -1.7, -2.13, -0.27, -8.46, -2.84, -6.87, -5.83, -0.1872, 2.1481, 0.1158, 0.5281, -1.8223, 0.0915, 0.7151, -0.8405, -2.0111, -3.334, -6.4471, -4.4105, -4.6678, -3.1753, -1.0549, 0.413, 0.3646, 0.4079, -1.2917, -1.9496, -0.3031, 0.4079, 0.477, 0.5175, -1.8505, 0.2491, 1.5527, -1.9323, 0.5002, -1.0408, -4.0503, -7.1318, -5.3993, -6.681, 0.3234, 0.9008, -8.7538, -6.8492, -2.7942, -2.7649, -1.8774, -0.6156, -2.2755, -1.6659, -5.8935, 0.2473, -2.05, -8.47, -7.26, -2.15, -0.2124, -1.6571, -5.2409, -4.8529, -1.8022, -1.8869, -6.0163, -1.876, -2.1283, -5.4589, 0.1351, -7.182, -2.0911, -0.7483, 0.3651, -1.962, -1.9361, -0.2708, 0.4115, -2.24, -2.0, -6.34, -0.27, -6.8802, -2.3158, -6.9618, -3.1046, -6.8837, 0.3308, -2.005, -0.8244, -1.1895, 5.9752, 6.6819, -2.8735, -3.3662, 3.8788, -0.2297, -0.2351, 0.148, 0.438, -2.0163, -1.3257, -1.9026, -1.46, -7.18, -7.27, -1.22, -0.94, -0.5699, -2.39, 0.4131, -1.649, -3.9758, -1.8637, -4.5617, -6.2815, 0.413, 8.1552, 1.1051}, _
                         New Double() {-5.0736, -3.5617, -2.4589, -4.8417, 0.7468, -0.6594, 0.4375, -1.1477, 7.5548, 2.0774, 4.0967, 5.1202, -1.2521, 5.29, 3.8164, 4.7779, 5.7249, 4.9666, 0.9127, 2.6294, 5.4348, 4.2369, 0.4025, 4.6933, 3.4432, 5.1211, 0.91, 3.21, 0.8409, -5.0083, 2.8624, 0.9011, 1.0375, 5.6415, 1.1105, 5.088, 1.3442, 2.684, 3.4237, 0.3499, 0.364, 0.4276, 0.3454, 1.7444, 1.2232, -2.1998, 1.0152, 4.0362, 4.2448, 6.2384, 7.26, 5.46, 1.0341, 5.3609, 3.9019, 2.5772, 3.67, 4.5759, 4.5373, 0.4084, -0.8286, 4.2838, 4.9267, 4.5119, 2.2944, 1.5, 4.9, -2.59, -0.35, 6.43, 3.57, 5.54, 3.54, 3.429, -1.7345, 4.4198, 0.9456, 2.8788, 2.7578, 0.6525, 3.9129, 3.691, 11.3463, 6.6844, 2.8463, 5.4448, 5.4946, 4.7545, 0.4425, 2.3755, 0.8812, 7.0643, 3.7952, -0.8865, 0.362, 1.0711, 2.403, 5.6113, -2.777, 0.6442, 4.9788, 4.2623, 3.973, 4.949, 5.3422, 4.5184, 5.7737, 0.3876, 1.4931, 6.0162, 2.4511, 7.5643, 5.3238, 7.6377, 2.445, 3.2214, 5.5939, 4.5649, 2.5846, 3.32, 6.54, 4.78, 3.75, 2.2073, 1.9555, -1.4772, 4.8171, 8.3859, 3.839, 6.3821, 5.0211, 3.0663, 6.5122, 2.9208, 3.3717, 2.4651, -0.6193, 0.3342, 5.3368, 6.3431, 6.256, 0.9659, 3.37, 6.48, 4.3099, 1.24, 6.0399, 2.4041, 4.8159, 3.1898, 5.15, 2.6145, 5.1442, 4.0732, 4.0931, 4.7275, -0.1955, 2.1206, 2.0147, 4.522, 0.9364, -1.7656, 2.5691, 0.8885, 3.7234, 7.5259, 5.1791, 5.04, 5.83, 5.7699, 3.73, 3.2, 2.3, 3.61, 0.9772, 4.9494, 6.819, 4.9081, 4.8935, 5.7083, 2.4605, 5.6116, 0.793}, _
                         New Double() {2.7302, 0.9858, 4.6108, 3.6948, -0.2195, 0.8664, 0.4375, 1.0054, 0.7482, 1.1501, -0.5444, -0.5506, 3.4106, 2.79, 4.0635, 0.3769, 0.4358, 3.7744, -0.4686, 3.5225, 4.7861, 0.5871, 0.4181, 5.0834, -1.6696, 0.7261, -0.33, 6.49, -0.2316, 4.2191, 1.7749, 0.9461, 0.0934, -0.3569, 0.1089, 0.0191, -0.403, 4.3721, 1.6266, 0.3874, 0.4018, 0.3871, 0.3738, -0.6956, 0.1756, 3.7599, -0.5382, 3.0141, 6.4939, -0.9023, -2.08, 0.37, 0.0397, 4.4564, 2.3445, 4.0724, 1.91, 3.6223, 1.4199, 0.4529, 3.6137, 0.6911, 3.8835, 4.0733, 1.7684, 0.59, 3.64, 1.1399, 0.4, -0.53, 1.31, -0.18, -0.92, 3.4822, 3.0041, 3.753, -0.4424, 2.2088, 3.6874, -0.3113, 1.6721, 1.0025, 5.6246, 3.6609, -4.1983, -0.7306, 0.8558, 2.3607, 0.3931, 3.6863, -0.3864, 3.209, 1.4512, 0.7156, 0.401, 0.0082, 3.9927, 4.3368, 4.214, 1.0754, 4.1249, 1.0274, 0.8803, -1.2251, 0.0, 0.6227, -0.9804, 0.2896, -0.02, -0.3459, -5.2764, -3.4369, 2.7917, -5.0117, -0.3342, 1.5037, 3.3176, 0.1186, 4.2936, 1.31, -1.01, 0.12, 1.51, 0.6744, 0.5701, -1.1506, 0.1353, 2.2631, 1.6243, 0.2079, 3.4957, 1.9539, 1.4541, 5.1043, 0.4824, 1.7835, 0.7476, 0.364, 4.2398, 3.7292, 1.1841, -0.4478, 1.59, 2.65, 0.78, 0.78, 0.81, 2.1778, 2.8835, 2.5878, 2.9084, 4.3638, 3.4429, 4.2461, 4.3515, -0.7342, 0.2039, -0.1739, -2.1953, 2.6033, 0.8283, 1.2188, 4.116, -0.2637, 1.768, 4.0161, 4.0166, 3.44, -0.54, -1.1, 3.33, 0.86, 2.7599, 1.83, -0.47, 3.9007, -2.4646, 4.3987, 3.5897, -0.6575, 4.3041, 0.5981, 0.2658}, _
                         New Double() {4.8311, 5.3551, 1.0647, 4.8253, 0.4116, 1.8488, 0.435, 1.637, 3.1443, 2.4927, 5.8311, 5.2048, 0.6133, 4.54, 4.1072, 7.2284, 4.8425, 4.1886, 0.4794, 1.373, 5.0484, 4.6673, 0.4129, 4.1571, 5.4713, 4.6498, 0.5699, 0.5, 0.5828, 4.0147, 3.3696, 2.0419, 0.8262, 5.8771, 0.5615, 5.1802, 8.3622, 1.0057, 2.4223, 0.3801, 0.403, 0.5081, 0.3662, 0.5651, 0.701, 1.3601, 0.4671, 3.2292, 4.6604, 3.9323, 7.17, 5.89, 0.6079, 1.9019, 1.7178, 1.2359, 5.78, 4.9074, 5.3007, 0.4458, 0.9358, 6.003, 4.2989, 4.0202, 4.048, 0.89, 4.14, 3.66, 2.1, 8.23, 4.71, 5.88, 8.33, 4.1717, 5.2562, 4.3185, 0.6882, 3.0567, 1.1838, 0.9509, 4.4012, 2.6976, 10.1029, 2.8436, -0.3484, 5.368, 3.4412, 4.9638, 0.4232, 1.5482, 0.5243, 3.8143, 3.2884, 1.949, 0.382, 0.5461, 1.42, 4.3434, 1.2222, 1.1652, 4.1756, 4.7458, 6.2827, 9.4574, 5.1146, 5.5693, 6.3118, 0.4139, 0.7039, 8.8541, -2.1219, 1.0169, 4.1833, 0.2814, 5.197, 3.6845, 4.0265, 6.1595, 1.2588, 3.28, 9.21, 5.04, 3.54, 4.6798, -1.4348, 8.783, 2.9459, 5.6405, 3.7145, 6.2843, 4.4711, 4.2588, 5.0369, 1.1334, 5.7769, 3.0619, 1.5794, 0.3548, 3.9233, 4.0394, 5.5612, 0.5558, 3.95, 4.36, 4.57, 1.49, 5.1106, 3.1658, 2.5722, 3.6575, 2.4833, 1.0676, 4.7444, 3.2418, 3.3681, 13.5093, 5.099, 6.5113, 3.0245, 5.5407, 1.5598, 2.5409, 1.0652, 0.5229, 3.6699, 7.2256, 4.792, 4.18, 5.95, 5.24, 4.46, 3.67, 2.5, 4.07, 0.5844, 4.2965, 4.4487, 4.069, 2.6238, 1.998, 1.4262, 5.6468, 0.4556}, _
                         New Double() {-0.0214, 0.8743, 3.7122, 0.1589, 0.7844, 1.8234, 0.4283, 0.7248, 1.2717, 0.896, 2.6441, 2.2105, 2.585, 0.38, -0.0942, 6.3909, 1.2815, 0.5796, 1.4497, 5.2489, -0.4169, 6.066, 0.4033, 1.8142, 4.1208, 3.1458, 1.55, 5.36, 1.486, 0.2446, 1.3006, 1.1217, 1.6285, 1.3851, 2.1172, 1.5368, 4.4986, 4.9806, 2.2224, 0.3883, 0.4209, 0.5054, 0.3846, 3.196, 1.6996, 4.2951, 1.5818, 0.2607, 0.4475, 1.7562, 1.6299, 0.41, 2.0379, -0.3783, 3.2968, 4.9671, 3.51, 2.04, 0.1296, 0.4512, 1.5646, 2.4014, 0.358, 1.3586, 2.54, 0.75, 1.1399, 1.72, 1.83, 1.6, 1.93, 2.22, 5.98, 1.0078, 2.1055, 1.9284, 1.6872, 1.9448, 5.5951, 0.9227, 0.8626, 1.5216, 2.1374, 2.423, 4.0479, 3.3956, 1.4162, 0.6762, 0.443, 5.0173, 1.5516, 1.306, 2.141, 1.7705, 0.402, 2.351, 4.7706, 1.11, 5.0204, 1.1769, 0.2056, 1.0787, -5.0082, 2.9745, 1.5101, 5.7444, 2.7939, 0.2904, 2.4257, 2.7113, 3.2519, 5.0335, 1.2849, 5.5244, 3.4104, 1.5631, 1.1593, 1.9712, 4.7016, 1.0, 2.0099, 0.37, 1.19, 1.9414, 0.3088, 5.7717, 3.2554, 1.4817, 1.5737, 2.2173, 0.3048, 1.4978, 5.0942, 5.2274, 1.8003, 1.3478, 1.2689, 0.3633, 0.4799, -0.416, 2.8847, 1.599, 1.3799, -0.16, 1.07, 0.5, 1.0653, 1.3416, 1.4447, 1.1974, 1.1252, 4.9344, -1.3046, 0.6441, 2.3274, 4.3284, 2.077, 5.6226, 1.5469, -2.7227, 1.1407, 0.5288, 5.365, 1.85, 0.4922, -1.7342, -0.6098, 0.73, 1.02, 2.2599, 1.21, 2.66, 1.89, 1.43, 1.6002, 0.2948, 2.4667, 1.5555, 5.6118, 3.2689, 4.765, 0.5634, 2.4339}, _
                         New Double() {1.429, 2.3221, -1.4954, 1.4114, 0.2548, 0.1946, 0.4283, 0.7018, -2.687, 0.5618, -0.586, -0.7003, -2.1686, 1.46, 0.8785, -0.2366, -0.9156, 1.1309, 0.1579, -2.5171, 1.0769, 2.4222, 0.4177, 2.8877, 1.0435, 1.2507, 0.08, -2.88, 0.0645, 0.5965, -0.0813, 0.1775, 0.2041, -1.0637, -0.2403, -1.1531, 2.2801, -2.7463, 0.2175, 0.3772, 0.4308, 0.5417, 0.3762, 0.0722, 0.1107, -1.3727, 0.0492, 1.5157, 3.1156, 0.631, -0.15, -0.97, 0.1405, -0.8608, 1.7907, -2.9916, 2.69, 0.9852, -1.2764, 0.4372, -0.2275, -1.0376, 1.211, 1.4786, 0.7322, 0.75, 1.66, 0.53, 0.49, -2.99, 0.43, -1.29, -0.85, 1.1553, 2.2536, 1.0761, 0.2254, -0.0021, -2.5426, 0.3524, 1.9256, -0.1971, 4.6379, -1.582, -1.9494, -0.4629, -0.249, 2.1126, 0.4229, -2.0193, 0.0588, 1.5105, 0.1948, 0.4554, 0.401, -0.1584, -2.3921, 1.4153, -2.5436, 0.7169, 1.0256, 4.2689, 4.2351, 0.9629, -1.157, 0.6652, -0.7927, 0.3861, 0.433, -4.0295, 8.9318, 3.663, 1.5613, 4.4707, 2.6661, 0.3607, 1.858, -0.3526, -2.3732, 0.51, -2.15, -1.11, 0.3, 3.6104, -4.8153, 2.759, -0.2797, 1.7502, 0.723, -0.365, 1.7826, 0.7904, -0.4946, -2.7744, -0.6425, 0.5709, 0.3568, 0.3511, 1.8377, 1.7672, 4.5629, 0.0066, 0.5, 2.29, -1.31, 0.82, -1.7833, 0.9622, 0.2158, 1.2608, 0.7428, -2.8328, 1.5448, 2.7854, 2.9989, 0.1644, 0.2126, 2.1198, 4.0902, 1.4218, 0.1849, 0.7735, -2.9923, 0.0811, 0.107, 1.1693, 1.0512, 1.6299, -1.52, -0.59, 2.49, 4.13, 0.93, 0.59, -0.0184, 1.1928, 2.3343, 1.1075, -0.3231, -0.3776, -2.3882, -0.8151, -0.2161}, _
                         New Double() {2.4166, 6.4916, 0.6449, 4.404, -0.2856, 0.4596, 0.4283, 0.9421, 4.0137, 1.1397, 6.362, 5.1362, 0.3529, 3.04, 3.2163, 8.671, 6.6362, 3.1629, -0.9805, -0.197, 1.7403, 6.7933, 0.4581, 1.8349, 7.2781, 9.6611, -0.91, 0.45, -0.7181, 2.9805, 1.9801, 0.738, -1.0969, 4.9708, -1.5804, 5.6051, 3.1511, 0.3718, 2.2729, 0.3753, 0.3931, 0.4504, 0.3582, -2.4596, -1.4796, -0.425, -0.928, 2.7241, 0.1394, 5.3334, 5.28, 4.85, -0.586, 4.2391, 8.719, 0.1628, 5.46, 1.4471, 6.6995, 0.4376, 0.2445, 4.9548, 3.2205, 2.811, 1.9077, -0.53, 4.18, 2.13, 0.02, 4.88, 3.2599, 4.41, 5.74, 4.1053, 12.5836, 3.4584, -0.7944, 2.5276, 0.428, -0.0393, 2.3555, 2.0549, 5.7571, 6.1053, 10.3345, 7.485, 3.9341, 2.5214, 0.4239, -0.3449, -0.7699, 2.6596, 2.4603, 0.7366, 0.392, -1.8475, 0.2209, 3.9013, -0.2255, 0.4591, 3.0036, 8.0534, 4.9699, 5.4187, 5.4823, 8.4802, 7.0333, 0.3819, -2.4048, 4.4191, 9.0244, 11.5264, 3.5071, 12.31, 5.6693, 2.9086, 4.3198, 5.3134, 0.1155, 2.22, 6.19, 5.88, 2.52, 7.4191, 0.2832, 4.9739, 7.4197, 5.5193, 3.3239, 5.7108, 3.1374, 3.0717, 3.9642, 0.4242, 3.4923, 1.8054, 0.4955, 0.3649, 2.7509, 3.0257, 7.049, -0.8733, 2.44, 3.73, 3.89, 1.0, 4.7926, 1.7386, 3.7032, 2.5097, 4.1019, 0.3788, 3.3513, 2.7712, 3.2307, 7.823, 9.187, 8.3787, 6.6936, 5.0774, 0.7621, 1.4637, 0.9314, -0.9756, 3.223, 7.4914, 4.808, 4.2, 5.01, 4.92, 4.14, 7.7, 2.05, 3.36, -0.9022, 3.2521, 10.7565, 2.2759, 6.9593, 5.2478, -0.0149, 4.5762, -0.1348}, _
                         New Double() {3.4245, 6.0959, -0.837, 4.4563, -0.0609, 0.5429, 0.4283, 0.4756, 2.1528, 0.7741, 2.4468, 2.991, -0.1417, 3.66, 2.5432, 4.5066, 3.1242, 2.7931, -0.1121, -1.8324, 2.1275, 6.4174, 0.3985, 2.2869, 5.3522, 7.1012, 0.09, -1.74, -0.0577, 2.2474, 1.2557, 0.7634, 0.2207, 1.3285, -0.1427, 2.2664, 2.6709, -1.7776, 1.8006, 0.3884, 0.4111, 0.4663, 0.3569, -0.3022, 0.3513, -0.246, -0.098, 2.4629, -2.7963, 1.8506, 2.5299, 2.19, -0.5263, 3.9441, 6.5424, -1.8049, 1.8131, 1.8577, 1.0347, 0.4391, 0.0331, 2.3796, 2.9578, 1.6753, 1.3357, 0.54, 4.01, 1.94, 0.76, 0.78, 2.52, 3.17, 4.65, 2.5254, 6.0598, 1.183, 0.0352, 1.3661, -1.7813, 0.1464, 2.1713, 1.7254, 2.4974, -0.7922, 12.7988, 6.8338, 3.6501, 1.5237, 0.4432, -1.0483, 0.0267, 2.29, 1.379, 0.5951, 0.393, -0.2184, -1.737, 3.2187, -1.4423, 0.2448, 2.7944, 7.0058, 6.1093, 4.6875, 2.24, 5.0865, 3.2223, 0.2904, 0.0, -0.1567, 14.9888, 9.0782, 3.2374, 7.8679, 4.6135, 1.4443, 3.7792, 1.5539, -1.7021, 2.09, -0.38, 1.44, 2.05, 5.4349, -0.0467, 2.8767, 2.3499, 4.2942, 1.9728, 1.816, 2.7346, 2.1867, -0.502, -1.7161, 1.1595, 1.0913, 0.4034, 0.3537, 2.4014, 2.4251, 5.6686, -0.02, 1.91, 3.6, 0.35, 0.84, 1.2295, 2.2083, 4.1607, 2.8101, 4.3453, -1.8348, 3.3016, 2.9276, 2.8384, 3.6495, 2.4009, 8.6868, 11.2117, 5.5028, 0.9309, 1.6881, -2.0205, 0.0296, 2.4563, 6.3023, 3.8791, 3.86, 2.93, 2.13, 3.39, 6.83, 1.37, 2.47, -0.0377, 2.9007, 6.3404, 1.9682, 5.3625, 3.5583, -1.829, 3.398, -1.2943}, _
                         New Double() {0.2524, 5.2673, -1.3459, 0.3856, 0.2713, 0.1419, 0.4283, -0.0090, -4.34, -0.7688, -3.3001, -3.485, -1.6194, 0.5699, -0.1396, -2.0699, -4.9597, -0.1969, 0.5197, -2.8508, -0.2105, -1.0271, 0.4395, 0.271, -1.377, 7.4424, 0.52, -1.77, 0.6356, -0.3817, -0.8536, 0.0992, 1.1893, -3.713, 1.8289, -3.908, -1.2665, -2.7147, -1.3229, 0.3772, 0.3997, 0.4448, 0.3754, 1.0975, 1.7391, -1.8497, 0.6546, 0.7806, 1.1966, -4.1642, -2.58, -4.18, 1.2232, -2.5689, -4.1597, -2.536, 5.3376, -0.1435, -4.6767, 0.4359, -0.6727, -3.1829, -0.1786, 0.1602, -0.4187, 0.95, -0.11, -0.47, 0.54, -2.88, -1.01, -3.2599, -4.44, 0.1283, 3.5025, -0.0254, 0.6422, -1.0845, -2.54, 0.6334, 0.1922, -1.0704, 2.1412, -2.4377, 1.2255, -5.0408, -1.1435, 0.1321, 0.4335, -3.1745, 0.6756, -0.8986, -1.3213, -0.3327, 0.391, 1.8562, -2.9987, -0.1646, -2.9648, 0.7571, -0.4854, 4.1256, 2.6515, -0.2488, -3.4429, -2.4201, -3.642, 0.4826, 2.1615, -2.1978, 1.5564, -5.1217, 0.1349, -3.8067, 2.6894, -0.5883, 0.5719, -4.1186, -2.9533, -0.42, -3.05, -3.97, -0.92, 3.5915, 0.6075, -1.6604, -4.4063, -0.5871, -1.1379, -4.8692, -0.2244, -1.0984, -2.3786, -2.9101, -2.9684, -0.6354, 0.0582, 0.3532, -0.1334, 0.1595, 4.4111, 0.6649, -1.05, -0.79, -3.32, 0.04, -3.2941, -0.3407, -3.1629, -0.7524, -3.6204, -2.7521, 0.0799, 0.5988, 1.0616, -1.4, 0.4445, -0.9345, 1.8304, 2.3572, 0.115, 0.0371, -2.6143, 0.9995, -0.711, 0.4711, -0.2465, 0.42, -3.8, -3.61, 0.73, 4.33, 0.27, -0.85, 0.6778, -0.2106, -4.063, -0.9644, -2.1307, -3.2025, -3.1487, 3.7046, 1.8038}, _
                         New Double() {3.464, 1.4006, 1.7841, 4.8124, -0.5521, 0.4274, 0.4275, 0.8484, 0.3267, 0.6421, 1.9114, 1.9057, 0.8023, 3.43, 2.4221, 2.0117, 1.8252, 3.2781, -1.1202, 1.8565, 2.2424, 3.6482, 0.443, 2.5676, 1.4556, 4.5172, -1.21, 1.9, -1.1196, 3.4459, 1.2721, 0.3436, -0.6327, -0.2702, -0.6677, 0.9864, 5.4949, 2.1578, 0.9443, 0.3995, 0.4326, 0.4582, 0.3274, -0.9353, -0.6549, 1.9197, -1.1749, 2.9278, 1.3997, -0.3459, 0.41, 0.49, -0.7937, 0.4353, 0.5854, 1.2273, 6.64, 2.2925, 1.2454, 0.4619, 1.1697, 1.3008, 3.3277, 2.9728, 1.9185, 0.76, 4.24, 1.98, 0.94, 1.98, 2.98, 1.17, 3.13, 3.9341, 6.2323, 2.4068, -1.0751, 1.6286, 2.111, -0.5183, 3.7063, 1.3434, 9.9843, -3.6904, 8.9161, 5.0888, 2.8253, 3.3313, 0.404, 1.9496, -0.9271, 2.7062, 1.7093, 1.2994, 0.4069, -0.7737, 2.0602, 2.9421, 1.9601, 0.905, 3.3171, 4.7373, 5.5351, 2.6185, 0.9724, 2.0833, 2.3758, 0.0721, -0.6572, 1.9262, 3.0652, 4.0485, 3.3562, 3.5699, 5.3928, 1.1362, 3.6709, 0.8159, 2.1036, 1.82, 1.87, 0.59, 2.17, 3.036, -2.1366, 5.7168, 1.6982, 3.8273, 1.7267, 0.4379, 2.9989, 1.8573, -2.7073, 2.0566, 2.196, 2.0047, 0.4144, 0.3651, 3.2992, 3.296, 6.6978, -1.0987, 1.91, 3.6, 0.29, 1.07, 0.1142, 1.791, 0.6806, 2.3319, 1.4099, 2.2593, 3.3759, 3.497, 3.3613, 2.34, 0.4212, 2.4415, 2.7557, 5.1618, 0.5671, 1.0086, 2.0057, -0.6972, 1.9439, 4.5217, 3.7329, 3.7, 0.86, 0.84, 3.97, 5.37, 2.62, 2.22, -1.0955, 3.3075, 4.2478, 2.3621, 2.3298, 0.1838, 1.9075, 0.0832, -0.8374}, _
                         New Double() {-2.1217, -1.1125, 1.7918, -2.8745, -0.2919, -0.2597, 0.4283, -0.5258, -1.6284, -0.9297, -0.5833, 0.0, 1.0911, -2.88, -0.6281, -0.4816, -0.0757, -2.0635, -0.4532, 2.164, -2.1104, -0.4014, 0.4036, -2.4373, 0.1991, -2.5778, -0.17, 1.87, -0.5032, -1.789, -0.5798, -0.1712, -0.0549, -0.2189, 0.5202, -0.411, 0.953, 2.3485, -0.4919, 0.3688, 0.3915, 0.4173, 0.3363, -1.1015, 0.4358, 1.5477, -0.5309, -0.9464, -2.3591, -0.0187, 0.55, 0.19, 0.0216, -2.4085, -3.1848, 2.766, -2.55, -2.1304, -1.544, 0.4401, 1.6328, -0.441, -2.0458, -2.0336, -0.5777, 0.51, -2.2599, -0.63, -0.18, 1.79, -1.04, -0.92, -0.36, -2.0158, -0.433, -2.1682, -0.5125, -0.6703, 2.3614, -0.6586, -1.7326, -1.0293, -5.5094, -0.6709, -0.6277, -1.7767, -1.533, -2.0863, 0.3839, 1.4524, -0.294, -1.9021, -0.6738, 0.1014, 0.402, 0.3032, 2.4703, -1.8653, 2.0886, 0.8728, -1.983, -2.9605, -5.1049, -2.9162, -0.4815, 0.0972, 0.1055, 0.1932, -0.1433, 1.5747, -5.7622, -3.1128, -1.477, -3.7675, -1.0421, -0.6202, -2.0372, -0.6308, 2.2727, -1.1399, 2.55, -1.23, -0.98, -2.9427, 0.0949, 2.8019, 1.7176, -2.3565, -1.0596, -0.1226, -2.0259, -0.8271, 0.4806, 2.4309, 0.8151, -0.1252, -0.0628, 0.3637, -2.3192, -2.2709, -1.6223, -0.4645, -0.79, -2.4, -0.42, -0.01, 0.3248, -0.8073, -1.146, -0.9176, -1.5591, 2.4418, -2.3493, -2.66, -2.6423, 1.8935, 0.2559, 0.78, -3.9455, -1.7557, -0.4205, -0.7946, 2.3161, -0.3166, -0.8129, -1.4814, -1.8024, -2.0299, -0.73, 0.2, -2.17, -1.35, -0.79, -0.77, -0.5084, -2.0392, -1.0014, -1.8852, 0.1084, 0.7339, 2.0721, -1.1645, 0.3933}, _
                         New Double() {3.8704, 4.8937, 2.9532, 3.4706, 1.0246, 1.7173, 0.4475, 1.6602, 2.0337, 2.2132, 1.7702, 2.6575, 1.4081, 3.91, 3.97, 1.0227, 1.2001, 3.804, 1.328, 2.719, 3.3114, 2.9981, 0.4964, 3.5449, 2.2443, 2.1985, 1.57, 2.32, 1.75, 3.97, 2.83, 1.9, 1.45, 2.21, 1.1316, 1.8914, -4.2444, 2.9582, 2.4839, 0.44, 0.4485, 0.47, 0.4633, 2.3123, 1.28, 3.47, 1.7601, 3.4792, 4.6857, 1.9584, 2.75, 1.56, 1.3712, -0.5181, -2.0162, 3.1093, 3.3, 2.6553, 0.3071, 0.4974, 1.3216, 1.8829, 3.7797, 3.6556, 2.6518, 0.82, 4.33, 2.17, 1.52, 3.27, 2.6, 1.33, -0.66, 3.8195, 3.8606, 2.7153, 1.7407, 2.657, 2.5797, 1.3367, 3.9906, 2.4177, 8.4164, 0.8856, 6.1219, -1.0108, 3.0019, 3.6767, 0.4928, 2.8702, 1.591, 3.1427, 2.2846, 1.703, 0.441, 1.0278, 3.0452, 3.21, 3.08, 1.06, 3.8536, 3.4746, 4.4952, 5.8823, 1.9355, -0.2913, 2.6344, 0.675, 2.0426, 3.4109, 2.9586, 2.9452, 3.858, 1.9159, 4.0096, 2.1785, 3.0248, 1.7128, 2.8774, 2.65, 3.74, 2.55, 2.7599, 3.879, 1.5647, 2.5348, 0.0704, 3.2985, 2.6721, 2.4557, 3.6296, 2.3702, 0.6168, 2.8746, 2.793, 2.696, 1.6259, 0.399, 3.797, 3.9063, 4.716, 1.757, 2.669, 3.8139, 1.8179, 1.2886, 1.8661, 2.6067, 1.766, 2.9256, 1.3476, 3.2296, 3.8878, 4.5488, 4.8319, 1.0519, 1.5598, 1.0319, 2.5852, 4.1827, 1.89, 1.9756, 3.0549, 1.5529, 2.7202, 3.5043, 3.9192, 4.47, 1.36, 3.0099, 3.73, 3.51, 2.33, 2.82, 1.6513, 3.8121, 3.0777, 3.1152, 1.0693, 2.4409, 3.3612, 2.1838, 1.0916}} _
      )
      ' Here  we  evaluate  the  expected  returns  of  six  funds  using  the
      ' historical approach.
      Dim expReturnsOfFunds As Double() = instanceOfAssetParameters.ExpectedReturns( _
         returnsOfFunds _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    This expected returns of the funds are:" )
      System.Console.WriteLine( " " )
      displayArray( expReturnsOfFunds )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation of the Expected Returns of the  Covariance  Matrix  of  the +" )
      System.Console.WriteLine( "+ six funds                                                              +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covarianceMatrix( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = returnsOfFunds" )
      ' Here we evaluate the covariance matrix of the 6 dunds considered.
      Dim covarianceOfFunds As Double()() = instanceOfAssetParameters.CovarianceMatrix( _
         returnsOfFunds _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The covariance matrix between the funds is:" )
      System.Console.WriteLine( " " )
      display2DArray( covarianceOfFunds )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ The value of the Funds with the highest and lowest expected returns +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    minFrontierReturn( double[] expectedReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     What is the highest and lowest expected return  of  the  funds  from" )
      System.Console.WriteLine( "     which the  portfolio  can  be  constructed.  Note,  that  this  will" )
      System.Console.WriteLine( "     correspond to the minimum and maximum of the range  over  which  the" )
      System.Console.WriteLine( "     Efficient Frontier exists." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns = expReturnsOfFunds" )
      Dim leastReturn As Double = instanceOfMarkowitz.MinFrontierReturn( _
         expReturnsOfFunds _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The value of the lowest expected return is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( leastReturn ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ The value of the Funds with the highest and lowest expected returns +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    maxFrontierReturn( double[] expectedReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns = expReturnsOfFunds" )
      Dim greaterReturn As Double = instanceOfMarkowitz.MaxFrontierReturn( _
         expReturnsOfFunds _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The value of the highest expected return is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( greaterReturn ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the Efficient Frontier and read  off  Optimal  Portfolio  for +" )
      System.Console.WriteLine( "+ given values of the expected return                                    +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    efficientFrontier( double expectedReturn," )
      System.Console.WriteLine( "                       int numberOfAssets )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     Within this  section  we  evaluate  the  Efficient  Frontier  at  20" )
      System.Console.WriteLine( "     equally distributed points over its range and read off  the  weights" )
      System.Console.WriteLine( "     of the optimal portfolio when the expected return is 0.2, 0.4, 0.6." )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     WARNING: THIS COMPUTATION IS LIKELY TO TAKE MORE THAN AN HOUR." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn = 0.2" )
      System.Console.WriteLine( "    numberOfAssets = 6" )
      ' Here we evaluate the 20 points on the  Efficient  Frontier  and  store
      ' them with a private field.
      instanceOfMarkowitz.CalculateEfficientFrontier( _
         covarianceOfFunds, _
         expReturnsOfFunds, _
         20, _
         0.00000001 _
      )
      ' Here we read off the value  of  the  weights  of  the  assets  of  the
      ' optimal portfolio on the Efficient Frntier when  the  expected  return
      ' is 0.2.
      Dim optimalPortfolio4Return1 As Double() = instanceOfMarkowitz.EfficientFrontier( _
         0.2, _
         6 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    When the expected return of 0.2 the weights of the assets are:" )
      System.Console.WriteLine( " " )
      displayArray( optimalPortfolio4Return1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the Efficient Frontier and read  off  Optimal  Portfolio  for +" )
      System.Console.WriteLine( "+ given values of the expected return                                    +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    efficientFrontier( double expectedReturn," )
      System.Console.WriteLine( "                       int numberOfAssets )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn = 0.4" )
      System.Console.WriteLine( "    numberOfAssets = 6" )
      ' Here we read off the value  of  the  weights  of  the  assets  of  the
      ' optimal portfolio on the Efficient Frntier when  the  expected  return
      ' is 0.4.
      Dim optimalPortfolio4Return2 As Double() = instanceOfMarkowitz.EfficientFrontier( _
         0.4, _
         6 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    When the expected return of 0.4 the weights of the assets are:" )
      System.Console.WriteLine( " " )
      displayArray( optimalPortfolio4Return2 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the Efficient Frontier and read  off  Optimal  Portfolio  for +" )
      System.Console.WriteLine( "+ given values of the expected return                                    +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    efficientFrontier( double expectedReturn," )
      System.Console.WriteLine( "                       int numberOfAssets )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn = 0.6" )
      System.Console.WriteLine( "    numberOfAssets = 6" )
      ' Here we read off the value  of  the  weights  of  the  assets  of  the
      ' optimal portfolio on the Efficient Frntier when  the  expected  return
      ' is 0.6
      Dim optimalPortfolio4Return3 As Double() = instanceOfMarkowitz.EfficientFrontier( _
         0.6, _
         6 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    When the expected return of 0.6 the weights of the assets are:" )
      System.Console.WriteLine( " " )
      displayArray( optimalPortfolio4Return3 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Asset weights on the evaluated poitns of the Efficient Frontier +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    getEfficientFrontierAssetWeights(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "     Here we return the 20 arrays which  represent  the  weights  of  the" )
      System.Console.WriteLine( "     assets within the portfolios  corresponding  to  the  20  points  at" )
      System.Console.WriteLine( "     which the Efficient  Frontier  was  evaluated  using  the  calculate" )
      System.Console.WriteLine( "     Efficient Frontier method. Where each array has the following  form:" )
      System.Console.WriteLine( "     the first term is the weight of  the  first  asset  from  which  the" )
      System.Console.WriteLine( "     portfolio can be selected, the second term is  the  weights  of  the" )
      System.Console.WriteLine( "     second asset and so on." )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Reads the values  of  the  asset  weights  at  the  points  where  the
      ' Efficient Frontier was evaluated
      Dim assetWeightsEfficientFrontier1 As Double()() = instanceOfMarkowitz.GetEfficientFrontierAssetWeights( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The weights of the portfolios at the evaluation points are:" )
      System.Console.WriteLine( " " )
      display2DArray( assetWeightsEfficientFrontier1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Use SolveFrontier to find Optimal Portfolios for given maximum  levels +" )
      System.Console.WriteLine( "+ of risk                                                                +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findReturn( double risk," )
      System.Console.WriteLine( "                double[] riskAtPoints," )
      System.Console.WriteLine( "                double[] returnAtPoints )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    risk = 0.2" )
      System.Console.WriteLine( "    riskAtPoints = riskAtPoints1" )
      System.Console.WriteLine( "    returnAtPoints = returnAtPoints1" )
      ' Read off the values of the expected  return  at  which  the  Efficient
      ' Frontier was evaluated above.
      Dim returnAtPoints1 As Double() = instanceOfMarkowitz.GetEfficientFrontierExpectedReturns( _
      )
      ' Read off the values of the expected  return  at  which  the  Efficient
      ' Frontier was evaluated abive.
      Dim riskAtPoints1 As Double() = instanceOfMarkowitz.GetEfficientFrontierPortfolioRisks( _
         covarianceOfFunds _
      )
      ' Here we find the expected return of the optimal  portfolio  for  value
      ' of the risk.
      Dim optimalPortfolio4Risk1 As Double = instanceOfSolveFrontier.FindReturn( _
         0.2, _
         riskAtPoints1, _
         returnAtPoints1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The portfolio with  the  maximum  expected  return  when  the  maximum" )
      System.Console.WriteLine( "    allowable risk is 0.2 is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( optimalPortfolio4Risk1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Use SolveFrontier to find Optimal Portfolios for given maximum  levels +" )
      System.Console.WriteLine( "+ of risk                                                                +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findReturn( double risk," )
      System.Console.WriteLine( "                double[] riskAtPoints," )
      System.Console.WriteLine( "                double[] returnAtPoints )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    risk = 0.4" )
      System.Console.WriteLine( "    riskAtPoints = riskAtPoints1" )
      System.Console.WriteLine( "    returnAtPoints = returnAtPoints1" )
      ' Here we find the expected return of the optimal  portfolio  for  value
      ' of the risk.
      Dim optimalPortfolio4Risk2 As Double = instanceOfSolveFrontier.FindReturn( _
         0.4, _
         riskAtPoints1, _
         returnAtPoints1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The portfolio with  the  maximum  expected  return  when  the  maximum" )
      System.Console.WriteLine( "    allowable risk is 0.4 is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( optimalPortfolio4Risk2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Use SolveFrontier to find Optimal Portfolios for given maximum  levels +" )
      System.Console.WriteLine( "+ of risk                                                                +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    findReturn( double risk," )
      System.Console.WriteLine( "                double[] riskAtPoints," )
      System.Console.WriteLine( "                double[] returnAtPoints )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    risk = 0.6" )
      System.Console.WriteLine( "    riskAtPoints = riskAtPoints1" )
      System.Console.WriteLine( "    returnAtPoints = returnAtPoints1" )
      ' Here we find the expected return of the optimal  portfolio  for  value
      ' of the risk.
      Dim optimalPortfolio4Risk3 As Double = instanceOfSolveFrontier.FindReturn( _
         0.6, _
         riskAtPoints1, _
         returnAtPoints1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The portfolio with  the  maximum  expected  return  when  the  maximum" )
      System.Console.WriteLine( "    allowable risk is 0.6 is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( optimalPortfolio4Risk3 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( " " )
   End Sub

   Function Double2String(ByVal d As Double) As String
      If (System.Double.IsNaN(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsNegativeInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsPositiveInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MinValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MaxValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      Dim frac As Double = d - Int(d)
      Dim frac4 As Double = Int(frac * 10000) / 10000.0
      Double2String = (Int(d) + frac4).ToString()
      Exit Function
   End Function

   Sub displayArray(ByVal a As Double())
      System.Console.Write("     {")
      For I As Integer = 0 To -1 + a.Length
         System.Console.Write(Double2String(a(I)))
         If (I < -1 + a.Length) Then System.Console.Write(", ")
      Next I
      System.Console.Write("}")
   End Sub

   Sub display2DArray(ByVal a As Double()())
      For I As Integer = 0 To -1 + a.Length
         If (I = 0) Then
            System.Console.Write("     {{")
         Else
            System.Console.Write("      {")
         End If
         For J As Integer = 0 To -1 + a(I).Length
            System.Console.Write(Double2String(a(I)(J)))
            If (J < -1 + a(I).Length) Then
               System.Console.Write(", ")
            Else
               System.Console.Write("}")
               End If
         Next J
         If (I < -1 + a.Length) Then
            System.Console.Write(",")
            System.Console.WriteLine()
            Else
               System.Console.Write("}")
            End If
      Next I
   End Sub
End Module

