Imports System
Imports Microsoft.VisualBasic
Imports WebCab.Lib.Util.Example
Imports WebCab.Libraries.Finance.Portfolio

Module OptimalDiversificationClient
   Sub Main()
      ' used components
      Dim instanceOfAssetParameters As AssetParameters = New AssetParameters
      Dim instanceOfTwoAssetPortfolio As WebCab.Libraries.Finance.Portfolio.TwoAssetPortfolio = New WebCab.Libraries.Finance.Portfolio.TwoAssetPortfolio
      '
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "                #################################################" )
      System.Console.WriteLine( "                # OptimalDiversification Console Client Example #" )
      System.Console.WriteLine( "                #################################################" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " Overview" )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    With this example we consider the following problem: Say  the  first" )
      System.Console.WriteLine( "    asset represents a portfolio which is  held  and  the  second  asset" )
      System.Console.WriteLine( "    represents an asset which the portfolio manager  wishes  to  add  to" )
      System.Console.WriteLine( "    the portfolio such the optimal effects (i.e. minimize the  risk)  of" )
      System.Console.WriteLine( "    diversification from the purchase is felt. The question  to  address" )
      System.Console.WriteLine( "    here now many of shares of Asset 2 should the portfolio manager  buy" )
      System.Console.WriteLine( "    in order to achieve this? We will consider  two  assets,  for  which" )
      System.Console.WriteLine( "    you know three possible returns may take place and  you  can  assign" )
      System.Console.WriteLine( "    corresponding probabilities for each of these returns  taking  place" )
      System.Console.WriteLine( "    in accordance with the following table: State | Asset1  |  Asset2  |" )
      System.Console.WriteLine( "    Probability -------------------------------------- 1st state  |  300" )
      System.Console.WriteLine( "    | 500 | 0.5 2nd state | 310 | 400 | 0.2 3rd state | 330 | 550 | 0.3" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ First we evaluate the Standard deviation of the  Portfolio  (i.e.  1st +" )
      System.Console.WriteLine( "+ Asset)                                                                 +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    standardDeviation( double[] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here      we  evaluate  the  standard  deviation  of  the  portfolio" )
      System.Console.WriteLine( "     corresponding to th 1st asset." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {300.0, 310.0, 330.0}" )
      ' Here        we  evaluate  the  standard  deviation  of  the  portfolio
      ' corresponding to th 1st asset.
      Dim standard1 As Double = instanceOfTwoAssetPortfolio.StandardDeviation( _
         New Double() {300.0, 310.0, 330.0} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The standard deviation of the portfolio is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( standard1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Then we evaluate the Standard Deviation of the 2nd Asset +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    standardDeviation( double[] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the standard deviation of the 2nd Asset." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {500.0, 400.0, 550.0}" )
      ' Here we evaluate the standard deviation of the 2nd Asset.
      Dim standard2 As Double = instanceOfTwoAssetPortfolio.StandardDeviation( _
         New Double() {500.0, 400.0, 550.0} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The standard deviation of the 2nd Asset is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( standard2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Covariance between the two Asset is Evaluted +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covariance( double[] probability," )
      System.Console.WriteLine( "                double[] rateOfReturn1," )
      System.Console.WriteLine( "                double[] rateOfReturn2 )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the covariance between the Portfolio  and  the  2nd" )
      System.Console.WriteLine( "     Asset." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = {0.5, 0.2, 0.3}" )
      System.Console.WriteLine( "    rateOfReturn1 = {300.0, 310.0, 330.0}" )
      System.Console.WriteLine( "    rateOfReturn2 = {500.0, 400.0, 550.0}" )
      ' Here we evaluate the covariance between  the  Portfolio  and  the  2nd
      ' Asset.
      Dim covariance1 As Double = instanceOfTwoAssetPortfolio.Covariance( _
         New Double() {0.5, 0.2, 0.3}, _
         New Double() {300.0, 310.0, 330.0}, _
         New Double() {500.0, 400.0, 550.0} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The covariance between the two assets is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( covariance1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Now we can evaluate the optimal weight +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weight2MinimizeRisk( double standardDeviation1," )
      System.Console.WriteLine( "                         double standardDeviation2," )
      System.Console.WriteLine( "                         double covariance )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the weight of the original  portfolio  (i.e.  Asset" )
      System.Console.WriteLine( "     1) within the constructed  portfolio  consisting  of  Portfolio  and" )
      System.Console.WriteLine( "     Asset 2, in which the risk is minimized." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    standardDeviation1 = standard1" )
      System.Console.WriteLine( "    standardDeviation2 = standard2" )
      System.Console.WriteLine( "    covariance = covariance1" )
      ' Here   is  evaluate  the  weight  of  the  Portfolio  in  the  optimal
      ' portfolio.
      Dim optimalWeight1 As Double = instanceOfTwoAssetPortfolio.Weight2MinimizeRisk( _
         standard1, _
         standard2, _
         covariance1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The optimal weight in terms of minimizing the risk  of  the  portfolio" )
      System.Console.WriteLine( "    is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( optimalWeight1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Risk of the Optimal Portfolio +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolio2Risk( double alpha," )
      System.Console.WriteLine( "                    double standardDeviation1," )
      System.Console.WriteLine( "                    double standardDeviation2," )
      System.Console.WriteLine( "                    double covariance )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the Risk of the Optimal  Portfolio.  That  is,  the" )
      System.Console.WriteLine( "     risk of the portfolio found which  take  maximum  advantage  of  the" )
      System.Console.WriteLine( "     effects of diversification." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    alpha = optimalWeight1" )
      System.Console.WriteLine( "    standardDeviation1 = standard1" )
      System.Console.WriteLine( "    standardDeviation2 = standard2" )
      System.Console.WriteLine( "    covariance = covariance1" )
      ' Here we evaluate the risk pf the optimal portfolio.
      Dim riskOptimalPort1 As Double = instanceOfTwoAssetPortfolio.Portfolio2Risk( _
         optimalWeight1, _
         standard1, _
         standard2, _
         covariance1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( riskOptimalPort1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Expected Return of the Optimal Portfolio +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolio2Return( double alpha," )
      System.Console.WriteLine( "                      double expectedReturn1," )
      System.Console.WriteLine( "                      double expectedReturn2 )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate  the  expected  return  of  the  optimal  portfolio" )
      System.Console.WriteLine( "     found." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    alpha = optimalWeight1" )
      System.Console.WriteLine( "    expectedReturn1 = expected1" )
      System.Console.WriteLine( "    expectedReturn2 = expected2" )
      ' Here we evaluate the expected return of Asset 1.
      Dim expected1 As Double = instanceOfAssetParameters.ExpectedReturn( _
         New Double() {0.5, 0.2, 0.3}, _
         New Double() {300.0, 310.0, 330.0} _
      )
      ' Here we evaluate the expected return of Asset 2.
      Dim expected2 As Double = instanceOfAssetParameters.ExpectedReturn( _
         New Double() {0.5, 0.2, 0.3}, _
         New Double() {500.0, 400.0, 550.0} _
      )
      ' Here we evaluate the expected return of the optimal portfolio found.
      Dim expectedPort1 As Double = instanceOfTwoAssetPortfolio.Portfolio2Return( _
         optimalWeight1, _
         expected1, _
         expected2 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected return of the optimal portfolio is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( expectedPort1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Risk of the Original Portfolio +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    standardDeviation( double[] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Note that the risk is just another terms for the standard  deviation" )
      System.Console.WriteLine( "     which we evaluate for the original portfolio (i.e. Asset 1) here." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {300.0, 310.0, 330.0}" )
      ' Here we evaluate the risk (i.e. standard deviation)  of  the  original
      ' portfolio (i.e. Asset 1).
      Dim risk1 As Double = instanceOfTwoAssetPortfolio.StandardDeviation( _
         New Double() {300.0, 310.0, 330.0} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk (or standard deviation) of the original portfolio is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( risk1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Expected Return of the Original Portfolio +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn( double[] probability," )
      System.Console.WriteLine( "                    double[] returns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the  expected  return  of  the  original  portfolio" )
      System.Console.WriteLine( "     (i.e. Asset 1)" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = {0.5, 0.2, 0.3}" )
      System.Console.WriteLine( "    returns = {300.0, 310.0, 330.0}" )
      ' Here we evaluate the expeted return of the original portfolio.
      Dim originalPortExpectedReturn1 As Double = instanceOfAssetParameters.ExpectedReturn( _
         New Double() {0.5, 0.2, 0.3}, _
         New Double() {300.0, 310.0, 330.0} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected return of the original portfolio is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( originalPortExpectedReturn1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( " " )
   End Sub

   Function Double2String(ByVal d As Double) As String
      If (System.Double.IsNaN(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsNegativeInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsPositiveInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MinValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MaxValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      Dim frac As Double = d - Int(d)
      Dim frac4 As Double = Int(frac * 10000) / 10000.0
      Double2String = (Int(d) + frac4).ToString()
      Exit Function
   End Function

   Sub displayArray(ByVal a As Double())
      System.Console.Write("     {")
      For I As Integer = 0 To -1 + a.Length
         System.Console.Write(Double2String(a(I)))
         If (I < -1 + a.Length) Then System.Console.Write(", ")
      Next I
      System.Console.Write("}")
   End Sub

   Sub display2DArray(ByVal a As Double()())
      For I As Integer = 0 To -1 + a.Length
         If (I = 0) Then
            System.Console.Write("     {{")
         Else
            System.Console.Write("      {")
         End If
         For J As Integer = 0 To -1 + a(I).Length
            System.Console.Write(Double2String(a(I)(J)))
            If (J < -1 + a(I).Length) Then
               System.Console.Write(", ")
            Else
               System.Console.Write("}")
               End If
         Next J
         If (I < -1 + a.Length) Then
            System.Console.Write(",")
            System.Console.WriteLine()
            Else
               System.Console.Write("}")
            End If
      Next I
   End Sub
End Module

