Imports System
Imports Microsoft.VisualBasic
Imports WebCab.Lib.Util.Example
Imports WebCab.Libraries.Finance.Portfolio

Module TwoAssetPortfolioClient
   Sub Main()
      ' used components
      Dim instanceOfTwoAssetPortfolio As WebCab.Libraries.Finance.Portfolio.TwoAssetPortfolio = New WebCab.Libraries.Finance.Portfolio.TwoAssetPortfolio
      '
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "                   ############################################" )
      System.Console.WriteLine( "                   # TwoAssetPortfolio Console Client Example #" )
      System.Console.WriteLine( "                   ############################################" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " Overview" )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    Within this client we provide an example for  each  of  the  methods" )
      System.Console.WriteLine( "    within Two Asset Portfolio." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ The Correlation Coefficient between two assets +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    correlationCoef( double covariance," )
      System.Console.WriteLine( "                     double standardDeviation1," )
      System.Console.WriteLine( "                     double standardDeviation2 )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What is the correlation coefficient  when  the  between  two  assets" )
      System.Console.WriteLine( "     when the standard deviation of the  first  asset  is  0.4,  and  the" )
      System.Console.WriteLine( "     second asset is 0.6, and the covariance between the assets is 0.2?" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covariance = 0.2" )
      System.Console.WriteLine( "    standardDeviation1 = 0.4" )
      System.Console.WriteLine( "    standardDeviation2 = 0.6" )
      Dim CorrelationCoef1 As Double = instanceOfTwoAssetPortfolio.CorrelationCoef( _
         0.2, _
         0.4, _
         0.6 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The correlation coefficient is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( CorrelationCoef1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Estimate of the Future Covariance using the Scenario Approach +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covariance( double[] probability," )
      System.Console.WriteLine( "                double[] rateOfReturn1," )
      System.Console.WriteLine( "                double[] rateOfReturn2 )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What is the expected value of the covariance of the returns  on  two" )
      System.Console.WriteLine( "     funds when we have  the  following  expectations  of  the  following" )
      System.Console.WriteLine( "     scenarios:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - The probability of the 1st state occurring is  20  percent,  in" )
      System.Console.WriteLine( "        this instance:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "           - 1st Fund expected return = -3 percent" )
      System.Console.WriteLine( "           - 2nd Fund expected return = 6 percent" )
      System.Console.WriteLine( "           " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - The probability of the 2nd state occurring is  30  percent,  in" )
      System.Console.WriteLine( "        this instance:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "           - 1st Fund expected return = 3 percent" )
      System.Console.WriteLine( "           - 2nd Fund expected return = -2 percent" )
      System.Console.WriteLine( "           " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - The probability of the 3rd state occurring is  30  percent,  in" )
      System.Console.WriteLine( "        this instance:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "           - 1st Fund expected return = -3 percent" )
      System.Console.WriteLine( "           - 2nd Fund expected return = 6 percent" )
      System.Console.WriteLine( "           " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - The probability of the 4th state occurring is  20  percent,  in" )
      System.Console.WriteLine( "        this instance:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "           - 1st Fund expected return = 3 percent" )
      System.Console.WriteLine( "           - 2nd Fund expected return = -2 percent" )
      System.Console.WriteLine( "           " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = {0.2, 0.3, 0.3, 0.2}" )
      System.Console.WriteLine( "    rateOfReturn1 = {-0.03, 0.03, 0.05, 0.02}" )
      System.Console.WriteLine( "    rateOfReturn2 = {0.06, -0.02, 0.08, -0.09}" )
      ' Here we evaluate the covariance. Note  that  the  probability  of  the
      ' occurence sum to 1
      Dim covariance1 As Double = instanceOfTwoAssetPortfolio.Covariance( _
         New Double() {0.2, 0.3, 0.3, 0.2}, _
         New Double() {-0.03, 0.03, 0.05, 0.02}, _
         New Double() {0.06, -0.02, 0.08, -0.09} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The (expected) covariance is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( covariance1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation of the covariance using historical values +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covariance( double[] historicalReturns1," )
      System.Console.WriteLine( "                double[] historicalReturns2 )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What is the (historical) covariance between two  assets  which  over" )
      System.Console.WriteLine( "     the past 6 months have the following monthly returns:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - The 1st Assets percentage monthly returns where: 5, 6,  2,  -1," )
      System.Console.WriteLine( "        2, -2" )
      System.Console.WriteLine( "        - The 2nd Assets percentage monthly returns where: 4, 2,  4,  -2," )
      System.Console.WriteLine( "        4, 1" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns1 = {0.05, 0.06, 0.02, -0.01, 0.02, -0.02}" )
      System.Console.WriteLine( "    historicalReturns2 = {0.04, 0.02, 0.04, -0.02, 0.04, 0.01}" )
      Dim covariance2 As Double = instanceOfTwoAssetPortfolio.Covariance( _
         New Double() {0.05, 0.06, 0.02, -0.01, 0.02, -0.02}, _
         New Double() {0.04, 0.02, 0.04, -0.02, 0.04, 0.01} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The (historical) covariance between the two assets is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( covariance2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation of the Standard Deviation using Probability Distribution +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    standardDeviation( double[] probability," )
      System.Console.WriteLine( "                       double[] rateOfReturn )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What of the expected standard deviation of a fund for which we  know" )
      System.Console.WriteLine( "     will take  one  of  four  states  with  the  following  returns  and" )
      System.Console.WriteLine( "     probabilities:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Probability of 1st State = 20 percent, Return = -3 percent" )
      System.Console.WriteLine( "        - Probability of 1st State = 30 percent, Return = 2 percent" )
      System.Console.WriteLine( "        - Probability of 1st State = 30 percent, Return = 1 percent" )
      System.Console.WriteLine( "        - Probability of 1st State = 20 percent, Return = 0 percent" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = {0.2, 0.3, 0.3, 0.2}" )
      System.Console.WriteLine( "    rateOfReturn = {-0.03, 0.02, 0.01, 0.0}" )
      ' Here we evaluate the standard deviation.
      Dim standardDeviation1 As Double = instanceOfTwoAssetPortfolio.StandardDeviation( _
         New Double() {0.2, 0.3, 0.3, 0.2}, _
         New Double() {-0.03, 0.02, 0.01, 0.0} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The (expected) standard deviation is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( standardDeviation1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation of the Standard Deviation using Probability Distribution +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    standardDeviation( double[] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What is the standard deviation  of  the  monthly  returns  when  the" )
      System.Console.WriteLine( "     historical returns over the past 6 months is: 5, 6,  2,  -1,  2,  -2" )
      System.Console.WriteLine( "     percent respectively." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {0.05, 0.06, 0.02, -0.01, 0.02, -0.02}" )
      ' Here we evaluate the standard deviation from the historical values.
      Dim standardDeviation2 As Double = instanceOfTwoAssetPortfolio.StandardDeviation( _
         New Double() {0.05, 0.06, 0.02, -0.01, 0.02, -0.02} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The standard deviation is the returns is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( standardDeviation2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Risk of a Portfolio with Two Assets +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolio2Variance( double alpha," )
      System.Console.WriteLine( "                        double standardDeviation1," )
      System.Console.WriteLine( "                        double standardDeviation2," )
      System.Console.WriteLine( "                        double correlation )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What is the risk of a portfolio with two assets where the alpha  (or" )
      System.Console.WriteLine( "     weight) of the first asset is 0.6 (hence the weight  of  the  second" )
      System.Console.WriteLine( "     asset is 0.4), the standard deviation of the returns  of  the  first" )
      System.Console.WriteLine( "     asset is 0.25, and the standard deviation  of  the  returns  of  the" )
      System.Console.WriteLine( "     second asset is 0.15, and the covariance between the assets is 0.5?" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    alpha = 0.6" )
      System.Console.WriteLine( "    standardDeviation1 = 0.25" )
      System.Console.WriteLine( "    standardDeviation2 = 0.15" )
      System.Console.WriteLine( "    correlation = 0.5" )
      Dim portfolio2Variance1 As Double = instanceOfTwoAssetPortfolio.Portfolio2Variance( _
         0.6, _
         0.25, _
         0.15, _
         0.5 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the portfolio with two assets is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( portfolio2Variance1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Expected Return of a Portfolio with Two Assets +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolio2Return( double alpha," )
      System.Console.WriteLine( "                      double expectedReturn1," )
      System.Console.WriteLine( "                      double expectedReturn2 )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What is the expected return of the following two portfolios:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - 1st  Portfolio:  Alpha  (or  weight  of  first  asset)  =  0.5," )
      System.Console.WriteLine( "        Expected return of the 1st asset = 25  percent,  Expected  return" )
      System.Console.WriteLine( "        of the 2nd asset = 35 percent" )
      System.Console.WriteLine( "        - 2nd Portfolio:  Alpha  (or  weight  of  second  asset)  =  0.3," )
      System.Console.WriteLine( "        Expected return of the 1st asset = 25  percent,  Expected  return" )
      System.Console.WriteLine( "        of the 2nd asset = 35 percent" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    alpha = 0.5" )
      System.Console.WriteLine( "    expectedReturn1 = 0.25" )
      System.Console.WriteLine( "    expectedReturn2 = 0.35" )
      Dim portfolio2Return1 As Double = instanceOfTwoAssetPortfolio.Portfolio2Return( _
         0.5, _
         0.25, _
         0.35 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected return of the 1st Portfolio is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( portfolio2Return1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Expected Return of a Portfolio with Two Assets +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    portfolio2Return( double alpha," )
      System.Console.WriteLine( "                      double expectedReturn1," )
      System.Console.WriteLine( "                      double expectedReturn2 )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    alpha = 0.3" )
      System.Console.WriteLine( "    expectedReturn1 = 0.25" )
      System.Console.WriteLine( "    expectedReturn2 = 0.35" )
      Dim portfolio2Return2 As Double = instanceOfTwoAssetPortfolio.Portfolio2Return( _
         0.3, _
         0.25, _
         0.35 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected return of the 2nd Portfolio is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( portfolio2Return2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Optimal Diversification of a Portfolio with Two Assets +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weight2MinimizeRisk( double standardDeviation1," )
      System.Console.WriteLine( "                         double standardDeviation2," )
      System.Console.WriteLine( "                         double covariance )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     What is the weight of the first asset which minimizes the risk of  a" )
      System.Console.WriteLine( "     portfolio with two assets where the standard deviation of the  first" )
      System.Console.WriteLine( "     asset is 0.25, the standard deviation of the second asset  is  0.35," )
      System.Console.WriteLine( "     and the covariance is one of the following:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Covariance = 1, the assets are perfectly correlated" )
      System.Console.WriteLine( "        - Covariance = 0.50, the assets are positively correlated" )
      System.Console.WriteLine( "        - Covariance = 0, the assets are not correlated" )
      System.Console.WriteLine( "        - Covariance = -0.5, the assets are negatively correlated" )
      System.Console.WriteLine( "        -     Covariance  =  -1,  the  assets  are  perfectly  negatively" )
      System.Console.WriteLine( "        correlated" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    standardDeviation1 = 0.25" )
      System.Console.WriteLine( "    standardDeviation2 = 0.35" )
      System.Console.WriteLine( "    covariance = 1" )
      Dim weight2MinimizeRisk1 As Double = instanceOfTwoAssetPortfolio.Weight2MinimizeRisk( _
         0.25, _
         0.35, _
         1.0 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The weight of  the  first  asset  which  minimizes  the  risk  of  the" )
      System.Console.WriteLine( "    portfolio where the covariance is 1, is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( weight2MinimizeRisk1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Optimal Diversification of a Portfolio with Two Assets +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weight2MinimizeRisk( double standardDeviation1," )
      System.Console.WriteLine( "                         double standardDeviation2," )
      System.Console.WriteLine( "                         double covariance )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    standardDeviation1 = 0.25" )
      System.Console.WriteLine( "    standardDeviation2 = 0.35" )
      System.Console.WriteLine( "    covariance = 0.5" )
      Dim weight2MinimizeRisk2 As Double = instanceOfTwoAssetPortfolio.Weight2MinimizeRisk( _
         0.25, _
         0.35, _
         0.5 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The weight of  the  first  asset  which  minimizes  the  risk  of  the" )
      System.Console.WriteLine( "    portfolio where the covariance is 0.5, is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( weight2MinimizeRisk2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Optimal Diversification of a Portfolio with Two Assets +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weight2MinimizeRisk( double standardDeviation1," )
      System.Console.WriteLine( "                         double standardDeviation2," )
      System.Console.WriteLine( "                         double covariance )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    standardDeviation1 = 0.25" )
      System.Console.WriteLine( "    standardDeviation2 = 0.35" )
      System.Console.WriteLine( "    covariance = 0" )
      Dim weight2MinimizeRisk3 As Double = instanceOfTwoAssetPortfolio.Weight2MinimizeRisk( _
         0.25, _
         0.35, _
         0.0 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The weight of  the  first  asset  which  minimizes  the  risk  of  the" )
      System.Console.WriteLine( "    portfolio where the covariance is 0, is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( weight2MinimizeRisk3 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Optimal Diversification of a Portfolio with Two Assets +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weight2MinimizeRisk( double standardDeviation1," )
      System.Console.WriteLine( "                         double standardDeviation2," )
      System.Console.WriteLine( "                         double covariance )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    standardDeviation1 = 0.25" )
      System.Console.WriteLine( "    standardDeviation2 = 0.35" )
      System.Console.WriteLine( "    covariance = -0.5" )
      Dim weight2MinimizeRisk4 As Double = instanceOfTwoAssetPortfolio.Weight2MinimizeRisk( _
         0.25, _
         0.35, _
         -0.5 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The weight of  the  first  asset  which  minimizes  the  risk  of  the" )
      System.Console.WriteLine( "    portfolio where the covariance is -0.5, is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( weight2MinimizeRisk4 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Optimal Diversification of a Portfolio with Two Assets +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weight2MinimizeRisk( double standardDeviation1," )
      System.Console.WriteLine( "                         double standardDeviation2," )
      System.Console.WriteLine( "                         double covariance )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    standardDeviation1 = 0.25" )
      System.Console.WriteLine( "    standardDeviation2 = 0.35" )
      System.Console.WriteLine( "    covariance = -1" )
      Dim weight2MinimizeRisk5 As Double = instanceOfTwoAssetPortfolio.Weight2MinimizeRisk( _
         0.25, _
         0.35, _
         -1.0 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The weight of  the  first  asset  which  minimizes  the  risk  of  the" )
      System.Console.WriteLine( "    portfolio where the covariance is -1, is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( weight2MinimizeRisk5 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( " " )
   End Sub

   Function Double2String(ByVal d As Double) As String
      If (System.Double.IsNaN(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsNegativeInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsPositiveInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MinValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MaxValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      Dim frac As Double = d - Int(d)
      Dim frac4 As Double = Int(frac * 10000) / 10000.0
      Double2String = (Int(d) + frac4).ToString()
      Exit Function
   End Function

   Sub displayArray(ByVal a As Double())
      System.Console.Write("     {")
      For I As Integer = 0 To -1 + a.Length
         System.Console.Write(Double2String(a(I)))
         If (I < -1 + a.Length) Then System.Console.Write(", ")
      Next I
      System.Console.Write("}")
   End Sub

   Sub display2DArray(ByVal a As Double()())
      For I As Integer = 0 To -1 + a.Length
         If (I = 0) Then
            System.Console.Write("     {{")
         Else
            System.Console.Write("      {")
         End If
         For J As Integer = 0 To -1 + a(I).Length
            System.Console.Write(Double2String(a(I)(J)))
            If (J < -1 + a(I).Length) Then
               System.Console.Write(", ")
            Else
               System.Console.Write("}")
               End If
         Next J
         If (I < -1 + a.Length) Then
            System.Console.Write(",")
            System.Console.WriteLine()
            Else
               System.Console.Write("}")
            End If
      Next I
   End Sub
End Module

