Imports System
Imports Microsoft.VisualBasic
Imports WebCab.Lib.Util.Example
Imports WebCab.Libraries.Finance.Portfolio

Module AuEquityClient
   Sub Main()
      ' used components
      Dim instanceOfAssetParameters As AssetParameters = New AssetParameters
      Dim instanceOfCapitalMarket As WebCab.Libraries.Finance.Portfolio.CapitalMarket = New WebCab.Libraries.Finance.Portfolio.CapitalMarket
      '
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "                       ###################################" )
      System.Console.WriteLine( "                       # AuEquity Console Client Example #" )
      System.Console.WriteLine( "                       ###################################" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " Overview" )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    Overview of this Example" )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    Within this example we construct a  variety  of  Optimal  Portfolios" )
      System.Console.WriteLine( "    with   differing  risk/reward  profiles  for  an  Australian  Equity" )
      System.Console.WriteLine( "    Investment Company in accordance  with  the  Capital  Asset  Pricing" )
      System.Console.WriteLine( "    Model (CAPM)." )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    Australian Equity Portfolio Company" )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    With this example we consider a equity portfolio company  which  can" )
      System.Console.WriteLine( "    construct  portfolio  consisting  of  the  following  35  Australian" )
      System.Console.WriteLine( "    listed company stocks. Moreover,  the  company  itself  is  able  to" )
      System.Console.WriteLine( "    leverage or deleverage this portfolio by  either  borrowing  from  a" )
      System.Console.WriteLine( "    local bank at the prevailing base rate, or deleveraging the  company" )
      System.Console.WriteLine( "    by deposited excess capital with a local bank at the base rate.  The" )
      System.Console.WriteLine( "    base rate is known to be: 0.25 percent per month." )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    AU Stock Code for the Asset from which the Equity Portfolio  can  be" )
      System.Console.WriteLine( "    constructed" )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "       - WPL AU Equity" )
      System.Console.WriteLine( "       - MCP AU Equity" )
      System.Console.WriteLine( "       - CML AU Equity" )
      System.Console.WriteLine( "       - MXI AU Equity" )
      System.Console.WriteLine( "       - WES AU Equity" )
      System.Console.WriteLine( "       - CTX AU Equity" )
      System.Console.WriteLine( "       - PMM AU Equity" )
      System.Console.WriteLine( "       - WOW AU Equity" )
      System.Console.WriteLine( "       - BHP AU Equity" )
      System.Console.WriteLine( "       - PRG AU Equity" )
      System.Console.WriteLine( "       - IWF AU Equity" )
      System.Console.WriteLine( "       - TNE AU Equity" )
      System.Console.WriteLine( "       - UGL AU Equity" )
      System.Console.WriteLine( "       - BBG AU Equity" )
      System.Console.WriteLine( "       - FUN AU Equity" )
      System.Console.WriteLine( "       - WOR AU Equity" )
      System.Console.WriteLine( "       - CCL AU Equity" )
      System.Console.WriteLine( "       - LLC AU Equity" )
      System.Console.WriteLine( "       - GNS AU Equity" )
      System.Console.WriteLine( "       - AAU AU Equity" )
      System.Console.WriteLine( "       - SGS AU Equity" )
      System.Console.WriteLine( "       - VWD AU Equity" )
      System.Console.WriteLine( "       - MLE AU Equity" )
      System.Console.WriteLine( "       - BRK AU Equity" )
      System.Console.WriteLine( "       - TSE AU Equity" )
      System.Console.WriteLine( "       - MCC AU Equity" )
      System.Console.WriteLine( "       - DOW AU Equity" )
      System.Console.WriteLine( "       - MGW AU Equity" )
      System.Console.WriteLine( "       - CEY AU Equity" )
      System.Console.WriteLine( "       - SEV AU Equity" )
      System.Console.WriteLine( "       - CDR AU Equity" )
      System.Console.WriteLine( "       - AVV AU Equity" )
      System.Console.WriteLine( "       - RCD AU Equity" )
      System.Console.WriteLine( "       - MAP AU Equity" )
      System.Console.WriteLine( "       - IAG AU Equity" )
      System.Console.WriteLine( "       " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    Period of Historical Data" )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    In the application of portfolio theory  (Markowitz  and  CAPM),  you" )
      System.Console.WriteLine( "    are required  to  use  historical  data  for  the  purposes  of  the" )
      System.Console.WriteLine( "    evaluation of the expected returned and  the  covariance  matrix  of" )
      System.Console.WriteLine( "    the historical returns. Within this example we  assume  we  wish  to" )
      System.Console.WriteLine( "    construct  to  optimal  Portfolio  in  the  immediate  future  after" )
      System.Console.WriteLine( "    28/2/2005, and have chosen to use monthly data from the period:" )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "       - Beginning of Period: 31/01/2001" )
      System.Console.WriteLine( "       - End period: 28/02/2005" )
      System.Console.WriteLine( "       " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ We first evaluate the covariance of the asset being considered +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covarianceMatrix( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     We first evaluate the covariance matrix of  the  historical  returns" )
      System.Console.WriteLine( "     from which the portfolios can be constructed." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {{12.85, 12.254, 12.066, 11.836, 13.078, 14.568, 12.732, 12.313, 12.375, 12.407, 11.91, 12.0, 11.784, 12.516, 13.355, 12.3, 12.764, 12.336, 12.073, 12.002, 11.405, 11.055, 10.982, 11.3859, 10.733, 9.9789, 10.242, 10.768, 10.759, 11.6329, 12.488, 12.544, 12.7929, 12.63, 13.117, 14.129, 13.929, 14.53, 15.239, 16.0539, 15.782, 16.18, 17.4609, 17.7719, 19.21, 19.181, 20.54, 19.8009, 20.343, 21.78}," )
      System.Console.WriteLine( "                        {0.905, 0.89, 0.881, 0.915, 0.915, 0.899, 0.988, 0.899, 0.997, 1.048, 1.065, 1.159, 1.374, 1.2709, 1.554, 1.404, 1.733, 1.662, 1.599, 1.777, 1.999, 1.929, 2.021, 2.066, 2.158, 2.112, 2.176, 2.372, 2.994, 3.088, 3.521, 3.521, 3.926, 3.925, 3.925, 4.117, 4.684, 4.655, 4.472, 4.404, 4.218, 4.424, 4.4429, 4.6289, 4.76, 5.73, 5.5, 5.98, 5.6, 4.5199}," )
      System.Console.WriteLine( "                        {5.5439, 5.57, 5.475, 6.121, 6.281, 5.591, 5.458, 6.245, 6.112, 6.843, 7.373, 7.553, 7.679, 7.859, 7.715, 6.967, 6.071, 6.062, 5.6689, 5.349, 5.467, 5.953, 6.121, 5.869, 5.851, 5.282, 5.776, 6.547, 6.357, 6.661, 6.985, 6.994, 7.232, 7.516, 7.196, 7.313, 7.071, 7.545, 7.854, 8.236, 8.393, 8.452, 8.747, 8.836, 9.2, 9.5399, 9.98, 9.86, 9.28, 9.55}," )
      System.Console.WriteLine( "                        {0.168, 0.14, 0.125, 0.133, 0.117, 0.113, 0.121, 0.133, 0.117, 0.129, 0.121, 0.121, 0.121, 0.125, 0.121, 0.125, 0.13, 0.138, 0.147, 0.164, 0.164, 0.191, 0.26, 0.305, 0.314, 0.314, 0.314, 0.305, 0.356, 0.356, 0.487, 0.591, 0.652, 0.6899, 0.758, 0.805, 0.873, 0.8, 0.781, 0.742, 0.673, 0.732, 0.8, 0.859, 0.81, 0.96, 1.07, 0.99, 0.97, 0.91}," )
      System.Console.WriteLine( "                        {13.559, 13.902, 15.041, 17.228, 17.038, 20.439, 21.374, 21.787, 22.3619, 22.915, 24.53, 23.831, 23.531, 24.709, 24.793, 22.119, 22.383, 21.14, 21.917, 23.0829, 21.5829, 21.024, 22.3649, 21.224, 22.5, 20.322, 18.018, 19.876, 20.354, 20.525, 21.636, 22.869, 22.685, 24.258, 23.589, 24.2689, 25.817, 25.633, 27.031, 26.639, 26.332, 27.404, 27.478, 28.909, 30.775, 33.4189, 36.737, 38.276, 37.795, 39.1}," )
      System.Console.WriteLine( "                        {2.12, 2.157, 1.907, 1.936, 1.965, 1.57, 1.301, 1.358, 0.915, 1.161, 1.3778, 1.3778, 1.609, 1.58, 1.917, 1.657, 1.551, 1.484, 1.5129, 1.676, 1.59, 1.763, 2.119, 2.062, 2.033, 1.927, 2.245, 2.678, 2.601, 2.794, 3.324, 3.487, 3.721, 4.247, 4.198, 4.5, 5.5519, 6.829, 7.063, 7.792, 8.433, 9.093, 9.014, 9.014, 9.27, 8.93, 9.17, 10.86, 11.15, 14.0}," )
      System.Console.WriteLine( "                        {1.1, 1.067, 0.975, 1.042, 1.084, 1.242, 1.166, 1.109, 0.921, 1.124, 1.116, 1.183, 1.369, 1.606, 1.978, 2.09, 1.761, 1.596, 1.266, 1.102, 1.137, 1.1278, 1.02, 0.877, 0.94, 0.832, 0.94, 0.992, 0.871, 0.992, 1.223, 1.177, 1.3798, 1.532, 1.427, 1.37, 1.275, 1.3798, 1.456, 1.495, 1.651, 1.72, 1.925, 1.925, 2.19, 2.43, 3.02, 2.81, 3.56, 3.91}," )
      System.Console.WriteLine( "                        {6.924, 7.482, 7.439, 8.048, 8.6039, 9.859, 9.904, 9.614, 10.764, 10.301, 10.074, 10.21, 10.7579, 11.009, 11.475, 12.073, 11.953, 12.091, 11.154, 11.034, 11.478, 11.487, 10.563, 10.638, 11.142, 10.797, 11.587, 12.241, 11.606, 11.862, 11.18, 11.142, 11.304, 10.725, 10.938, 11.381, 11.323, 11.314, 11.63, 11.581, 11.492, 11.188, 11.492, 12.65, 13.62, 13.38, 15.0, 15.01, 14.59, 15.56}," )
      System.Console.WriteLine( "                        {7.716, 8.617, 8.023, 8.809, 9.21, 8.8859, 8.296, 7.971, 7.338, 7.638, 8.7129, 9.109, 9.699, 10.228, 9.89, 9.3699, 9.3699, 9.032, 8.94, 8.546, 8.489, 9.09, 9.618, 9.646, 8.477, 8.696, 8.819, 8.591, 8.173, 8.318, 9.435, 10.523, 10.166, 11.283, 10.955, 11.849, 10.974, 11.917, 11.917, 11.249, 11.857, 12.289, 12.926, 13.009, 14.228, 13.722, 15.308, 15.199, 16.12, 19.14}," )
      System.Console.WriteLine( "                        {1.523, 1.6258, 1.481, 1.609, 1.763, 1.883, 1.805, 1.962, 1.796, 1.866, 1.927, 2.0059, 1.978, 2.156, 2.067, 2.076, 2.236, 1.996, 1.939, 2.119, 2.074, 1.885, 1.831, 1.804, 1.767, 1.592, 1.647, 1.923, 1.997, 2.052, 2.1269, 2.184, 2.25, 2.259, 2.447, 2.551, 2.613, 2.786, 2.498, 2.93, 3.123, 2.998, 3.239, 3.278, 3.288, 3.052, 3.2679, 3.435, 3.25, 3.24}," )
      System.Console.WriteLine( "                        {0.657, 0.65, 0.613, 0.517, 0.613, 0.5649, 0.637, 0.6919, 0.525, 0.619, 0.644, 0.67, 0.644, 0.787, 0.796, 0.805, 0.744, 0.779, 0.6929, 0.779, 0.806, 0.904, 0.886, 0.841, 0.967, 1.065, 1.067, 1.002, 1.141, 1.2609, 1.299, 1.5209, 1.66, 1.471, 1.48, 1.604, 1.757, 1.872, 1.892, 1.94, 1.804, 1.784, 1.901, 2.106, 2.34, 2.47, 2.5, 2.55, 2.55, 2.4}," )
      System.Console.WriteLine( "                        {1.056, 0.845, 0.682, 0.861, 0.742, 0.708, 0.716, 0.725, 0.6879, 0.776, 0.782, 0.757, 0.714, 0.645, 0.671, 0.584, 0.496, 0.531, 0.366, 0.392, 0.329, 0.3469, 0.262, 0.2, 0.258, 0.236, 0.226, 0.258, 0.304, 0.336, 0.387, 0.419, 0.419, 0.429, 0.467, 0.458, 0.534, 0.524, 0.536, 0.526, 0.526, 0.546, 0.624, 0.604, 0.6, 0.59, 0.62, 0.68, 0.7, 0.67}," )
      System.Console.WriteLine( "                        {1.287, 1.355, 1.2709, 1.677, 1.868, 1.85, 1.79, 1.945, 1.749, 1.767, 2.032, 2.294, 2.403, 2.871, 2.765, 2.657, 2.747, 2.702, 2.549, 2.594, 2.324, 2.361, 2.379, 2.517, 2.7, 2.562, 2.619, 2.629, 2.629, 2.676, 2.928, 3.62, 3.547, 3.89, 3.766, 4.062, 4.138, 4.147, 4.04, 4.418, 4.865, 4.952, 5.186, 5.691, 5.882, 6.692, 6.366, 6.218, 7.106, 7.383}," )
      System.Console.WriteLine( "                        {3.828, 4.158, 4.3949, 4.623, 4.424, 4.785, 5.431, 6.862, 6.065, 7.225, 7.614, 7.643, 8.6649, 8.209, 8.243, 7.829, 8.1969, 8.252, 6.908, 7.515, 6.723, 6.252, 6.373, 6.485, 6.429, 4.992, 4.78, 5.429, 5.648, 5.858, 6.364, 6.583, 7.108, 7.102, 6.772, 6.918, 6.801, 7.209, 7.653, 7.495, 8.1359, 8.146, 8.0079, 9.251, 9.408, 10.5, 11.4, 11.45, 12.05, 13.7}," )
      System.Console.WriteLine( "                        {0.422, 0.422, 0.352, 0.381, 0.423, 0.394, 0.381, 0.39, 0.351, 0.413, 0.536, 0.5709, 0.536, 0.553, 0.5709, 0.562, 0.707, 0.6889, 0.616, 0.707, 0.766, 0.858, 0.886, 0.932, 0.987, 0.987, 1.028, 1.2, 1.238, 1.409, 1.466, 1.79, 1.79, 1.771, 1.973, 2.108, 2.05, 2.021, 1.951, 2.1389, 2.129, 2.1389, 2.365, 2.375, 2.35, 2.63, 2.67, 1.93, 1.98, 1.92}," )
      System.Console.WriteLine( "                        {1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.732, 1.656, 1.704, 1.865, 1.903, 1.942, 2.2839, 2.475, 2.953, 3.273, 3.041, 3.166, 3.099, 3.099, 3.15, 2.992, 2.904, 2.855, 3.248, 3.849, 3.9, 5.26, 5.46, 5.67, 5.94, 6.2}," )
      System.Console.WriteLine( "                        {3.932, 4.151, 3.809, 3.769, 3.688, 3.89, 4.26, 4.651, 4.86, 4.467, 4.753, 5.324, 5.67, 5.2, 5.233, 5.404, 5.45, 5.747, 5.675, 5.702, 5.382, 4.817, 4.89, 4.808, 5.227, 5.287, 5.249, 5.287, 5.082, 5.305, 5.444, 5.35, 5.407, 5.567, 5.756, 5.889, 6.002, 6.354, 6.576, 6.643, 6.923, 6.682, 6.768, 7.106, 6.89, 7.223, 7.312, 7.979, 7.704, 8.18}," )
      System.Console.WriteLine( "                        {14.362, 13.171, 11.0559, 12.342, 10.528, 11.0559, 10.5719, 9.405, 9.813, 9.8859, 10.558, 11.578, 11.891, 10.625, 10.518, 10.446, 9.278, 9.467, 9.134, 9.981, 9.147, 8.993, 9.048, 8.803, 8.205, 8.025, 8.569, 9.315, 7.841, 7.694, 7.988, 9.955, 9.673, 10.528, 9.861, 9.438, 9.748, 9.47, 9.785, 10.206, 9.709, 9.833, 9.948, 10.9149, 11.189, 11.307, 11.953, 12.982, 13.374, 12.4}," )
      System.Console.WriteLine( "                        {0.63, 0.6899, 0.851, 0.995, 0.963, 0.912, 0.849, 0.954, 0.791, 0.869, 0.938, 0.988, 1.078, 1.125, 1.381, 1.483, 1.718, 1.62, 1.533, 1.738, 1.891, 1.864, 1.98, 1.99, 2.1429, 2.341, 2.232, 2.395, 2.558, 2.75, 2.878, 2.868, 3.06, 3.084, 2.824, 3.0, 2.727, 2.925, 2.871, 2.978, 3.233, 3.214, 3.324, 3.515, 3.618, 4.13, 4.2, 4.73, 4.53, 4.48}," )
      System.Console.WriteLine( "                        {0.924, 0.939, 0.5639, 0.806, 0.742, 0.726, 0.677, 0.806, 0.676, 0.751, 0.735, 0.751, 0.735, 0.777, 0.747, 0.712, 0.687, 0.858, 0.944, 0.927, 0.933, 0.835, 0.827, 0.8, 0.8, 0.764, 0.8, 0.8189, 0.8189, 0.828, 0.828, 0.92, 1.069, 1.135, 0.956, 1.079, 1.06, 1.012, 1.106, 1.087, 1.0189, 1.067, 1.155, 1.213, 1.15, 1.12, 1.07, 1.07, 1.1, 1.1}," )
      System.Console.WriteLine( "                        {0.941, 0.933, 0.781, 0.847, 1.026, 1.082, 0.988, 0.86, 0.753, 0.64, 0.612, 0.64, 0.621, 0.781, 0.979, 0.913, 0.979, 1.026, 1.129, 1.393, 1.139, 1.035, 1.101, 1.0169, 0.951, 0.932, 0.847, 0.988, 0.885, 0.894, 1.0068, 1.177, 1.12, 1.206, 1.302, 1.167, 1.157, 1.119, 1.051, 0.994, 1.032, 1.022, 1.119, 1.177, 1.22, 1.3, 1.41, 1.48, 1.62, 1.58}," )
      System.Console.WriteLine( "                        {0.487, 0.543, 0.447, 0.462, 0.462, 0.411, 0.426, 0.455, 0.368, 0.405, 0.471, 0.463, 0.478, 0.515, 0.587, 0.502, 0.533, 0.533, 0.525, 0.556, 0.602, 0.5629, 0.58, 0.654, 0.6959, 0.704, 0.727, 0.823, 0.919, 1.05, 1.094, 1.077, 1.234, 1.181, 1.135, 1.098, 1.162, 1.208, 1.23, 1.191, 1.239, 1.239, 1.258, 1.506, 1.487, 1.47, 1.54, 1.52, 1.65, 1.62}," )
      System.Console.WriteLine( "                        {0.503, 0.456, 0.388, 0.374, 0.381, 0.378, 0.371, 0.414, 0.371, 0.4069, 0.487, 0.511, 0.488, 0.496, 0.511, 0.504, 0.557, 0.54, 0.508, 0.548, 0.483, 0.54, 0.5719, 0.592, 0.6, 0.6, 0.575, 0.634, 0.685, 0.6919, 0.728, 0.79, 0.8159, 0.861, 0.843, 0.898, 0.898, 0.972, 1.0088, 1.0, 1.0, 1.028, 1.115, 1.231, 1.319, 1.483, 1.493, 1.74, 1.93, 1.91}," )
      System.Console.WriteLine( "                        {1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.2709, 1.199, 1.09, 1.18, 1.208, 1.062, 1.062, 0.969, 1.043, 1.285, 1.3879, 1.322, 1.444, 1.444, 1.397, 1.52, 1.805, 1.982, 2.137, 2.04, 2.079, 2.37, 2.487, 2.862, 3.05, 3.365, 3.73, 4.68, 4.35}," )
      System.Console.WriteLine( "                        {1.557, 1.557, 1.557, 1.557, 1.557, 1.769, 1.858, 1.902, 1.99, 1.928, 2.052, 2.282, 2.194, 1.99, 2.437, 2.392, 2.609, 2.545, 2.455, 2.681, 2.626, 2.479, 2.433, 2.479, 2.47, 2.497, 2.722, 2.656, 2.872, 2.966, 3.154, 3.416, 3.53, 4.095, 4.258, 4.439, 4.191, 4.688, 4.805, 4.853, 5.0279, 4.97, 4.863, 5.222, 5.409, 6.248, 6.12, 6.663, 6.86, 7.06}," )
      System.Console.WriteLine( "                        {1.056, 1.056, 1.056, 1.056, 1.056, 1.056, 1.056, 1.0209, 1.012, 1.1, 1.065, 1.056, 1.321, 1.287, 1.422, 1.359, 1.17, 1.17, 1.152, 1.062, 1.1359, 1.173, 1.154, 1.293, 1.2, 1.108, 1.099, 1.1, 1.0048, 0.901, 1.062, 1.024, 0.958, 1.149, 1.121, 1.303, 1.322, 1.427, 1.5169, 1.281, 1.488, 1.98, 2.148, 2.739, 3.48, 3.81, 4.25, 3.99, 4.95, 6.3}," )
      System.Console.WriteLine( "                        {1.964, 1.676, 1.437, 1.847, 1.854, 1.881, 2.36, 2.394, 2.144, 2.846, 2.811, 2.636, 2.811, 2.97, 3.1469, 2.758, 2.652, 2.334, 2.086, 2.188, 2.261, 2.005, 1.932, 1.969, 1.859, 1.805, 2.063, 2.21, 2.652, 2.836, 2.726, 2.873, 3.306, 3.344, 3.544, 3.677, 3.591, 3.221, 3.0099, 3.308, 3.078, 3.078, 3.174, 3.725, 3.952, 4.486, 4.4269, 4.674, 5.059, 5.01}," )
      System.Console.WriteLine( "                        {2.463, 2.523, 2.48, 2.437, 2.715, 3.089, 3.046, 3.559, 3.546, 3.989, 3.9, 3.767, 3.883, 4.432, 4.5, 3.593, 4.311, 4.221, 3.907, 4.132, 4.257, 4.323, 4.3869, 4.3869, 4.414, 4.003, 4.069, 3.827, 3.771, 3.603, 3.948, 4.2, 4.527, 4.676, 4.59, 4.647, 4.485, 4.581, 4.5, 4.6369, 4.559, 4.559, 4.822, 4.948, 4.929, 5.1, 5.2699, 5.65, 6.0, 5.7}," )
      System.Console.WriteLine( "                        {0.754, 0.821, 0.832, 0.988, 0.931, 1.045, 0.945, 0.914, 0.98, 1.068, 1.102, 1.102, 1.331, 1.67, 1.953, 1.83, 1.61, 1.583, 1.539, 1.853, 1.761, 1.963, 2.148, 2.083, 2.12, 1.973, 2.02, 2.039, 2.19, 2.058, 2.266, 2.322, 2.379, 2.456, 2.379, 2.649, 2.774, 3.189, 3.14, 2.846, 2.817, 3.14, 3.278, 3.533, 4.0, 4.3, 4.04, 4.08, 3.99, 4.4}," )
      System.Console.WriteLine( "                        {5.4589, 5.723, 5.399, 6.0599, 5.863, 6.128, 6.464, 6.241, 5.562, 5.759, 6.106, 6.035, 6.158, 6.264, 6.484, 5.5359, 5.2619, 4.925, 4.783, 4.686, 4.385, 4.42, 4.218, 4.164, 4.191, 3.459, 3.549, 3.979, 4.5679, 4.437, 4.979, 5.221, 5.352, 5.768, 5.059, 5.873, 5.538, 5.174, 5.136, 4.922, 4.961, 5.01, 5.029, 4.757, 4.806, 6.04, 6.3, 6.41, 7.5, 7.55}," )
      System.Console.WriteLine( "                        {0.769, 0.76, 0.662, 0.617, 0.59, 0.742, 0.742, 0.783, 0.737, 0.71, 0.654, 0.663, 0.6909, 0.645, 0.627, 0.599, 0.663, 0.663, 0.746, 0.792, 0.854, 0.854, 0.797, 0.74, 0.712, 0.6929, 0.728, 0.787, 0.835, 0.903, 1.078, 1.2528, 1.069, 1.0088, 1.089, 1.1278, 1.277, 1.108, 1.1278, 1.385, 1.534, 1.445, 1.474, 1.732, 1.85, 2.0, 2.39, 2.46, 2.46, 2.2599}," )
      System.Console.WriteLine( "                        {1.932, 1.508, 1.178, 0.895, 0.49, 1.225, 0.66, 0.49, 0.377, 0.339, 0.339, 0.594, 0.641, 0.735, 0.613, 0.5649, 0.471, 0.622, 0.5649, 0.518, 0.518, 0.603, 0.594, 0.528, 0.528, 0.471, 0.622, 0.631, 0.754, 0.773, 1.056, 1.357, 1.467, 1.477, 1.5149, 1.592, 1.6298, 1.784, 2.047, 2.175, 1.93, 2.243, 2.449, 2.39, 2.38, 1.77, 1.68, 1.3899, 1.6, 1.54}," )
      System.Console.WriteLine( "                        {1.563, 1.563, 1.563, 1.667, 1.699, 1.659, 1.651, 1.659, 1.533, 1.566, 1.566, 1.566, 1.557, 1.577, 1.552, 1.527, 1.644, 1.36, 1.402, 1.627, 1.687, 1.67, 1.653, 1.619, 1.832, 2.06, 2.043, 2.209, 2.323, 2.691, 2.718, 2.586, 2.65, 2.775, 2.811, 3.0179, 3.108, 3.449, 3.322, 3.687, 3.745, 3.831, 4.07, 4.343, 4.215, 4.89, 5.7699, 5.604, 6.22, 5.8}," )
      System.Console.WriteLine( "                        {1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.1, 0.893, 0.797, 0.737, 0.944, 1.034, 0.916, 0.835, 0.907, 1.18, 1.335, 1.523, 1.551, 1.6359, 1.748, 1.6359, 1.702, 1.741, 1.741, 1.635, 1.721, 1.865, 1.97, 2.194, 2.341, 2.5259, 2.7599, 3.0139, 3.14, 3.46, 3.35}," )
      System.Console.WriteLine( "                        {2.332, 2.358, 2.436, 2.445, 2.55, 2.992, 2.902, 2.876, 2.673, 2.843, 2.708, 2.798, 2.997, 2.906, 3.09, 3.035, 2.999, 2.862, 2.644, 2.908, 2.824, 2.306, 2.371, 2.537, 2.5, 2.834, 2.726, 2.914, 3.14, 3.196, 3.525, 3.742, 3.971, 4.258, 3.999, 4.066, 4.086, 4.306, 4.625, 4.732, 4.508, 4.868, 4.849, 4.946, 5.2, 5.39, 5.84, 6.43, 6.5, 6.4}}" )
      ' Here we evaluate the covariance matrix of the  historical  returns  of
      ' the assets from which the portfolios can be constructed.
      Dim covariance1 As Double()() = instanceOfAssetParameters.CovarianceMatrix( _
         New Double()() {New Double() {12.85, 12.254, 12.066, 11.836, 13.078, 14.568, 12.732, 12.313, 12.375, 12.407, 11.91, 12.0, 11.784, 12.516, 13.355, 12.3, 12.764, 12.336, 12.073, 12.002, 11.405, 11.055, 10.982, 11.3859, 10.733, 9.9789, 10.242, 10.768, 10.759, 11.6329, 12.488, 12.544, 12.7929, 12.63, 13.117, 14.129, 13.929, 14.53, 15.239, 16.0539, 15.782, 16.18, 17.4609, 17.7719, 19.21, 19.181, 20.54, 19.8009, 20.343, 21.78}, _
                         New Double() {0.905, 0.89, 0.881, 0.915, 0.915, 0.899, 0.988, 0.899, 0.997, 1.048, 1.065, 1.159, 1.374, 1.2709, 1.554, 1.404, 1.733, 1.662, 1.599, 1.777, 1.999, 1.929, 2.021, 2.066, 2.158, 2.112, 2.176, 2.372, 2.994, 3.088, 3.521, 3.521, 3.926, 3.925, 3.925, 4.117, 4.684, 4.655, 4.472, 4.404, 4.218, 4.424, 4.4429, 4.6289, 4.76, 5.73, 5.5, 5.98, 5.6, 4.5199}, _
                         New Double() {5.5439, 5.57, 5.475, 6.121, 6.281, 5.591, 5.458, 6.245, 6.112, 6.843, 7.373, 7.553, 7.679, 7.859, 7.715, 6.967, 6.071, 6.062, 5.6689, 5.349, 5.467, 5.953, 6.121, 5.869, 5.851, 5.282, 5.776, 6.547, 6.357, 6.661, 6.985, 6.994, 7.232, 7.516, 7.196, 7.313, 7.071, 7.545, 7.854, 8.236, 8.393, 8.452, 8.747, 8.836, 9.2, 9.5399, 9.98, 9.86, 9.28, 9.55}, _
                         New Double() {0.168, 0.14, 0.125, 0.133, 0.117, 0.113, 0.121, 0.133, 0.117, 0.129, 0.121, 0.121, 0.121, 0.125, 0.121, 0.125, 0.13, 0.138, 0.147, 0.164, 0.164, 0.191, 0.26, 0.305, 0.314, 0.314, 0.314, 0.305, 0.356, 0.356, 0.487, 0.591, 0.652, 0.6899, 0.758, 0.805, 0.873, 0.8, 0.781, 0.742, 0.673, 0.732, 0.8, 0.859, 0.81, 0.96, 1.07, 0.99, 0.97, 0.91}, _
                         New Double() {13.559, 13.902, 15.041, 17.228, 17.038, 20.439, 21.374, 21.787, 22.3619, 22.915, 24.53, 23.831, 23.531, 24.709, 24.793, 22.119, 22.383, 21.14, 21.917, 23.0829, 21.5829, 21.024, 22.3649, 21.224, 22.5, 20.322, 18.018, 19.876, 20.354, 20.525, 21.636, 22.869, 22.685, 24.258, 23.589, 24.2689, 25.817, 25.633, 27.031, 26.639, 26.332, 27.404, 27.478, 28.909, 30.775, 33.4189, 36.737, 38.276, 37.795, 39.1}, _
                         New Double() {2.12, 2.157, 1.907, 1.936, 1.965, 1.57, 1.301, 1.358, 0.915, 1.161, 1.3778, 1.3778, 1.609, 1.58, 1.917, 1.657, 1.551, 1.484, 1.5129, 1.676, 1.59, 1.763, 2.119, 2.062, 2.033, 1.927, 2.245, 2.678, 2.601, 2.794, 3.324, 3.487, 3.721, 4.247, 4.198, 4.5, 5.5519, 6.829, 7.063, 7.792, 8.433, 9.093, 9.014, 9.014, 9.27, 8.93, 9.17, 10.86, 11.15, 14.0}, _
                         New Double() {1.1, 1.067, 0.975, 1.042, 1.084, 1.242, 1.166, 1.109, 0.921, 1.124, 1.116, 1.183, 1.369, 1.606, 1.978, 2.09, 1.761, 1.596, 1.266, 1.102, 1.137, 1.1278, 1.02, 0.877, 0.94, 0.832, 0.94, 0.992, 0.871, 0.992, 1.223, 1.177, 1.3798, 1.532, 1.427, 1.37, 1.275, 1.3798, 1.456, 1.495, 1.651, 1.72, 1.925, 1.925, 2.19, 2.43, 3.02, 2.81, 3.56, 3.91}, _
                         New Double() {6.924, 7.482, 7.439, 8.048, 8.6039, 9.859, 9.904, 9.614, 10.764, 10.301, 10.074, 10.21, 10.7579, 11.009, 11.475, 12.073, 11.953, 12.091, 11.154, 11.034, 11.478, 11.487, 10.563, 10.638, 11.142, 10.797, 11.587, 12.241, 11.606, 11.862, 11.18, 11.142, 11.304, 10.725, 10.938, 11.381, 11.323, 11.314, 11.63, 11.581, 11.492, 11.188, 11.492, 12.65, 13.62, 13.38, 15.0, 15.01, 14.59, 15.56}, _
                         New Double() {7.716, 8.617, 8.023, 8.809, 9.21, 8.8859, 8.296, 7.971, 7.338, 7.638, 8.7129, 9.109, 9.699, 10.228, 9.89, 9.3699, 9.3699, 9.032, 8.94, 8.546, 8.489, 9.09, 9.618, 9.646, 8.477, 8.696, 8.819, 8.591, 8.173, 8.318, 9.435, 10.523, 10.166, 11.283, 10.955, 11.849, 10.974, 11.917, 11.917, 11.249, 11.857, 12.289, 12.926, 13.009, 14.228, 13.722, 15.308, 15.199, 16.12, 19.14}, _
                         New Double() {1.523, 1.6258, 1.481, 1.609, 1.763, 1.883, 1.805, 1.962, 1.796, 1.866, 1.927, 2.0059, 1.978, 2.156, 2.067, 2.076, 2.236, 1.996, 1.939, 2.119, 2.074, 1.885, 1.831, 1.804, 1.767, 1.592, 1.647, 1.923, 1.997, 2.052, 2.1269, 2.184, 2.25, 2.259, 2.447, 2.551, 2.613, 2.786, 2.498, 2.93, 3.123, 2.998, 3.239, 3.278, 3.288, 3.052, 3.2679, 3.435, 3.25, 3.24}, _
                         New Double() {0.657, 0.65, 0.613, 0.517, 0.613, 0.5649, 0.637, 0.6919, 0.525, 0.619, 0.644, 0.67, 0.644, 0.787, 0.796, 0.805, 0.744, 0.779, 0.6929, 0.779, 0.806, 0.904, 0.886, 0.841, 0.967, 1.065, 1.067, 1.002, 1.141, 1.2609, 1.299, 1.5209, 1.66, 1.471, 1.48, 1.604, 1.757, 1.872, 1.892, 1.94, 1.804, 1.784, 1.901, 2.106, 2.34, 2.47, 2.5, 2.55, 2.55, 2.4}, _
                         New Double() {1.056, 0.845, 0.682, 0.861, 0.742, 0.708, 0.716, 0.725, 0.6879, 0.776, 0.782, 0.757, 0.714, 0.645, 0.671, 0.584, 0.496, 0.531, 0.366, 0.392, 0.329, 0.3469, 0.262, 0.2, 0.258, 0.236, 0.226, 0.258, 0.304, 0.336, 0.387, 0.419, 0.419, 0.429, 0.467, 0.458, 0.534, 0.524, 0.536, 0.526, 0.526, 0.546, 0.624, 0.604, 0.6, 0.59, 0.62, 0.68, 0.7, 0.67}, _
                         New Double() {1.287, 1.355, 1.2709, 1.677, 1.868, 1.85, 1.79, 1.945, 1.749, 1.767, 2.032, 2.294, 2.403, 2.871, 2.765, 2.657, 2.747, 2.702, 2.549, 2.594, 2.324, 2.361, 2.379, 2.517, 2.7, 2.562, 2.619, 2.629, 2.629, 2.676, 2.928, 3.62, 3.547, 3.89, 3.766, 4.062, 4.138, 4.147, 4.04, 4.418, 4.865, 4.952, 5.186, 5.691, 5.882, 6.692, 6.366, 6.218, 7.106, 7.383}, _
                         New Double() {3.828, 4.158, 4.3949, 4.623, 4.424, 4.785, 5.431, 6.862, 6.065, 7.225, 7.614, 7.643, 8.6649, 8.209, 8.243, 7.829, 8.1969, 8.252, 6.908, 7.515, 6.723, 6.252, 6.373, 6.485, 6.429, 4.992, 4.78, 5.429, 5.648, 5.858, 6.364, 6.583, 7.108, 7.102, 6.772, 6.918, 6.801, 7.209, 7.653, 7.495, 8.1359, 8.146, 8.0079, 9.251, 9.408, 10.5, 11.4, 11.45, 12.05, 13.7}, _
                         New Double() {0.422, 0.422, 0.352, 0.381, 0.423, 0.394, 0.381, 0.39, 0.351, 0.413, 0.536, 0.5709, 0.536, 0.553, 0.5709, 0.562, 0.707, 0.6889, 0.616, 0.707, 0.766, 0.858, 0.886, 0.932, 0.987, 0.987, 1.028, 1.2, 1.238, 1.409, 1.466, 1.79, 1.79, 1.771, 1.973, 2.108, 2.05, 2.021, 1.951, 2.1389, 2.129, 2.1389, 2.365, 2.375, 2.35, 2.63, 2.67, 1.93, 1.98, 1.92}, _
                         New Double() {1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.732, 1.656, 1.704, 1.865, 1.903, 1.942, 2.2839, 2.475, 2.953, 3.273, 3.041, 3.166, 3.099, 3.099, 3.15, 2.992, 2.904, 2.855, 3.248, 3.849, 3.9, 5.26, 5.46, 5.67, 5.94, 6.2}, _
                         New Double() {3.932, 4.151, 3.809, 3.769, 3.688, 3.89, 4.26, 4.651, 4.86, 4.467, 4.753, 5.324, 5.67, 5.2, 5.233, 5.404, 5.45, 5.747, 5.675, 5.702, 5.382, 4.817, 4.89, 4.808, 5.227, 5.287, 5.249, 5.287, 5.082, 5.305, 5.444, 5.35, 5.407, 5.567, 5.756, 5.889, 6.002, 6.354, 6.576, 6.643, 6.923, 6.682, 6.768, 7.106, 6.89, 7.223, 7.312, 7.979, 7.704, 8.18}, _
                         New Double() {14.362, 13.171, 11.0559, 12.342, 10.528, 11.0559, 10.5719, 9.405, 9.813, 9.8859, 10.558, 11.578, 11.891, 10.625, 10.518, 10.446, 9.278, 9.467, 9.134, 9.981, 9.147, 8.993, 9.048, 8.803, 8.205, 8.025, 8.569, 9.315, 7.841, 7.694, 7.988, 9.955, 9.673, 10.528, 9.861, 9.438, 9.748, 9.47, 9.785, 10.206, 9.709, 9.833, 9.948, 10.9149, 11.189, 11.307, 11.953, 12.982, 13.374, 12.4}, _
                         New Double() {0.63, 0.6899, 0.851, 0.995, 0.963, 0.912, 0.849, 0.954, 0.791, 0.869, 0.938, 0.988, 1.078, 1.125, 1.381, 1.483, 1.718, 1.62, 1.533, 1.738, 1.891, 1.864, 1.98, 1.99, 2.1429, 2.341, 2.232, 2.395, 2.558, 2.75, 2.878, 2.868, 3.06, 3.084, 2.824, 3.0, 2.727, 2.925, 2.871, 2.978, 3.233, 3.214, 3.324, 3.515, 3.618, 4.13, 4.2, 4.73, 4.53, 4.48}, _
                         New Double() {0.924, 0.939, 0.5639, 0.806, 0.742, 0.726, 0.677, 0.806, 0.676, 0.751, 0.735, 0.751, 0.735, 0.777, 0.747, 0.712, 0.687, 0.858, 0.944, 0.927, 0.933, 0.835, 0.827, 0.8, 0.8, 0.764, 0.8, 0.8189, 0.8189, 0.828, 0.828, 0.92, 1.069, 1.135, 0.956, 1.079, 1.06, 1.012, 1.106, 1.087, 1.0189, 1.067, 1.155, 1.213, 1.15, 1.12, 1.07, 1.07, 1.1, 1.1}, _
                         New Double() {0.941, 0.933, 0.781, 0.847, 1.026, 1.082, 0.988, 0.86, 0.753, 0.64, 0.612, 0.64, 0.621, 0.781, 0.979, 0.913, 0.979, 1.026, 1.129, 1.393, 1.139, 1.035, 1.101, 1.0169, 0.951, 0.932, 0.847, 0.988, 0.885, 0.894, 1.0068, 1.177, 1.12, 1.206, 1.302, 1.167, 1.157, 1.119, 1.051, 0.994, 1.032, 1.022, 1.119, 1.177, 1.22, 1.3, 1.41, 1.48, 1.62, 1.58}, _
                         New Double() {0.487, 0.543, 0.447, 0.462, 0.462, 0.411, 0.426, 0.455, 0.368, 0.405, 0.471, 0.463, 0.478, 0.515, 0.587, 0.502, 0.533, 0.533, 0.525, 0.556, 0.602, 0.5629, 0.58, 0.654, 0.6959, 0.704, 0.727, 0.823, 0.919, 1.05, 1.094, 1.077, 1.234, 1.181, 1.135, 1.098, 1.162, 1.208, 1.23, 1.191, 1.239, 1.239, 1.258, 1.506, 1.487, 1.47, 1.54, 1.52, 1.65, 1.62}, _
                         New Double() {0.503, 0.456, 0.388, 0.374, 0.381, 0.378, 0.371, 0.414, 0.371, 0.4069, 0.487, 0.511, 0.488, 0.496, 0.511, 0.504, 0.557, 0.54, 0.508, 0.548, 0.483, 0.54, 0.5719, 0.592, 0.6, 0.6, 0.575, 0.634, 0.685, 0.6919, 0.728, 0.79, 0.8159, 0.861, 0.843, 0.898, 0.898, 0.972, 1.0088, 1.0, 1.0, 1.028, 1.115, 1.231, 1.319, 1.483, 1.493, 1.74, 1.93, 1.91}, _
                         New Double() {1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.2709, 1.199, 1.09, 1.18, 1.208, 1.062, 1.062, 0.969, 1.043, 1.285, 1.3879, 1.322, 1.444, 1.444, 1.397, 1.52, 1.805, 1.982, 2.137, 2.04, 2.079, 2.37, 2.487, 2.862, 3.05, 3.365, 3.73, 4.68, 4.35}, _
                         New Double() {1.557, 1.557, 1.557, 1.557, 1.557, 1.769, 1.858, 1.902, 1.99, 1.928, 2.052, 2.282, 2.194, 1.99, 2.437, 2.392, 2.609, 2.545, 2.455, 2.681, 2.626, 2.479, 2.433, 2.479, 2.47, 2.497, 2.722, 2.656, 2.872, 2.966, 3.154, 3.416, 3.53, 4.095, 4.258, 4.439, 4.191, 4.688, 4.805, 4.853, 5.0279, 4.97, 4.863, 5.222, 5.409, 6.248, 6.12, 6.663, 6.86, 7.06}, _
                         New Double() {1.056, 1.056, 1.056, 1.056, 1.056, 1.056, 1.056, 1.0209, 1.012, 1.1, 1.065, 1.056, 1.321, 1.287, 1.422, 1.359, 1.17, 1.17, 1.152, 1.062, 1.1359, 1.173, 1.154, 1.293, 1.2, 1.108, 1.099, 1.1, 1.0048, 0.901, 1.062, 1.024, 0.958, 1.149, 1.121, 1.303, 1.322, 1.427, 1.5169, 1.281, 1.488, 1.98, 2.148, 2.739, 3.48, 3.81, 4.25, 3.99, 4.95, 6.3}, _
                         New Double() {1.964, 1.676, 1.437, 1.847, 1.854, 1.881, 2.36, 2.394, 2.144, 2.846, 2.811, 2.636, 2.811, 2.97, 3.1469, 2.758, 2.652, 2.334, 2.086, 2.188, 2.261, 2.005, 1.932, 1.969, 1.859, 1.805, 2.063, 2.21, 2.652, 2.836, 2.726, 2.873, 3.306, 3.344, 3.544, 3.677, 3.591, 3.221, 3.0099, 3.308, 3.078, 3.078, 3.174, 3.725, 3.952, 4.486, 4.4269, 4.674, 5.059, 5.01}, _
                         New Double() {2.463, 2.523, 2.48, 2.437, 2.715, 3.089, 3.046, 3.559, 3.546, 3.989, 3.9, 3.767, 3.883, 4.432, 4.5, 3.593, 4.311, 4.221, 3.907, 4.132, 4.257, 4.323, 4.3869, 4.3869, 4.414, 4.003, 4.069, 3.827, 3.771, 3.603, 3.948, 4.2, 4.527, 4.676, 4.59, 4.647, 4.485, 4.581, 4.5, 4.6369, 4.559, 4.559, 4.822, 4.948, 4.929, 5.1, 5.2699, 5.65, 6.0, 5.7}, _
                         New Double() {0.754, 0.821, 0.832, 0.988, 0.931, 1.045, 0.945, 0.914, 0.98, 1.068, 1.102, 1.102, 1.331, 1.67, 1.953, 1.83, 1.61, 1.583, 1.539, 1.853, 1.761, 1.963, 2.148, 2.083, 2.12, 1.973, 2.02, 2.039, 2.19, 2.058, 2.266, 2.322, 2.379, 2.456, 2.379, 2.649, 2.774, 3.189, 3.14, 2.846, 2.817, 3.14, 3.278, 3.533, 4.0, 4.3, 4.04, 4.08, 3.99, 4.4}, _
                         New Double() {5.4589, 5.723, 5.399, 6.0599, 5.863, 6.128, 6.464, 6.241, 5.562, 5.759, 6.106, 6.035, 6.158, 6.264, 6.484, 5.5359, 5.2619, 4.925, 4.783, 4.686, 4.385, 4.42, 4.218, 4.164, 4.191, 3.459, 3.549, 3.979, 4.5679, 4.437, 4.979, 5.221, 5.352, 5.768, 5.059, 5.873, 5.538, 5.174, 5.136, 4.922, 4.961, 5.01, 5.029, 4.757, 4.806, 6.04, 6.3, 6.41, 7.5, 7.55}, _
                         New Double() {0.769, 0.76, 0.662, 0.617, 0.59, 0.742, 0.742, 0.783, 0.737, 0.71, 0.654, 0.663, 0.6909, 0.645, 0.627, 0.599, 0.663, 0.663, 0.746, 0.792, 0.854, 0.854, 0.797, 0.74, 0.712, 0.6929, 0.728, 0.787, 0.835, 0.903, 1.078, 1.2528, 1.069, 1.0088, 1.089, 1.1278, 1.277, 1.108, 1.1278, 1.385, 1.534, 1.445, 1.474, 1.732, 1.85, 2.0, 2.39, 2.46, 2.46, 2.2599}, _
                         New Double() {1.932, 1.508, 1.178, 0.895, 0.49, 1.225, 0.66, 0.49, 0.377, 0.339, 0.339, 0.594, 0.641, 0.735, 0.613, 0.5649, 0.471, 0.622, 0.5649, 0.518, 0.518, 0.603, 0.594, 0.528, 0.528, 0.471, 0.622, 0.631, 0.754, 0.773, 1.056, 1.357, 1.467, 1.477, 1.5149, 1.592, 1.6298, 1.784, 2.047, 2.175, 1.93, 2.243, 2.449, 2.39, 2.38, 1.77, 1.68, 1.3899, 1.6, 1.54}, _
                         New Double() {1.563, 1.563, 1.563, 1.667, 1.699, 1.659, 1.651, 1.659, 1.533, 1.566, 1.566, 1.566, 1.557, 1.577, 1.552, 1.527, 1.644, 1.36, 1.402, 1.627, 1.687, 1.67, 1.653, 1.619, 1.832, 2.06, 2.043, 2.209, 2.323, 2.691, 2.718, 2.586, 2.65, 2.775, 2.811, 3.0179, 3.108, 3.449, 3.322, 3.687, 3.745, 3.831, 4.07, 4.343, 4.215, 4.89, 5.7699, 5.604, 6.22, 5.8}, _
                         New Double() {1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.1, 0.893, 0.797, 0.737, 0.944, 1.034, 0.916, 0.835, 0.907, 1.18, 1.335, 1.523, 1.551, 1.6359, 1.748, 1.6359, 1.702, 1.741, 1.741, 1.635, 1.721, 1.865, 1.97, 2.194, 2.341, 2.5259, 2.7599, 3.0139, 3.14, 3.46, 3.35}, _
                         New Double() {2.332, 2.358, 2.436, 2.445, 2.55, 2.992, 2.902, 2.876, 2.673, 2.843, 2.708, 2.798, 2.997, 2.906, 3.09, 3.035, 2.999, 2.862, 2.644, 2.908, 2.824, 2.306, 2.371, 2.537, 2.5, 2.834, 2.726, 2.914, 3.14, 3.196, 3.525, 3.742, 3.971, 4.258, 3.999, 4.066, 4.086, 4.306, 4.625, 4.732, 4.508, 4.868, 4.849, 4.946, 5.2, 5.39, 5.84, 6.43, 6.5, 6.4}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The covariance matrix of the assets historical returns is:" )
      System.Console.WriteLine( " " )
      display2DArray( covariance1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ We next evaluate the expected returns of the asset being considered +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns( double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here    we  evaluate  the  expected  returns  of  the  assets  under" )
      System.Console.WriteLine( "     consideration." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    historicalReturns = {{12.85, 12.254, 12.066, 11.836, 13.078, 14.568, 12.732, 12.313, 12.375, 12.407, 11.91, 12.0, 11.784, 12.516, 13.355, 12.3, 12.764, 12.336, 12.073, 12.002, 11.405, 11.055, 10.982, 11.3859, 10.733, 9.9789, 10.242, 10.768, 10.759, 11.6329, 12.488, 12.544, 12.7929, 12.63, 13.117, 14.129, 13.929, 14.53, 15.239, 16.0539, 15.782, 16.18, 17.4609, 17.7719, 19.21, 19.181, 20.54, 19.8009, 20.343, 21.78}," )
      System.Console.WriteLine( "                        {0.905, 0.89, 0.881, 0.915, 0.915, 0.899, 0.988, 0.899, 0.997, 1.048, 1.065, 1.159, 1.374, 1.2709, 1.554, 1.404, 1.733, 1.662, 1.599, 1.777, 1.999, 1.929, 2.021, 2.066, 2.158, 2.112, 2.176, 2.372, 2.994, 3.088, 3.521, 3.521, 3.926, 3.925, 3.925, 4.117, 4.684, 4.655, 4.472, 4.404, 4.218, 4.424, 4.4429, 4.6289, 4.76, 5.73, 5.5, 5.98, 5.6, 4.5199}," )
      System.Console.WriteLine( "                        {5.5439, 5.57, 5.475, 6.121, 6.281, 5.591, 5.458, 6.245, 6.112, 6.843, 7.373, 7.553, 7.679, 7.859, 7.715, 6.967, 6.071, 6.062, 5.6689, 5.349, 5.467, 5.953, 6.121, 5.869, 5.851, 5.282, 5.776, 6.547, 6.357, 6.661, 6.985, 6.994, 7.232, 7.516, 7.196, 7.313, 7.071, 7.545, 7.854, 8.236, 8.393, 8.452, 8.747, 8.836, 9.2, 9.5399, 9.98, 9.86, 9.28, 9.55}," )
      System.Console.WriteLine( "                        {0.168, 0.14, 0.125, 0.133, 0.117, 0.113, 0.121, 0.133, 0.117, 0.129, 0.121, 0.121, 0.121, 0.125, 0.121, 0.125, 0.13, 0.138, 0.147, 0.164, 0.164, 0.191, 0.26, 0.305, 0.314, 0.314, 0.314, 0.305, 0.356, 0.356, 0.487, 0.591, 0.652, 0.6899, 0.758, 0.805, 0.873, 0.8, 0.781, 0.742, 0.673, 0.732, 0.8, 0.859, 0.81, 0.96, 1.07, 0.99, 0.97, 0.91}," )
      System.Console.WriteLine( "                        {13.559, 13.902, 15.041, 17.228, 17.038, 20.439, 21.374, 21.787, 22.3619, 22.915, 24.53, 23.831, 23.531, 24.709, 24.793, 22.119, 22.383, 21.14, 21.917, 23.0829, 21.5829, 21.024, 22.3649, 21.224, 22.5, 20.322, 18.018, 19.876, 20.354, 20.525, 21.636, 22.869, 22.685, 24.258, 23.589, 24.2689, 25.817, 25.633, 27.031, 26.639, 26.332, 27.404, 27.478, 28.909, 30.775, 33.4189, 36.737, 38.276, 37.795, 39.1}," )
      System.Console.WriteLine( "                        {2.12, 2.157, 1.907, 1.936, 1.965, 1.57, 1.301, 1.358, 0.915, 1.161, 1.3778, 1.3778, 1.609, 1.58, 1.917, 1.657, 1.551, 1.484, 1.5129, 1.676, 1.59, 1.763, 2.119, 2.062, 2.033, 1.927, 2.245, 2.678, 2.601, 2.794, 3.324, 3.487, 3.721, 4.247, 4.198, 4.5, 5.5519, 6.829, 7.063, 7.792, 8.433, 9.093, 9.014, 9.014, 9.27, 8.93, 9.17, 10.86, 11.15, 14.0}," )
      System.Console.WriteLine( "                        {1.1, 1.067, 0.975, 1.042, 1.084, 1.242, 1.166, 1.109, 0.921, 1.124, 1.116, 1.183, 1.369, 1.606, 1.978, 2.09, 1.761, 1.596, 1.266, 1.102, 1.137, 1.1278, 1.02, 0.877, 0.94, 0.832, 0.94, 0.992, 0.871, 0.992, 1.223, 1.177, 1.3798, 1.532, 1.427, 1.37, 1.275, 1.3798, 1.456, 1.495, 1.651, 1.72, 1.925, 1.925, 2.19, 2.43, 3.02, 2.81, 3.56, 3.91}," )
      System.Console.WriteLine( "                        {6.924, 7.482, 7.439, 8.048, 8.6039, 9.859, 9.904, 9.614, 10.764, 10.301, 10.074, 10.21, 10.7579, 11.009, 11.475, 12.073, 11.953, 12.091, 11.154, 11.034, 11.478, 11.487, 10.563, 10.638, 11.142, 10.797, 11.587, 12.241, 11.606, 11.862, 11.18, 11.142, 11.304, 10.725, 10.938, 11.381, 11.323, 11.314, 11.63, 11.581, 11.492, 11.188, 11.492, 12.65, 13.62, 13.38, 15.0, 15.01, 14.59, 15.56}," )
      System.Console.WriteLine( "                        {7.716, 8.617, 8.023, 8.809, 9.21, 8.8859, 8.296, 7.971, 7.338, 7.638, 8.7129, 9.109, 9.699, 10.228, 9.89, 9.3699, 9.3699, 9.032, 8.94, 8.546, 8.489, 9.09, 9.618, 9.646, 8.477, 8.696, 8.819, 8.591, 8.173, 8.318, 9.435, 10.523, 10.166, 11.283, 10.955, 11.849, 10.974, 11.917, 11.917, 11.249, 11.857, 12.289, 12.926, 13.009, 14.228, 13.722, 15.308, 15.199, 16.12, 19.14}," )
      System.Console.WriteLine( "                        {1.523, 1.6258, 1.481, 1.609, 1.763, 1.883, 1.805, 1.962, 1.796, 1.866, 1.927, 2.0059, 1.978, 2.156, 2.067, 2.076, 2.236, 1.996, 1.939, 2.119, 2.074, 1.885, 1.831, 1.804, 1.767, 1.592, 1.647, 1.923, 1.997, 2.052, 2.1269, 2.184, 2.25, 2.259, 2.447, 2.551, 2.613, 2.786, 2.498, 2.93, 3.123, 2.998, 3.239, 3.278, 3.288, 3.052, 3.2679, 3.435, 3.25, 3.24}," )
      System.Console.WriteLine( "                        {0.657, 0.65, 0.613, 0.517, 0.613, 0.5649, 0.637, 0.6919, 0.525, 0.619, 0.644, 0.67, 0.644, 0.787, 0.796, 0.805, 0.744, 0.779, 0.6929, 0.779, 0.806, 0.904, 0.886, 0.841, 0.967, 1.065, 1.067, 1.002, 1.141, 1.2609, 1.299, 1.5209, 1.66, 1.471, 1.48, 1.604, 1.757, 1.872, 1.892, 1.94, 1.804, 1.784, 1.901, 2.106, 2.34, 2.47, 2.5, 2.55, 2.55, 2.4}," )
      System.Console.WriteLine( "                        {1.056, 0.845, 0.682, 0.861, 0.742, 0.708, 0.716, 0.725, 0.6879, 0.776, 0.782, 0.757, 0.714, 0.645, 0.671, 0.584, 0.496, 0.531, 0.366, 0.392, 0.329, 0.3469, 0.262, 0.2, 0.258, 0.236, 0.226, 0.258, 0.304, 0.336, 0.387, 0.419, 0.419, 0.429, 0.467, 0.458, 0.534, 0.524, 0.536, 0.526, 0.526, 0.546, 0.624, 0.604, 0.6, 0.59, 0.62, 0.68, 0.7, 0.67}," )
      System.Console.WriteLine( "                        {1.287, 1.355, 1.2709, 1.677, 1.868, 1.85, 1.79, 1.945, 1.749, 1.767, 2.032, 2.294, 2.403, 2.871, 2.765, 2.657, 2.747, 2.702, 2.549, 2.594, 2.324, 2.361, 2.379, 2.517, 2.7, 2.562, 2.619, 2.629, 2.629, 2.676, 2.928, 3.62, 3.547, 3.89, 3.766, 4.062, 4.138, 4.147, 4.04, 4.418, 4.865, 4.952, 5.186, 5.691, 5.882, 6.692, 6.366, 6.218, 7.106, 7.383}," )
      System.Console.WriteLine( "                        {3.828, 4.158, 4.3949, 4.623, 4.424, 4.785, 5.431, 6.862, 6.065, 7.225, 7.614, 7.643, 8.6649, 8.209, 8.243, 7.829, 8.1969, 8.252, 6.908, 7.515, 6.723, 6.252, 6.373, 6.485, 6.429, 4.992, 4.78, 5.429, 5.648, 5.858, 6.364, 6.583, 7.108, 7.102, 6.772, 6.918, 6.801, 7.209, 7.653, 7.495, 8.1359, 8.146, 8.0079, 9.251, 9.408, 10.5, 11.4, 11.45, 12.05, 13.7}," )
      System.Console.WriteLine( "                        {0.422, 0.422, 0.352, 0.381, 0.423, 0.394, 0.381, 0.39, 0.351, 0.413, 0.536, 0.5709, 0.536, 0.553, 0.5709, 0.562, 0.707, 0.6889, 0.616, 0.707, 0.766, 0.858, 0.886, 0.932, 0.987, 0.987, 1.028, 1.2, 1.238, 1.409, 1.466, 1.79, 1.79, 1.771, 1.973, 2.108, 2.05, 2.021, 1.951, 2.1389, 2.129, 2.1389, 2.365, 2.375, 2.35, 2.63, 2.67, 1.93, 1.98, 1.92}," )
      System.Console.WriteLine( "                        {1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.732, 1.656, 1.704, 1.865, 1.903, 1.942, 2.2839, 2.475, 2.953, 3.273, 3.041, 3.166, 3.099, 3.099, 3.15, 2.992, 2.904, 2.855, 3.248, 3.849, 3.9, 5.26, 5.46, 5.67, 5.94, 6.2}," )
      System.Console.WriteLine( "                        {3.932, 4.151, 3.809, 3.769, 3.688, 3.89, 4.26, 4.651, 4.86, 4.467, 4.753, 5.324, 5.67, 5.2, 5.233, 5.404, 5.45, 5.747, 5.675, 5.702, 5.382, 4.817, 4.89, 4.808, 5.227, 5.287, 5.249, 5.287, 5.082, 5.305, 5.444, 5.35, 5.407, 5.567, 5.756, 5.889, 6.002, 6.354, 6.576, 6.643, 6.923, 6.682, 6.768, 7.106, 6.89, 7.223, 7.312, 7.979, 7.704, 8.18}," )
      System.Console.WriteLine( "                        {14.362, 13.171, 11.0559, 12.342, 10.528, 11.0559, 10.5719, 9.405, 9.813, 9.8859, 10.558, 11.578, 11.891, 10.625, 10.518, 10.446, 9.278, 9.467, 9.134, 9.981, 9.147, 8.993, 9.048, 8.803, 8.205, 8.025, 8.569, 9.315, 7.841, 7.694, 7.988, 9.955, 9.673, 10.528, 9.861, 9.438, 9.748, 9.47, 9.785, 10.206, 9.709, 9.833, 9.948, 10.9149, 11.189, 11.307, 11.953, 12.982, 13.374, 12.4}," )
      System.Console.WriteLine( "                        {0.63, 0.6899, 0.851, 0.995, 0.963, 0.912, 0.849, 0.954, 0.791, 0.869, 0.938, 0.988, 1.078, 1.125, 1.381, 1.483, 1.718, 1.62, 1.533, 1.738, 1.891, 1.864, 1.98, 1.99, 2.1429, 2.341, 2.232, 2.395, 2.558, 2.75, 2.878, 2.868, 3.06, 3.084, 2.824, 3.0, 2.727, 2.925, 2.871, 2.978, 3.233, 3.214, 3.324, 3.515, 3.618, 4.13, 4.2, 4.73, 4.53, 4.48}," )
      System.Console.WriteLine( "                        {0.924, 0.939, 0.5639, 0.806, 0.742, 0.726, 0.677, 0.806, 0.676, 0.751, 0.735, 0.751, 0.735, 0.777, 0.747, 0.712, 0.687, 0.858, 0.944, 0.927, 0.933, 0.835, 0.827, 0.8, 0.8, 0.764, 0.8, 0.8189, 0.8189, 0.828, 0.828, 0.92, 1.069, 1.135, 0.956, 1.079, 1.06, 1.012, 1.106, 1.087, 1.0189, 1.067, 1.155, 1.213, 1.15, 1.12, 1.07, 1.07, 1.1, 1.1}," )
      System.Console.WriteLine( "                        {0.941, 0.933, 0.781, 0.847, 1.026, 1.082, 0.988, 0.86, 0.753, 0.64, 0.612, 0.64, 0.621, 0.781, 0.979, 0.913, 0.979, 1.026, 1.129, 1.393, 1.139, 1.035, 1.101, 1.0169, 0.951, 0.932, 0.847, 0.988, 0.885, 0.894, 1.0068, 1.177, 1.12, 1.206, 1.302, 1.167, 1.157, 1.119, 1.051, 0.994, 1.032, 1.022, 1.119, 1.177, 1.22, 1.3, 1.41, 1.48, 1.62, 1.58}," )
      System.Console.WriteLine( "                        {0.487, 0.543, 0.447, 0.462, 0.462, 0.411, 0.426, 0.455, 0.368, 0.405, 0.471, 0.463, 0.478, 0.515, 0.587, 0.502, 0.533, 0.533, 0.525, 0.556, 0.602, 0.5629, 0.58, 0.654, 0.6959, 0.704, 0.727, 0.823, 0.919, 1.05, 1.094, 1.077, 1.234, 1.181, 1.135, 1.098, 1.162, 1.208, 1.23, 1.191, 1.239, 1.239, 1.258, 1.506, 1.487, 1.47, 1.54, 1.52, 1.65, 1.62}," )
      System.Console.WriteLine( "                        {0.503, 0.456, 0.388, 0.374, 0.381, 0.378, 0.371, 0.414, 0.371, 0.4069, 0.487, 0.511, 0.488, 0.496, 0.511, 0.504, 0.557, 0.54, 0.508, 0.548, 0.483, 0.54, 0.5719, 0.592, 0.6, 0.6, 0.575, 0.634, 0.685, 0.6919, 0.728, 0.79, 0.8159, 0.861, 0.843, 0.898, 0.898, 0.972, 1.0088, 1.0, 1.0, 1.028, 1.115, 1.231, 1.319, 1.483, 1.493, 1.74, 1.93, 1.91}," )
      System.Console.WriteLine( "                        {1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.2709, 1.199, 1.09, 1.18, 1.208, 1.062, 1.062, 0.969, 1.043, 1.285, 1.3879, 1.322, 1.444, 1.444, 1.397, 1.52, 1.805, 1.982, 2.137, 2.04, 2.079, 2.37, 2.487, 2.862, 3.05, 3.365, 3.73, 4.68, 4.35}," )
      System.Console.WriteLine( "                        {1.557, 1.557, 1.557, 1.557, 1.557, 1.769, 1.858, 1.902, 1.99, 1.928, 2.052, 2.282, 2.194, 1.99, 2.437, 2.392, 2.609, 2.545, 2.455, 2.681, 2.626, 2.479, 2.433, 2.479, 2.47, 2.497, 2.722, 2.656, 2.872, 2.966, 3.154, 3.416, 3.53, 4.095, 4.258, 4.439, 4.191, 4.688, 4.805, 4.853, 5.0279, 4.97, 4.863, 5.222, 5.409, 6.248, 6.12, 6.663, 6.86, 7.06}," )
      System.Console.WriteLine( "                        {1.056, 1.056, 1.056, 1.056, 1.056, 1.056, 1.056, 1.0209, 1.012, 1.1, 1.065, 1.056, 1.321, 1.287, 1.422, 1.359, 1.17, 1.17, 1.152, 1.062, 1.1359, 1.173, 1.154, 1.293, 1.2, 1.108, 1.099, 1.1, 1.0048, 0.901, 1.062, 1.024, 0.958, 1.149, 1.121, 1.303, 1.322, 1.427, 1.5169, 1.281, 1.488, 1.98, 2.148, 2.739, 3.48, 3.81, 4.25, 3.99, 4.95, 6.3}," )
      System.Console.WriteLine( "                        {1.964, 1.676, 1.437, 1.847, 1.854, 1.881, 2.36, 2.394, 2.144, 2.846, 2.811, 2.636, 2.811, 2.97, 3.1469, 2.758, 2.652, 2.334, 2.086, 2.188, 2.261, 2.005, 1.932, 1.969, 1.859, 1.805, 2.063, 2.21, 2.652, 2.836, 2.726, 2.873, 3.306, 3.344, 3.544, 3.677, 3.591, 3.221, 3.0099, 3.308, 3.078, 3.078, 3.174, 3.725, 3.952, 4.486, 4.4269, 4.674, 5.059, 5.01}," )
      System.Console.WriteLine( "                        {2.463, 2.523, 2.48, 2.437, 2.715, 3.089, 3.046, 3.559, 3.546, 3.989, 3.9, 3.767, 3.883, 4.432, 4.5, 3.593, 4.311, 4.221, 3.907, 4.132, 4.257, 4.323, 4.3869, 4.3869, 4.414, 4.003, 4.069, 3.827, 3.771, 3.603, 3.948, 4.2, 4.527, 4.676, 4.59, 4.647, 4.485, 4.581, 4.5, 4.6369, 4.559, 4.559, 4.822, 4.948, 4.929, 5.1, 5.2699, 5.65, 6.0, 5.7}," )
      System.Console.WriteLine( "                        {0.754, 0.821, 0.832, 0.988, 0.931, 1.045, 0.945, 0.914, 0.98, 1.068, 1.102, 1.102, 1.331, 1.67, 1.953, 1.83, 1.61, 1.583, 1.539, 1.853, 1.761, 1.963, 2.148, 2.083, 2.12, 1.973, 2.02, 2.039, 2.19, 2.058, 2.266, 2.322, 2.379, 2.456, 2.379, 2.649, 2.774, 3.189, 3.14, 2.846, 2.817, 3.14, 3.278, 3.533, 4.0, 4.3, 4.04, 4.08, 3.99, 4.4}," )
      System.Console.WriteLine( "                        {5.4589, 5.723, 5.399, 6.0599, 5.863, 6.128, 6.464, 6.241, 5.562, 5.759, 6.106, 6.035, 6.158, 6.264, 6.484, 5.5359, 5.2619, 4.925, 4.783, 4.686, 4.385, 4.42, 4.218, 4.164, 4.191, 3.459, 3.549, 3.979, 4.5679, 4.437, 4.979, 5.221, 5.352, 5.768, 5.059, 5.873, 5.538, 5.174, 5.136, 4.922, 4.961, 5.01, 5.029, 4.757, 4.806, 6.04, 6.3, 6.41, 7.5, 7.55}," )
      System.Console.WriteLine( "                        {0.769, 0.76, 0.662, 0.617, 0.59, 0.742, 0.742, 0.783, 0.737, 0.71, 0.654, 0.663, 0.6909, 0.645, 0.627, 0.599, 0.663, 0.663, 0.746, 0.792, 0.854, 0.854, 0.797, 0.74, 0.712, 0.6929, 0.728, 0.787, 0.835, 0.903, 1.078, 1.2528, 1.069, 1.0088, 1.089, 1.1278, 1.277, 1.108, 1.1278, 1.385, 1.534, 1.445, 1.474, 1.732, 1.85, 2.0, 2.39, 2.46, 2.46, 2.2599}," )
      System.Console.WriteLine( "                        {1.932, 1.508, 1.178, 0.895, 0.49, 1.225, 0.66, 0.49, 0.377, 0.339, 0.339, 0.594, 0.641, 0.735, 0.613, 0.5649, 0.471, 0.622, 0.5649, 0.518, 0.518, 0.603, 0.594, 0.528, 0.528, 0.471, 0.622, 0.631, 0.754, 0.773, 1.056, 1.357, 1.467, 1.477, 1.5149, 1.592, 1.6298, 1.784, 2.047, 2.175, 1.93, 2.243, 2.449, 2.39, 2.38, 1.77, 1.68, 1.3899, 1.6, 1.54}," )
      System.Console.WriteLine( "                        {1.563, 1.563, 1.563, 1.667, 1.699, 1.659, 1.651, 1.659, 1.533, 1.566, 1.566, 1.566, 1.557, 1.577, 1.552, 1.527, 1.644, 1.36, 1.402, 1.627, 1.687, 1.67, 1.653, 1.619, 1.832, 2.06, 2.043, 2.209, 2.323, 2.691, 2.718, 2.586, 2.65, 2.775, 2.811, 3.0179, 3.108, 3.449, 3.322, 3.687, 3.745, 3.831, 4.07, 4.343, 4.215, 4.89, 5.7699, 5.604, 6.22, 5.8}," )
      System.Console.WriteLine( "                        {1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.1, 0.893, 0.797, 0.737, 0.944, 1.034, 0.916, 0.835, 0.907, 1.18, 1.335, 1.523, 1.551, 1.6359, 1.748, 1.6359, 1.702, 1.741, 1.741, 1.635, 1.721, 1.865, 1.97, 2.194, 2.341, 2.5259, 2.7599, 3.0139, 3.14, 3.46, 3.35}," )
      System.Console.WriteLine( "                        {2.332, 2.358, 2.436, 2.445, 2.55, 2.992, 2.902, 2.876, 2.673, 2.843, 2.708, 2.798, 2.997, 2.906, 3.09, 3.035, 2.999, 2.862, 2.644, 2.908, 2.824, 2.306, 2.371, 2.537, 2.5, 2.834, 2.726, 2.914, 3.14, 3.196, 3.525, 3.742, 3.971, 4.258, 3.999, 4.066, 4.086, 4.306, 4.625, 4.732, 4.508, 4.868, 4.849, 4.946, 5.2, 5.39, 5.84, 6.43, 6.5, 6.4}}" )
      ' Here       we  evaluate  the  expcted  returns  of  the  assets  under
      ' consideration.
      Dim expectedReturns1 As Double() = instanceOfAssetParameters.ExpectedReturns( _
         New Double()() {New Double() {12.85, 12.254, 12.066, 11.836, 13.078, 14.568, 12.732, 12.313, 12.375, 12.407, 11.91, 12.0, 11.784, 12.516, 13.355, 12.3, 12.764, 12.336, 12.073, 12.002, 11.405, 11.055, 10.982, 11.3859, 10.733, 9.9789, 10.242, 10.768, 10.759, 11.6329, 12.488, 12.544, 12.7929, 12.63, 13.117, 14.129, 13.929, 14.53, 15.239, 16.0539, 15.782, 16.18, 17.4609, 17.7719, 19.21, 19.181, 20.54, 19.8009, 20.343, 21.78}, _
                         New Double() {0.905, 0.89, 0.881, 0.915, 0.915, 0.899, 0.988, 0.899, 0.997, 1.048, 1.065, 1.159, 1.374, 1.2709, 1.554, 1.404, 1.733, 1.662, 1.599, 1.777, 1.999, 1.929, 2.021, 2.066, 2.158, 2.112, 2.176, 2.372, 2.994, 3.088, 3.521, 3.521, 3.926, 3.925, 3.925, 4.117, 4.684, 4.655, 4.472, 4.404, 4.218, 4.424, 4.4429, 4.6289, 4.76, 5.73, 5.5, 5.98, 5.6, 4.5199}, _
                         New Double() {5.5439, 5.57, 5.475, 6.121, 6.281, 5.591, 5.458, 6.245, 6.112, 6.843, 7.373, 7.553, 7.679, 7.859, 7.715, 6.967, 6.071, 6.062, 5.6689, 5.349, 5.467, 5.953, 6.121, 5.869, 5.851, 5.282, 5.776, 6.547, 6.357, 6.661, 6.985, 6.994, 7.232, 7.516, 7.196, 7.313, 7.071, 7.545, 7.854, 8.236, 8.393, 8.452, 8.747, 8.836, 9.2, 9.5399, 9.98, 9.86, 9.28, 9.55}, _
                         New Double() {0.168, 0.14, 0.125, 0.133, 0.117, 0.113, 0.121, 0.133, 0.117, 0.129, 0.121, 0.121, 0.121, 0.125, 0.121, 0.125, 0.13, 0.138, 0.147, 0.164, 0.164, 0.191, 0.26, 0.305, 0.314, 0.314, 0.314, 0.305, 0.356, 0.356, 0.487, 0.591, 0.652, 0.6899, 0.758, 0.805, 0.873, 0.8, 0.781, 0.742, 0.673, 0.732, 0.8, 0.859, 0.81, 0.96, 1.07, 0.99, 0.97, 0.91}, _
                         New Double() {13.559, 13.902, 15.041, 17.228, 17.038, 20.439, 21.374, 21.787, 22.3619, 22.915, 24.53, 23.831, 23.531, 24.709, 24.793, 22.119, 22.383, 21.14, 21.917, 23.0829, 21.5829, 21.024, 22.3649, 21.224, 22.5, 20.322, 18.018, 19.876, 20.354, 20.525, 21.636, 22.869, 22.685, 24.258, 23.589, 24.2689, 25.817, 25.633, 27.031, 26.639, 26.332, 27.404, 27.478, 28.909, 30.775, 33.4189, 36.737, 38.276, 37.795, 39.1}, _
                         New Double() {2.12, 2.157, 1.907, 1.936, 1.965, 1.57, 1.301, 1.358, 0.915, 1.161, 1.3778, 1.3778, 1.609, 1.58, 1.917, 1.657, 1.551, 1.484, 1.5129, 1.676, 1.59, 1.763, 2.119, 2.062, 2.033, 1.927, 2.245, 2.678, 2.601, 2.794, 3.324, 3.487, 3.721, 4.247, 4.198, 4.5, 5.5519, 6.829, 7.063, 7.792, 8.433, 9.093, 9.014, 9.014, 9.27, 8.93, 9.17, 10.86, 11.15, 14.0}, _
                         New Double() {1.1, 1.067, 0.975, 1.042, 1.084, 1.242, 1.166, 1.109, 0.921, 1.124, 1.116, 1.183, 1.369, 1.606, 1.978, 2.09, 1.761, 1.596, 1.266, 1.102, 1.137, 1.1278, 1.02, 0.877, 0.94, 0.832, 0.94, 0.992, 0.871, 0.992, 1.223, 1.177, 1.3798, 1.532, 1.427, 1.37, 1.275, 1.3798, 1.456, 1.495, 1.651, 1.72, 1.925, 1.925, 2.19, 2.43, 3.02, 2.81, 3.56, 3.91}, _
                         New Double() {6.924, 7.482, 7.439, 8.048, 8.6039, 9.859, 9.904, 9.614, 10.764, 10.301, 10.074, 10.21, 10.7579, 11.009, 11.475, 12.073, 11.953, 12.091, 11.154, 11.034, 11.478, 11.487, 10.563, 10.638, 11.142, 10.797, 11.587, 12.241, 11.606, 11.862, 11.18, 11.142, 11.304, 10.725, 10.938, 11.381, 11.323, 11.314, 11.63, 11.581, 11.492, 11.188, 11.492, 12.65, 13.62, 13.38, 15.0, 15.01, 14.59, 15.56}, _
                         New Double() {7.716, 8.617, 8.023, 8.809, 9.21, 8.8859, 8.296, 7.971, 7.338, 7.638, 8.7129, 9.109, 9.699, 10.228, 9.89, 9.3699, 9.3699, 9.032, 8.94, 8.546, 8.489, 9.09, 9.618, 9.646, 8.477, 8.696, 8.819, 8.591, 8.173, 8.318, 9.435, 10.523, 10.166, 11.283, 10.955, 11.849, 10.974, 11.917, 11.917, 11.249, 11.857, 12.289, 12.926, 13.009, 14.228, 13.722, 15.308, 15.199, 16.12, 19.14}, _
                         New Double() {1.523, 1.6258, 1.481, 1.609, 1.763, 1.883, 1.805, 1.962, 1.796, 1.866, 1.927, 2.0059, 1.978, 2.156, 2.067, 2.076, 2.236, 1.996, 1.939, 2.119, 2.074, 1.885, 1.831, 1.804, 1.767, 1.592, 1.647, 1.923, 1.997, 2.052, 2.1269, 2.184, 2.25, 2.259, 2.447, 2.551, 2.613, 2.786, 2.498, 2.93, 3.123, 2.998, 3.239, 3.278, 3.288, 3.052, 3.2679, 3.435, 3.25, 3.24}, _
                         New Double() {0.657, 0.65, 0.613, 0.517, 0.613, 0.5649, 0.637, 0.6919, 0.525, 0.619, 0.644, 0.67, 0.644, 0.787, 0.796, 0.805, 0.744, 0.779, 0.6929, 0.779, 0.806, 0.904, 0.886, 0.841, 0.967, 1.065, 1.067, 1.002, 1.141, 1.2609, 1.299, 1.5209, 1.66, 1.471, 1.48, 1.604, 1.757, 1.872, 1.892, 1.94, 1.804, 1.784, 1.901, 2.106, 2.34, 2.47, 2.5, 2.55, 2.55, 2.4}, _
                         New Double() {1.056, 0.845, 0.682, 0.861, 0.742, 0.708, 0.716, 0.725, 0.6879, 0.776, 0.782, 0.757, 0.714, 0.645, 0.671, 0.584, 0.496, 0.531, 0.366, 0.392, 0.329, 0.3469, 0.262, 0.2, 0.258, 0.236, 0.226, 0.258, 0.304, 0.336, 0.387, 0.419, 0.419, 0.429, 0.467, 0.458, 0.534, 0.524, 0.536, 0.526, 0.526, 0.546, 0.624, 0.604, 0.6, 0.59, 0.62, 0.68, 0.7, 0.67}, _
                         New Double() {1.287, 1.355, 1.2709, 1.677, 1.868, 1.85, 1.79, 1.945, 1.749, 1.767, 2.032, 2.294, 2.403, 2.871, 2.765, 2.657, 2.747, 2.702, 2.549, 2.594, 2.324, 2.361, 2.379, 2.517, 2.7, 2.562, 2.619, 2.629, 2.629, 2.676, 2.928, 3.62, 3.547, 3.89, 3.766, 4.062, 4.138, 4.147, 4.04, 4.418, 4.865, 4.952, 5.186, 5.691, 5.882, 6.692, 6.366, 6.218, 7.106, 7.383}, _
                         New Double() {3.828, 4.158, 4.3949, 4.623, 4.424, 4.785, 5.431, 6.862, 6.065, 7.225, 7.614, 7.643, 8.6649, 8.209, 8.243, 7.829, 8.1969, 8.252, 6.908, 7.515, 6.723, 6.252, 6.373, 6.485, 6.429, 4.992, 4.78, 5.429, 5.648, 5.858, 6.364, 6.583, 7.108, 7.102, 6.772, 6.918, 6.801, 7.209, 7.653, 7.495, 8.1359, 8.146, 8.0079, 9.251, 9.408, 10.5, 11.4, 11.45, 12.05, 13.7}, _
                         New Double() {0.422, 0.422, 0.352, 0.381, 0.423, 0.394, 0.381, 0.39, 0.351, 0.413, 0.536, 0.5709, 0.536, 0.553, 0.5709, 0.562, 0.707, 0.6889, 0.616, 0.707, 0.766, 0.858, 0.886, 0.932, 0.987, 0.987, 1.028, 1.2, 1.238, 1.409, 1.466, 1.79, 1.79, 1.771, 1.973, 2.108, 2.05, 2.021, 1.951, 2.1389, 2.129, 2.1389, 2.365, 2.375, 2.35, 2.63, 2.67, 1.93, 1.98, 1.92}, _
                         New Double() {1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.732, 1.656, 1.704, 1.865, 1.903, 1.942, 2.2839, 2.475, 2.953, 3.273, 3.041, 3.166, 3.099, 3.099, 3.15, 2.992, 2.904, 2.855, 3.248, 3.849, 3.9, 5.26, 5.46, 5.67, 5.94, 6.2}, _
                         New Double() {3.932, 4.151, 3.809, 3.769, 3.688, 3.89, 4.26, 4.651, 4.86, 4.467, 4.753, 5.324, 5.67, 5.2, 5.233, 5.404, 5.45, 5.747, 5.675, 5.702, 5.382, 4.817, 4.89, 4.808, 5.227, 5.287, 5.249, 5.287, 5.082, 5.305, 5.444, 5.35, 5.407, 5.567, 5.756, 5.889, 6.002, 6.354, 6.576, 6.643, 6.923, 6.682, 6.768, 7.106, 6.89, 7.223, 7.312, 7.979, 7.704, 8.18}, _
                         New Double() {14.362, 13.171, 11.0559, 12.342, 10.528, 11.0559, 10.5719, 9.405, 9.813, 9.8859, 10.558, 11.578, 11.891, 10.625, 10.518, 10.446, 9.278, 9.467, 9.134, 9.981, 9.147, 8.993, 9.048, 8.803, 8.205, 8.025, 8.569, 9.315, 7.841, 7.694, 7.988, 9.955, 9.673, 10.528, 9.861, 9.438, 9.748, 9.47, 9.785, 10.206, 9.709, 9.833, 9.948, 10.9149, 11.189, 11.307, 11.953, 12.982, 13.374, 12.4}, _
                         New Double() {0.63, 0.6899, 0.851, 0.995, 0.963, 0.912, 0.849, 0.954, 0.791, 0.869, 0.938, 0.988, 1.078, 1.125, 1.381, 1.483, 1.718, 1.62, 1.533, 1.738, 1.891, 1.864, 1.98, 1.99, 2.1429, 2.341, 2.232, 2.395, 2.558, 2.75, 2.878, 2.868, 3.06, 3.084, 2.824, 3.0, 2.727, 2.925, 2.871, 2.978, 3.233, 3.214, 3.324, 3.515, 3.618, 4.13, 4.2, 4.73, 4.53, 4.48}, _
                         New Double() {0.924, 0.939, 0.5639, 0.806, 0.742, 0.726, 0.677, 0.806, 0.676, 0.751, 0.735, 0.751, 0.735, 0.777, 0.747, 0.712, 0.687, 0.858, 0.944, 0.927, 0.933, 0.835, 0.827, 0.8, 0.8, 0.764, 0.8, 0.8189, 0.8189, 0.828, 0.828, 0.92, 1.069, 1.135, 0.956, 1.079, 1.06, 1.012, 1.106, 1.087, 1.0189, 1.067, 1.155, 1.213, 1.15, 1.12, 1.07, 1.07, 1.1, 1.1}, _
                         New Double() {0.941, 0.933, 0.781, 0.847, 1.026, 1.082, 0.988, 0.86, 0.753, 0.64, 0.612, 0.64, 0.621, 0.781, 0.979, 0.913, 0.979, 1.026, 1.129, 1.393, 1.139, 1.035, 1.101, 1.0169, 0.951, 0.932, 0.847, 0.988, 0.885, 0.894, 1.0068, 1.177, 1.12, 1.206, 1.302, 1.167, 1.157, 1.119, 1.051, 0.994, 1.032, 1.022, 1.119, 1.177, 1.22, 1.3, 1.41, 1.48, 1.62, 1.58}, _
                         New Double() {0.487, 0.543, 0.447, 0.462, 0.462, 0.411, 0.426, 0.455, 0.368, 0.405, 0.471, 0.463, 0.478, 0.515, 0.587, 0.502, 0.533, 0.533, 0.525, 0.556, 0.602, 0.5629, 0.58, 0.654, 0.6959, 0.704, 0.727, 0.823, 0.919, 1.05, 1.094, 1.077, 1.234, 1.181, 1.135, 1.098, 1.162, 1.208, 1.23, 1.191, 1.239, 1.239, 1.258, 1.506, 1.487, 1.47, 1.54, 1.52, 1.65, 1.62}, _
                         New Double() {0.503, 0.456, 0.388, 0.374, 0.381, 0.378, 0.371, 0.414, 0.371, 0.4069, 0.487, 0.511, 0.488, 0.496, 0.511, 0.504, 0.557, 0.54, 0.508, 0.548, 0.483, 0.54, 0.5719, 0.592, 0.6, 0.6, 0.575, 0.634, 0.685, 0.6919, 0.728, 0.79, 0.8159, 0.861, 0.843, 0.898, 0.898, 0.972, 1.0088, 1.0, 1.0, 1.028, 1.115, 1.231, 1.319, 1.483, 1.493, 1.74, 1.93, 1.91}, _
                         New Double() {1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.2709, 1.199, 1.09, 1.18, 1.208, 1.062, 1.062, 0.969, 1.043, 1.285, 1.3879, 1.322, 1.444, 1.444, 1.397, 1.52, 1.805, 1.982, 2.137, 2.04, 2.079, 2.37, 2.487, 2.862, 3.05, 3.365, 3.73, 4.68, 4.35}, _
                         New Double() {1.557, 1.557, 1.557, 1.557, 1.557, 1.769, 1.858, 1.902, 1.99, 1.928, 2.052, 2.282, 2.194, 1.99, 2.437, 2.392, 2.609, 2.545, 2.455, 2.681, 2.626, 2.479, 2.433, 2.479, 2.47, 2.497, 2.722, 2.656, 2.872, 2.966, 3.154, 3.416, 3.53, 4.095, 4.258, 4.439, 4.191, 4.688, 4.805, 4.853, 5.0279, 4.97, 4.863, 5.222, 5.409, 6.248, 6.12, 6.663, 6.86, 7.06}, _
                         New Double() {1.056, 1.056, 1.056, 1.056, 1.056, 1.056, 1.056, 1.0209, 1.012, 1.1, 1.065, 1.056, 1.321, 1.287, 1.422, 1.359, 1.17, 1.17, 1.152, 1.062, 1.1359, 1.173, 1.154, 1.293, 1.2, 1.108, 1.099, 1.1, 1.0048, 0.901, 1.062, 1.024, 0.958, 1.149, 1.121, 1.303, 1.322, 1.427, 1.5169, 1.281, 1.488, 1.98, 2.148, 2.739, 3.48, 3.81, 4.25, 3.99, 4.95, 6.3}, _
                         New Double() {1.964, 1.676, 1.437, 1.847, 1.854, 1.881, 2.36, 2.394, 2.144, 2.846, 2.811, 2.636, 2.811, 2.97, 3.1469, 2.758, 2.652, 2.334, 2.086, 2.188, 2.261, 2.005, 1.932, 1.969, 1.859, 1.805, 2.063, 2.21, 2.652, 2.836, 2.726, 2.873, 3.306, 3.344, 3.544, 3.677, 3.591, 3.221, 3.0099, 3.308, 3.078, 3.078, 3.174, 3.725, 3.952, 4.486, 4.4269, 4.674, 5.059, 5.01}, _
                         New Double() {2.463, 2.523, 2.48, 2.437, 2.715, 3.089, 3.046, 3.559, 3.546, 3.989, 3.9, 3.767, 3.883, 4.432, 4.5, 3.593, 4.311, 4.221, 3.907, 4.132, 4.257, 4.323, 4.3869, 4.3869, 4.414, 4.003, 4.069, 3.827, 3.771, 3.603, 3.948, 4.2, 4.527, 4.676, 4.59, 4.647, 4.485, 4.581, 4.5, 4.6369, 4.559, 4.559, 4.822, 4.948, 4.929, 5.1, 5.2699, 5.65, 6.0, 5.7}, _
                         New Double() {0.754, 0.821, 0.832, 0.988, 0.931, 1.045, 0.945, 0.914, 0.98, 1.068, 1.102, 1.102, 1.331, 1.67, 1.953, 1.83, 1.61, 1.583, 1.539, 1.853, 1.761, 1.963, 2.148, 2.083, 2.12, 1.973, 2.02, 2.039, 2.19, 2.058, 2.266, 2.322, 2.379, 2.456, 2.379, 2.649, 2.774, 3.189, 3.14, 2.846, 2.817, 3.14, 3.278, 3.533, 4.0, 4.3, 4.04, 4.08, 3.99, 4.4}, _
                         New Double() {5.4589, 5.723, 5.399, 6.0599, 5.863, 6.128, 6.464, 6.241, 5.562, 5.759, 6.106, 6.035, 6.158, 6.264, 6.484, 5.5359, 5.2619, 4.925, 4.783, 4.686, 4.385, 4.42, 4.218, 4.164, 4.191, 3.459, 3.549, 3.979, 4.5679, 4.437, 4.979, 5.221, 5.352, 5.768, 5.059, 5.873, 5.538, 5.174, 5.136, 4.922, 4.961, 5.01, 5.029, 4.757, 4.806, 6.04, 6.3, 6.41, 7.5, 7.55}, _
                         New Double() {0.769, 0.76, 0.662, 0.617, 0.59, 0.742, 0.742, 0.783, 0.737, 0.71, 0.654, 0.663, 0.6909, 0.645, 0.627, 0.599, 0.663, 0.663, 0.746, 0.792, 0.854, 0.854, 0.797, 0.74, 0.712, 0.6929, 0.728, 0.787, 0.835, 0.903, 1.078, 1.2528, 1.069, 1.0088, 1.089, 1.1278, 1.277, 1.108, 1.1278, 1.385, 1.534, 1.445, 1.474, 1.732, 1.85, 2.0, 2.39, 2.46, 2.46, 2.2599}, _
                         New Double() {1.932, 1.508, 1.178, 0.895, 0.49, 1.225, 0.66, 0.49, 0.377, 0.339, 0.339, 0.594, 0.641, 0.735, 0.613, 0.5649, 0.471, 0.622, 0.5649, 0.518, 0.518, 0.603, 0.594, 0.528, 0.528, 0.471, 0.622, 0.631, 0.754, 0.773, 1.056, 1.357, 1.467, 1.477, 1.5149, 1.592, 1.6298, 1.784, 2.047, 2.175, 1.93, 2.243, 2.449, 2.39, 2.38, 1.77, 1.68, 1.3899, 1.6, 1.54}, _
                         New Double() {1.563, 1.563, 1.563, 1.667, 1.699, 1.659, 1.651, 1.659, 1.533, 1.566, 1.566, 1.566, 1.557, 1.577, 1.552, 1.527, 1.644, 1.36, 1.402, 1.627, 1.687, 1.67, 1.653, 1.619, 1.832, 2.06, 2.043, 2.209, 2.323, 2.691, 2.718, 2.586, 2.65, 2.775, 2.811, 3.0179, 3.108, 3.449, 3.322, 3.687, 3.745, 3.831, 4.07, 4.343, 4.215, 4.89, 5.7699, 5.604, 6.22, 5.8}, _
                         New Double() {1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.1, 0.893, 0.797, 0.737, 0.944, 1.034, 0.916, 0.835, 0.907, 1.18, 1.335, 1.523, 1.551, 1.6359, 1.748, 1.6359, 1.702, 1.741, 1.741, 1.635, 1.721, 1.865, 1.97, 2.194, 2.341, 2.5259, 2.7599, 3.0139, 3.14, 3.46, 3.35}, _
                         New Double() {2.332, 2.358, 2.436, 2.445, 2.55, 2.992, 2.902, 2.876, 2.673, 2.843, 2.708, 2.798, 2.997, 2.906, 3.09, 3.035, 2.999, 2.862, 2.644, 2.908, 2.824, 2.306, 2.371, 2.537, 2.5, 2.834, 2.726, 2.914, 3.14, 3.196, 3.525, 3.742, 3.971, 4.258, 3.999, 4.066, 4.086, 4.306, 4.625, 4.732, 4.508, 4.868, 4.849, 4.946, 5.2, 5.39, 5.84, 6.43, 6.5, 6.4}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected return of the assets are:" )
      System.Console.WriteLine( " " )
      displayArray( expectedReturns1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Minimum  value  of  the  expected  return  over  which  the  Efficient +" )
      System.Console.WriteLine( "+ Frontier exits                                                         +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    minFrontierReturn( double[] expectedReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the minimum  expected  return  of  the  range  over" )
      System.Console.WriteLine( "     which the Efficient Frontier  exits.  As  a  general  remark  it  is" )
      System.Console.WriteLine( "     usually best to evaluate the range of the  expected  return  of  the" )
      System.Console.WriteLine( "     Efficient Frontier in order  to  provide  a  range  over  which  the" )
      System.Console.WriteLine( "     Efficient Frontier can be evaluated and the  range  over  which  the" )
      System.Console.WriteLine( "     optimal portfolio can be sort." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" )
      Dim min1 As Double = instanceOfCapitalMarket.MinFrontierReturn( _
         expectedReturns1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The minimum  bound  of  the  range  of  the  expected  return  of  the" )
      System.Console.WriteLine( "    Efficient Frontier is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( min1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Maximum  value  of  the  expected  return  over  which  the  Efficient +" )
      System.Console.WriteLine( "+ Frontier exits                                                         +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    maxFrontierReturn( double[] expectedReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the maximum  expected  return  of  the  range  over" )
      System.Console.WriteLine( "     which the Efficient Frontier  exits.  As  a  general  remark  it  is" )
      System.Console.WriteLine( "     usually best to evaluate the range of the  expected  return  of  the" )
      System.Console.WriteLine( "     Efficient Frontier in order  to  provide  a  range  over  which  the" )
      System.Console.WriteLine( "     Efficient Frontier can be evaluated and the  range  over  which  the" )
      System.Console.WriteLine( "     optimal portfolio can be sort." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" )
      Dim max1 As Double = instanceOfCapitalMarket.MaxFrontierReturn( _
         expectedReturns1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The maximum  bound  of  the  range  of  the  expected  return  of  the" )
      System.Console.WriteLine( "    Efficient Frontier is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( max1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Here we construct the Efficient Frontier +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    calculateEfficientFrontier( double minimumExpectedReturn," )
      System.Console.WriteLine( "                                double maximumExpectedReturn," )
      System.Console.WriteLine( "                                double[][] covarianceMatrix," )
      System.Console.WriteLine( "                                double[] expectedReturns," )
      System.Console.WriteLine( "                                int numberInterpolationPoints," )
      System.Console.WriteLine( "                                double precision )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Construct the Efficient Frontier and  set  the  results  to  private" )
      System.Console.WriteLine( "     fields. Note that we use 100 interpolation points equal  distributed" )
      System.Console.WriteLine( "     over the entire range over which the Efficient Frontier exits." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    minimumExpectedReturn = min1" )
      System.Console.WriteLine( "    maximumExpectedReturn = max1" )
      System.Console.WriteLine( "    covarianceMatrix = covariance1" )
      System.Console.WriteLine( "    expectedReturns = expectedReturns1" )
      System.Console.WriteLine( "    numberInterpolationPoints = 100" )
      System.Console.WriteLine( "    precision = 0.00000001" )
      ' Here we construct the efficient frontier.
      instanceOfCapitalMarket.CalculateEfficientFrontier( _
         min1, _
         max1, _
         covariance1, _
         expectedReturns1, _
         100, _
         0.00000001 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The Efficient Frontier has now been evaluate of persisted  by  setting" )
      System.Console.WriteLine( "    various private fields which record to the points about  which  it  is" )
      System.Console.WriteLine( "    interpolated." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Values of  the  Expected  Return  at  the  evaluation  points  of  the +" )
      System.Console.WriteLine( "+ Efficient Frontier                                                     +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    getEfficientFrontierExpectedReturns(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we get the values of the Efficient Frontier for the  points  at" )
      System.Console.WriteLine( "     which the Efficient Frontier has been evaluated." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Here we get the values of the Expected returns at the points on  which
      ' Efficient Frontier has been evaluated.
      Dim returnEF1 As Double() = instanceOfCapitalMarket.GetEfficientFrontierExpectedReturns( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The values of the expected return for  which  the  Efficient  Frontier" )
      System.Console.WriteLine( "    has been evaluated are:" )
      System.Console.WriteLine( " " )
      displayArray( returnEF1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Values of the Risk at the evaluation points of the Efficient Frontier +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    getEfficientFrontierPortfolioRisks( double[][] covarianceMatrix )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we get the values of the  Portfolio  Risk  for  the  points  at" )
      System.Console.WriteLine( "     which the Efficient Frontier has been evaluated." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    covarianceMatrix = covariance1" )
      ' Here we get the values of the risk at the points  on  which  Efficient
      ' Frontier has been evaluated.
      Dim riskEF1 As Double() = instanceOfCapitalMarket.GetEfficientFrontierPortfolioRisks( _
         covariance1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The values of the risk of the portfolio at the  points  at  which  the" )
      System.Console.WriteLine( "    Efficient Frontier is evaluated is:" )
      System.Console.WriteLine( " " )
      displayArray( riskEF1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Asset Weights of the evaluated Portfolios on the Efficient Frontier +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    getEfficientFrontierAssetWeights(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we get the asset weights of the portfolios  at  the  points  on" )
      System.Console.WriteLine( "     the Efficient Frontier for which it has been evaluated." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Here we get the weights of the portfolios on the Efficient Frontier.
      Dim weightsEF1 As Double()() = instanceOfCapitalMarket.GetEfficientFrontierAssetWeights( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The weights of the portfolios is:" )
      System.Console.WriteLine( " " )
      display2DArray( weightsEF1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Identify the Market Portfolio +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    marketPortfolio( double minimumExpectedReturn," )
      System.Console.WriteLine( "                     double maximumExpectedReturn," )
      System.Console.WriteLine( "                     double[][] covarianceMatrix," )
      System.Console.WriteLine( "                     double marketRate )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     We will  now  identify  the  market  portfolio  which  lies  of  the" )
      System.Console.WriteLine( "     Efficient Frontier  and  is  distinguished  by  having  the  highest" )
      System.Console.WriteLine( "     return per unit of risk." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    minimumExpectedReturn = min1" )
      System.Console.WriteLine( "    maximumExpectedReturn = max1" )
      System.Console.WriteLine( "    covarianceMatrix = covariance1" )
      System.Console.WriteLine( "    marketRate = 0.1" )
      ' Here we evaluate the  weights  of  the  assets  contained  within  the
      ' Market Portfolio
      Dim marketPortfolio1 As Double() = instanceOfCapitalMarket.MarketPortfolio( _
         min1, _
         max1, _
         covariance1, _
         0.1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The weights of the assets within the market portfolio are:" )
      System.Console.WriteLine( " " )
      displayArray( marketPortfolio1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Here we evaluate the Risk of the Market Portfolio +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    marketPortfolioRisk( double[] weights," )
      System.Console.WriteLine( "                         double[][] covariance )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the risk of the  market  portfolio  found.  We  use" )
      System.Console.WriteLine( "     here a method from the Capital  Markets  class  but  we  could  have" )
      System.Console.WriteLine( "     applied the MarketPortfolioRisk method  from  the  Asset  Parameters" )
      System.Console.WriteLine( "     class." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weights = marketPortfolio1" )
      System.Console.WriteLine( "    covariance = covariance1" )
      ' Here we evaluate the risk of the market portfolio.
      Dim marketPortfolioRisk1 As Double = instanceOfCapitalMarket.MarketPortfolioRisk( _
         marketPortfolio1, _
         covariance1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the market portfolio is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( marketPortfolioRisk1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Here we evaluate the Expected Return of the Market Portfolio +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    marketPortfolioExpectedReturn( double[] weights," )
      System.Console.WriteLine( "                                   double[][] historicalReturns )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we get the expected return of the Market Portfolio." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    weights = marketPortfolio1" )
      System.Console.WriteLine( "    historicalReturns = {{12.85, 12.254, 12.066, 11.836, 13.078, 14.568, 12.732, 12.313, 12.375, 12.407, 11.91, 12.0, 11.784, 12.516, 13.355, 12.3, 12.764, 12.336, 12.073, 12.002, 11.405, 11.055, 10.982, 11.3859, 10.733, 9.9789, 10.242, 10.768, 10.759, 11.6329, 12.488, 12.544, 12.7929, 12.63, 13.117, 14.129, 13.929, 14.53, 15.239, 16.0539, 15.782, 16.18, 17.4609, 17.7719, 19.21, 19.181, 20.54, 19.8009, 20.343, 21.78}," )
      System.Console.WriteLine( "                        {0.905, 0.89, 0.881, 0.915, 0.915, 0.899, 0.988, 0.899, 0.997, 1.048, 1.065, 1.159, 1.374, 1.2709, 1.554, 1.404, 1.733, 1.662, 1.599, 1.777, 1.999, 1.929, 2.021, 2.066, 2.158, 2.112, 2.176, 2.372, 2.994, 3.088, 3.521, 3.521, 3.926, 3.925, 3.925, 4.117, 4.684, 4.655, 4.472, 4.404, 4.218, 4.424, 4.4429, 4.6289, 4.76, 5.73, 5.5, 5.98, 5.6, 4.5199}," )
      System.Console.WriteLine( "                        {5.5439, 5.57, 5.475, 6.121, 6.281, 5.591, 5.458, 6.245, 6.112, 6.843, 7.373, 7.553, 7.679, 7.859, 7.715, 6.967, 6.071, 6.062, 5.6689, 5.349, 5.467, 5.953, 6.121, 5.869, 5.851, 5.282, 5.776, 6.547, 6.357, 6.661, 6.985, 6.994, 7.232, 7.516, 7.196, 7.313, 7.071, 7.545, 7.854, 8.236, 8.393, 8.452, 8.747, 8.836, 9.2, 9.5399, 9.98, 9.86, 9.28, 9.55}," )
      System.Console.WriteLine( "                        {0.168, 0.14, 0.125, 0.133, 0.117, 0.113, 0.121, 0.133, 0.117, 0.129, 0.121, 0.121, 0.121, 0.125, 0.121, 0.125, 0.13, 0.138, 0.147, 0.164, 0.164, 0.191, 0.26, 0.305, 0.314, 0.314, 0.314, 0.305, 0.356, 0.356, 0.487, 0.591, 0.652, 0.6899, 0.758, 0.805, 0.873, 0.8, 0.781, 0.742, 0.673, 0.732, 0.8, 0.859, 0.81, 0.96, 1.07, 0.99, 0.97, 0.91}," )
      System.Console.WriteLine( "                        {13.559, 13.902, 15.041, 17.228, 17.038, 20.439, 21.374, 21.787, 22.3619, 22.915, 24.53, 23.831, 23.531, 24.709, 24.793, 22.119, 22.383, 21.14, 21.917, 23.0829, 21.5829, 21.024, 22.3649, 21.224, 22.5, 20.322, 18.018, 19.876, 20.354, 20.525, 21.636, 22.869, 22.685, 24.258, 23.589, 24.2689, 25.817, 25.633, 27.031, 26.639, 26.332, 27.404, 27.478, 28.909, 30.775, 33.4189, 36.737, 38.276, 37.795, 39.1}," )
      System.Console.WriteLine( "                        {2.12, 2.157, 1.907, 1.936, 1.965, 1.57, 1.301, 1.358, 0.915, 1.161, 1.3778, 1.3778, 1.609, 1.58, 1.917, 1.657, 1.551, 1.484, 1.5129, 1.676, 1.59, 1.763, 2.119, 2.062, 2.033, 1.927, 2.245, 2.678, 2.601, 2.794, 3.324, 3.487, 3.721, 4.247, 4.198, 4.5, 5.5519, 6.829, 7.063, 7.792, 8.433, 9.093, 9.014, 9.014, 9.27, 8.93, 9.17, 10.86, 11.15, 14.0}," )
      System.Console.WriteLine( "                        {1.1, 1.067, 0.975, 1.042, 1.084, 1.242, 1.166, 1.109, 0.921, 1.124, 1.116, 1.183, 1.369, 1.606, 1.978, 2.09, 1.761, 1.596, 1.266, 1.102, 1.137, 1.1278, 1.02, 0.877, 0.94, 0.832, 0.94, 0.992, 0.871, 0.992, 1.223, 1.177, 1.3798, 1.532, 1.427, 1.37, 1.275, 1.3798, 1.456, 1.495, 1.651, 1.72, 1.925, 1.925, 2.19, 2.43, 3.02, 2.81, 3.56, 3.91}," )
      System.Console.WriteLine( "                        {6.924, 7.482, 7.439, 8.048, 8.6039, 9.859, 9.904, 9.614, 10.764, 10.301, 10.074, 10.21, 10.7579, 11.009, 11.475, 12.073, 11.953, 12.091, 11.154, 11.034, 11.478, 11.487, 10.563, 10.638, 11.142, 10.797, 11.587, 12.241, 11.606, 11.862, 11.18, 11.142, 11.304, 10.725, 10.938, 11.381, 11.323, 11.314, 11.63, 11.581, 11.492, 11.188, 11.492, 12.65, 13.62, 13.38, 15.0, 15.01, 14.59, 15.56}," )
      System.Console.WriteLine( "                        {7.716, 8.617, 8.023, 8.809, 9.21, 8.8859, 8.296, 7.971, 7.338, 7.638, 8.7129, 9.109, 9.699, 10.228, 9.89, 9.3699, 9.3699, 9.032, 8.94, 8.546, 8.489, 9.09, 9.618, 9.646, 8.477, 8.696, 8.819, 8.591, 8.173, 8.318, 9.435, 10.523, 10.166, 11.283, 10.955, 11.849, 10.974, 11.917, 11.917, 11.249, 11.857, 12.289, 12.926, 13.009, 14.228, 13.722, 15.308, 15.199, 16.12, 19.14}," )
      System.Console.WriteLine( "                        {1.523, 1.6258, 1.481, 1.609, 1.763, 1.883, 1.805, 1.962, 1.796, 1.866, 1.927, 2.0059, 1.978, 2.156, 2.067, 2.076, 2.236, 1.996, 1.939, 2.119, 2.074, 1.885, 1.831, 1.804, 1.767, 1.592, 1.647, 1.923, 1.997, 2.052, 2.1269, 2.184, 2.25, 2.259, 2.447, 2.551, 2.613, 2.786, 2.498, 2.93, 3.123, 2.998, 3.239, 3.278, 3.288, 3.052, 3.2679, 3.435, 3.25, 3.24}," )
      System.Console.WriteLine( "                        {0.657, 0.65, 0.613, 0.517, 0.613, 0.5649, 0.637, 0.6919, 0.525, 0.619, 0.644, 0.67, 0.644, 0.787, 0.796, 0.805, 0.744, 0.779, 0.6929, 0.779, 0.806, 0.904, 0.886, 0.841, 0.967, 1.065, 1.067, 1.002, 1.141, 1.2609, 1.299, 1.5209, 1.66, 1.471, 1.48, 1.604, 1.757, 1.872, 1.892, 1.94, 1.804, 1.784, 1.901, 2.106, 2.34, 2.47, 2.5, 2.55, 2.55, 2.4}," )
      System.Console.WriteLine( "                        {1.056, 0.845, 0.682, 0.861, 0.742, 0.708, 0.716, 0.725, 0.6879, 0.776, 0.782, 0.757, 0.714, 0.645, 0.671, 0.584, 0.496, 0.531, 0.366, 0.392, 0.329, 0.3469, 0.262, 0.2, 0.258, 0.236, 0.226, 0.258, 0.304, 0.336, 0.387, 0.419, 0.419, 0.429, 0.467, 0.458, 0.534, 0.524, 0.536, 0.526, 0.526, 0.546, 0.624, 0.604, 0.6, 0.59, 0.62, 0.68, 0.7, 0.67}," )
      System.Console.WriteLine( "                        {1.287, 1.355, 1.2709, 1.677, 1.868, 1.85, 1.79, 1.945, 1.749, 1.767, 2.032, 2.294, 2.403, 2.871, 2.765, 2.657, 2.747, 2.702, 2.549, 2.594, 2.324, 2.361, 2.379, 2.517, 2.7, 2.562, 2.619, 2.629, 2.629, 2.676, 2.928, 3.62, 3.547, 3.89, 3.766, 4.062, 4.138, 4.147, 4.04, 4.418, 4.865, 4.952, 5.186, 5.691, 5.882, 6.692, 6.366, 6.218, 7.106, 7.383}," )
      System.Console.WriteLine( "                        {3.828, 4.158, 4.3949, 4.623, 4.424, 4.785, 5.431, 6.862, 6.065, 7.225, 7.614, 7.643, 8.6649, 8.209, 8.243, 7.829, 8.1969, 8.252, 6.908, 7.515, 6.723, 6.252, 6.373, 6.485, 6.429, 4.992, 4.78, 5.429, 5.648, 5.858, 6.364, 6.583, 7.108, 7.102, 6.772, 6.918, 6.801, 7.209, 7.653, 7.495, 8.1359, 8.146, 8.0079, 9.251, 9.408, 10.5, 11.4, 11.45, 12.05, 13.7}," )
      System.Console.WriteLine( "                        {0.422, 0.422, 0.352, 0.381, 0.423, 0.394, 0.381, 0.39, 0.351, 0.413, 0.536, 0.5709, 0.536, 0.553, 0.5709, 0.562, 0.707, 0.6889, 0.616, 0.707, 0.766, 0.858, 0.886, 0.932, 0.987, 0.987, 1.028, 1.2, 1.238, 1.409, 1.466, 1.79, 1.79, 1.771, 1.973, 2.108, 2.05, 2.021, 1.951, 2.1389, 2.129, 2.1389, 2.365, 2.375, 2.35, 2.63, 2.67, 1.93, 1.98, 1.92}," )
      System.Console.WriteLine( "                        {1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.732, 1.656, 1.704, 1.865, 1.903, 1.942, 2.2839, 2.475, 2.953, 3.273, 3.041, 3.166, 3.099, 3.099, 3.15, 2.992, 2.904, 2.855, 3.248, 3.849, 3.9, 5.26, 5.46, 5.67, 5.94, 6.2}," )
      System.Console.WriteLine( "                        {3.932, 4.151, 3.809, 3.769, 3.688, 3.89, 4.26, 4.651, 4.86, 4.467, 4.753, 5.324, 5.67, 5.2, 5.233, 5.404, 5.45, 5.747, 5.675, 5.702, 5.382, 4.817, 4.89, 4.808, 5.227, 5.287, 5.249, 5.287, 5.082, 5.305, 5.444, 5.35, 5.407, 5.567, 5.756, 5.889, 6.002, 6.354, 6.576, 6.643, 6.923, 6.682, 6.768, 7.106, 6.89, 7.223, 7.312, 7.979, 7.704, 8.18}," )
      System.Console.WriteLine( "                        {14.362, 13.171, 11.0559, 12.342, 10.528, 11.0559, 10.5719, 9.405, 9.813, 9.8859, 10.558, 11.578, 11.891, 10.625, 10.518, 10.446, 9.278, 9.467, 9.134, 9.981, 9.147, 8.993, 9.048, 8.803, 8.205, 8.025, 8.569, 9.315, 7.841, 7.694, 7.988, 9.955, 9.673, 10.528, 9.861, 9.438, 9.748, 9.47, 9.785, 10.206, 9.709, 9.833, 9.948, 10.9149, 11.189, 11.307, 11.953, 12.982, 13.374, 12.4}," )
      System.Console.WriteLine( "                        {0.63, 0.6899, 0.851, 0.995, 0.963, 0.912, 0.849, 0.954, 0.791, 0.869, 0.938, 0.988, 1.078, 1.125, 1.381, 1.483, 1.718, 1.62, 1.533, 1.738, 1.891, 1.864, 1.98, 1.99, 2.1429, 2.341, 2.232, 2.395, 2.558, 2.75, 2.878, 2.868, 3.06, 3.084, 2.824, 3.0, 2.727, 2.925, 2.871, 2.978, 3.233, 3.214, 3.324, 3.515, 3.618, 4.13, 4.2, 4.73, 4.53, 4.48}," )
      System.Console.WriteLine( "                        {0.924, 0.939, 0.5639, 0.806, 0.742, 0.726, 0.677, 0.806, 0.676, 0.751, 0.735, 0.751, 0.735, 0.777, 0.747, 0.712, 0.687, 0.858, 0.944, 0.927, 0.933, 0.835, 0.827, 0.8, 0.8, 0.764, 0.8, 0.8189, 0.8189, 0.828, 0.828, 0.92, 1.069, 1.135, 0.956, 1.079, 1.06, 1.012, 1.106, 1.087, 1.0189, 1.067, 1.155, 1.213, 1.15, 1.12, 1.07, 1.07, 1.1, 1.1}," )
      System.Console.WriteLine( "                        {0.941, 0.933, 0.781, 0.847, 1.026, 1.082, 0.988, 0.86, 0.753, 0.64, 0.612, 0.64, 0.621, 0.781, 0.979, 0.913, 0.979, 1.026, 1.129, 1.393, 1.139, 1.035, 1.101, 1.0169, 0.951, 0.932, 0.847, 0.988, 0.885, 0.894, 1.0068, 1.177, 1.12, 1.206, 1.302, 1.167, 1.157, 1.119, 1.051, 0.994, 1.032, 1.022, 1.119, 1.177, 1.22, 1.3, 1.41, 1.48, 1.62, 1.58}," )
      System.Console.WriteLine( "                        {0.487, 0.543, 0.447, 0.462, 0.462, 0.411, 0.426, 0.455, 0.368, 0.405, 0.471, 0.463, 0.478, 0.515, 0.587, 0.502, 0.533, 0.533, 0.525, 0.556, 0.602, 0.5629, 0.58, 0.654, 0.6959, 0.704, 0.727, 0.823, 0.919, 1.05, 1.094, 1.077, 1.234, 1.181, 1.135, 1.098, 1.162, 1.208, 1.23, 1.191, 1.239, 1.239, 1.258, 1.506, 1.487, 1.47, 1.54, 1.52, 1.65, 1.62}," )
      System.Console.WriteLine( "                        {0.503, 0.456, 0.388, 0.374, 0.381, 0.378, 0.371, 0.414, 0.371, 0.4069, 0.487, 0.511, 0.488, 0.496, 0.511, 0.504, 0.557, 0.54, 0.508, 0.548, 0.483, 0.54, 0.5719, 0.592, 0.6, 0.6, 0.575, 0.634, 0.685, 0.6919, 0.728, 0.79, 0.8159, 0.861, 0.843, 0.898, 0.898, 0.972, 1.0088, 1.0, 1.0, 1.028, 1.115, 1.231, 1.319, 1.483, 1.493, 1.74, 1.93, 1.91}," )
      System.Console.WriteLine( "                        {1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.2709, 1.199, 1.09, 1.18, 1.208, 1.062, 1.062, 0.969, 1.043, 1.285, 1.3879, 1.322, 1.444, 1.444, 1.397, 1.52, 1.805, 1.982, 2.137, 2.04, 2.079, 2.37, 2.487, 2.862, 3.05, 3.365, 3.73, 4.68, 4.35}," )
      System.Console.WriteLine( "                        {1.557, 1.557, 1.557, 1.557, 1.557, 1.769, 1.858, 1.902, 1.99, 1.928, 2.052, 2.282, 2.194, 1.99, 2.437, 2.392, 2.609, 2.545, 2.455, 2.681, 2.626, 2.479, 2.433, 2.479, 2.47, 2.497, 2.722, 2.656, 2.872, 2.966, 3.154, 3.416, 3.53, 4.095, 4.258, 4.439, 4.191, 4.688, 4.805, 4.853, 5.0279, 4.97, 4.863, 5.222, 5.409, 6.248, 6.12, 6.663, 6.86, 7.06}," )
      System.Console.WriteLine( "                        {1.056, 1.056, 1.056, 1.056, 1.056, 1.056, 1.056, 1.0209, 1.012, 1.1, 1.065, 1.056, 1.321, 1.287, 1.422, 1.359, 1.17, 1.17, 1.152, 1.062, 1.1359, 1.173, 1.154, 1.293, 1.2, 1.108, 1.099, 1.1, 1.0048, 0.901, 1.062, 1.024, 0.958, 1.149, 1.121, 1.303, 1.322, 1.427, 1.5169, 1.281, 1.488, 1.98, 2.148, 2.739, 3.48, 3.81, 4.25, 3.99, 4.95, 6.3}," )
      System.Console.WriteLine( "                        {1.964, 1.676, 1.437, 1.847, 1.854, 1.881, 2.36, 2.394, 2.144, 2.846, 2.811, 2.636, 2.811, 2.97, 3.1469, 2.758, 2.652, 2.334, 2.086, 2.188, 2.261, 2.005, 1.932, 1.969, 1.859, 1.805, 2.063, 2.21, 2.652, 2.836, 2.726, 2.873, 3.306, 3.344, 3.544, 3.677, 3.591, 3.221, 3.0099, 3.308, 3.078, 3.078, 3.174, 3.725, 3.952, 4.486, 4.4269, 4.674, 5.059, 5.01}," )
      System.Console.WriteLine( "                        {2.463, 2.523, 2.48, 2.437, 2.715, 3.089, 3.046, 3.559, 3.546, 3.989, 3.9, 3.767, 3.883, 4.432, 4.5, 3.593, 4.311, 4.221, 3.907, 4.132, 4.257, 4.323, 4.3869, 4.3869, 4.414, 4.003, 4.069, 3.827, 3.771, 3.603, 3.948, 4.2, 4.527, 4.676, 4.59, 4.647, 4.485, 4.581, 4.5, 4.6369, 4.559, 4.559, 4.822, 4.948, 4.929, 5.1, 5.2699, 5.65, 6.0, 5.7}," )
      System.Console.WriteLine( "                        {0.754, 0.821, 0.832, 0.988, 0.931, 1.045, 0.945, 0.914, 0.98, 1.068, 1.102, 1.102, 1.331, 1.67, 1.953, 1.83, 1.61, 1.583, 1.539, 1.853, 1.761, 1.963, 2.148, 2.083, 2.12, 1.973, 2.02, 2.039, 2.19, 2.058, 2.266, 2.322, 2.379, 2.456, 2.379, 2.649, 2.774, 3.189, 3.14, 2.846, 2.817, 3.14, 3.278, 3.533, 4.0, 4.3, 4.04, 4.08, 3.99, 4.4}," )
      System.Console.WriteLine( "                        {5.4589, 5.723, 5.399, 6.0599, 5.863, 6.128, 6.464, 6.241, 5.562, 5.759, 6.106, 6.035, 6.158, 6.264, 6.484, 5.5359, 5.2619, 4.925, 4.783, 4.686, 4.385, 4.42, 4.218, 4.164, 4.191, 3.459, 3.549, 3.979, 4.5679, 4.437, 4.979, 5.221, 5.352, 5.768, 5.059, 5.873, 5.538, 5.174, 5.136, 4.922, 4.961, 5.01, 5.029, 4.757, 4.806, 6.04, 6.3, 6.41, 7.5, 7.55}," )
      System.Console.WriteLine( "                        {0.769, 0.76, 0.662, 0.617, 0.59, 0.742, 0.742, 0.783, 0.737, 0.71, 0.654, 0.663, 0.6909, 0.645, 0.627, 0.599, 0.663, 0.663, 0.746, 0.792, 0.854, 0.854, 0.797, 0.74, 0.712, 0.6929, 0.728, 0.787, 0.835, 0.903, 1.078, 1.2528, 1.069, 1.0088, 1.089, 1.1278, 1.277, 1.108, 1.1278, 1.385, 1.534, 1.445, 1.474, 1.732, 1.85, 2.0, 2.39, 2.46, 2.46, 2.2599}," )
      System.Console.WriteLine( "                        {1.932, 1.508, 1.178, 0.895, 0.49, 1.225, 0.66, 0.49, 0.377, 0.339, 0.339, 0.594, 0.641, 0.735, 0.613, 0.5649, 0.471, 0.622, 0.5649, 0.518, 0.518, 0.603, 0.594, 0.528, 0.528, 0.471, 0.622, 0.631, 0.754, 0.773, 1.056, 1.357, 1.467, 1.477, 1.5149, 1.592, 1.6298, 1.784, 2.047, 2.175, 1.93, 2.243, 2.449, 2.39, 2.38, 1.77, 1.68, 1.3899, 1.6, 1.54}," )
      System.Console.WriteLine( "                        {1.563, 1.563, 1.563, 1.667, 1.699, 1.659, 1.651, 1.659, 1.533, 1.566, 1.566, 1.566, 1.557, 1.577, 1.552, 1.527, 1.644, 1.36, 1.402, 1.627, 1.687, 1.67, 1.653, 1.619, 1.832, 2.06, 2.043, 2.209, 2.323, 2.691, 2.718, 2.586, 2.65, 2.775, 2.811, 3.0179, 3.108, 3.449, 3.322, 3.687, 3.745, 3.831, 4.07, 4.343, 4.215, 4.89, 5.7699, 5.604, 6.22, 5.8}," )
      System.Console.WriteLine( "                        {1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.1, 0.893, 0.797, 0.737, 0.944, 1.034, 0.916, 0.835, 0.907, 1.18, 1.335, 1.523, 1.551, 1.6359, 1.748, 1.6359, 1.702, 1.741, 1.741, 1.635, 1.721, 1.865, 1.97, 2.194, 2.341, 2.5259, 2.7599, 3.0139, 3.14, 3.46, 3.35}," )
      System.Console.WriteLine( "                        {2.332, 2.358, 2.436, 2.445, 2.55, 2.992, 2.902, 2.876, 2.673, 2.843, 2.708, 2.798, 2.997, 2.906, 3.09, 3.035, 2.999, 2.862, 2.644, 2.908, 2.824, 2.306, 2.371, 2.537, 2.5, 2.834, 2.726, 2.914, 3.14, 3.196, 3.525, 3.742, 3.971, 4.258, 3.999, 4.066, 4.086, 4.306, 4.625, 4.732, 4.508, 4.868, 4.849, 4.946, 5.2, 5.39, 5.84, 6.43, 6.5, 6.4}}" )
      ' Here we evaluate the expected return of the market portfolio.
      Dim marketPortfolioReturn1 As Double = instanceOfCapitalMarket.MarketPortfolioExpectedReturn( _
         marketPortfolio1, _
         New Double()() {New Double() {12.85, 12.254, 12.066, 11.836, 13.078, 14.568, 12.732, 12.313, 12.375, 12.407, 11.91, 12.0, 11.784, 12.516, 13.355, 12.3, 12.764, 12.336, 12.073, 12.002, 11.405, 11.055, 10.982, 11.3859, 10.733, 9.9789, 10.242, 10.768, 10.759, 11.6329, 12.488, 12.544, 12.7929, 12.63, 13.117, 14.129, 13.929, 14.53, 15.239, 16.0539, 15.782, 16.18, 17.4609, 17.7719, 19.21, 19.181, 20.54, 19.8009, 20.343, 21.78}, _
                         New Double() {0.905, 0.89, 0.881, 0.915, 0.915, 0.899, 0.988, 0.899, 0.997, 1.048, 1.065, 1.159, 1.374, 1.2709, 1.554, 1.404, 1.733, 1.662, 1.599, 1.777, 1.999, 1.929, 2.021, 2.066, 2.158, 2.112, 2.176, 2.372, 2.994, 3.088, 3.521, 3.521, 3.926, 3.925, 3.925, 4.117, 4.684, 4.655, 4.472, 4.404, 4.218, 4.424, 4.4429, 4.6289, 4.76, 5.73, 5.5, 5.98, 5.6, 4.5199}, _
                         New Double() {5.5439, 5.57, 5.475, 6.121, 6.281, 5.591, 5.458, 6.245, 6.112, 6.843, 7.373, 7.553, 7.679, 7.859, 7.715, 6.967, 6.071, 6.062, 5.6689, 5.349, 5.467, 5.953, 6.121, 5.869, 5.851, 5.282, 5.776, 6.547, 6.357, 6.661, 6.985, 6.994, 7.232, 7.516, 7.196, 7.313, 7.071, 7.545, 7.854, 8.236, 8.393, 8.452, 8.747, 8.836, 9.2, 9.5399, 9.98, 9.86, 9.28, 9.55}, _
                         New Double() {0.168, 0.14, 0.125, 0.133, 0.117, 0.113, 0.121, 0.133, 0.117, 0.129, 0.121, 0.121, 0.121, 0.125, 0.121, 0.125, 0.13, 0.138, 0.147, 0.164, 0.164, 0.191, 0.26, 0.305, 0.314, 0.314, 0.314, 0.305, 0.356, 0.356, 0.487, 0.591, 0.652, 0.6899, 0.758, 0.805, 0.873, 0.8, 0.781, 0.742, 0.673, 0.732, 0.8, 0.859, 0.81, 0.96, 1.07, 0.99, 0.97, 0.91}, _
                         New Double() {13.559, 13.902, 15.041, 17.228, 17.038, 20.439, 21.374, 21.787, 22.3619, 22.915, 24.53, 23.831, 23.531, 24.709, 24.793, 22.119, 22.383, 21.14, 21.917, 23.0829, 21.5829, 21.024, 22.3649, 21.224, 22.5, 20.322, 18.018, 19.876, 20.354, 20.525, 21.636, 22.869, 22.685, 24.258, 23.589, 24.2689, 25.817, 25.633, 27.031, 26.639, 26.332, 27.404, 27.478, 28.909, 30.775, 33.4189, 36.737, 38.276, 37.795, 39.1}, _
                         New Double() {2.12, 2.157, 1.907, 1.936, 1.965, 1.57, 1.301, 1.358, 0.915, 1.161, 1.3778, 1.3778, 1.609, 1.58, 1.917, 1.657, 1.551, 1.484, 1.5129, 1.676, 1.59, 1.763, 2.119, 2.062, 2.033, 1.927, 2.245, 2.678, 2.601, 2.794, 3.324, 3.487, 3.721, 4.247, 4.198, 4.5, 5.5519, 6.829, 7.063, 7.792, 8.433, 9.093, 9.014, 9.014, 9.27, 8.93, 9.17, 10.86, 11.15, 14.0}, _
                         New Double() {1.1, 1.067, 0.975, 1.042, 1.084, 1.242, 1.166, 1.109, 0.921, 1.124, 1.116, 1.183, 1.369, 1.606, 1.978, 2.09, 1.761, 1.596, 1.266, 1.102, 1.137, 1.1278, 1.02, 0.877, 0.94, 0.832, 0.94, 0.992, 0.871, 0.992, 1.223, 1.177, 1.3798, 1.532, 1.427, 1.37, 1.275, 1.3798, 1.456, 1.495, 1.651, 1.72, 1.925, 1.925, 2.19, 2.43, 3.02, 2.81, 3.56, 3.91}, _
                         New Double() {6.924, 7.482, 7.439, 8.048, 8.6039, 9.859, 9.904, 9.614, 10.764, 10.301, 10.074, 10.21, 10.7579, 11.009, 11.475, 12.073, 11.953, 12.091, 11.154, 11.034, 11.478, 11.487, 10.563, 10.638, 11.142, 10.797, 11.587, 12.241, 11.606, 11.862, 11.18, 11.142, 11.304, 10.725, 10.938, 11.381, 11.323, 11.314, 11.63, 11.581, 11.492, 11.188, 11.492, 12.65, 13.62, 13.38, 15.0, 15.01, 14.59, 15.56}, _
                         New Double() {7.716, 8.617, 8.023, 8.809, 9.21, 8.8859, 8.296, 7.971, 7.338, 7.638, 8.7129, 9.109, 9.699, 10.228, 9.89, 9.3699, 9.3699, 9.032, 8.94, 8.546, 8.489, 9.09, 9.618, 9.646, 8.477, 8.696, 8.819, 8.591, 8.173, 8.318, 9.435, 10.523, 10.166, 11.283, 10.955, 11.849, 10.974, 11.917, 11.917, 11.249, 11.857, 12.289, 12.926, 13.009, 14.228, 13.722, 15.308, 15.199, 16.12, 19.14}, _
                         New Double() {1.523, 1.6258, 1.481, 1.609, 1.763, 1.883, 1.805, 1.962, 1.796, 1.866, 1.927, 2.0059, 1.978, 2.156, 2.067, 2.076, 2.236, 1.996, 1.939, 2.119, 2.074, 1.885, 1.831, 1.804, 1.767, 1.592, 1.647, 1.923, 1.997, 2.052, 2.1269, 2.184, 2.25, 2.259, 2.447, 2.551, 2.613, 2.786, 2.498, 2.93, 3.123, 2.998, 3.239, 3.278, 3.288, 3.052, 3.2679, 3.435, 3.25, 3.24}, _
                         New Double() {0.657, 0.65, 0.613, 0.517, 0.613, 0.5649, 0.637, 0.6919, 0.525, 0.619, 0.644, 0.67, 0.644, 0.787, 0.796, 0.805, 0.744, 0.779, 0.6929, 0.779, 0.806, 0.904, 0.886, 0.841, 0.967, 1.065, 1.067, 1.002, 1.141, 1.2609, 1.299, 1.5209, 1.66, 1.471, 1.48, 1.604, 1.757, 1.872, 1.892, 1.94, 1.804, 1.784, 1.901, 2.106, 2.34, 2.47, 2.5, 2.55, 2.55, 2.4}, _
                         New Double() {1.056, 0.845, 0.682, 0.861, 0.742, 0.708, 0.716, 0.725, 0.6879, 0.776, 0.782, 0.757, 0.714, 0.645, 0.671, 0.584, 0.496, 0.531, 0.366, 0.392, 0.329, 0.3469, 0.262, 0.2, 0.258, 0.236, 0.226, 0.258, 0.304, 0.336, 0.387, 0.419, 0.419, 0.429, 0.467, 0.458, 0.534, 0.524, 0.536, 0.526, 0.526, 0.546, 0.624, 0.604, 0.6, 0.59, 0.62, 0.68, 0.7, 0.67}, _
                         New Double() {1.287, 1.355, 1.2709, 1.677, 1.868, 1.85, 1.79, 1.945, 1.749, 1.767, 2.032, 2.294, 2.403, 2.871, 2.765, 2.657, 2.747, 2.702, 2.549, 2.594, 2.324, 2.361, 2.379, 2.517, 2.7, 2.562, 2.619, 2.629, 2.629, 2.676, 2.928, 3.62, 3.547, 3.89, 3.766, 4.062, 4.138, 4.147, 4.04, 4.418, 4.865, 4.952, 5.186, 5.691, 5.882, 6.692, 6.366, 6.218, 7.106, 7.383}, _
                         New Double() {3.828, 4.158, 4.3949, 4.623, 4.424, 4.785, 5.431, 6.862, 6.065, 7.225, 7.614, 7.643, 8.6649, 8.209, 8.243, 7.829, 8.1969, 8.252, 6.908, 7.515, 6.723, 6.252, 6.373, 6.485, 6.429, 4.992, 4.78, 5.429, 5.648, 5.858, 6.364, 6.583, 7.108, 7.102, 6.772, 6.918, 6.801, 7.209, 7.653, 7.495, 8.1359, 8.146, 8.0079, 9.251, 9.408, 10.5, 11.4, 11.45, 12.05, 13.7}, _
                         New Double() {0.422, 0.422, 0.352, 0.381, 0.423, 0.394, 0.381, 0.39, 0.351, 0.413, 0.536, 0.5709, 0.536, 0.553, 0.5709, 0.562, 0.707, 0.6889, 0.616, 0.707, 0.766, 0.858, 0.886, 0.932, 0.987, 0.987, 1.028, 1.2, 1.238, 1.409, 1.466, 1.79, 1.79, 1.771, 1.973, 2.108, 2.05, 2.021, 1.951, 2.1389, 2.129, 2.1389, 2.365, 2.375, 2.35, 2.63, 2.67, 1.93, 1.98, 1.92}, _
                         New Double() {1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.666, 1.732, 1.656, 1.704, 1.865, 1.903, 1.942, 2.2839, 2.475, 2.953, 3.273, 3.041, 3.166, 3.099, 3.099, 3.15, 2.992, 2.904, 2.855, 3.248, 3.849, 3.9, 5.26, 5.46, 5.67, 5.94, 6.2}, _
                         New Double() {3.932, 4.151, 3.809, 3.769, 3.688, 3.89, 4.26, 4.651, 4.86, 4.467, 4.753, 5.324, 5.67, 5.2, 5.233, 5.404, 5.45, 5.747, 5.675, 5.702, 5.382, 4.817, 4.89, 4.808, 5.227, 5.287, 5.249, 5.287, 5.082, 5.305, 5.444, 5.35, 5.407, 5.567, 5.756, 5.889, 6.002, 6.354, 6.576, 6.643, 6.923, 6.682, 6.768, 7.106, 6.89, 7.223, 7.312, 7.979, 7.704, 8.18}, _
                         New Double() {14.362, 13.171, 11.0559, 12.342, 10.528, 11.0559, 10.5719, 9.405, 9.813, 9.8859, 10.558, 11.578, 11.891, 10.625, 10.518, 10.446, 9.278, 9.467, 9.134, 9.981, 9.147, 8.993, 9.048, 8.803, 8.205, 8.025, 8.569, 9.315, 7.841, 7.694, 7.988, 9.955, 9.673, 10.528, 9.861, 9.438, 9.748, 9.47, 9.785, 10.206, 9.709, 9.833, 9.948, 10.9149, 11.189, 11.307, 11.953, 12.982, 13.374, 12.4}, _
                         New Double() {0.63, 0.6899, 0.851, 0.995, 0.963, 0.912, 0.849, 0.954, 0.791, 0.869, 0.938, 0.988, 1.078, 1.125, 1.381, 1.483, 1.718, 1.62, 1.533, 1.738, 1.891, 1.864, 1.98, 1.99, 2.1429, 2.341, 2.232, 2.395, 2.558, 2.75, 2.878, 2.868, 3.06, 3.084, 2.824, 3.0, 2.727, 2.925, 2.871, 2.978, 3.233, 3.214, 3.324, 3.515, 3.618, 4.13, 4.2, 4.73, 4.53, 4.48}, _
                         New Double() {0.924, 0.939, 0.5639, 0.806, 0.742, 0.726, 0.677, 0.806, 0.676, 0.751, 0.735, 0.751, 0.735, 0.777, 0.747, 0.712, 0.687, 0.858, 0.944, 0.927, 0.933, 0.835, 0.827, 0.8, 0.8, 0.764, 0.8, 0.8189, 0.8189, 0.828, 0.828, 0.92, 1.069, 1.135, 0.956, 1.079, 1.06, 1.012, 1.106, 1.087, 1.0189, 1.067, 1.155, 1.213, 1.15, 1.12, 1.07, 1.07, 1.1, 1.1}, _
                         New Double() {0.941, 0.933, 0.781, 0.847, 1.026, 1.082, 0.988, 0.86, 0.753, 0.64, 0.612, 0.64, 0.621, 0.781, 0.979, 0.913, 0.979, 1.026, 1.129, 1.393, 1.139, 1.035, 1.101, 1.0169, 0.951, 0.932, 0.847, 0.988, 0.885, 0.894, 1.0068, 1.177, 1.12, 1.206, 1.302, 1.167, 1.157, 1.119, 1.051, 0.994, 1.032, 1.022, 1.119, 1.177, 1.22, 1.3, 1.41, 1.48, 1.62, 1.58}, _
                         New Double() {0.487, 0.543, 0.447, 0.462, 0.462, 0.411, 0.426, 0.455, 0.368, 0.405, 0.471, 0.463, 0.478, 0.515, 0.587, 0.502, 0.533, 0.533, 0.525, 0.556, 0.602, 0.5629, 0.58, 0.654, 0.6959, 0.704, 0.727, 0.823, 0.919, 1.05, 1.094, 1.077, 1.234, 1.181, 1.135, 1.098, 1.162, 1.208, 1.23, 1.191, 1.239, 1.239, 1.258, 1.506, 1.487, 1.47, 1.54, 1.52, 1.65, 1.62}, _
                         New Double() {0.503, 0.456, 0.388, 0.374, 0.381, 0.378, 0.371, 0.414, 0.371, 0.4069, 0.487, 0.511, 0.488, 0.496, 0.511, 0.504, 0.557, 0.54, 0.508, 0.548, 0.483, 0.54, 0.5719, 0.592, 0.6, 0.6, 0.575, 0.634, 0.685, 0.6919, 0.728, 0.79, 0.8159, 0.861, 0.843, 0.898, 0.898, 0.972, 1.0088, 1.0, 1.0, 1.028, 1.115, 1.231, 1.319, 1.483, 1.493, 1.74, 1.93, 1.91}, _
                         New Double() {1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.208, 1.2709, 1.199, 1.09, 1.18, 1.208, 1.062, 1.062, 0.969, 1.043, 1.285, 1.3879, 1.322, 1.444, 1.444, 1.397, 1.52, 1.805, 1.982, 2.137, 2.04, 2.079, 2.37, 2.487, 2.862, 3.05, 3.365, 3.73, 4.68, 4.35}, _
                         New Double() {1.557, 1.557, 1.557, 1.557, 1.557, 1.769, 1.858, 1.902, 1.99, 1.928, 2.052, 2.282, 2.194, 1.99, 2.437, 2.392, 2.609, 2.545, 2.455, 2.681, 2.626, 2.479, 2.433, 2.479, 2.47, 2.497, 2.722, 2.656, 2.872, 2.966, 3.154, 3.416, 3.53, 4.095, 4.258, 4.439, 4.191, 4.688, 4.805, 4.853, 5.0279, 4.97, 4.863, 5.222, 5.409, 6.248, 6.12, 6.663, 6.86, 7.06}, _
                         New Double() {1.056, 1.056, 1.056, 1.056, 1.056, 1.056, 1.056, 1.0209, 1.012, 1.1, 1.065, 1.056, 1.321, 1.287, 1.422, 1.359, 1.17, 1.17, 1.152, 1.062, 1.1359, 1.173, 1.154, 1.293, 1.2, 1.108, 1.099, 1.1, 1.0048, 0.901, 1.062, 1.024, 0.958, 1.149, 1.121, 1.303, 1.322, 1.427, 1.5169, 1.281, 1.488, 1.98, 2.148, 2.739, 3.48, 3.81, 4.25, 3.99, 4.95, 6.3}, _
                         New Double() {1.964, 1.676, 1.437, 1.847, 1.854, 1.881, 2.36, 2.394, 2.144, 2.846, 2.811, 2.636, 2.811, 2.97, 3.1469, 2.758, 2.652, 2.334, 2.086, 2.188, 2.261, 2.005, 1.932, 1.969, 1.859, 1.805, 2.063, 2.21, 2.652, 2.836, 2.726, 2.873, 3.306, 3.344, 3.544, 3.677, 3.591, 3.221, 3.0099, 3.308, 3.078, 3.078, 3.174, 3.725, 3.952, 4.486, 4.4269, 4.674, 5.059, 5.01}, _
                         New Double() {2.463, 2.523, 2.48, 2.437, 2.715, 3.089, 3.046, 3.559, 3.546, 3.989, 3.9, 3.767, 3.883, 4.432, 4.5, 3.593, 4.311, 4.221, 3.907, 4.132, 4.257, 4.323, 4.3869, 4.3869, 4.414, 4.003, 4.069, 3.827, 3.771, 3.603, 3.948, 4.2, 4.527, 4.676, 4.59, 4.647, 4.485, 4.581, 4.5, 4.6369, 4.559, 4.559, 4.822, 4.948, 4.929, 5.1, 5.2699, 5.65, 6.0, 5.7}, _
                         New Double() {0.754, 0.821, 0.832, 0.988, 0.931, 1.045, 0.945, 0.914, 0.98, 1.068, 1.102, 1.102, 1.331, 1.67, 1.953, 1.83, 1.61, 1.583, 1.539, 1.853, 1.761, 1.963, 2.148, 2.083, 2.12, 1.973, 2.02, 2.039, 2.19, 2.058, 2.266, 2.322, 2.379, 2.456, 2.379, 2.649, 2.774, 3.189, 3.14, 2.846, 2.817, 3.14, 3.278, 3.533, 4.0, 4.3, 4.04, 4.08, 3.99, 4.4}, _
                         New Double() {5.4589, 5.723, 5.399, 6.0599, 5.863, 6.128, 6.464, 6.241, 5.562, 5.759, 6.106, 6.035, 6.158, 6.264, 6.484, 5.5359, 5.2619, 4.925, 4.783, 4.686, 4.385, 4.42, 4.218, 4.164, 4.191, 3.459, 3.549, 3.979, 4.5679, 4.437, 4.979, 5.221, 5.352, 5.768, 5.059, 5.873, 5.538, 5.174, 5.136, 4.922, 4.961, 5.01, 5.029, 4.757, 4.806, 6.04, 6.3, 6.41, 7.5, 7.55}, _
                         New Double() {0.769, 0.76, 0.662, 0.617, 0.59, 0.742, 0.742, 0.783, 0.737, 0.71, 0.654, 0.663, 0.6909, 0.645, 0.627, 0.599, 0.663, 0.663, 0.746, 0.792, 0.854, 0.854, 0.797, 0.74, 0.712, 0.6929, 0.728, 0.787, 0.835, 0.903, 1.078, 1.2528, 1.069, 1.0088, 1.089, 1.1278, 1.277, 1.108, 1.1278, 1.385, 1.534, 1.445, 1.474, 1.732, 1.85, 2.0, 2.39, 2.46, 2.46, 2.2599}, _
                         New Double() {1.932, 1.508, 1.178, 0.895, 0.49, 1.225, 0.66, 0.49, 0.377, 0.339, 0.339, 0.594, 0.641, 0.735, 0.613, 0.5649, 0.471, 0.622, 0.5649, 0.518, 0.518, 0.603, 0.594, 0.528, 0.528, 0.471, 0.622, 0.631, 0.754, 0.773, 1.056, 1.357, 1.467, 1.477, 1.5149, 1.592, 1.6298, 1.784, 2.047, 2.175, 1.93, 2.243, 2.449, 2.39, 2.38, 1.77, 1.68, 1.3899, 1.6, 1.54}, _
                         New Double() {1.563, 1.563, 1.563, 1.667, 1.699, 1.659, 1.651, 1.659, 1.533, 1.566, 1.566, 1.566, 1.557, 1.577, 1.552, 1.527, 1.644, 1.36, 1.402, 1.627, 1.687, 1.67, 1.653, 1.619, 1.832, 2.06, 2.043, 2.209, 2.323, 2.691, 2.718, 2.586, 2.65, 2.775, 2.811, 3.0179, 3.108, 3.449, 3.322, 3.687, 3.745, 3.831, 4.07, 4.343, 4.215, 4.89, 5.7699, 5.604, 6.22, 5.8}, _
                         New Double() {1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.1, 0.893, 0.797, 0.737, 0.944, 1.034, 0.916, 0.835, 0.907, 1.18, 1.335, 1.523, 1.551, 1.6359, 1.748, 1.6359, 1.702, 1.741, 1.741, 1.635, 1.721, 1.865, 1.97, 2.194, 2.341, 2.5259, 2.7599, 3.0139, 3.14, 3.46, 3.35}, _
                         New Double() {2.332, 2.358, 2.436, 2.445, 2.55, 2.992, 2.902, 2.876, 2.673, 2.843, 2.708, 2.798, 2.997, 2.906, 3.09, 3.035, 2.999, 2.862, 2.644, 2.908, 2.824, 2.306, 2.371, 2.537, 2.5, 2.834, 2.726, 2.914, 3.14, 3.196, 3.525, 3.742, 3.971, 4.258, 3.999, 4.066, 4.086, 4.306, 4.625, 4.732, 4.508, 4.868, 4.849, 4.946, 5.2, 5.39, 5.84, 6.43, 6.5, 6.4}} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The expected return of the market portfolio is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( marketPortfolioReturn1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Find the Risk of the Leveraged Portfolio on the CML +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    riskCML( double expectedReturn," )
      System.Console.WriteLine( "             double equityExpected," )
      System.Console.WriteLine( "             double marketRate," )
      System.Console.WriteLine( "             double equityRisk )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the Risk of  the  Portfolio  on  the  CML  with  an" )
      System.Console.WriteLine( "     expected return of 7 per  period.  Recall,  that  since  the  Market" )
      System.Console.WriteLine( "     Portfolio has a expected return less than 7, we will be  considering" )
      System.Console.WriteLine( "     a leveraged portfolio which has borrowed cash  from  the  market  at" )
      System.Console.WriteLine( "     the prevailing rate of 0.25 percent per month in order  to  purchase" )
      System.Console.WriteLine( "     more units of the market portfolio." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn = 7" )
      System.Console.WriteLine( "    equityExpected = marketPortfolioReturn1" )
      System.Console.WriteLine( "    marketRate = 0.25" )
      System.Console.WriteLine( "    equityRisk = marketPortfolioRisk1" )
      ' Here we evaluate the  Risk  of  the  Portfolio  on  the  CML  with  an
      ' expected return of 7 per period (i.e. a leveraged portfolio).
      Dim riskCML1 As Double = instanceOfCapitalMarket.RiskCML( _
         7.0, _
         marketPortfolioReturn1, _
         0.25, _
         marketPortfolioRisk1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the leveraged  portfolio  on  the  CML  with  an  expected" )
      System.Console.WriteLine( "    return of 7 per period, is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( riskCML1 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Find the Risk of the Unleveraged Portfolio on the CML +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    riskCML( double expectedReturn," )
      System.Console.WriteLine( "             double equityExpected," )
      System.Console.WriteLine( "             double marketRate," )
      System.Console.WriteLine( "             double equityRisk )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the Risk of  the  Portfolio  on  the  CML  with  an" )
      System.Console.WriteLine( "     expected return of 4 per  period.  Recall,  that  since  the  Market" )
      System.Console.WriteLine( "     Portfolio  has  a  expected  return  greater  than  4,  we  will  be" )
      System.Console.WriteLine( "     considering a unleveraged portfolio which lends cash to  the  market" )
      System.Console.WriteLine( "     at the prevailing rate of 0.25  percent  per  month  and  invest  to" )
      System.Console.WriteLine( "     remaining capital within the market portfolio.  That  is,  since  we" )
      System.Console.WriteLine( "     require a portfolio with a return lower than  the  market  portfolio" )
      System.Console.WriteLine( "     we are able to hold a portfolio consisting  of  a  weighting  within" )
      System.Console.WriteLine( "     the market portfolio (i.e. risky asset)  with  the  remaining  being" )
      System.Console.WriteLine( "     lent to the market (i.e. zero risk asset)." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    expectedReturn = 4" )
      System.Console.WriteLine( "    equityExpected = marketPortfolioReturn1" )
      System.Console.WriteLine( "    marketRate = 0.25" )
      System.Console.WriteLine( "    equityRisk = marketPortfolioRisk1" )
      ' Here we evaluate the  Risk  of  the  Portfolio  on  the  CML  with  an
      ' expected return of 4 per period (i.e. a unleveraged portfolio).
      Dim riskCML2 As Double = instanceOfCapitalMarket.RiskCML( _
         4.0, _
         marketPortfolioReturn1, _
         0.25, _
         marketPortfolioRisk1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The risk of the unleveraged portfolio on  the  CML  with  an  expected" )
      System.Console.WriteLine( "    return of 4 per period, is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.Write( double2String( riskCML2 ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( " " )
   End Sub

   Function Double2String(ByVal d As Double) As String
      If (System.Double.IsNaN(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsNegativeInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (System.Double.IsPositiveInfinity(d)) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MinValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      If (d = Double.MaxValue) Then
          Double2String = d.ToString()
          Exit Function
      End If
      Dim frac As Double = d - Int(d)
      Dim frac4 As Double = Int(frac * 10000) / 10000.0
      Double2String = (Int(d) + frac4).ToString()
      Exit Function
   End Function

   Sub displayArray(ByVal a As Double())
      System.Console.Write("     {")
      For I As Integer = 0 To -1 + a.Length
         System.Console.Write(Double2String(a(I)))
         If (I < -1 + a.Length) Then System.Console.Write(", ")
      Next I
      System.Console.Write("}")
   End Sub

   Sub display2DArray(ByVal a As Double()())
      For I As Integer = 0 To -1 + a.Length
         If (I = 0) Then
            System.Console.Write("     {{")
         Else
            System.Console.Write("      {")
         End If
         For J As Integer = 0 To -1 + a(I).Length
            System.Console.Write(Double2String(a(I)(J)))
            If (J < -1 + a(I).Length) Then
               System.Console.Write(", ")
            Else
               System.Console.Write("}")
               End If
         Next J
         If (I < -1 + a.Length) Then
            System.Console.Write(",")
            System.Console.WriteLine()
            Else
               System.Console.Write("}")
            End If
      Next I
   End Sub
End Module

